#!/usr/bin/ksh
#
# create summary statistics page for the web Gateway
# 
# Ed Seufert - June 28, 96
#

#
# Setup general configuration variables.
#  

. /usr/people/imswww/bin/statsConf.inc

weblogdir=$stats_sum_root/web

cd $weblogdir

echo "<html>"
echo "<title>"
echo "EOS Data Gateway Statistics"
echo "</title>"

echo "<body>"

# create header portion of the page.

echo "<table>"
echo "<tr>"
echo "<td align=center>"
echo "<img src=\"http://harp.gsfc.nasa.gov/~imswww/pub/icons/nasalogo.gif\" alt=\"NASA logo\"></td>"

echo "<td>"
echo "<h1>EOS Data Gateway Statistics </h1>"

echo "<P>"

echo "<p>"
echo "</td>"
echo "</tr>"
echo "</table>"

echo "<p>"

echo "<hr>"
########################################################################
echo "<!-------------------------------------------------------------------------->"

echo "<h2> Summary Statistics for all Web Gateways </h2>"

echo "<a href=\"http://harp.gsfc.nasa.gov/~imswww/stats/summary/web/statGlobalTextSummary.text\">Text version of the summary statistics.</a>"

echo "<P>"

echo "<a href=\"http://harp.gsfc.nasa.gov/~imswww/stats/summary/web/multi-daac-stats.html\">Statistics on cross data center queries.</a>"

echo "<P>"
echo "<hr>"

#
# Now build month graph table
##############################################################################

echo "<h2> Monthly Graphs:  </h2>"
typeset -i nitems 
nitems=0
typeset -i ncolumns
# number of chip gifs to be displayed on one line on the page. 
ncolumns=4
echo "<table>"

for graph in $(ls *month.html)
do
     year="$(echo $graph | awk -F. '{print $1}' )"
     month="$(echo $graph | awk -F. '{print $2}' )"
          temp1="$line1"
          line1="$temp1 <td> <a href=\"./$year.$month.gif\"><img src=\"./$year.$month-chip.gif\" border=0></a></td>"
          temp2="$line2"
          line2="$temp2 <td> <a href=\"./$year.$month.month.html\">$year-$month</a></td>" 
          nitems=`expr $nitems + 1`

 
     if [ "$nitems" -eq "$ncolumns" ]; 
     then 
          echo "<tr>"
          echo "$line1"
          echo "</tr>"
          echo "<tr>"
          echo "$line2"
          echo "</tr>"
          nitems=0
          line1=" "
          line2=" "
     fi
    
done 
     if [ "$nitems" -ne "$ncolumns" ]; 
     then
          echo "<tr>"
          echo "$line1"
          echo "</tr>"
          echo "<tr>"
          echo "$line2"
          echo "</tr>"
     fi



echo "</table>"

echo "<hr>"

# now for the footer
##############################################################################

echo "<hr>"

echo "<address>"
echo "<font size=-1>"
echo "Send questions and comments to:"
echo "<a href=\"mailto:imswww-dev@harp.gsfc.nasa.gov\">imswww-dev@harp.gsfc.nasa.gov</a>"
echo "<br>"
echo "NASA/GSFC Task Representative: Yonsook Enloe," 
echo "<a href=\"mailto:yonsook@killians.gsfc.nasa.gov\">yonsook@killians.gsfc.nasa.gov</a>"
echo "<br>"
echo "<a href=\"/~imswww/pub/manuals/imsuser_contacts.html\">"
echo "Full contact information</a> is available."
echo "<br>"
echo "</font></address>"
echo "</html>"
