#!/u/joe/perl561/bin/perl -w
#
# Copyright (c) 1996 U.S. Geological Survey (USGS)
#
# Permission to use, copy, modify, distribute, and sell this software and its
# documentation for any purpose is hereby granted without fee, provided that
# the above copyright notice appear in all copies and that both that
# copyright notice and this permission notice appear in supporting
# documentation, and that the name of USGS not be used in advertising or
# publicity pertaining to distribution of the software without specific,
# written prior permission.  USGS makes no representations about the
# suitability of this software for any purpose.  It is provided "as is"
# without express or implied warranty.
#
# USGS DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL USGS
# BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
# OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
# CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

# unbuffer stdout
$|=1;

# Ok , Figure out the system_architecture to include ( IRIX, Solaris, etc)
# We need to add this to the @INC so that Perl can find the C modules associated
# with the CPAN modules ( GD)
BEGIN {
    # Determine architecture
    eval "use Config";
    $system_architecture = $Config{archname};
}

BEGIN {
   use Cwd;
   # Figure out top directory:
   my $path = (($0 =~ m|^/|) ? $0 : (cwd()."/$0"));
   ($path =~ m|^(.*)/[^/]+$|) or
          die ( "can't extract info from $path!");
   my $top = "$1/..";

   # Set up include path:
   unshift @INC, "$top/lib/perl/first", "$top/lib/perl", "$top/lib/perl/plus", "
$top/lib/perl/CPAN", "$top/lib/perl/CPAN/$system_architecture";
}


my $write_path = "./drawglobe.log";
#open SEARCH, ">$write_path" or die "open $write_path: $!";
#print SEARCH "drawglobe running\n";

use URI::Escape;
my $request_method = $ENV{'REQUEST_METHOD'};
#print SEARCH "$request_method\n";

my $query;
my (@parts, $key, $val);
if ($request_method =~ /^(get|head)$/i) {

   $query = $ENV{'QUERY_STRING'};   
#   print SEARCH "$query\n";
   $query =~ tr/+/ /;      # RFC1630
#   print SEARCH "$query\n";
   @parts = split(/&/, $query);
   foreach (@parts) {      # Extract into key and value.
     ($key, $val) = m/^(.*?)=(.*)/;
     $val = (defined $val) ? uri_unescape($val) : '';
     $key = uri_unescape($key);
#     print SEARCH "$key , $val\n";


     $args[@args] = '-width '    . $val if($key eq 'width');
     $args[@args] = '-height '   . $val if($key eq 'height');
     $args[@args] = '-clat '     . $val if($key eq 'clat');
     $args[@args] = '-clon '     . $val if($key eq 'clon');
     $args[@args] = '-zoom '     . $val*100 if($key eq 'zoom');
     $args[@args] = '-gridinc '  . $val if($key eq 'grid');
     $args[@args] = '-proj ' . $val if ($key eq 'proj');
     $args[@args] = '-political '       if($key eq 'polit' && $val eq 'yes');
     $args[@args] = '-water '           if($key eq 'lakriv' && $val eq 'yes');
     # wrs, roads, rail and place overlays are only visible on 
     # medres (zoom 16 or higher).  wrs can equal 'none', 'wrs1', 'wrs2'.
     $args[@args] = '-'.$val.' '        if($key eq 'wrs' && $val ne 'none');
     $args[@args] = '-roads '           if($key eq 'roads' && $val eq 'yes');
     $args[@args] = '-rail '            if($key eq 'rail' && $val eq 'yes');
     $args[@args] = '-places '          if($key eq 'places' && $val eq 'yes');
   }
}

#  $args[@args] = '-width 450';
#  $args[@args] = '-height 300';
#  $args[@args] = '-clat 49';
#  $args[@args] = '-clon 2.5';
#  $args[@args] = '-zoom 25600'; 
#  $args[@args] = '-gridinc 15';
#  $args[@args] = '-political ';
#  $args[@args] = '-water ';
#  $args[@args] = '-places ';
#  $args[@args] = '-roads ';
#  $args[@args] = '-rail ';
#  $args[@args] = '-wrs2 ';

#close SEARCH;


$cmdline = './glismapper';
foreach $arg (@args)
{
  $cmdline .= " $arg";
}
$cmdline .= ' < /dev/null';

# build the map
print "Content-type: image/gif\n\n";
exec $cmdline;
