package IU::Account;

=head1 NAME

IU::Account - user account at a DAAC

=head1 RCS INFO

$Id: Account.pm,v 1.4 1997/03/13 15:24:15 eryq Exp $

=cut

use IU;
use IU::Chunk;
use strict;
    
#------------------------------------------------------------
# new PARAMHASH
#------------------------------------------------------------
sub new {
    my ($class, %params) = @_;
    bless \%params, $class;
}

#------------------------------------------------------------
# from_chunk CHUNK
#------------------------------------------------------------
sub from_chunk {    
    my ($self, $chunk) = @_;
    ref($self) or $self = $self->new;
    $self->{Name}     = $chunk->value('ACCOUNT_NUMBER');
    $self->{Value}    = $chunk->value('BALANCE');
    $self->{ErrorMsg} = $chunk->value('ERROR');    
    $self;
}

#------------------------------------------------------------
#
# Access methods...
#
#------------------------------------------------------------
sub name      { $_[0]->{Name} };
sub value     { $_[0]->{Value} };
sub error_msg { $_[0]->{ErrorMsg} };

#------------------------------------------------------------
1;
