package IU::AccountStatus;

=head1 NAME

IU::AccountStatus - user account at a DAAC

=head1 RCS INFO

$Id: AccountStatus.pm,v 1.3 1998/05/15 15:01:45 solomon Exp $

=cut

use IU;
use IU::Chunk;
use IU::Log;
use strict;
    
#------------------------------------------------------------
# new PARAMHASH
#------------------------------------------------------------
sub new {
    my ($class, %params) = @_;
    bless \%params, $class;
}

#------------------------------------------------------------
# from_chunk CHUNK
#------------------------------------------------------------
sub from_chunk {    
    my ($self, $chunk) = @_;
    ref($self) or $self = $self->new;
    $self->{Name}     = $chunk->value('BILLING_ID') || 
                        $chunk->value('ACCOUNT_NUMBER');
    $self->{Value}    = $chunk->value('BALANCE');
    $self->{DataSet} = $chunk->value('DATASET_COLLECTION') ||
                       $chunk->value('ACCOUNT_COMMENT');
    $self->{ErrorMsg} = $chunk->value('ERROR');
    $self;
}

#------------------------------------------------------------
#
# Access methods...
#
#------------------------------------------------------------
sub name      { $_[0]->{Name} };
sub value     { $_[0]->{Value} };
sub dataset   { $_[0]->{DataSet} };
sub error_msg { $_[0]->{ErrorMsg} };

#------------------------------------------------------------
1;
