package IU::BrowseFile;

=head1 NAME

IU::BrowseFile - a browse file

=cut

use IU;
use IU::Chunk;
use strict;

#------------------------------------------------------------
# new PARAMHASH
#------------------------------------------------------------
sub new {
    my ($class, %params) = @_;
    my $self = bless {}, $class;
    $self->{Path} = $params{Path} if $params{Path};
    $self;
}

#------------------------------------------------------------
# from_chunk
#------------------------------------------------------------
sub from_chunk {
    my ($self, $chunk) = @_;

    # Trap for error:
    ($chunk->value('x-error')) and return error $chunk->value('x-error');

    # Create it:
    ref($self) or $self = $self->new;    
    $self->{Path} = $chunk->value('image-pathname');
    $self;
}

#------------------------------------------------------------
# path
#------------------------------------------------------------
# Get/set the path.
sub path {
    my $self = shift;
    @_ ? ($self->{Path} = shift) : $self->{Path};
}

#------------------------------------------------------------
# filename
#------------------------------------------------------------
sub filename {
  IU::Util::path_filename($_[0]->{Path});
}

#------------------------------------------------------------
1;
