=head1 NAME

IU::Javascript - utility class for generating javascript 

=cut

package IU::Javascript;
use strict;


#------------------------------------------------------------
# escape -- make string a javascript safe string literal 
#------------------------------------------------------------
sub escape {
 
    my($str) = @_;
    $str =~ s/\'/\\\'/g;	# escape ' as \'
    $str =~ s/\"/\\\"/g;	# escape " as \"
    $str =~ s/\r/\\r/g;         # escape carriage return as \r
    $str =~ s/\f/\\f/g;         # escape formfeed as \f
    $str =~ s/\n/\\n/g;	        # escape newline as \n
    $str =~ s/\t/\\t/g;	        # escape tab as \t
    return $str;
}

#------------------------------------------------------------
1;
