#------------------------------------------------------------
package IU::SETUP;

=head1 NAME

IU::SETUP - IMS/WWW setup parameters, in Perl form

=head1 DESCRIPTION

Current IWS/www setup, predigested for Perl.
Contains mostly the info in SETUP.

=head1 WARNINGS

If you are writing an IW module, do I<not> "use" this file directly...  
It will corrupt your namespace!  It is loaded into the IU:: package; 
you should access these values through $IU::VarName.

B<DO NOT EDIT THIS FILE!>  Your changes will be lost when setup is re-run.  
Edit the top-level SETUP file instead, and re-run "setup.

=cut

require Exporter;
@ISA = qw(Exporter);

@EXPORT = qw($AccountMax $AcronymsUrl $ActiveSessionPort $ActiveTimeCheck $AdminCrypt $AirsBrowseSearchTitle $AllAccountsMax $AllowJava $CacheComfort $CacheLinger $CacheMax $CacheShelfLife $CalendarEmbed $CalendarTimeout $CalendarUrl $CgiUrl $CountryList $CriticalAllAccountsMax $CustomizeMetadata $DaacDocsUrl $DictFile $DisableByDiscipline $DisplayBrowseSearch $DocsDir $DocsUrl $EOSHomeUrl $EcsHomeDaac $EcsProfileGateway $EcsProfileSmc $EcsRegistration $EmailGasp $EosDisHomeUrl $EosOtherSourcesUrl $EosRelatedSitesUrl $ExpectLocation $ExplorerUrl $FAQUrl $ForceDebug $GaeaDataDir $GaeaDistribDir $GazetteerUrl $GcmdGetdifUrl $GcmdGetsuppUrl $GcmdHomeUrl $GcmdHostAddr $GcmdPort $GnatsEmail $GranColumnsMax $GuideKillTime $GuideLimit $GuideType $HavePersistentSessions $HdfInfoUrl $HdfTools $HomeEmail $HomeUrl $HttpdHost $ImsDefnUrl $ImsGUIUrl $ImsGlossUrl $ImsHomeUrl $ImsSitesUrl $ImsUserUrl $JavaFAQUrl $LdLibraryPath $LibDir $ListLength $ListMax $LocalStatsDir $LogDir $LogLevel $LogoutTime $MTPEHomeUrl $MapCgiScript $MapResolution $MaxFreetextDatasets $MaxGransDefault $MaxSearchTime $MisrLimit $MorePaths $NASAHomeUrl $NASAOrgCode $NetscapeUrl $OfficialEmail $OfficialName $OfficialTag $OutreachUrl $PSAMax $PerlHttpdPort $PersistentDir $PolicyAccess $PolicyPrivacy $PolicySecurity $PrimaryPort $QueryPreviewUrl $RandomContext $RandomLength $ReleaseType $ResultsLifetime $SampleDataUrl $SecurePort $SecureServer $SecuredDir $SendmailCmd $SessionLife $SiteAdmin $SiteAdminEmail $SiteName $SiteSpecDir $SitesWithKey $Slogin $SpidexConf $SpidexTimeout $SpidexUrl $StateList $StatsEmail $StatsId $StatsUrl $SyslogLevel $SystemName $Templates $TerraProductsUrl $TopDir $TutorialUrl $UpdateEvery $UseNonSpatial $UseNonTemporal $UserSurveyUrl $ValidsPort $Version $WebmasterEmail $WebmasterName $WebmasterTag $WelcomeUrl $WgHttpdPort $WhatsNewUrl $WwwUser);

$AccountMax = 
      '20 mb';
$AcronymsUrl = 
      'http://gcmd.gsfc.nasa.gov/acronyms.html';
$ActiveSessionPort = 
      '6600';
$ActiveTimeCheck = 
      '15';
$AdminCrypt = 
      'hbPrr2uaKXQcs';
$AirsBrowseSearchTitle = 
      'AIRS Browse';
$AllAccountsMax = 
      '2 gb';
$AllowJava = 
      'N';
$CacheComfort = 
      '5mb';
$CacheLinger = 
      '2m';
$CacheMax = 
      '10mb';
$CacheShelfLife = 
      '30m';
$CalendarEmbed = 
      '../../cgi-bin/beta/grab-cal.cgi';
$CalendarTimeout = 
      '10';
$CalendarUrl = 
      'http://redhook.gsfc.nasa.gov/ims-bin/uptime-cal.cgi';
$CgiUrl = 
      '/imsdev-bin/beta/';
$CountryList = 
      'conf/countries.txt';
$CriticalAllAccountsMax = 
      '10 gb';
$CustomizeMetadata = 
      'YES';
$DaacDocsUrl = 
      'http://www-v0ims.gsfc.nasa.gov/v0ims/DOCUMENTATION/documentation.html';
$DictFile = 
      'knuth_words';
$DisableByDiscipline = 
      'NO';
$DisplayBrowseSearch = 
      'YES';
$DocsDir = 
      '/www/imsdev/beta/docs';
$DocsUrl = 
      '/~imsdev/beta/';
$EOSHomeUrl = 
      'http://eos.nasa.gov';
$EcsHomeDaac = 
      'GSFC';
$EcsProfileGateway = 
      '';
$EcsProfileSmc = 
      'SMC-UPG';
$EcsRegistration = 
      'http://lyta.gsfc.nasa.gov/~imsdev/beta/imswelcome/ecsNotice.html';
$EmailGasp = 
      'YES';
$EosDisHomeUrl = 
      'http://eos.nasa.gov/eosdis';
$EosOtherSourcesUrl = 
      'http://www-v0ims.gsfc.nasa.gov/v0ims/RELSITES/other_source.html';
$EosRelatedSitesUrl = 
      'http://www-v0ims.gsfc.nasa.gov/v0ims/RELSITES/relsites.html';
$ExpectLocation = 
      '/usr/bin/expect';
$ExplorerUrl = 
      'http://www.microsoft.com/windows/ie/download/ie5all.htm';
$FAQUrl = 
      'http://lyta.gsfc.nasa.gov/~imsdev/beta/imswelcome/imswww.faq.html';
$ForceDebug = 
      'NO';
$GaeaDataDir = 
      '/imsdev/support_files_preops/sup_files';
$GaeaDistribDir = 
      '/imsdev/support_files_ops/dist_files';
$GazetteerUrl = 
      'http://fat-albert.alexandria.ucsb.edu:8827/gazetteer/';
$GcmdGetdifUrl = 
      'http://gcmd.nasa.gov/getdif.htm';
$GcmdGetsuppUrl = 
      'http://gcmd.gsfc.nasa.gov/cgi-bin/md/getsupp.pl';
$GcmdHomeUrl = 
      'http://gcmd.gsfc.nasa.gov/';
$GcmdHostAddr = 
      '192.107.190.77';
$GcmdPort = 
      '5502';
$GnatsEmail = 
      'bugs@killians.gsfc.nasa.gov';
$GranColumnsMax = 
      '20';
$GuideKillTime = 
      '15m';
$GuideLimit = 
      '100';
$GuideType = 
      'TRANSITIONAL';
$HavePersistentSessions = 
      'YES';
$HdfInfoUrl = 
      'http://www.ncsa.uiuc.edu/SDG/Homepage/hdf.html';
$HdfTools = 
      'http://hdfeos.gsfc.nasa.gov/hdfeos/viewingHDFEOS.html';
$HomeEmail = 
      'imswww-dev@harp.gsfc.nasa.gov';
$HomeUrl = 
      'http://www-v0ims.gsfc.nasa.gov/v0ims/eosdis_home.html';
$HttpdHost = 
      'lyta.gsfc.nasa.gov';
$ImsDefnUrl = 
      'http://www-v0ims.gsfc.nasa.gov/v0ims/definitions/';
$ImsGUIUrl = 
      'http://www-v0ims.gsfc.nasa.gov/v0ims/ims_access.html';
$ImsGlossUrl = 
      'http://www-v0ims.gsfc.nasa.gov/v0ims/glossary.of.terms.html';
$ImsHomeUrl = 
      'http://www-v0ims.gsfc.nasa.gov/v0ims/eosdis_home.html';
$ImsSitesUrl = 
      'http://lyta.gsfc.nasa.gov/~imsdev/beta/imswelcome/imswwwsites.html';
$ImsUserUrl = 
      'http://www-v0ims.gsfc.nasa.gov/v0ims/DAACS.html';
$JavaFAQUrl = 
      'http://lyta.gsfc.nasa.gov/~imsdev/beta/imswelcome/imswww-javafaq.html';
$LdLibraryPath = 
      '/usr/lib:/usr/local/lib:/usr/local/hdf5/lib';
$LibDir = 
      '/www/imsdev/beta/lib';
$ListLength = 
      '10';
$ListMax = 
      '1000';
$LocalStatsDir = 
      '';
$LogDir = 
      '/www/imsdev/beta/log';
$LogLevel = 
      'normal';
$LogoutTime = 
      '1 d';
$MTPEHomeUrl = 
      'http://www.earth.nasa.gov';
$MapCgiScript = 
      'drawglobe.cgi';
$MapResolution = 
      'ULTRA';
$MaxFreetextDatasets = 
      '20';
$MaxGransDefault = 
      '100';
$MaxSearchTime = 
      '90';
$MisrLimit = 
      '10';
$MorePaths = 
      '/usr/bsd:/usr/sbin:/www/imswww/wais';
$NASAHomeUrl = 
      'http://www.nasa.gov';
$NASAOrgCode = 
      '423';
$NetscapeUrl = 
      'http://home.netscape.com/computing/download/index.html';
$OfficialEmail = 
      'Mail Code 423, NASA/GSFC, Greenbelt, MD 20771';
$OfficialName = 
      'Medora Macie';
$OfficialTag = 
      'Medora.B.Macie.1';
$OutreachUrl = 
      'http://www-v0ims.gsfc.nasa.gov/v0ims/OUTREACH/outreach.html';
$PSAMax = 
      '2';
$PerlHttpdPort = 
      '';
$PersistentDir = 
      '/imsdev/persistentUsers-beta/';
$PolicyAccess = 
      'US Government';
$PolicyPrivacy = 
      'US Government';
$PolicySecurity = 
      'US Government';
$PrimaryPort = 
      '80';
$QueryPreviewUrl = 
      '';
$RandomContext = 
      '6';
$RandomLength = 
      '9';
$ReleaseType = 
      'Public';
$ResultsLifetime = 
      '14 d';
$SampleDataUrl = 
      'http://www-v0ims.gsfc.nasa.gov/v0ims/DATAPRODSERV/sample_data.html';
$SecurePort = 
      '';
$SecureServer = 
      '0';
$SecuredDir = 
      'secured';
$SendmailCmd = 
      '/usr/lib/sendmail -t -i -oeq';
$SessionLife = 
      '4h';
$SiteAdmin = 
      'imswww-gasp@harp.gsfc.nasa.gov';
$SiteAdminEmail = 
      'imswww-gasp@harp.gsfc.nasa.gov';
$SiteName = 
      'Goddard Space Flight Center';
$SiteSpecDir = 
      '/imsdev/site_specific';
$SitesWithKey = 
      'ASF,asf@eos.gsfc.nasa.gov';
$Slogin = 
      '/usr/local/bin/slogin';
$SpidexConf = 
      'http://guide.gsfc.nasa.gov:80/guide/conf/spidex.conf';
$SpidexTimeout = 
      '300';
$SpidexUrl = 
      'http://guide.gsfc.nasa.gov:80/guide/cgi-bin/guide/search/nph-search.cgi';
$StateList = 
      'conf/states.txt';
$StatsEmail = 
      'imswww-stats@harp.gsfc.nasa.gov';
$StatsId = 
      'v0ieww00';
$StatsUrl = 
      'http://harp.gsfc.nasa.gov/~imswww/stats/summary/web/global-imswww-stats.html';
$SyslogLevel = 
      '7';
$SystemName = 
      'EOS Data Gateway';
$Templates = 
      '/www/imsdev/beta/docs/templates';
$TerraProductsUrl = 
      'http://eosdatainfo.gsfc.nasa.gov/eosdata/terra/terra_dataprod.html';
$TopDir = 
      '/www/imsdev/beta';
$TutorialUrl = 
      'http://edcdaac.usgs.gov/tutorial/';
$UpdateEvery = 
      '15';
$UseNonSpatial = 
      'YES';
$UseNonTemporal = 
      'YES';
$UserSurveyUrl = 
      '';
$ValidsPort = 
      'preops';
$Version = 
      '3.6';
$WebmasterEmail = 
      'chao-hsi_chang@sesda.com';
$WebmasterName = 
      'Chao-Hsi Chang';
$WebmasterTag = 
      'Chao-Hsi.Chang.1';
$WelcomeUrl = 
      '/~imsdev/beta/imswelcome/index.html';
$WgHttpdPort = 
      '';
$WhatsNewUrl = 
      'http://www-v0ims.gsfc.nasa.gov/v0ims/NEWS/news.html';
$WwwUser = 
      'wwwuser.wwwuser';

#-------------------- end of file --------------------
