package IU::SubLogger;

=head1 NAME

IU::SubLogger -- log to a subroutine

=cut


use IU::Logger;
use IU::Log;

@IU::SubLogger::ISA = qw(IU::Logger);

use strict;


#------------------------------------------------------------
# open -- open a subroutine-logger stream
#------------------------------------------------------------
sub open {
    my ($type, $sub, $data) = @_;
    IU::Log->import;

    # Create the object:
    my $new = IU::Logger->open();
    $new->{Sub} = $sub or return undef;
    $new->{Data} = $data;
    bless $new, $type;
}

#------------------------------------------------------------
# msg -- log the given message
#------------------------------------------------------------
sub msg {
    no strict; 

    my ($self, $msgtype, $msgno, $caller, @msg) = @_;
    local($DATA) = $self->{Data};

    &{$self->{Sub}} if $self->{Sub};
}

#------------------------- end of file -------------------------
1;
