package IU::TrackedOrderManager;


=head1 NAME

IU::TrackedOrderManager - mangages orders returned in product results.

=head1 SYNOPSIS

=head1 DESCRIPTION

This object manages tracked orders returned from Data centers 

=cut

use IU;
use IU::ODL ();
use IU::Log;
use IU::IW;
use IU::TrackedOrder;


use strict;

use vars qw(@ISA @EXPORT
            $TRACKED_ORDER_MGR);
@ISA = qw(Exporter);
@EXPORT = qw($TRACKED_ORDER_MGR);
#------------------------------
# create_tracked_orders
#------------------------------
# Read in orders saved in session and 
# create list of tracked order objects
# returns list of tracked order objects if
# there are any, returns "NO ORDERS" if
# there are none.

sub create_tracked_orders  {
    my @tracked_orders = ();
    my $filename ;
    my $pathname = $SESSION->path_to('orders');

   # loop through all order files in the session
    while (defined($filename = glob("$pathname/*.order")))  {
         open(ORDERS, $filename)  or next;
         my $odl = eval { parse IU::ODL \*ORDERS };
         close ORDERS;

         # create a tracked order from ODL and push it on a list
         my $tracked_order = IU::TrackedOrder->from_ODL($odl);
         push @tracked_orders, $tracked_order;
   }

   return (int @tracked_orders ? @tracked_orders : 'NO ORDERS');
}        
1;
