package IW::CommStat::PRODUCT_REQUEST;

=head1 IW::CommStat::PRODUCT_REQUEST;

Track communication status for orders.  There is no
post-processing, and the number of granules is not reported.

=cut

use strict;
use vars qw(@ISA);
use IW::App;

use IU::Log;

@ISA = qw(IW::CommStat);

#------------------------------------------------------------
# init
#------------------------------------------------------------
sub init {
    my $self = shift;
    $self->{OpName} = 'order';
    $self;
}

#------------------------------------------------------------
# finished_ok
#------------------------------------------------------------
# We're finished... but did we really finish okay?
# The default test is that EVERY CONNECTION must have finished okay,
# AND we must have at least ONE CONNECTION!!!!!!

sub finished_ok {
    my $self = shift;
    my $conn;

    # Get connections:
    my @conns = $self->client->conn_statuses;
    @conns or return error "couldn't have finished ok: no connections!";

    # Check em all:
    foreach $conn (@conns) {
	return 1 if $conn->finished_ok;
    }
    0;
}

1;
