package IW::GeoWidget::GlobalGranOnly;

=head1 NAME

IW::GeoWidget::GlobalGranOnly - class for global granules only geoselection.

=cut

use strict;

use IU;
use IU::Log;
use IU::Query;

use IW::App;
use IW::GeoWidget::Base;

use vars qw(@ISA);
@ISA = qw(IW::GeoWidget::Base);

#------------------------------------------------------------
# draw
#------------------------------------------------------------
# Instance method, abstract.
# Draw the widget (map, etc.)

sub draw { 

   $HTML->t('Return only Data Granules which cover the entire Earth.')
        ->BR
        ->t('Note: This is different than a global search.');
   1;
}

#------------------------------------------------------------
# update 
#------------------------------------------------------------

sub update {

   return IU::Geo::Global->new;
}

#------------------------------------------------------------
# is_supported STRING
#------------------------------------------------------------
# class method
# Return true is this class supports the passed in geotype.

sub is_supported {
   my ($class,$geotype) = @_; 
   return 1 if ($geotype eq 'Global granules only');
   0;
}

#------------------------------------------------------------
# is_compatable GEO
#------------------------------------------------------------
# class method
# Return geotype if this class supports the passed in geo object.

sub is_compatable {
   my ($class,$geo) = @_;
   my $ODL_type = $geo ? $geo->ODL_type : undef;
   return 'Global granules only' if ($ODL_type eq 'GLOBAL_GRANULES_ONLY');
   undef;
}

#------------------------------------------------------------
1;

