package IW::GeoWidget::GlobalMap;

=head1 NAME

IW::GeoWidget::GlobalMap - do global geoselection, note this is just 
a special case of the RangeMap.

=cut

use strict;

use IU::Log;
use IW::App;

use IW::GeoWidget::RangeMap;
use vars qw(@ISA);
@ISA = qw(IW::GeoWidget::RangeMap);

#------------------------------------------------------------
# update GEO
#------------------------------------------------------------
# Update current state of geo

sub update {

   # Set map state to beginning i.e. START:
   $REQ->param('p_mapstate' => 'START');
   # Clear RANGE_LOC CGI tags so they don't carry over to draw:
   $REQ->param('p_north'=>undef);
   $REQ->param('p_west' =>undef);
   $REQ->param('p_south'=>undef);
   $REQ->param('p_east' =>undef);

   # Return global search:
   return IU::Geo::Range->new(90.0, -180.0, -90.0, 180.0); 
}

#------------------------------------------------------------
# show_directions
#------------------------------------------------------------
# Suppress the directions on the global map by overriding the parent
# method in RangeMap.pm with method that returns 0 (false).

sub show_directions { return 0 }

#------------------------------------------------------------
# is_supported STRING
#------------------------------------------------------------
# class method
# Return true is this class supported the passed in geotype.

sub is_supported {
   my ($class,$geotype) = @_;
   return 1 if ($geotype eq 'Global Search');
   0;
}

#------------------------------------------------------------
# is_compatable GEO
#------------------------------------------------------------
# class method
# Return geotype if this class supports the passed in geo object.

sub is_compatable {
   undef;
}

#------------------------------------------------------------
1;
