package IW::ModeADMINGENPWD;

=head1 NAME

IW::ModeADMINGENPWD - Generate and mail a persistent user's  password

=head1 DESCRIPTION

A subclass of IW::ModeADMINPopup *and* ModeFORGOT, allowing an administrator 
to generate and mail a password to a user, just as the user could using 
ModeFORGOT.

=head1 NOTES

This is an administrative subclass of ModeFORGOT, so all we have to do is
let the widget know that when we realize it, and ModeFORGOT will handle the
rest.

=head1 AUTHOR

Joe McMahon, Raytheon

Adapted from Jim Amrhein's ModeADMINCHGPASSWD code.

=cut


use IU;
use IU::Log;
use IU::Event;

use IW::App;
use IW::ModeADMINPopup;
use IW::ModeFORGOT;
use IW::Widget::EmailOrAccount;
use IW::User;

@ISA = qw(IW::ModeADMINPopup IW::ModeFORGOT);

use strict;


#------------------------------------------------------------
#
# Globals
#
#------------------------------------------------------------

my $Title = 'Generate a Password for a Persistent User';

#------------------------------------------------------------
#
# Submode handlers...
#
#------------------------------------------------------------

#------------------------------------------------------------
# submode_START
#------------------------------------------------------------
# I<Instance method.>
# Display the submit form, the user's name, and two instances of the new 
# password

sub submode_START {
    my ($self, $modality) = @_;

    # Start the page:
    $self->start_page(Title => $Title);

    # Start the form:
    $HTML -> HR;
    $HTML -> script_FORM;
 
    my $widget = IW::Widget::EmailOrAccount->new(Mode => 'ADMINGENPWD',
						 Submode => 'LOOKUP',
						 Admin   => 1,
						 Text    => 'Enter email or '.
						            'persistent '.
						            'account name '.
						            'for which a '.
						            'password should '.
						            'be generated.',
                                                 Modal   => $modality
						);
    debug "Widget initialized";

    # We have to save the widget so ModeFORGOT can ask it what to say.
    $self->{Widget} = $widget;

    # Do it...    
    $widget -> print;
    debug "Widget printed";

    # End the form:
    $HTML -> _script_FORM;

    # End the page:
    $self->end_page();

1;
}

#------------------------------------------------------------
# submode_DEFAULT
#------------------------------------------------------------
# What to do if invoked with no explicit submode...

sub submode_DEFAULT {
    my $self = shift;
    $self -> submode_START(0);
}

#------------------------------------------------------------
1;








