package IW::ModeAPPLET; 

=head1 NAME

IW::ModeAPPLET - Parse/Intialize Web Gateway. 

=cut

# Which libraries do I really NEED?

use IU;
use IU::Log;

use IW::App;
use IW::Util qw(:url :output);
use URI::Escape;
use IW::CGI;
require CGI::Request;

use strict;
use vars qw(@ISA $User);

@ISA = qw(IW::Mode);


#------------------------------------------------------------
# send_page
#------------------------------------------------------------
# I<Utility>.  Send the search form.

sub send_page {

    my $self = shift;

    # Setup a default message:
    unless ($APP->message) {
        $APP->message(" Applet Page ");
    }

    # Start the page:
    $APP->start_page(Title=>"ModeAPPLET ",
                     Context=>'appletpage');
    # $HTML -> script_FORM;
    # IW::Popup::pass_foreign;
    # $HTML -> _script_FORM;

 $HTML -> hidden('pmap.mapname' => "$self->{Mapname}");


   #--------------------
    # End it and send it:
    #--------------------

    $APP->suppress_key(1);
    $APP->end_page;
    1;
}


#------------------------------------------------------------
# parse_java
#------------------------------------------------------------
# I<Utility>.  Opens/Reads/Parses Java.txt into object that the Web Gateway
# can be intialized from.

sub parse_java {

    my $self = shift;
    #  encode/decode "Get" String
    my ($hidden_values, $decoded_hidden); 
    # Once we have eliminated the & 
    my $single_pair ;

    # Open Java.txt :
    my $odlfile = $SESSION->path_to('Java.txt');
    open QUERY, "$odlfile" or puke 572, "The Applet was not able to save your selection";
    while ( <QUERY>) {
	 $hidden_values = $_;
	debug $hidden_values;	
     }
     close QUERY;

    # Precaution so that if an error occurred the second time through
    # the applet, ModeAPPLET wouldn't read the original Java.txt file.
    # debug "Renaming Java.txt";
    # rename ( $odlfile,$SESSION->path_to('JustReadJava.txt'));

    $decoded_hidden = uri_unescape( $hidden_values );
    debug "Decode : $decoded_hidden ";

    # Breakup the line into key=value pairs
    my @array_pairs = split ( /&/ , $decoded_hidden);

    my %build_hash;
    foreach $single_pair ( @array_pairs ) {
	debug "Pair = $single_pair";
	my ( $name, $value) = split ( /=/ , $single_pair);

	# Add the key and value to a hash table
	my $decoded_value = uri_unescape( $value );
	$build_hash{$name}=  $decoded_value;
	debug "Key = $name , Value = $decoded_value";
    }	

	# "Load" the next mode ( defaults to Search Form)
	# then "Goto" the Mode from the JumpMenu
	switch IW::Mode  Tags =>\%build_hash;
1;
}

#------------------------------------------------------------
# submode_DEFAULT
#------------------------------------------------------------
# I<Instance method>.  What to do if there's no explicit submode.

sub submode_DEFAULT {
    shift->submode_SHOW;
}


#------------------------------------------------------------
# submode_SHOW
#------------------------------------------------------------
# I<Instance method>.
# Just show the search form page, without taking any action.

sub submode_SHOW {
    my $self = shift;
    $self->parse_java();
#    $self->send_page();
}


#------------------------------------------------------------
# go
#------------------------------------------------------------
# Main entry point for mode.

sub go {
    my $self = shift;
 
    # Get session or die:
    $APP->get_session;

    # What do we do?
    my $submode = ($REQ->param('submode') || 'DEFAULT');
    my $method = "submode_\U$submode\E";
    $self->$method() or puke "failed while handling submode $submode!";
    1;
}

#------------------------------------------------------------ 
