package IW::ModeAPPLETCOMM;

=head1 NAME

IW::ModeAPPLETCOMM - handles POST communications between Applets and the EDG. 

=head1 NOTES

=head2 ASSUMPTIONS


=head1 RCS INFO


=cut

use IU;
use IU::Log;

use IW::App;

use strict;
use vars qw(@ISA);
@ISA = qw(IW::Mode);

#------------------------------
#
# SUBMODE HANDLERS...
#
#------------------------------

#------------------------------------------------------------ 
# submode_DEFAULT 
#------------------------------------------------------------ 
# I<Instance method>.  What to do if there's no explicit submode.

sub submode_DEFAULT {
   shift->submode_POST;
}

#------------------------------------------------------------
# submode_POST
#------------------------------------------------------------
# I<Instance method>.

sub submode_POST {
   my $self = shift;

   my %savedreq;
   foreach ($REQ->params) { $savedreq{$_} = [$REQ->param($_)] }

   $SESSION->state->{savedreq} = \%savedreq;
   $SESSION->state->{test} = 'TEST';

   my %restoredreq =  %{$SESSION->state->{savedreq}}; 

   foreach my $tag (keys %restoredreq) {
      my $values;
      foreach (@{$restoredreq{$tag}}) { $values .= $_ }; 
      print $tag." = ".$values."\n";
   }


   # Output the results to the applet:
   my $sid = $SESSION->id;
   print "SID=". $sid . "\n";

   $REPLY->flush_output;

   1;
}

#------------------------------------------------------------
# submode_GET
#------------------------------------------------------------
# I<Instance method>

sub submode_GET {
   my $self = shift;

   my $guestsid = $REQ->param('guestsid');
   my $guestSession = IU::Session->resume(Id => $guestsid, Type=>'STANDARD');
   eval { $guestSession->setup_state(Opts=>'READER|NONBLOCK') };
   my %restoredreq =  %{$guestSession->state->{savedreq}};
   foreach (keys %restoredreq) {$REQ->param($_ => @{$restoredreq{$_}})}; 

   my $submode = $REQ->param('dosubmode');
   $REQ->param('submode'=>$submode);
   my $mode = $REQ->param('domode');
   my $modeclass = "IW::Mode$mode";
   if (!(eval("require $modeclass;"))) {
      puke 602, "module $modeclass not loaded: ", ($@ ? $@ : ''),
      "is mode '$mode' unsupported?";
   }
   $modeclass->go;

   1;
}

#------------------------------------------------------------
# go
#------------------------------------------------------------
# Main entry point for mode.

sub go {
   my $self = shift;
   $self->init;
   $self->go_submode;
}

#------------------------------------------------------------
# init
#------------------------------------------------------------
# Init this mode:
#   Get session if not switched here.

sub init {
   my $self = shift;

   # Get session if we need it.
   $APP->get_session('CREATE');

   1;
}
1;
