package IW::ModeBROWSERTEST;

=head1 NAME

IW::ModeBROWSERTEST - the browser test

=cut

use IU;
use IU::Event;
use IW::App;
use IW::Util qw(:url :output);

@ISA = qw(IW::Mode);


#------------------------------------------------------------
# send_reply -- send the full "welcome" document
#------------------------------------------------------------
sub send_reply {

    # Start the page:
    $APP->start_page(Title   =>'BROWSER TEST',
		     Context =>'browsertest');
    
    # Log event, but ONLY the first time through!
    unless (defined($REQ->param('test-imageinput-ok'))) {
	ims_event('BROWSERTEST');
    }
     
    # Echo browser:
    my $agent = $REQ->cgi->var('HTTP_USER_AGENT');
    $HTML -> HR -> P;
    if ($agent) {
	$HTML -> t("You are apparently using ") 
	      -> t_B($agent) 
              -> t('.');
    }
    else {
	$HTML -> t_B("The browser you are using does not supply its name...")
	      -> t("which is a bad sign.");
    }

    # Directions:
    $HTML -> P;
    output $HTML <<EOF;
        You will be shown a series of tests, each of which determines whether
        your browser supports a certain HTML feature.
	If you manage to make it all the way to the end
	without being told to STOP, then your current 
        WWW browser is able to run the EOS Data Gateway.
EOF

    # Recommend Netscape:
    $HTML -> P
	  -> A(HREF=>$IU::NetscapeUrl)
          -> IMG(SRC => doc_url('btns/netscape-now.gif'),
		 ALIGN => 'LEFT',
		 BORDER => 0,
		 ALT  => 'NETSCAPE NOW!')
          -> _A;		    
    $HTML -> t('If your browser is ') 
          -> t_EM('not') 
          -> t(' capable of running the EOS Data Gateway, you can simply ',
	       'download the latest public-domain version of ')
          -> hypertext('Netscape', $IU::NetscapeUrl) 
          -> t('.')
          -> BR(CLEAR=>'ALL');

    $HTML -> P
          -> A(HREF=>$IU::ExplorerUrl)
          -> IMG(SRC => doc_url('btns/ie-button.gif'),
                 ALIGN => 'LEFT',
                 BORDER => 0,
                 ALT  => 'IE NOW!')
          -> _A;
    $HTML -> t(' Click here to download the latest version of ')
          -> hypertext('Internet Explorer', $IU::ExplorerUrl)
          -> t('.')
          -> BR(CLEAR=>'ALL');
    




    # Forms:
    print "<P><hr><h2>Test 1: Forms support (required)</h2>\n";
    print <<EOF;
    You should see a text entry field and a checkbox, right here:
        <P STYLE="margin-left:10%">
            <form method=POST action="none">
            <input name="x" value="Hello!">
            <input type=checkbox name="y">
            </form>  
        </P>

    If there's nothing there, then your browser does not support forms:
    <i>you cannot use the EOS Data Gateway.</i>
    STOP RIGHT NOW, AND UPGRADE YOUR BROWSER.
    <p>
    Otherwise, keep going...
EOF

    # Hidden fields:
    print "<P><hr><h2>Test 2: Hidden fields (required)</h2>\n";
    print <<EOF;
    You should see absolutely nothing right here (except maybe a blank line):
        <P STYLE="margin-left:10%">
            <form method=POST action="none">
            <input type=hidden name="NotHidden" value="Failed!">
            </form>  
        </P>

    If you <i>did</i> see something there, then your browser does not 
    support "hidden fields":
    <i>you cannot use the EOS Data Gateway.</i>
    STOP RIGHT NOW, AND UPGRADE YOUR BROWSER.
    <p>
    Otherwise, keep going...
EOF

    # Image input:
    if ($REQ->param('test-imageinput-ok')) {
       $message = '<b><font size=+1>Image input looks okay!</font></b>';
    }        
    my $sid = (defined $SESSION) ? $SESSION->id : '';
    print <<EOF;
    <P><HR>
    <H2><A NAME="test-imageinput">Test 3: Image input (required)</a></h2>
    Click on this button.  It should take you right back to this page,
    except that a message will appear next to the button (you may have
    to scroll back down to this point):
        <P STYLE="margin-left:10%">
            <form method=POST action="nph-ims.cgi#test-imageinput">
            <input type="hidden" name="sid" value="$sid">
            <input type="hidden" name="mode" value="BROWSERTEST">
            <input type="hidden" name="test-imageinput-ok" value="1">
            <input type="image" alt="image input submit test button" src="${IU::DocsUrl}btns/inline-submit.gif"> 
            $message
           </form>  
        </P>

    If there's no button, or if something went wrong, then your browser
    doesn't support "image" input:
    <i>you cannot use the EOS Data Gateway.</i>
    STOP RIGHT NOW, AND UPGRADE YOUR BROWSER.
    <p>
    Otherwise, keep going...
EOF

    # Tables:
    print <<EOF;
    <P><hr><h2>Test 4: Tables (required)</a></h2>
    You should see the numbers 1 through 9 arranged in a table,
    with 3 rows and 3 columns, and headers along the top and left sides.
    All the cells should have borders around them, and the number "5"
    should be big, bold, and surrounded by little checkmarks:
        <P STYLE="margin-left:10%">
           <table border=1>
           <tr><th>      </th><th>Left</th><th>Center</th><th>Right</th></tr>
           <tr><th>Top   </th><td>1</td><td>2</td><td>3</td></tr>
           <tr><th>Middle</th><td>4</td><td><h2>
               <img src="${IU::DocsUrl}icons/status-ok-sm.gif" alt="X">
               5
               <img src="${IU::DocsUrl}icons/status-ok-sm.gif" alt="X">
               </h2></td><td>6</td></tr>
           <tr><th>Bottom</th><td>7</td><td>8</td><td>9</td></tr>
           </table>
        </P>
    If instead you got a mess (usually with everything all on one line)
    or nothing at all,
    then your browser does not support HTML3 tables... or else 
    it does not support them properly.
    <i>you cannot use the EOS Data Gateway.</i>
    STOP RIGHT NOW, AND UPGRADE YOUR BROWSER.
    <p>
    Otherwise, keep going...
EOF

    # Transparent images:
    print qq!<P><hr><h2>Test 5: Transparent images (recommended)</a></h2>\n!;
    print <<EOF;
    These two icons should appear, respectively, as a circle and triangle,
    with no hint of a rectangular border around them:
        <P STYLE="margin-left:10%">
           <img src="${IU::DocsUrl}icons/note.gif" alt="circle (note)">
           <img src="${IU::DocsUrl}icons/warning.gif" alt="triangle (warning)">
        </P>
    If you can see a rectangular border around either one,
    then your browser does not support transparent GIFs.
    Although you <em>can</em> use the gateway, output will not look as
    nice as it could:
    you should <em>seriously</em> consider upgrading.
    <p>
    Keep going...
EOF
       
    # Small fonts:
    print qq!<P><hr><h2>Test 6: Small font size (recommended)</a></h2>\n!;
    print <<EOF;
    In the two sentences that follow, the first should be normal-sized,
    and the second should be slightly smaller:
        <P STYLE="margin-left:10%">
           This is a sentence that uses the NORMAL font size.<br>
           <font size=-1>
           This is a sentence that uses the SMALLER font size.<br>
           </font>
    </P>
    If instead they both look identical in size, 
    then your browser does not support numeric font-size specifications.
    Although you <em>can</em> use the gateway, output may take up
    a lot of room, forcing you to scroll or expand your browser window: 
    you should really consider upgrading.
    <p>
    Keep going...
EOF

    # Java :
    print qq!<P><hr><h2>Test 7: Is Java Enabled (optional)</a></h2>\n!;
    print <<EOF;
    If you don't see "Java is enabled" below this message, either your browser 
    doesn't support Java or you've turned Java off in your preferences. 
    At this time, Java isn't required , but as newer releases become available
    we're looking to integrate Java into more components of the system.
    <p>
EOF

    $HTML -> P 
	  -> applet_code(ClassName  => 'IMSWG.IW.JavaEnabled.JavaEnabled.class',
                     CodeBase  => ${IU::DocsUrl}.'java/',
                     Width     => 150,
                     Height    => 30,
                     Alt       => "'Java enabled' applet")
          -> _applet_code
	  ->P ->t("Keep going...");

    # Done:
    $HTML -> P -> HR 
          -> H2
          -> IMG(SRC=>doc_url('icons/status-ok.gif'), 
                 ALT=>"OK")
          -> t(" DONE!")
          -> _H2;
    output $HTML <<EOF;
       If you got to this point, then your browser is capable of using
       the EOS Data Gateway!  If at any point it was recommended that you 
       upgrade your browser, you may wish to do so.
EOF

    # Send them to the interface:
    $HTML -> P;
    $HTML -> t("You may now ")
          -> hypertext("proceed to the welcome page", 
               	$IU::WelcomeUrl )
          -> t(" and search for data!")
          -> P;

    # End it and send it:
    $APP->end_page;
    1;
}

#------------------------------------------------------------
# go
#------------------------------------------------------------
# Entry point.

sub go {
    my $self = shift;
    
    # Get session. We have to have one.
    $APP->get_session('CREATE');

    # We don't want a navigator here.
    $APP->suppress_links(1);
    
    # Output the page:
    send_reply() or puke "couldn't send reply!";
    1;
}

#------------------------------------------------------------
1;
