package IW::ModeDEFNCRITERIA;

=head1 NAME

IW::ModeDEFNCRITERIA - mode to display the definition or comment field for
the extended attributes.

=cut

use IU;
use IU::Log;
use IU::Query;
use IU::Session;
use IU::Category;
use IU::Criterion;

use IW::App;
use IW::ModeSLCT;

use strict;
use vars qw(@ISA);

@ISA = qw(IW::ModeSLCT);

#------------------------------------------------------------
# new PARAMHASH
#------------------------------------------------------------
sub new {
    my $self = shift->SUPER::new(Context=>'defncriteria',
                                 @_);      # inherited constructor
    $self;
}

#------------------------------------------------------------
# print_page PARAMHASH
#------------------------------------------------------------
sub comment {
   my $self = shift;
   my $criteria_name = shift;
   $QUERY ||= IU::Query->new;
   my @criteria = $QUERY->depvalid_interface->get_criteria_name($criteria_name);
   my $crit;
   foreach $crit (@criteria) {
      return $crit->comment;
   }
}

#------------------------------------------------------------
# print_page PARAMHASH
#------------------------------------------------------------
# I<Instance method.>
# Start the page.  Identical to $APP->start_page, except that the
# title and supertitle have been automatically supplied (although
# you can override them if you wish).

sub print_page {
   my $self = shift;
   # Start page:
   $APP->suppress_key(1);
   $APP->start_page(SuperTitle => "Granule Attributes: ",
                    Title      => "Extended Attribute Definition",
                    Context    => 'defncriteria');

   my $item = $REQ->param('item');
   my $comment = $self->comment($item);
   $HTML -> t("Definition for $item:");
   $HTML -> BR;
   $HTML -> BR;
   $HTML -> t($comment);
   $APP->end_page;
}
#------------------------------
#
# Submode handlers
#
#------------------------------
#------------------------------------------------------------
# submode_DEFAULT
#------------------------------------------------------------
sub submode_DEFAULT {
   my $self = shift;
   $self->print_page;
   return 1;
}
#------------------------------------------------------------
1;
