package IW::ModeDNLOAD;

=head1 NAME

IW::ModeDNLOAD - download a file

=head1 DESCRIPTION

This mode is used for downloading miscellaneous files in the session
directory to the user's browser.  We use this mode, instead of direct
hyperlinks, so that we can force a save-to-disk no matter what the
file extension might be, and maybe generate our own filename in the process.

Note that this mode is really only intended for the downloading of
actualy disk files; it's not intended for synthesizing complex
files from CGI parameters.

=head1 NOTES

I would very much like for this mode to go away, in preference to
direct hyperlinks.

=cut

use IU;
use IU::Log;

use IW::App;
use IW::Util qw(:url :output);

@ISA = qw(IW::Mode);

use strict;


#------------------------------------------------------------
# download_query
#------------------------------------------------------------
# Download the last query.

sub download_query {

    ### KLUDGE... change this so that it reads in the query file!

    # Get path:
    my $path = $SESSION->path_to('pub/query.dat');

    # Send the HTTP-reply header:
    my $head = new IW::ReplyHead;
    $head->okay if $REPLY->need_status_line;
    $head->content_type('text/x-ims-search');
    $head->filename('untitled.query');
    $head->send(\*STDOUT);
    
    # Send the ODL file:
    interpolate($path, \*STDOUT);

    # Done!
    $REPLY->all_done;
    1;
}

#------------------------------------------------------------
# go
#------------------------------------------------------------
# Main entry point.

sub go {
    my $self = shift;
    
    # Get session or die:
    $APP->get_session();

    # What do we do?
    my $submode = $REQ->param('submode');
  SWITCH: for ($submode) {
      /QUERY/ and do {
	  download_query()     or puke "couldn't send file";
	  last;
      };
      puke 600, "bad submode: $submode!";
  }
    1;
}

#------------------------------------------------------------
1;

