package IW::ModeGAZETTEER;

=head1 NAME

IW::ModeGAZETTEER - page to display link to gazetteer 

=cut

use IU;
use IU::Session;
use IW::App;
use IW::Util qw(:url :output);

@ISA = qw(IW::Mode);


#------------------------------------------------------------
# send_reply -- send the page 
#------------------------------------------------------------
sub send_reply {

    # Don't show navigation bar
    $APP->suppress_links(1);
    # Start the page:
    $APP->start_page(
		     Title=>"Gazetteer");

    if ($IU::GazetteerUrl) {

       my $sid = $SESSION->id;
       my $edgurl = script_action();
       my $gazetteerlink = "$IU::GazetteerUrl?sid=$sid&edg=$edgurl";

       $HTML -> t(
       'The link below takes you to the Alexandria Digital Libary (ADL) ',
       'Gazetteer. The ADL Gazetteer will be displayed in this web browser ',
       'window and the EOS Data Gateway remains displayed in its original ',
       'window (though it maybe hidden from view by this window).')
       -> P
       -> t( 
       'You can use the ADL Gazetteer to find by name the coordinates for a ',
       'political, man-made or natural feature. Once you have found the ',
       'feature of interest you will have to manually enter the coordinates ',
       'in the \'Choose Search Area\' section of the EOS Data Gateway ',
       '\'Search Creation\' page. Note that the format of the ', 
       'latitude and longitude maybe different between the Gazetteer and ',
       'the EOS Data Gateway.')
       -> P
       -> t(
       'To manually enter the coordinates on the \'Search Creation\' page:')
       -> UL 
       -> LI
       -> t(
       'Latitude/Longitude point - use the \'Type-in Lat/Lon Point\' ',
       'option under Choose Search Area.')
       -> LI 
       -> t(
       'Latitude/Longitude range (box) - use the ',
       '\'Type-in Lat/Lon Range\' option under Choose Search Area.')
       -> _UL
       -> P
       -> CENTER
       -> B
       -> hypertext('ADL Gazetteer',$gazetteerlink, TARGET=>'support')
       -> _B
       -> _CENTER
       ->P;

    } else {

       $HTML->B->t(
       'Sorry Gazetteer is not available');

    }

    # End it and send it:
    $APP->end_page;
    1;
}

#------------------------------------------------------------
# go
#------------------------------------------------------------

sub go {
    my $self = shift;

    # Get session or die:
    $APP->get_session();

    # Output the page:
    send_reply() or puke "couldn't send reply!";
    1;
}

#------------------------------------------------------------
1;
