package IW::ModeMAINSRCH;

=head1 NAME

IW::ModeMAINSRCH - child class of ModeABSTRACTSRCH. This is the main
                 search form used for building Primary, Summary, Detailed,
                 Granule, Local Id, and Browse Searches.

                 methods (overrides of ModeABSTRACTSRCH methods):

                   _get_widgetbox - returns MainWidgetBox.

                   _mode - returns MAINSRCH.

=cut

use IW::SrchForm::MainWidgetBox; # The widget box used by this form.

use IW::ModeABSTRACTSRCH;
use vars qw(@ISA);
@ISA = qw(IW::ModeABSTRACTSRCH);

use strict;

#------------------------------------------------------------
#------------------------------------------------------------
# Override methods: There are required in order to be an
# child class of ModeABSTRACTSRCH. 
#------------------------------------------------------------
#------------------------------------------------------------

#------------------------------------------------------------
# _get_widgetbox
#------------------------------------------------------------
# Override of Abstract method:
# Name of WidgetBox to use for this form:

sub _get_widgetbox { return 'MainWidgetBox' }

#------------------------------------------------------------
# _mode
#------------------------------------------------------------
# Override of Abstract method:
# Name of this mode:

sub _mode { return 'MAINSRCH' }

#------------------------------------------------------------
1;
