package IW::SrchForm::AccountStatusWidgetBox;

=head1 NAME

IW::SrchForm::AccountStatusWidgetBox - layout account status form and 
handle updates.

=head1 DESCRIPTION


=cut

use strict;
use vars qw(@ISA);

use IU;
use IU::Log;
use IU::AccountStatusRequest;

use IW::App;
use IW::SrchForm::StickyNote;
use IW::SrchForm::SrchTypeWidget;
use IW::SrchForm::AccountStatusWidget;
use IW::Util qw(:url :output);

use IW::SrchForm::AbstractWidgetBox;
@ISA = qw(IW::SrchForm::AbstractWidgetBox);

# Globals

#------------------------------------------------------------
# widgets
#------------------------------------------------------------
# Return array of widgets for the requested search type:
# Note if no type is specified then array all widgets
# used in widget box is returned.

sub widgets {

   my $self = shift;
   my @widgets = ('AccountStatusWidget');
   return @widgets;
}

#---------------------------------------------------------------------
# update
#---------------------------------------------------------------------

sub update {

   my $self = shift;

   $self->{AccountStatusWidget}->update;

   # install query into the session.
   # Note that this should be the only install done in the search form.
   $self->install_query;
}


#---------------------------------------------------------------------
# draw
#---------------------------------------------------------------------

sub draw {

   my $self = shift;

   $APP->start_page(Title => 'Account Status Request Form',
                    Context    => 'accountstatform');

   $HTML -> HR;
   # Begin form, it has to have the multipart encoding stuff for the uploader.
   $HTML -> script_FORM(ACTION  => script_action().'#SCROLL');
   $HTML -> msubmit_flag;

   # Print message at top of page:
   $self->{StickyNote}->draw_top;
   $self->{AccountStatusWidget}->draw;

   # End the form
   $HTML -> _script_FORM;

   # End page
   $APP->end_page;
   1;
}


sub lookup_query {

   $QUERY = IU::AccountStatusRequest->lookup || IU::AccountStatusRequest->new;
   1;
}

sub install_query {$QUERY->install}

#---------------------------------------------------------------------
1;
