package IW::SrchForm::AirsWidgetBox;

=head1 NAME

IW::SrchForm::AirsWidgetBox - layout Airs search form and handle updates.

=head1 DESCRIPTION


=cut

use strict;
use vars qw(@ISA);

use IU;
use IU::Log;
use IU::Query;

use IW::App;
use IW::SrchForm::StickyNote;
use IW::SrchForm::SrchTypeWidget;
use IW::SrchForm::AirsLinksWidget;
use IW::SrchForm::AirsGeoWidget;
use IW::SrchForm::NodesWidget;
use IW::SrchForm::ButtonsWidget;
use IW::SrchForm::AirsButtonsWidget;
use IW::SrchForm::GranuleOptionsWidget;
use IW::Util qw(:url :output);

use IW::SrchForm::AbstractWidgetBox;
@ISA = qw(IW::SrchForm::AbstractWidgetBox);

# Globals

#------------------------------------------------------------
# widgets
#------------------------------------------------------------
# Return array of widgets for the requested search type:
# Note if no type is specified then array all widgets
# used in widget box is returned.

sub widgets {

   my $self = shift;
   my $srch_type = shift || 'ALL';

   # Which widgets are associated with the particular search type: 
   my %WIDGETS = ('INVENTORY_SEARCH'     => ['AirsLinksWidget',
                                             'AirsGeoWidget',
                                             'NodesWidget',
                                             'GranuleOptionsWidget',
                                             'AirsButtonsWidget'],
                  'ALL'                  => ['SrchTypeWidget',
                                             'AirsLinksWidget',
                                             'AirsGeoWidget',
                                             'NodesWidget',
                                             'GranuleOptionsWidget',
                                             'AirsButtonsWidget']);

   return @{$WIDGETS{$srch_type}};
}
#---------------------------------------------------------------------
1;
