package IW::SrchForm::GranIdWidget;

=head1 NAME

IW::SrchForm::GranIdWiget - layout granule ID widget and handle updates.

=head1 DESCRIPTION


=cut

use strict;

#use IU::Log;
use IU::Query;
use IW::App;
use IW::Util qw(:string);

use IW::SrchForm::AbstractWidget;
use vars qw(@ISA);
@ISA = qw(IW::SrchForm::AbstractWidget);

#---------------------------------------------------------------------
# name
#---------------------------------------------------------------------

sub name {

   return 'GranId';

}


#---------------------------------------------------------------------
# draw_widget
#---------------------------------------------------------------------

sub draw_widget {

   my $self = shift;

   # Set CGI tag with previous or default selection.
   $REQ->param('p.gids' => join("\n", $QUERY->granule_ids));

   # Start table
   $HTML -> TABLE(WIDTH=>'100%', CELLPADDING=>4,
               CELLSPACING=>1, CLASS=>'srchwidgethdr');
   # First row
   $HTML -> TR(VALIGN=>'TOP');
   $HTML -> TD(CLASS=>'srchwidgetbody', COLSPAN=>2,VALIGN=>'TOP');
   $HTML -> t_B("Enter one Data Granule ID per line:");
   $HTML -> e('nbsp');
   $HTML -> e('nbsp');
   $HTML -> e('nbsp');
   $HTML -> t("Some data centers allow wildcards (*).");
   $HTML -> BR;
   $HTML -> input_textarea(Name=>'p.gids',
                              Rows=>6,
                              Cols=>80);
   $HTML -> _TD;
   $HTML -> _TR;
   $HTML -> _TABLE;

1;
}

#---------------------------------------------------------------------
# update_widget
#---------------------------------------------------------------------

sub update_widget {

   my $self = shift;

   if ($REQ->param('p.gids'))  {

      my $text = $REQ->param('p.gids');
      my @gids = grep {$_ ne ''} (map {trim($_)} (split /\r\n+/, $text));
      $QUERY->granule_ids(\@gids);
   } 
1;
}

#---------------------------------------------------------------------
1;
