package IW::SrchForm::GuideTextWidget;

=head1 NAME

IW::SrchForm::GuideTextWidget - layout dependent valids widget and handle 
updates.

=head1 DESCRIPTION


=cut

use strict;

#use IU::Log;
use IU::Query;
use IW::Util qw(:url :string);
use IW::App;

use IW::SrchForm::AbstractWidget;
use vars qw(@ISA);
@ISA = qw(IW::SrchForm::AbstractWidget);

#---------------------------------------------------------------------
# name
#---------------------------------------------------------------------

sub name {

   return 'GuideTextWidget';

}

#---------------------------------------------------------------------
# draw_widget
#---------------------------------------------------------------------

sub draw_widget {

   my $self = shift;

   # Only draw widget if search type is guide search.
   return if ($QUERY->search_type ne 'GUIDE_SEARCH');

   # Set CGI from query:
   $REQ->param('p.text' => $QUERY->text_string);

   # Put some space between the widgets.
   $HTML->P;

   # Start table
   $HTML-> TABLE(WIDTH=>'100%', BORDER=>0, CELLPADDING=>4,
                 CELLSPACING=>1, CLASS=>'srchwidgethdr');

   # First row, title
   $HTML-> TR(VALIGN=>'TOP');
   $HTML-> TD;
   $HTML-> FONT(SIZE=>'+2');
   $HTML-> t_B("Type In Text");
   $HTML->_FONT;
   $HTML->_TD;
   $HTML->_TR;

   # Second row, directions
   $HTML-> TR(CLASS=>'srchwidgetbody')-> TD;
   $HTML-> t("Enter one or more words, phrases, or boolean expressions. ")
        -> t("See the ")->A(HREF=>help_url("guidesrchform"))
        -> t("help")->_A-> t(" for more information.");
   $HTML-> P;
   $HTML-> input_textarea(Name=>'p.text', Rows=>3, Cols=>60);
   $HTML->_TD ->_TR;

   $HTML->_TABLE;

1;
}

#---------------------------------------------------------------------
# update_widget
#---------------------------------------------------------------------

sub update_widget {

   my $self = shift;

   if ($REQ->param('p.text')) { 
      my $text = $REQ->param('p.text');
      $text =~ s/[\r\n]+/ /g;
      $text = trim($text);
      $QUERY->text_string(($text eq '') ? undef : $text);
   }
1;
}

#---------------------------------------------------------------------
1;
