package IW::SrchForm::LocalIdWidget;

=head1 NAME

IW::SrchForm::LocalIdWiget - layout local granule ID widget and handle 
updates.

=cut

use strict;

use IU::Query; # For $QUERY.
use IW::App; # For $HTML.
use IW::Util qw(:string); # For chmop function.

use IW::SrchForm::AbstractWidget;
use vars qw(@ISA);
@ISA = qw(IW::SrchForm::AbstractWidget);

#---------------------------------------------------------------------
# name
#---------------------------------------------------------------------

sub name {

   return 'LocalId';

}


#---------------------------------------------------------------------
# draw_widget
#---------------------------------------------------------------------

sub draw_widget {

   my $self = shift;


   # Set CGI tags with any previous or default selection.
   $REQ->param("p.Local Granule ID" => $QUERY->get_local_granule_id);

   # Begin table
   $HTML -> TABLE(WIDTH=>'100%', BORDER=>0, CELLPADDING=>4,
               CELLSPACING=>1, CLASS=>'srchwidgethdr');

   # First row 
   $HTML -> TR(VALIGN=>'TOP');
   # First column
   $HTML -> TD(CLASS=>'srchwidgetbody',COLSPAN=>2,VALIGN=>'TOP');
   $HTML -> t_B("Enter a single unique Local Granule ID: ");
   $HTML -> t("(80 characters maximum)");
   $HTML -> BR; 
   $HTML -> input_text(Name=>"p.Local Granule ID", Size=>65, Maxlength=>80);
   $HTML -> _TD;
   $HTML -> _TR;
   $HTML -> _TABLE; 

1;
}

#---------------------------------------------------------------------
# update_widget
#---------------------------------------------------------------------

sub update_widget {

   my $self = shift;

   if ($REQ->param('p.Local Granule ID')) {

      my $text = $REQ->param('p.Local Granule ID');
      # remove any end of line chars.
      chomp($text);
      $QUERY->set_local_granule_id($text);
   }
1;
}

#---------------------------------------------------------------------
1;
