package IW::SrchForm::NodesWidget;

=head1 NAME

IW::SrchForm::NodesWiget - layout Airs node widget and handle updates.

=head1 DESCRIPTION


=cut

use strict;

use IU::Log;
use IU::Granule;
use IU::Query;
use IW::App;
use IW::Util qw(:string);

use IW::SrchForm::AbstractWidget;
use vars qw(@ISA);
@ISA = qw(IW::SrchForm::AbstractWidget);

#---------------------------------------------------------------------
# name
#---------------------------------------------------------------------

sub name {

   return 'Nodes';

}


#---------------------------------------------------------------------
# draw_widget
#---------------------------------------------------------------------

sub draw_widget {

   my $self = shift;

   # Get stored info:
   my $gkey   = $SESSION->state->{IntBrowseGkey} || die "no gkey in state!";
   my $origin = $SESSION->state->{IntBrowseOrigin} || 'results';
   # Log into appropriate database:
   my $gdb = lc($origin);
   my $INVSTORE;
   eval {$INVSTORE = IU::InvStore->open($SESSION->path_to("$gdb.gdb"),
         'READER')    };
         $@ and return 0;

   # Get the granule:
   my @granules = $INVSTORE->granules([$gkey]);
   my $node = defined($granules[0]) ? $granules[0]->node_type : undef;
   # Put some space between the widgets.
   $HTML->P;

   # Start table
   $HTML -> TABLE(WIDTH=>'100%', BORDER=>0, CELLPADDING=>4,
               CELLSPACING=>1, CLASS=>'srchwidgethdr');
   # First row
   $HTML -> TR(VALIGN=>'TOP');
   $HTML -> TD;
   $self->print_section_title("Select your node type (not required)");
   $HTML ->_TD;
   $HTML ->_TR;
      
   # Second row
   $HTML -> TR->TD(CLASS=>'srchwidgetbody');
   if(lc($node) eq 'descending') {
      $HTML -> select_one(Name    => 'p.nodetype',
                          Choices => ['NotAscending', 'NotDescending',
                                      'Ascending', 'Descending',
                                      'NorthPole', 'SouthPole','All']);
   } else {
      $HTML -> select_one(Name    => 'p.nodetype',
                          Choices => ['NotDescending', 'NotAscending',
                                      'Ascending', 'Descending',
                                      'NorthPole', 'SouthPole','All']);
   }

   $HTML -> _TD;
   $HTML -> _TR;
   $HTML -> _TABLE;

1;
}

#---------------------------------------------------------------------
# update_widget
#---------------------------------------------------------------------

sub update_widget {

   my $self = shift;
  
   my $text = $REQ->param('p.nodetype');
   if(defined($text) && ($text)) {
      # remove any end of line chars.
      chomp($text);
      $QUERY->set_node_type($text);
   }
1;
}

#---------------------------------------------------------------------
1;
