package IW::SrchForm::SrchTypeToggleWidget;

=head1 NAME

IW::SrchForm::SrchTypeWidget - layout toggles for changing primary search type.

=head1 DESCRIPTION


=cut

use strict;

use IU; # For puke.
# use IU::Log;

use IW::App; # For $HTML.
use IW::Util qw(:url);

use IW::SrchForm::SrchTypeWidget;
use vars qw(@ISA);
@ISA = qw(IW::SrchForm::SrchTypeWidget);


#---------------------------------------------------------------------
# draw_widget
#---------------------------------------------------------------------

sub draw_widget { 
    my $self = shift;
    my $type = $self->type;

    # Link to toggle back to primary data search:
    if ($self->type eq 'INVENTORY_SEARCH' || 
        $self->type eq 'LOCAL_GRANULE_SEARCH' ||
        $self->type eq 'GRANULE_SEARCH') {

       my $num_columns = '3';

       $HTML->P;
       $HTML -> TABLE(WIDTH=>'100%', CELLPADDING=>4,
          CELLSPACING=>1, CLASS=>'srchwidgethdr');
       ###
       ### ROW 1...
       ###
       $HTML -> TR ->TD(WIDTH=>'100%', COLSPAN =>$num_columns);

       $self->print_section_title('Choose a Data Search Type');
       $HTML ->_TD->_TR;

       my @inv_types = ('INVENTORY_SEARCH',
                        'GRANULE_SEARCH',
                        'LOCAL_GRANULE_SEARCH');

       $self->print_toggle_buttons(\@inv_types,'3');

       $HTML ->_TABLE;
    }

}

#---------------------------------------------------------------------
# Override parent update
#---------------------------------------------------------------------
sub update { 1; }

#---------------------------------------------------------------------
1;
