package IW::Widget::CombinedShowGranuleId;

=head1 NAME

IW::Widget::CombinedShowGranuleId - widget on search form for selecting granule id

=head1 DESCRIPTION


IW::Widget::CombinedShowGranuleId - widget on search form for selecting granule id

=head1 DESCRIPTION
=cut

use IU;
use IU::Log;
use IU::Query;
use IU::Category;

use IW::App;
use IW::Util qw(:url);
use IW::Widget::CombinedWidget;
use IW::Widget::DepValids;

use HTML::Stream qw(:funcs);

use strict;


use vars qw(@ISA);

@ISA = qw(IW::Widget::CombinedWidget);


#------------------------------------------------------------
# new PARAMHASH
#------------------------------------------------------------
# I<Constructor.>  PARAMHASH can contain:
#
#     BGCOLOR    => background color of table cells (default is light grey)
#     Category   => the query category... mandatory!
#     Mode       => the main search-form mode to perform edit/delete with
#     OptionType => The default selection for toggle button


sub new {
    my ($class, %params) = @_;
    $params{Mode}    ||= 'NOMODE';
    $params{BGCOLOR} ||= '#D0D0D0';
    if($QUERY->search_type eq 'LOCAL_GRANULE_SEARCH') {
        $params{Category} ||= 'EXTENDED_SEARCH';
  
        
    }else{
        $params{Category} ||= 'GRANULE_ID_REQ';
       
    }
    bless \%params, $class;
}


#------------------------------------------------------------
# print PARAMHASH
#------------------------------------------------------------

sub print {
    my ($self, %params) = @_;

    # Set CGI from query:
    $self->set_CGI;  
   
    $HTML -> TABLE(WIDTH=>'100%', BORDER=>0, CELLPADDING=>4, 
      CELLSPACING=>1, BGCOLOR=>$self->{BGCOLOR});
    ###
    ### ROW1...
    ###
    $HTML -> TR(VALIGN=>'TOP');
 
    $HTML -> TD(ROWSPAN=>1, COLSPAN=>2,VALIGN=>'TOP');
    $HTML -> FONT(SIZE=>'4');
    if($QUERY->search_type eq 'LOCAL_GRANULE_SEARCH') {
        $HTML -> t_B("Enter a single unique Local Granule ID: ");
        $HTML -> t("(80 characters maximum)"); 
        $HTML -> _FONT;
        $HTML -> _TD;
        $HTML -> _TR;
        ###
        ### ROW2...
        ###
        $HTML -> TR->TD(COLSPAN=>2);
        $HTML -> input_text(Name=>"p.Local Granule ID", Size=>65, Maxlength => 80);

 }
    else {
       $HTML -> t_B("Enter one Data Granule ID per line:");
       $HTML -> _FONT;
       $HTML -> e('nbsp');
       $HTML -> e('nbsp');
       $HTML -> e('nbsp');
       $HTML -> t("Some data centers allow wildcards (*).");
       $HTML ->_TD->_TR;
       ###
       ### ROW2...
       ###
       $HTML -> TR->TD(COLSPAN=>2);      
       $HTML -> input_textarea(Name=>'p.gids',
                               Rows=>6,
                               Cols=>80);

    }
    $HTML -> _TD;
    $HTML -> _TR;

 
    $HTML -> _TABLE;    
 
}
#------------------------------------------------------------
# set_CGI
#------------------------------------------------------------
# Get any existing query values, and use them to fake our "input".
#
sub set_CGI {
    my $self = shift;
    if ($QUERY->search_type eq 'GRANULE_SEARCH') {
        $REQ->param('p.gids' => join("\n", $QUERY->granule_ids));
    }elsif ($QUERY->search_type eq 'LOCAL_GRANULE_SEARCH') {
       my $text;
       $text = $REQ->param("p.Local Granule ID");
       $REQ->param("p.Local Granule ID" => $QUERY->get_local_granule_id);         
       
    }
    1;
}


#------------------------------------------------------------
1;


