package IW::Widget::CombinedShowGuideText;

=head1 NAME

IW::Widget::CombinedShowGuideText - widget on search form for inputting guide text
=head1 DESCRIPTION


IW::Widget::CombinedShowGuideText- widget on search form for inputting guide text

=head1 DESCRIPTION
=cut

use IU;
use IU::Log;
use IU::Query;
use IU::Category;

use IW::App;
use IW::Util qw(:url);
use IW::Widget::CombinedWidget;
use IW::Widget::DepValids;

use HTML::Stream qw(:funcs);

use strict;


use vars qw(@ISA);

@ISA = qw(IW::Widget::CombinedWidget);


#------------------------------------------------------------
# new PARAMHASH
#------------------------------------------------------------
# I<Constructor.>  PARAMHASH can contain:
#
#     BGCOLOR    => background color of table cells (default is light grey)
#     Category   => the query category... mandatory!
#     Mode       => the main search-form mode to perform edit/delete with
#     OptionType => The default selection for toggle button


sub new {
    my ($class, %params) = @_;
    $params{Mode}    ||= 'NOMODE';
    $params{BGCOLOR} ||= '#D0D0D0';
    $params{Category} ||= 'GUIDE_SEARCH';
    bless \%params, $class;
}


#------------------------------------------------------------
# print PARAMHASH
#------------------------------------------------------------

sub print {
    my ($self, %params) = @_;

    # Set CGI from query:
    $self->set_CGI;  
    $HTML->P;
    $HTML -> TABLE(WIDTH=>'100%', BORDER=>0, CELLPADDING=>4, 
      CELLSPACING=>1, BGCOLOR=>$self->{BGCOLOR});
    ###
    ### ROW1... Header
    ###
    $HTML -> TR(VALIGN=>'TOP');

    $HTML -> TD(ROWSPAN=>1, COLSPAN=>2,VALIGN=>'TOP');
    $HTML -> FONT(SIZE=>'+2'); 
    $HTML -> t_B("Type in text:");
    $HTML -> _FONT;
    $HTML ->_TD->_TR;
    ###
    ### ROW2... Directions
    ###
    $HTML -> TR->TD(COLSPAN=>2);
    $HTML -> UL;
    $HTML -> LI;
    $HTML ->t("Enter one or more words, phrases, or boolean expresssions. ")
          ->t("See the ")->A(HREF=>help_url("guidesrchform"))
          ->t("help")->_A
          ->t(" for more information.");
    $HTML->_UL;
    $HTML ->_TD->_TR;
    ###
    ### ROW3...Text area
    ###
    $HTML -> TR->TD(COLSPAN=>2);
    $HTML -> input_textarea(Name=>'p.text',
                            Rows=>3,
                            Cols=>60);      
    
    $HTML -> _TD;
    $HTML -> _TR;

 
    $HTML -> _TABLE;    
 
}
#------------------------------------------------------------
# set_CGI
#------------------------------------------------------------
# Get any existing query values, and use them to fake our "input".
#
sub set_CGI {
    my $self = shift;
    $REQ->param('p.text' => $QUERY->text_string);
    1;
}
#------------------------------------------------------------
1;


