package IW::Widget::QueryUpload;

=head1 NAME

IW::Widget::QueryUpload - widget for query upload/download

=head1 INSTANCE VARIABLES

    Mode => mode that "submit" should return to 

=cut

use IU::Query;
use IW::App;
use IW::Util qw(:url);

use strict;

#------------------------------------------------------------
# new
#------------------------------------------------------------
# I<Constructor.>

sub new {
    my ($class, %params) = @_;
    $params{Mode}     ||= 'NOMODE';
    bless \%params, $class;
}

#------------------------------------------------------------
# print
#------------------------------------------------------------
# I<Instance method.>
# Realize the widget.

sub print {
    my $self = shift;

    $HTML -> msubmit_flag;
    $HTML -> TABLE(CELLPADDING=>1, CELLSPACING=>1);

    # Upload query:
    $HTML -> TR;
    $HTML -> TD(NOWRAP=>undef);
    $HTML -> msubmit_button(CAPTION => 'RESTORE search criteria',
                            QUERY   => ['mode'    => $self->{Mode},
					'submode' => 'UPLOAD']);
    $HTML -> _TD;
    $HTML -> TD;
    $HTML -> INPUT(TYPE=>'file',
		   NAME=>'userfile',
		   VALUE=>($REQ->param('userfile')||''),
		   SIZE=>35);
    $HTML -> _TD; 
    $HTML -> TR;

    # Separator:
#    $HTML -> TR 
#	  -> TD(COLSPAN=>2) -> HR(ALIGN=>'CENTER', WIDTH=>'50%') -> _TD 
#	  -> _TR;	

    # Download query (if there is one):
    if ($QUERY) {             # There's a query to download...

	# Subform:
	$HTML -> TR;  
	$HTML -> TD;
	$HTML -> msubmit_button(CAPTION => 'SAVE search criteria',
				QUERY   => ['mode'    => $self->{Mode},
					    'submode' => 'READINPUT',
					    'nextsubmode' => 'DOWNLOAD']);
	$HTML -> _TD;
    }
    else {                    # No query to download!
	$HTML -> TR;
	$HTML -> TD(COLSPAN=>2) -> small;
	$HTML -> t("When you have a valid query above, you will be able to ",
		   "save it using a button right here.");
	$HTML -> _small -> _TD;
    }
    $HTML -> _TR;

    # End form:
    $HTML -> _TABLE;
    $HTML -> hidden('bogus' => 'This field fixes a CGI::BasePlus bug');
}

#------------------------------------------------------------
1;
