package IW::Widget::QuickSearch;

=head1 NAME

IW::Widget::QuickSearch - widget for freetext search

=head1 INSTANCE VARIABLES

    Mode    => mode that "submit" should return to 
    Submode => submode that "submit" should return to 

=cut

use IU::Query;
use IW::App;
use IW::Util qw(:url);

use strict;

#------------------------------------------------------------
# new
#------------------------------------------------------------
# I<Constructor.>

sub new {
    my ($class, %params) = @_;
    $params{Mode}     ||= 'SSRCHFORM';
    $params{Submode}  ||= 'FREETEXT';
    bless \%params, $class;
}

#------------------------------------------------------------
# print
#------------------------------------------------------------
# I<Instance method.>
# Realize the widget.

sub print {
   my $self = shift;
   my $light_grey = "#EEEEEE";
   my $dark_grey = "#D0D0D0";
   my $gray_blue = "#708090";
   my $light_yellow = "#FFFFC0";

   my $OR_IT  = "Match ANY";
   my $AND_IT = "Match ALL";
   my $EXACT  = "Match EXACTLY";

  
   $HTML -> msubmit_flag;
  
   #------------------------------------------------------
   # IMPORTANT: Must include hidden fields for the input
   # field submit, this way the enter key from the input
   # field works the same way as the GO button.
   #------------------------------------------------------
#   $HTML -> hidden('mode'=>$self->{Mode}, 'submode'=>$self->{Submode}); 
   $HTML -> TABLE(BORDER=>0, CELLPADDING=>1, CELLSPACING=>0, 
            BGCOLOR=>$dark_grey);

   $HTML -> TR -> TD -> CENTER;
   $HTML -> t_B("Method 1:");
   $HTML -> BR;
   $HTML -> t_B("Data Set Lookup");
   $HTML -> _FONT -> _CENTER ->  _TD -> _TR;

   $HTML -> TR -> TD;
   $HTML -> TABLE(BORDER=>0, CELLPADDING=>0, CELLSPACING=>0,
                   BGCOLOR=>$dark_grey);
   $HTML -> TR -> TD -> CENTER;
   $HTML -> input_text(Name=>"p.quick_pattern", Size=>15);
   $HTML -> BR;

   # Pull down menu for query option, match ANY, ALL, or EXACT
   $HTML -> FONT(SIZE=>'-1');
   $HTML -> select_one(Name    => 'p.option',
                       Choices => [$OR_IT,
                                   $AND_IT,
                                   $EXACT]);
   $HTML -> _FONT ->BR;
   $HTML -> hypertext('Hint', help_url('dsetlookup'));
   $HTML -> t(" ");
   $HTML -> B -> FONT(COLOR=>"blue",SIZE=>"+1")

         -> msubmit_button(QUERY   => ['mode'    => $self->{Mode},
                                       'submode' => 'READINPUT',
                                       'p.srchmethod-next' => 'METHOD1',
                                       'nextsubmode' => $self->{Submode}],
                           CAPTION => "GO")
         -> _FONT -> _B;
   $HTML -> _CENTER;
   $HTML -> _TD -> _TR -> _TABLE;
   $HTML -> _TD -> _TR;

   $HTML -> _TABLE;
}

#------------------------------------------------------------

1;
