
package IW::Widget::URLTable;

=head1 NAME

IW::Widget::URLTable - table of URL links 

=cut

use IW::App;
use IW::Util (qw(:url));
use strict;


#------------------------------------------------------------
# new
#------------------------------------------------------------
sub new {
    my $self = bless {List=>[]}, shift;
    $self->add(shift, shift) while (@_);
    $self->{Header} = 0;
    $self;
}

#------------------------------------------------------------
# add HEADER, \@FURLS
#------------------------------------------------------------
sub add {
    my ($self, $head, $furls) = @_;
    push @{$self->{List}}, [$head,  $furls||[]];
}

#------------------------------------------------------------
# num_URLs
#------------------------------------------------------------
# Count the total number of URLs.
#
sub num_URLs {
    my $self = shift;
    my $count = 0;
    foreach (@{$self->{List}}) { $count += scalar(@{$_->[1]}) }
    $count;
}


#------------------------------------------------------------
# print
#------------------------------------------------------------
# Output as HTML.
#
sub print {
    my $self = shift;

    $HTML -> TABLE(CELLPADDING=>5);
    if ($self->{Header}) {
	$HTML -> TR -> TD -> t_B("Link:") -> _TD 
###	            -> TD -> t_B("Type:") -> _TD 
	            -> TD -> t_B("Description:") -> _TD
              -> _TR;
    }
    my @list = @{$self->{List}}; 
    my $listent;
    foreach $listent (@list) {
	my ($head, $furls) = @$listent;

        # For each URL of this type in the dataset:
        my $furl;
        foreach $furl (@$furls) {
            $HTML -> TR(VALIGN=>'TOP');
            $HTML -> TD 
                  -> hypertext($head,
                               logged_url($furl->URL,'type'=>$furl->type),
                               TARGET=>'support')
	          -> _TD;
            $HTML -> TD -> t($furl->comment) -> _TD;
	    $HTML -> _TR;
        }
    }
    $HTML -> _TABLE;
}

#------------------------------------------------------------
#------------------------------------------------------------
# print_short
#------------------------------------------------------------
# Output as HTML.
#
sub print_short {
    my $self = shift;
    my @list = @{$self->{List}}; 
    my $listent;
    foreach $listent (@list) {
	my ($head, $furls) = @$listent;

        # For each URL of this type in the dataset:
        my $furl;
        my @furlarray = @$furls;
        $furl = $furlarray[0];
        $HTML->hypertext($head,
                         logged_url($furl->URL,'type'=>$furl->type),
                         TARGET=>'support');
        $HTML->BR;
    }
}

#------------------------------------------------------------
1;


