/******************************************************** 
BEGIN_PROLOG
NAME                EcUtAuthenticator.c
DESCRIPTION         Function to generate an encrypted
                    authenticator from an first name, last
                    name and password

END_PROLOG
******************************************************* */

#include <stdio.h>
#include "EcUtMakeECSAuth.h"

void EcUtMakeECSAuth(
    char*    userId,
    char*    password,
    char*    ecsAuth)
{
    int i;
    /* If any of the parameters are empty, return an empty string */
    if ((strlen((const char*) password) == 0) ||
        (strlen((const char*) userId) == 0) ||
        (password == 0) ||
        (userId == 0))
    {
        strcpy(ecsAuth, "");
    }
    else
    {
        MD_CTX        context;
        char           input[MAX_STR];
        unsigned char digest[MAX_STR];
        unsigned int  len;

        /* put the user id and the password in a string */
        strcpy (input, userId);
        strcat (input, password);

        len = strlen (input);

        /* perform md5 hash on the string */
        MDInit   (&context);
        MDUpdate (&context, (unsigned char*) input, len);
        MDFinal  (digest, &context);

        /* expand the digest from 16-byte unsigned to 32-byte signed chars */
        for (i = 0; i < 16; i++)
        {
            sprintf(&ecsAuth[2*i], "%02x", digest[i]);
        }
        ecsAuth[32] = '\0';
    }
}
