/**********************************************************************/
/* Module Name:     clientfuncs.c                                     */
/* System:          NASA Master Directory (STX)                       */
/* Author:                                                            */
/* Creation Date:                                                     */
/*--------------------------------------------------------------------*/
/* Description:                                                       */
/*                                                                    */
/*                                                                    */
/*--------------------------------------------------------------------*/
/* Imports:                                                           */
/*                                                                    */
/*                                                                    */
/*--------------------------------------------------------------------*/
/* Exports:         call_MDServer();                                  */
/*                                                                    */
/*--------------------------------------------------------------------*/
/* Special Comments:                                                  */
/*                                                                    */
/**********************************************************************/
#include <Gaea_config.h>
#include <stdio.h>
/* The following include was added for Solaris */
#include <string.h>
#include "inet.h" 

call_MDserver(address, portno)
char *address;
int portno;
{
 struct sockaddr_in serv_addr;
 int sock;
 struct hostent *hp;
 struct servent *sp;


   /* create IP-family socket on which to make connection */

   sock = socket(AF_INET, SOCK_STREAM, 0);
   if (sock < 0 ) {
      socket_perror("md_connect: socket creation");
#ifdef EOSDIS
      return(-1);
#else
      exit(-1);
#endif
   }

   /* 
      fill in sockaddr_in structure that describe the remote IP address
      we want to connect to.
   */

/* bzero changed to memset for Solaris */
   /* bzero((char *) &serv_addr, sizeof(serv_addr)); */
   memset((char *) &serv_addr, '\0', sizeof(serv_addr));
   serv_addr.sin_family = AF_INET;
   serv_addr.sin_addr.s_addr = inet_addr(address);     
   serv_addr.sin_port = htons(portno);

   if (connect(sock, &serv_addr, sizeof(serv_addr)) < 0) { 
       socket_perror("md_connect: can't connect to server!\n");
#ifdef EOSDIS
       return(-1);
#else
       exit(-1);
#endif
   }
   return(sock);
}
