#include <ctype.h>
#include <string.h>
#include "strutils.h"
#include "date.h"

#define MAXDATESTR 32

int yesterday(datein,dateout)
char *datein,*dateout;
{
   DATEINT daterec;
   char isodate[MAXDATESTR];
   float juldate;

   if(valid_date(datein,&daterec,isodate)){
      juldate = julian(&daterec);
      juldate = juldate - 1.0;
      jul_to_date(juldate,dateout);
      return(1);
   }
   else{
      dateout[0] = 0;
      return(0);
   }
}

int tomorrow(datein,dateout)
char *datein,*dateout;
{
   DATEINT daterec;
   char isodate[MAXDATESTR];
   float juldate;

   if(valid_date(datein,&daterec,isodate)){
      juldate = julian(&daterec);
      juldate = juldate + 1.0;
      jul_to_date(juldate,dateout);
      return(1);
   }
   else{
      dateout[0]=0;
      return(0);
   }
}

int wasweekend(datein)
char *datein;
{
   char targetday[MAXDATESTR],isodat[MAXDATESTR];
   DATEINT daterec;
   
   if(valid_date(datein,&daterec,isodat)){
       strcpy(targetday,day_of_week(&daterec));
       chgupper(targetday);
       if(strcmp(targetday,"MONDAY") ==  0)
          return(1);
       else
          return(0);
   }
   return(0);
}

int weekend(datein,daystart,dayend)
char *datein,*daystart,*dayend;
{
   DATEINT daterec;
   char isodate[MAXDATESTR];
   float juldate;

   if(valid_date(datein,&daterec,isodate)){
      juldate = julian(&daterec);
      juldate = juldate - 3.0;
      jul_to_date(juldate,daystart);
   }
   else{
      daystart[0]=0;
      dayend[0] = 0;
      return(0);
   }
   if(valid_date(datein,&daterec,isodate)){
      juldate = julian(&daterec);
      juldate = juldate - 1.0;
      jul_to_date(juldate,dayend);
      return(1);
   }
   else{
      daystart[0]=0;
      dayend[0]=0;
      return(0);
   }

}

