#include <string.h>
#include <stdlib.h>
#include "mddefs.h"
#include "mdcodes.h"
#include "strutils.h"

char *ParseFetch(fetchbuf,valuebuf,numslots,rowsize)
char *fetchbuf,*valuebuf;
int numslots,rowsize;
{
   char *sptr;
   static char tilda[2]="~",newline[2]="\n";
   char tmpbuf[DBLINESIZE];
   int i;

   if(isblank(fetchbuf))
      return(0);
   sptr = valuebuf;
   for(i = 0; i < numslots; i++){
      fetchbuf = ParseString(fetchbuf,sptr,tilda);
      StripLeadingBlanks(sptr);
      StripTrailingBlanks(sptr);
      sptr+=rowsize;
   }

   do{
      fetchbuf = ParseString(fetchbuf,tmpbuf,tilda);
   } while ( (strcmp(tmpbuf,newline) != 0) && (*fetchbuf != NULL) );

   return(fetchbuf);
}


int ParseQuery(querybuf,channel,sqlstmt,mode)
char *querybuf,*sqlstmt;
int *channel,*mode;
{
   char *sptr;
   static char delims[4]="~, ";
   char word[20];
   int status=MD_NORMAL;
   static int open_mode=(-1);

   if(isblank(querybuf))
      return(MD_QBFEMP);

   sqlstmt[0] = 0;
   *channel = -1;
   *mode = open_mode;

   if(strchr(querybuf,delims[0]) == NULL){
      strcpy(sqlstmt,querybuf);
   }
   else{
      sptr = ParseString(querybuf,word,delims);
      if(isnumber(word)){
         *channel = atoi(word);
         strcpy(sqlstmt,sptr);
      }
      else{
         strcpy(sqlstmt,querybuf);
      }
      ReplaceChar(delims[0],' ',sqlstmt); 
      if(isblank(sqlstmt))
        return(MD_QBFEMP);
   }

   switch(open_mode){
      case BATCH:
         *channel = 0;
         break;

      case INTERACTIVE:
         if(*channel == -1)
            status = MD_INVCHN;
         break;

      case  -1:
         if((FindString(sqlstmt,"open")) != NULL){
            if(FindString(sqlstmt,"interactive") != NULL){
               open_mode = INTERACTIVE;
               *mode = open_mode;
            }
            else{
               open_mode = BATCH;
               *mode = open_mode;
            }
            *channel = 0;
         }
         else{
            status = MD_NODATABASE;
         }

   } /* End Switch on open_mode */

   return(status);
}
