 /* $RCSfile: IC_Commun.h,v $
 *
 * this file define the function prototypes for common level of the
 * communication status
 *
 */

/*----------------------------------------------------
 | $Log: IC_Commun.h,v $
 | Revision 1.7  1997/10/20 17:24:15  solomon
 | Updated to GUI IK layer 7_0_0_13.
 |
 * Revision 7.0  1997/04/11  17:53:37  ims
 * 6.1.1.3 Promoted to 7.0 J. Katen
 *
 * Revision 6.1.1.3  1997/04/07  19:25:19  winter
 * SMR 3999 - The Receiving Data light now comes on between receipt of a
 * directory result message and the contact to the GCMD.
 *
 * Revision 6.1.1.2  1997/02/21  19:54:51  winter
 * SMR 3862: Cleaned up, added code to prevent multiple inclusion. Changed
 * prototype for IC_GetStatus() to use IK_EventCode.
 *
 * Revision 6.1.1.1  1997/02/21  18:02:06  winter
 * Placeholder for new branch during work on Task Manager tuning.
 *
 * Revision 6.1  1996/10/18  14:15:28  ims
 * Promoted for 6.1 J. Katen
 *
 * Revision 6.0  1996/02/29  13:57:17  ims
 * COPIED FROM 5.1 FOR GUI_PROMO_6_0_960229.
 *
 * Revision 5.1  1995/12/28  19:27:55  ims
 * COPIED FROM 5.0 FOR GUI_PROMO_5_1_951228.
 *
 * Revision 5.0  1995/11/06  13:03:07  ims
 * PROMOTION FROM GUI_4_5_8_951030 FOR GUI_PROMO_5_0_951106
 *
 * Revision 4.5  1995/07/27  18:43:29  ims
 * PROMOTION FROM GUI_4_4_8_950501 FOR GUI_PROMO_4_5_950726
 *
 * Revision 4.4  1995/02/13  22:21:36  ims
 * PROMOTION FROM GUI_4_4_950106 FOR GUI_PROMO_4_4_950213
 *
 * Revision 4.3  1994/08/26  10:48:33  ims
 * COPIED FROM GUI_4_3_940824.
 *
 * Revision 4.0  1994/06/08  15:37:15  ims
 * PROMOTION FROM REV4
 *
 * Revision 3.0  1994/01/25  20:11:03  ims
 * ALPHA-1
 *
 | Revision 1.3  1993/09/03  18:37:04  heather
 | added routine IC_GetCommunicationComment to header
 |
 | Revision 1.2  1993/04/22  13:44:47  heather
 | 04/05/93
 |
 | Added:
 |  #include "IK_Nm.h"
 |  analysis: contains constant definition, IK_SEARCH_TYPE,
 |            needed for IC_GetStatus(), called by IX_brstats.c
 |
 | Added the following ANSI C prototypes:
 |  extern int IC_GetDaacCount(char *val1);
 |  extern void IC_GetStatus(int, char *val1);
 |  extern void IC_GetSearch(IK_SEARCH_TYPE val1, char *val2);
 |
 | Revision 1.1  1993/01/11  16:33:44  heather
 | Initial revision
 | 
 -----------------------------------------------------*/

#ifndef __IC_COMMUN_H__
#define __IC_COMMUN_H__

#include "IK_Nm.h"

extern int IC_GetDaacCount(char *val1);
extern int IC_GetStatus(IK_SEARCH_TYPE searchType, IK_EventCode eventCode);
extern void IC_GetSearch(IK_SEARCH_TYPE val1, char *val2);
extern void IC_GetCommunicationComment(int, char *);

#endif /* ! __IC_COMMUN_H__ */
