#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <sys/types.h>

#include "IK_BridgeExt.h"
#include "IK_Granule.h"

static struct gr_tree_struct
{
   char key[IK_GRANULE_KEY_SZ];
   struct gr_tree_struct *left;
   struct gr_tree_struct *right;
} *gr_tree;
   
void IK_bridge_tree_init(void)
{
   gr_tree = (struct gr_tree_struct *)0;
}

int IK_bridge_already_found(IK_SortKey *gr_key)
{
   struct gr_tree_struct *node;
   struct gr_tree_struct *prev;

   node = gr_tree;
   while (node)
    {
       prev = node;

       if (memcmp(node->key, gr_key->key, IK_GRANULE_KEY_SZ) == 0)
	   return (1);
       
       if (memcmp(node->key, gr_key->key, IK_GRANULE_KEY_SZ) < 0)
	   node = node->right;
       else
	   node = node->left;
    }

   node = (struct gr_tree_struct *)malloc(sizeof(struct gr_tree_struct));
   memcpy (node->key, gr_key->key, IK_GRANULE_KEY_SZ);
   node->left   = (struct gr_tree_struct *)0;
   node->right  = (struct gr_tree_struct *)0;

   if (!gr_tree)
    {
       gr_tree = node;
    }
   else
    {
       if (memcmp(prev->key, gr_key->key, IK_GRANULE_KEY_SZ) < 0)
	{
	   prev->right = node;
	}
       else
	{
	   prev->left = node;
	}
    }

   return (0);
}

static void IK_bridge_rec_tree_free(struct gr_tree_struct *tree)
{
   if (!tree)
       return;

   IK_bridge_rec_tree_free(tree->left);
   IK_bridge_rec_tree_free(tree->right);

   free(tree);
}

void IK_bridge_tree_free(void)
{
   IK_bridge_rec_tree_free(gr_tree);
   gr_tree = 0;
}


