/* File: $RCSfile: IK_Comment.c,v $
 * 
 * Synopsis: This file contains the function which support comments of JAM
 * screen.
 * 
 * Notes: */
/*----------------------------------------------------------------------
 | $Log: IK_Comment.c,v $
 | Revision 1.6  1997/03/06 15:38:52  amrhein
 | Updated to GUI's 6_1_12 IK
 |
 * Revision 6.1.1.1  1996/10/21  14:13:57  winter
 * Copied from 6.0.1.2 after 6.1 promotion.
 *
 * Revision 6.0.1.2  1996/10/01  18:53:32  winter
 * Removed GUI_CLIENT-conditional code.
 *
 * Revision 6.0.1.1  1996/10/01  18:52:24  winter
 * Placeholder for new branch during comm s/w overhaul.
 *
 * Revision 6.0  1996/02/29  15:36:33  ims
 * COPIED FROM 5.1 FOR GUI_PROMO_6_0_960229.
 *
 * Revision 5.1  1995/12/28  19:48:28  ims
 * COPIED FROM 5.0 FOR GUI_PROMO_5_1_951228.
 *
 * Revision 5.0  1995/11/06  13:03:26  ims
 * PROMOTION FROM GUI_4_5_8_951030 FOR GUI_PROMO_5_0_951106
 *
 * Revision 4.5  1995/07/27  18:41:49  ims
 * PROMOTION FROM GUI_4_4_8_950501 FOR GUI_PROMO_4_5_950726
 *
 * Revision 4.4.1.2  1995/02/13  22:32:45  ims
 * COPIED FROM 4.3.1.2 FOR GUI_PROMO_4_4_950213
 *
 * Revision 4.3.1.2  1994/08/26  11:33:49  ims
 * COPIED FROM REVISION 4.0.1.2.
 *
 * Revision 4.0.1.2  1994/08/16  20:00:06  erabelli
 * In the beginning of function IK_GetComments(..), IK_ImsErrno is set to 0.
 *
 * Revision 4.0.1.1  1994/07/08  11:58:16  winter
 * Added #include "IK_Ims.h" and #include <string.h>.
 *
 * Revision 4.0  1994/06/08  14:22:36  ims
 * PROMOTION FROM REV4
 *
 * Revision 3.1.1.5  1994/06/02  13:56:24  heather
 * change Client_Version to REVNAME in call to IK_SysConfig
 *
 * Revision 3.1.1.4  1994/06/01  23:42:20  heather
 * modify IK_PutComments to put the version and what client is running in the
 * file that gets sent to the USO
 *
 * Revision 3.1.1.3  1994/05/31  13:24:23  heather
 * added modifies for fix send comments
 *
 * Revision 3.1.1.2  1994/05/12  14:13:34  kerbel
 * Put comment.odl and comment.log files in GaeaTmp directory instead of
 * UserData directory
 * This is part of overhaul to move all transient files to GaeaTmp
 *
 * Revision 3.1.1.1  1994/05/09  18:28:25  kerbel
 * This is the place holder revision that starts the branch
 *
 * Revision 3.1  1994/04/05  09:49:52  ims
 * Promotion from MAR28_RELEASE
 *
 * Revision 3.0.1.1  1994/01/21  20:48:51  ryan
 * phase 1 cleanup
 *
 * Revision 3.0  1993/12/29  15:18:49  winter
 * ALPHA-1
 *
 | Revision 1.1  1993/04/21  16:40:20  lee
 | Initial revision
 |
 +---------------------------------------------------------------------*/


static const char *rcsid = "$Id: IK_Comment.c,v 1.6 1997/03/06 15:38:52 amrhein Exp $";

#include "IK_Ims.h"

/* C lib */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* ODL lib */
#include "odldef.h"
#include "odlinter.h"

/* IMS lib */
#include "IK_Syslog.h"
#include "IK_Errno.h"
#include "IK_Ims.h"
#include "IK_Msg.h"
#include "IK_Profi.h"
#include "IK_Comment.h"

static  AGGREGATE  comment = NULL;


/*
 * Name:
 *   IK_PutComments
 * 
 * Description:
 *   This function store comments in the disk file
 *
 * Parameters:
 *   int nline
 *   char *buffers[]
 *
 * Return Values:
 *   type: int
 *	Return: upon success,0. On failure, -1.
 * 
 * Warnings:
 *
 * Global Variables Used:
 *
 * Pre- and Post-Conditions
 *
 *   Precondition 1:
 *     A given comments exist.
 *   Postcondition 1:
 *     Store comments in the file. RETURN (0) as value of the function.
 *   Precondition 2:
 *     Insufficient resources to store comments in the file.
 *   Postcondition 2:
 *     return(-1) and LOG to Syslog().
 * 
 * Revision History:
 *
 *
 * 
 * 
 * 
 */

int             IK_PutComments(
   int nline,
   char *buffers[]
)
{

   FILE           *commentfile;
   FILE           *fp;
   int             n,i,j=0;
   PARAMETER       parameter,
                   comparameter;
   VALUE_DATA      value_data;
   VALUE           value;
   char            *context;
   char            line[82];
   char           client[5]="GUI";

   IK_MakeCommentTree();
   commentfile = fopen(strcat(IK_SysConfig("GaeaTmp"), "comment.odl"), "w+");
   fp = fopen(strcat(IK_SysConfig("GaeaTmp"), "comment.log"), "w+");
   if (commentfile != NULL && fp != NULL) {
       /* if it has comments text then write to odl tree, otherwise skip */
       if (nline >= 0) {

	  IK_GetProfileValues(IC_REQUEST, "REQUEST", "FIRST_NAME", &context);
	  comparameter = FindParameter(comment, "FIRST_NAME");
	  value = FirstValue(comparameter);
	  RemoveValue(value);
	  value_data = ODLConvertString(context, strlen(context));
	  fprintf(fp,"\nComments from %s ",context);
          free(context);
	  if (NewValue(comparameter, &value_data) == NULL) {
	      IK_ImsErrno = IK_ENOMEM;
	      IK_Syslog(LOG_ERR, "Unable to create ODL email value");
	  }
	  IK_GetProfileValues(IC_REQUEST, "REQUEST", "LAST_NAME", &context);
	  comparameter = FindParameter(comment, "LAST_NAME");
	  value = FirstValue(comparameter);
	  RemoveValue(value);
	  value_data = ODLConvertString(context, strlen(context));
	  fprintf(fp,"%s\n",context);
          free(context);
	  if (NewValue(comparameter, &value_data) == NULL) {
	      IK_ImsErrno = IK_ENOMEM;
	      IK_Syslog(LOG_ERR, "Unable to create ODL email value");
	  }
	  IK_GetProfileValues(IC_REQUEST, "REQUEST", "PHONE", &context);
	  comparameter = FindParameter(comment, "PHONE");
	  value = FirstValue(comparameter);
	  RemoveValue(value);
	  value_data = ODLConvertString(context, strlen(context));
	  fprintf(fp,"Phone number is %s\n",context);
          free(context);
	  if (NewValue(comparameter, &value_data) == NULL) {
	      IK_ImsErrno = IK_ENOMEM;
	      IK_Syslog(LOG_ERR, "Unable to create ODL email value");
	  }
	  IK_GetProfileValues(IC_REQUEST, "REQUEST", "EMAIL", &context);
	  comparameter = FindParameter(comment, "EMAIL");
	  value = FirstValue(comparameter);
	  RemoveValue(value);
	  value_data = ODLConvertString(context, strlen(context));
	  fprintf(fp,"Email is %s\n\n",context);
          free(context);
          fprintf(fp,"These comments are from the %s version %s client\n\n",
		  client,IK_SysConfig("REVNAME"));
	  if (NewValue(comparameter, &value_data) == NULL) {
	      IK_ImsErrno = IK_ENOMEM;
	      IK_Syslog(LOG_ERR, "Unable to create ODL email value");
	  } else{
	      comparameter = FindParameter(comment, "TEXT");
	      RemoveParameter(comparameter);

	      parameter = NewParameter(comment, KP_ATTRIBUTE, "TEXT");
	      if (parameter == NULL) {
		  IK_ImsErrno = IK_ENOMEM;
		  IK_Syslog(LOG_ERR, "Unable to create ODL TEXT Parameter");
	       } else{
		  parameter->value_kind = KV_SEQUENCE;
                  /* store comments to odl tree */
		  for (n = 0; n <= nline; n++) {
                      context = malloc(strlen(buffers[n])+1);
		      strcpy(context, buffers[n]);
		      comparameter = FindParameter(comment, "TEXT");
		      value_data = ODLConvertString(context, strlen(context));

		      if (NewValue(comparameter, &value_data) == NULL) {
			  IK_ImsErrno = IK_ENOMEM;
			  IK_Syslog(LOG_ERR, "Unable to create new ODL value");
		      } else {
			  comparameter->rows = 1;
			  comparameter->columns = comparameter->value_count;
		      }
                      i = 1;
/*                      while(j < strlen(buffers[0])){
                        line[0] = buffers[0][j];
                        if (line[0] != '\n' && line[0] != '\t'){
                          if (isprint(line[0]))
		              fprintf(fp,"%c",line[0]);
		        }
                        else
                          fprintf(fp,"%c",line[0]);
                        j++;
                        if (i >79){
                          fprintf(fp,"\n");
                          i = 0;
		        }
                        i++;
		      }*/
                      fprintf(fp,"%s\n",context);
                      free(context);
		   }
		   /* write odl tree only has comments text */
                   fclose(fp);
		   WriteLabel(commentfile, comment);

		   }
		}

	    }
            fclose(commentfile);
	} else{
	      IK_ImsErrno = IK_EBADF;
	      IK_Syslog(LOG_ERR, "Unable to open comment file");
	}

	return IK_ImsErrno ?-1:0;
}



/*
 * Name:
 *   IK_GetComments
 * 
 * Description:
 *   This function gets comments from the disk file
 *
 * Parameters:
 *   int  *nline
 *   char *buffers[]
 *
 * Return Values:
 *   type: int
 *     Return: upon success, 0. On failure, -1.
 * 
 * Warnings:
 *
 * Global Variables Used:
 *
 * Pre- and Post-Conditions
 *   Precondition 1:
 *     A given comments file exists.
 *   Postcondition 1:
 *     Return(0) and comments.
 *   Precondition 2:
 *     Insufficient memory to operation needed.
 *   Postcondition 2:
 *     RETURN(-1) and LOG to Syslog().
 *
 * Revision History:
 *
 * 
 * 
 * 
 * 
 */

int             IK_GetComments(
    int  *nline,
    char *buffers[]
)
{
    FILE           *commentfile;
    PARAMETER       parameter;
    AGGREGATE       aggregate;
    VALUE           value;
    int             i = 0,
                    status = 0;
    char            tempbuffer[20];

    IK_ImsErrno = 0;

    commentfile = fopen(strcat(IK_SysConfig("GaeaTmp"), "comment.odl"), "r");
    if (commentfile && fread(tempbuffer, sizeof(char), 10, commentfile)) {
        rewind(commentfile);
	comment = NewAggregate(NULL, KA_GROUP, "ROOT", NULL);
	if (comment) {
	   if (ReadLabel(commentfile, comment)) {
	      parameter = FindParameter(comment, "TEXT");
	      if (parameter != NULL) {
	         value = FirstValue(parameter);
	         if (value) {
                    /* get comments from odl tree */
		    do {
                        buffers[i] =malloc(strlen(value->item.value.string)+1);
		        strcpy(buffers[i++],value->item.value.string);
		        value = NextValue(value);

		     } while (value != NULL);
                                
	          }else{
	              IK_ImsErrno = IK_ENOMEM;
	              IK_Syslog(LOG_ERR, "Unable to create value");
		   }
                }else{
	              IK_ImsErrno = IK_ENOMEM;
	              IK_Syslog(LOG_ERR, "Unable to create parameter");
		}
	   }
	}
     }

     /* pass back the number of comment lines */
     *nline = --i;

     fclose(commentfile);
        
     return IK_ImsErrno?-1:0;
 }

/*
 * Name:
 *   IK_MakeCommentTree
 * 
 * Description:
 *   This function creates a comment tree.
 *
 * Parameters:
 *   none
 * 
 * Return Values:
 *   type: int
 *	Return: upon success, 0. On failure, -1.
 *
 * Warnings:
 *
 * Global Variables Used:
 *
 * Pre- and Post-Conditions
 *   Precondition 1:
 *     A sufficient memory.
 *   Postcondition 1:
 *     Return(0) and comments tree.
 *   Precondition 2:
 *     Insufficient memory to operation needed.
 *   Postcondition 2:
 *     RETURN(-1) and LOG to Syslog().
 *
 * Revision History:
 *
 * 
 * 
 * 
 * 
 */
int             IK_MakeCommentTree(
    void			/* no argument */
)
{
    PARAMETER       parameter;

    comment = NewAggregate(NULL, KA_GROUP, "ROOT", NULL);
    if (comment){
	parameter = NewParameter(comment, KP_ATTRIBUTE, "EMAIL");
	if (parameter) {
	    parameter->value_kind = KV_SCALAR;

	    parameter = NewParameter(comment, KP_ATTRIBUTE, "TEXT");
	    if (parameter)
	      parameter->value_kind = KV_SEQUENCE;
	    else{
		IK_ImsErrno = IK_ENOMEM;
		IK_Syslog(LOG_ERR, "Unable to create ODL text Parameter");
	    }
	    parameter = NewParameter(comment, KP_ATTRIBUTE, "FIRST_NAME");
	    if (parameter)
	      parameter->value_kind = KV_SCALAR;
	    else{
		IK_ImsErrno = IK_ENOMEM;
		IK_Syslog(LOG_ERR,
			  "Unable to create ODL first name Parameter");
	    }
	    parameter = NewParameter(comment, KP_ATTRIBUTE, "LAST_NAME");
	    if (parameter) 
	      parameter->value_kind = KV_SCALAR;
	    else{
		IK_ImsErrno = IK_ENOMEM;
		IK_Syslog(LOG_ERR, "Unable to create ODL last name Parameter");
	    }
	    parameter = NewParameter(comment, KP_ATTRIBUTE, "PHONE");
	    if (parameter) 
	      parameter->value_kind = KV_SCALAR;
	    else{
		IK_ImsErrno = IK_ENOMEM;
		IK_Syslog(LOG_ERR, "Unable to create ODL phone Parameter");
	    }

	}else{
	    IK_ImsErrno = IK_ENOMEM;
	    IK_Syslog(LOG_ERR, "Unable to create ODL email Parameter");
	}
    }else{
	IK_ImsErrno = IK_ENOMEM;
	IK_Syslog(LOG_ERR, "Unable to create ODL root");
    }

    return IK_ImsErrno?-1:0;
}

/*--- QED ---*/

