/*
 * File: IK_DatastP.h
 *
 * Description: This file contains data structures and manifest
 * constants for the private dataset structure, IK_DatasetP, as well
 * as function prototypes.
 *
 * Notes:
 *
 *-------------------------------------------------------------------------
 *
 * RCS information:
 *
 * $RCSfile: IK_DatastP.h,v $
 *
 * $Id: IK_DatastP.h,v 1.6 1997/03/06 15:38:52 amrhein Exp $
 *
 * $Log: IK_DatastP.h,v $
 * Revision 1.6  1997/03/06 15:38:52  amrhein
 * Updated to GUI's 6_1_12 IK
 *
 * Revision 6.1  1996/10/18  14:15:50  ims
 * Promoted for 6.1 J. Katen
 *
 * Revision 6.0  1996/02/29  15:37:16  ims
 * COPIED FROM 5.1 FOR GUI_PROMO_6_0_960229.
 *
 * Revision 5.1  1995/12/28  20:15:13  ims
 * COPIED FROM 5.0 FOR GUI_PROMO_5_1_951228.
 *
 * Revision 5.0  1995/11/06  13:03:31  ims
 * PROMOTION FROM GUI_4_5_8_951030 FOR GUI_PROMO_5_0_951106
 *
 * Revision 4.5  1995/07/27  18:41:58  ims
 * PROMOTION FROM GUI_4_4_8_950501 FOR GUI_PROMO_4_5_950726
 *
 * Revision 4.4.1.1  1995/02/13  22:34:23  ims
 * COPIED FROM 4.3.1.1 FOR GUI_PROMO_4_4_950213
 *
 * Revision 4.3.1.1  1994/08/26  11:43:20  ims
 * COPIED FROM REVISION 4.0.1.1.
 *
 * Revision 4.0.1.1  1994/06/08  16:57:38  ims
 * COPIED FROM REVISION 3.1.1.1.
 *
 * Revision 3.1.1.1  1994/04/18  12:55:47  winter
 * Extensive code cleanup by Eric Winter.
 *
 * Revision 3.1  1994/04/05  09:49:52  ims
 * Promotion from MAR28_RELEASE
 *
 * Revision 3.0  1993/12/29  15:18:49  winter
 * ALPHA-1
 *
 * Revision 1.1  1993/01/06  19:24:07  honce
 * Initial revision
 *
*/

/*****************************************************************************/

#ifndef __IK_DATASTP_H__
#define __IK_DATASTP_H__

/*****************************************************************************/

/* #include directives */

/* IMS headers */
#include "IK_Dataset.h"

/*****************************************************************************/

/* Define the private dataset structure. This structure is defined to
   increase the efficiency of memory reallocation when working with
   IK_Dataset structures. */

struct IK_DatasetP {

  /* dataset is the public-accessible data structure. */
  IK_Dataset dataset;

  /* nbytes is the sizeof(IK_Dataset) + data. */
  unsigned long nbytes;

  /* The aligned data starts here. */
  void *aligned_data;

};
typedef struct IK_DatasetP IK_DatasetP;

/*****************************************************************************/

#endif   /* !__IK_DATASTP_H__ */
