/* File: $RCSfile: IK_DepValInt.c,v $
 * 
 * Synopsis:
 *  this file conatains the functions that are internal to this
 * implimentation of dependant valids
 * 
 * Notes: */

/*--------------------------------------------------
 | $Log: IK_DepValInt.c,v $
 | Revision 1.6  1997/03/06 15:38:52  amrhein
 | Updated to GUI's 6_1_12 IK
 |
 * Revision 6.1.1.1  1996/10/21  14:17:51  winter
 * Copied from 6.0.1.4 after 6.1 promotion.
 *
 * Revision 6.0.1.4  1996/10/01  19:13:21  winter
 * Made !NDEBUG-conditional code mandatory.
 *
 * Revision 6.0.1.3  1996/09/27  12:45:43  winter
 * Fixed some casting errors in calls to gdbm functions caused when gdbm.h
 * was modified to use prototypes.
 *
 * Revision 6.0.1.2  1996/09/25  18:33:45  winter
 * Added #include <string.h> for string function prototypes.
 *
 * Revision 6.0.1.1  1996/09/25  18:32:15  winter
 * Placeholder for new branch during comm s/w overhaul.
 *
 * Revision 6.0  1996/02/29  15:37:23  ims
 * COPIED FROM 5.1 FOR GUI_PROMO_6_0_960229.
 *
 * Revision 5.1  1995/12/28  19:53:58  ims
 * COPIED FROM 5.0 FOR GUI_PROMO_5_1_951228.
 *
 * Revision 5.0  1995/11/06  13:03:32  ims
 * PROMOTION FROM GUI_4_5_8_951030 FOR GUI_PROMO_5_0_951106
 *
 * Revision 4.5  1995/07/27  18:41:59  ims
 * PROMOTION FROM GUI_4_4_8_950501 FOR GUI_PROMO_4_5_950726
 *
 * Revision 4.4.1.1  1995/02/13  22:34:31  ims
 * COPIED FROM 4.3.1.1 FOR GUI_PROMO_4_4_950213
 *
 * Revision 4.3.1.1  1994/08/26  11:44:11  ims
 * COPIED FROM REVISION 4.0.1.7.
 *
 * Revision 4.0.1.7  1994/07/25  19:17:49  winter
 * Changed prototype of return_table() to static, eliminating an IRIX 5
 * compiler warning.
 *
 * Revision 4.0.1.6  1994/07/18  15:13:53  kerbel
 * Fixed memory leak in fetchvalids() by releasing memory pointed to
 * by 'db_valids_key.dptr' pointer variable
 *
 * Revision 4.0.1.5  1994/06/30  13:22:04  hu
 * increase the size of reallocated memory so the union of the valids
 * won't go out of bound, this fix the core dump problem when all valids
 * were selected for Inventory search.
 *
 * Revision 4.0.1.3  1994/06/10  14:52:34  ryan
 * changed valids debug messages so that they are inside #ifdef XXDEBUG.
 *
 * Revision 4.0.1.2  1994/06/10  12:39:11  ryan
 * Greg Sylvain's fixes for dependent valids.
 *
 * Revision 4.0.1.1  1994/06/10  12:20:43  ryan
 * new branch
 *
 * Revision 4.0  1994/06/08  14:31:37  ims
 * PROMOTION FROM REV4
 *
 * Revision 3.1.1.2  1994/05/23  18:15:11  ryan
 * moved IK_Ims.h to be the first include file.
 *
 * Revision 3.1.1.1  1994/05/04  17:49:02  ims
 * COPIED FROM 3.0.1.2.
 *
 * Revision 3.0.1.2  1994/04/05  12:58:13  ryan
 * just added a few scathing comments.
 *
 * Revision 3.0.1.1  1994/01/27  19:17:47  winter
 * Placeholder revision for start of code cleanup branch.
 *
 * Revision 3.0  1993/12/29  15:18:49  winter
 * ALPHA-1
 *
 | Revision 1.7  1993/06/28  20:49:08  sylvain
 | In the set_union function, nbytes was being incremented instead of gbytes,
 | 	when new storage was being realloc()'d.  (The space wasn't used yet,
 | 	so nbytes shouldn't of been touched.)
 |
 | Revision 1.6  1993/04/21  17:14:12  sylvain
 | Totally rewrote the join function and it's now called set_union.
 | Added the function set_intersection that calls set_union to get the
 | 	union of all valids to be intersected, and then just does a union
 | 	of the datasets that are in the intersection of both valids lists.
 | Reworked the recursion in getvalids so that getvalids only recurses on
 | 	set_union calls.
 | Made RemoveInvalidParams generic so that both set_intersection and
 | 	set_union could re-use the same function.  (isn`t oop great. :-)
 | Removed some unused definitions and functions.
 |
 | Revision 1.5  1993/03/10  17:01:42  sylvain
 | I was sorting the table with the sort key being NULL in the union function
 | (I fixed that :-)
 |
 | Revision 1.4  1993/03/10  16:33:58  sylvain
 | fixed the union operation so that it performed a set union, as opposed to
 | a the set intersection of 2 tables.
 | as a consequence of the previous fix, if the caller just wants all of the
 | valids, we call IK_GetValid to return the table.
 |
 | Revision 1.4  1993/03/09  16:56:00  sylvain
 | union now computes the union of 2 set, and not the intersection.
 | removed the call to initvalids(), size we are now doing set unions and
 | not set intersections. (We want to start from nothing and grow).
 |
 | Revision 1.3  1993/02/26  00:14:41  sylvain
 | Made field_type in getvalids an array so that if the caller deletes
 | their version of the string, getvalids will still have a copy.
 | If getvalids is called to do a union with another field, getvalids
 | recurses again with the new field_type reset.
 |
 | Revision 1.2  1993/02/25  19:17:02  sylvain
 | Replaced the non-ANSI  varargs with the ANSI stdarg.h
 | Reworked the recursion so that you could first see the list
 | before you selected what valids you wanted from it. (Oops :-)
 | Added debugging output at DebugLevel 9
 |
 | Revision 1.1  1993/02/19  16:50:12  sylvain
 | Initial revision
 |
 +------------------------------------------------*/

static const char *rcsid = "$Id: IK_DepValInt.c,v 1.6 1997/03/06 15:38:52 amrhein Exp $";

#include "IK_Ims.h"		/* IMS master header file */

#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <ctype.h>		/* needed for toupper() */
#include <errno.h>
#include <pwd.h>

#include "gdbm.h"		/* gdbm prototypes and defs */

#include "IK_Errno.h"		/* IMS error numbers */
#include "IK_Syslog.h"		/* error logging */
#include "IK_Fixup.h"		/* memory management macros */
#include "IK_Ingest.h"		/* IK_ALIGN macro */
#include "IK_DataDic.h"		/* need IK_PARAMETER_ID_SZ */
#include "IK_Msg.h"		/* for IK_GetMessage proto */
#include "IK_Valid.h"
#include "IK_DepValid.h"	/* dep. valids defs */
#include "IK_DepValidP.h"	/* dep. valids private defs */

#include "odldef.h"		/* ODL defs */
#include "odlinter.h"		/* ODL interface protoptypes */

extern void IK_MapGdbmErrno  (void);
extern void IK_GDBMerr (void);

extern GDBM_FILE dep_valids_dbf, tag_dbf;


/* a valids table  */
typedef struct {
    char **tbl;			/* the valids table */
    int nbytes;			/* the number of bytes used */
    int gbytes;			/* the number of bytes allocated */
    char *aligned_data;		/* the end of the table */
} table;

/* NUM_VALIDS valids tables */
static table *valid_tables[NUM_VALIDS];

static char *valids_path[TBL_SZ];	/* the path used to get the table */

/* the recursive part of IK_GetDepValids() */

char **getvalids (char **);
static char **return_table(char*);	/* just return the current table */
/*
 * get the union of the internal valids tables and the valids tables
 * from storage
 */
static int set_union (IK_DepValidsStructP*, int);
/* 
 * get then intersection of the internal valids table and the valids 
 * tables from storage
 */
static int set_intersection (char **);

static int RemoveInvalidParams (char **, char **, int);
static int merge_tbls (table *, char **const);
/* this is used to iunvalidate an address */
#define INVALID_ADDR '\001'


/* other internal functions */

static IK_DepValidsStructP *fetchvalids (char *, char *);

static char **tblcpy (table *, char*);

static char field_type[IK_MAX_FIELD_SZ];   /* the first field in va_alist
					    * if  the first call */


/*  recursively get the next valids table
 * 
 * Analysis: 
 *     
 *   Precondition 1 :  there is more than one argument in the argument 
 *        list, and field_type is NOT defined
 *
 *   Postcondition 1: this is the first call to getvalids, so set field_type
 *     to the first argument in the va_alist, and recurse with the rest.
 *
 *   Precondition 2 :  the argument list only has one argument 
 *      in the list, and field_type is NOT defined
 *
 *   Postcondition 2: initialize the valids list with the non-dependant 
 *      valids list for the field type and return the valids list
 *
 *  Precondition 3: the argument list has more arguments and 
 *      the valids path entry is NULL.
 *
 *  Postcondition 3: get the new valids list based on field and union 
 *   with the existing valids table.  return the new valids table.
 * 
 *  Precondition 4: the current field value is also the current 
 *     valid path element
 *
 *  Postcondition 4: recurse with the rest of va_alist
 * 
 * Precondition 5: the current field value IS NOT the same as the 
 *   current valids path element.
 * 
 * Postcondition 5: return (-1) and set IK_ImsErrno to IK_EINVAL.
 * 
 * Notes:
 *
 *  (1) to minimize disk access, I only recompute the union if the new union 
 *       being done is different than the ones that have been done in the past.
 *
 * Return: upon success, 0. On failure, -1 and errno, IK_ImsErrno. */
char **getvalids 
    (
     char **va_alist			/* argument list containing valids */
     )
    /* This would appear to be a poor man's variable argument list.
     * Strange.
     * -pmr
     */
{
   int return_code = 0; 		/* no errors! */
   
   char *field_value,
        *ptr,			/* used to up case the arguments passed in */
        errbuf[4*IK_MAXBUFLEN],	/* used for logging messages to syslog */
        **return_tbl;	/* the table to return */
   static char last_field_type[IK_MAX_FIELD_SZ];

   IK_DINC_LEVEL(10);
   /* reset all tables ? */
   
   if (!va_alist) {            
       /* free up internal valids tables */
       /*IK_FREE_TBLS();*/

       {
	   if (valid_tables[0]) {
	       int ii;
	       for (ii=0; ii<NUM_VALIDS;++ii) {
		   free(valid_tables[ii]);
		   valid_tables[ii]=NULL;
	       }
	   }
       }

       
      last_field_type[0] = '\000';	/* no field_type set */
      IK_DPRINTF (10, LOG_DEBUG, "re-initializing the valids tables");
   }
   else {
      /* do we need a field_type ?, we wont if it's a recursive call */
      if (strcmp (field_type, "") == 0) {
	 (void) strcpy (field_type, *va_alist);
	 va_alist++;
      }
      if (!*va_alist)  {
	  /* 
	   * if we recurse with a NULL va_alist, getvalids will reset the 
	   * valid_tables, so we have to prematurely end the 
	   * recursion here
	   * we test want to return the field_value table because the 
	   * recursion is finished at this point.
	   */
	 return_tbl = return_table(field_type);
	 field_type[0] = '\000';	/* no field_type set */
	 return (return_tbl);
       }
      else {
	 /* 
	  * get the next parameter
	  */
	 field_value = *va_alist;
	 va_alist++;		                /* get the next argument */
	 for (ptr = field_value;*ptr;ptr++)	/* upcase the field value */
	     *ptr = toupper (*ptr);

	 /* get rid of leading spaces */
	 while (*field_value == ' ') 
	     field_value++;

	 if (strcmp (last_field_type, "") != 0 &&
	     strcmp (last_field_type, field_type) != 0)
	  {	
	     
	     return_code = set_intersection (--va_alist);
	     if (return_code >= 0)  {
		(void) strcpy (last_field_type, field_type);
		IK_DFUN_CALL(sprintf (errbuf, ".IK_GetDepValids.getvalids:Recursing to get the valids for %s x %s", 
				      field_type, field_value));
		IK_DPRINTF(10, LOG_DEBUG, errbuf);
		return_tbl = return_table(field_type);
		field_type[0] = '\000';	/* no field_type set */
		return (return_tbl);
	     }
	     else {
		IK_vSyslog (LOG_ERR, ".IK_GetDepValids.getvalids : set_intersection failed for %s x %s, IK_ImsErrno = %d - %s",
			    field_type, field_value, IK_ImsErrno, IK_GetMessage (IK_ImsErrno));
		field_type[0] = '\000';	/* no field_type set */
		return (NULL);
	     }			/* set_intersection or fetchvalids failed */
	  }			/* new field_value passed in */
	 else {
	    /* 
	     * the field_type is the same, 
	     * so just add them to the existing valids list
	     */
	    return_code = set_union (fetchvalids (field_type, field_value), 1);
	    if (return_code >= 0)  {
	       (void) strcpy (last_field_type, field_type);
	       IK_DFUN_CALL(sprintf (errbuf, ".IK_GetDepValids.getvalids:Recursing to get the valids for %s x %s", 
				     field_type, field_value));
	       IK_DPRINTF(10, LOG_DEBUG, errbuf);
		if (!*va_alist) {
		   return_tbl = return_table(field_type);
		   field_type[0] = '\000';	/* no field_type set */
		   return (return_tbl);
		}
		else
		    return (getvalids (va_alist));
	    }
	    else {
	       IK_vSyslog (LOG_ERR, ".IK_GetDepValids.getvalids : set_union failed for %s x %s, IK_ImsErrno = %d - %s",
			   field_type, field_value, IK_ImsErrno, IK_GetMessage (IK_ImsErrno));
	       field_type[0] = '\000';	/* no field_type set */
	       return(NULL);
	    }		/* fetchvalids or set_union failed */
	 }	        /* same field_type, just get the union */
      }			/* the valids were reset */
   }
   return NULL;
}



/*  this function just read a valids list from disk
 * 
 * Analysis: 
 *     
 *
 * Notes:  
 *
 * Return: upon success, 0. On failure, -1 and errno, IK_ImsErrno. */
static IK_DepValidsStructP *fetchvalids 
    (
     char *field,			/* the name of the field to fetch */
     char *value			/* the value of the field */
     )
{
   int return_code = 0;
   char *ptr,
        field_buf[IK_MAXBUFLEN],
        **tbl_ptr;
   datum db_tag_key,		/* the key to search for */
   db_valids_key,		/* the valids key to get */
   db_content;
   IK_DepValidsStructP *tbl;
   
   /* field name allready upcased by IK_GetDepValids() */

   /* get rid of trailing white space */
   for (ptr = value+strlen(value)-1;*ptr == ' ';ptr--)	
       /* NULL body */;
   
   (void) sprintf (field_buf, "%s\n%s", field, value);
   
   
   db_tag_key.dptr = field_buf;
   db_tag_key.dsize = strlen (field_buf) + 1;
   
   if (!dep_valids_dbf) {
      if (!IK_DepValidsInit()) {
	 IK_vSyslog (LOG_ERR, ".IK_GetDepValids.getvalids.fetchvalids: valids \
open failed:IK_ImsErrno = %d - %s", 
		     IK_ImsErrno, IK_GetMessage (IK_ImsErrno));
	 return_code = -1;
      }
   }
   else {			/* get the tag first */
      db_valids_key = gdbm_fetch (tag_dbf, db_tag_key);
      if (db_valids_key.dptr == NULL) {
	 IK_ImsErrno = IK_ENOENT;
	 tbl = NULL;
	 return_code = -1;
      }
      else {			/* use the tag to get the valids list */
	 db_content = gdbm_fetch (dep_valids_dbf, db_valids_key);
	 
	 if (db_content.dptr == NULL) {
	    IK_MapGdbmErrno();
	    IK_vSyslog (LOG_ERR, ".IK_GetDepValids.getvalids.fetchvalids.gdbm_fetch: failed, IK_ImsErrno = %d - %s",
			IK_ImsErrno, IK_GetMessage (IK_ImsErrno));
	    IK_ImsErrno = IK_ENOENT;
	    tbl = NULL;
	    return_code = -1;
	 }
	 else {
	    tbl = (IK_DepValidsStructP *) db_content.dptr;
	    tbl->head = (IK_DepValidsStruct *) IK_FIXUP (tbl, tbl->head);
	    tbl_ptr = (char **) tbl->head;
	    IK_FIXUP_LIST (tbl_ptr);
	    tbl_ptr = (char **) &(*tbl->head->daacs);
	    IK_FIXUP_LIST (tbl_ptr);
	    tbl_ptr = (char **) &(*tbl->head->datasets);
	    IK_FIXUP_LIST (tbl_ptr);
	    tbl_ptr = (char **) &(*tbl->head->sources);
	    IK_FIXUP_LIST (tbl_ptr);
	    tbl_ptr = (char **) &(*tbl->head->sensors);
	    IK_FIXUP_LIST (tbl_ptr);
	    tbl_ptr = (char **) &(*tbl->head->params);
	    IK_FIXUP_LIST (tbl_ptr);
	 }
      }

      free(db_valids_key.dptr);
   }
   return (return_code == 0 ? tbl : NULL);
}

/*  this function removes the duplicates from the table
 * 
 * this functiopn removes the duplicates from the table by just over-
 * writing the pointer to the duplicate string.  And since the 
 * table will be copied into te user's space anyway.  The space lost is
 * minimal.
 *
 * Analysis: 
 *  
 *     Precondition 1: The table doesn't have any duplicates
 *
 *     Postcondition 1: return the number of address in the 
 *         address block.
 *
 *     Precondition 2: A duplicate at address ptr, 
 *     	   where, start_ptr <= ptr <= end_ptr.
 *
 *     Postcondition 2: remove the duplicates by memove'ing the 
 *     	   address between ptr+1 and end_ptr back one address pointer.
 *     	   increment the number of address deleted by one.
 *
 *     Precondition 3: no more duplicates found.
 *
 *     Postcondition 3: return the number off address in the address block.
 *
 * Notes:  
 *
 * (1) Pre/Post 2 depends on the duplicate removal starting from the 
 *     end_ptr and proceeding to start_ptr.
 *
 * (2) the lists to be merged MUST be sorted to work correctly.
 *
 * Return: upon success, the number of duplicates in the table. On failure, 
 -1 and errno, IK_ImsErrno. 
 */
static int RemoveInvalidParams
(
 char **table1,			/* the original valids table */
 char **table2,			/* the new valids table to be merged in */
 int operation			/* which operation :
				 * 0 - mark duplicate entries invalid
				 * 1 - mark entries that aren't in the 
				 *     intersection invalid
				 */
)
{
   int return_code = 0,		/* no errors yet :-) */
       addr_cnt = 0,		/* the number of address in the block */
       index,			/* index used for sorting */
       cmp;			/* comparison value of the strcmp */
   char **ptr1,			/* pointers used for sorting the table */
        **ptr2,			/* an alias for table[12] */
        **ptr2_end,		/* the end of table2  */
        **saved_ptr1,		/* just to save some time */
        *tmp;

   IK_BOOLEAN data_found = IK_FALSE; /* for operation == 1, has data 
				      * been found */

   char errbuff[IK_MAXBUFLEN];

   /* find the end of the address blocks */
   for (ptr2_end = table2;*ptr2_end;ptr2_end++)
       /* NULL body */;
   
   ptr2 = ptr2_end;
   
   if (ptr2 > table2)
       ptr2--;
   
   if (*table1) {
      for (ptr1 = table1;*ptr1;ptr1++)
	  /* NULL body */;
      if (ptr1 > table1)
	  ptr1--;
      
      saved_ptr1 = ptr1;	/* only compute ptr1 once! */
      
      /* 
       * remove any duplicates
       */
      
      for (;!return_code && *ptr2 && ptr2 >= table2;
	   ptr2--) 
       {
	  for (ptr1 = saved_ptr1;!return_code && *ptr1 && ptr1 >= table1;
	       ptr1--)
	   {
	      /* 
	       * perform the respective operation, depending upon
	       * who called me
	       */
	      if (operation == 1) { /* called from set_intersection */
		 if ((cmp = strcmp (*ptr1, *ptr2))  == 0) { 
		    /* mark data as valid */
		    data_found = IK_TRUE;
		    break;
		 }
	      }
	      else if (operation == 0) { /* called from set_union */
	      /* if we are being called from set_intersection,
	       * then some fields in table1 may already be invalid
	       */
	      if (*ptr1) 
		 if ((cmp = strcmp (*ptr1, *ptr2))  == 0) {  
		    /* delete the address */
		     *ptr2 = (char *) INVALID_ADDR;
		     break;
		  }
	      }
	      else {
		 IK_vSyslog (LOG_ERR, ".IK_GetDepValids...RemoveInvalidParams called with an unsupported operation: %d",
			     operation);
		 return_code = -1;
		 break;
	      }			/* which operation should be performed */
	      if (cmp < 0) 
		  break;	/* we're past all variables in table 1 that 
				 * can be equal to ptr2
				 */
	   }			/* while parameters in table2 */
	  if (operation) {
	     if (!data_found) 
		     *ptr2 = (char *) INVALID_ADDR;
	     else
		 data_found = IK_FALSE;
	  }
	  if (*ptr2 != (char *) INVALID_ADDR && *ptr2) 
	      addr_cnt++;	/* a valid string to be added */
	  
       }			/* while parameters in table1 */
   }				/* is table1 NULL ? */
   else 
      addr_cnt = (int) (ptr2_end - table2);
     
   IK_DFUN_CALL (sprintf (errbuff, ".IK_GetDepValids...RemoveInvalidParams validating %d parameters",
			     addr_cnt));
   IK_DPRINTF (10, LOG_DEBUG, errbuff);
   return return_code == 0 ? addr_cnt : -1;
}

/*  this function gets the intersection of 2 sets
 * 
 * Analysis: 
 *     
 *
 * Notes:  
 *
 * Return: upon success, 0. On failure, -1 and errno, IK_ImsErrno. */
static int set_intersection 
(
 char **field_values		/* the field_values for the intersection */
)
{
   int return_code = 0;		/* no errors yet */

   char **dataset_valids,	/* the dataset valids list */
        **old_valids,		/* the internal valids list */
        **new_valids,		/* one of the valids lists just brought 
				 * in from disk */
        ****old_valids_ptr,	/* the current valids table 
				 * (the next old_valids table) */
        ***new_valids_ptr,	/* the next new_valids table */
        *ptr;			/* used to upcase the field_values */

   static table *old_valid_tbls[NUM_VALIDS]; 
   char errbuf[4*IK_MAXBUFLEN];

   if (!*field_values) {
      IK_vSyslog (LOG_ERR, "trying to get the intersection of a NULL table, IK_ImsErrno = %d - %s",
		  IK_ImsErrno, IK_GetMessage (IK_ImsErrno));
      IK_ImsErrno = IK_EINVAL;
      return_code = -1;
   }
   else {
      old_valid_tbls[0] = valid_tables[0];
      old_valid_tbls[1] = valid_tables[1];
      old_valid_tbls[2] = valid_tables[2];
      old_valid_tbls[3] = valid_tables[3];
      old_valid_tbls[4] = valid_tables[4];
      valid_tables[0] = NULL;
      valid_tables[1] = NULL;
      valid_tables[2] = NULL;
      valid_tables[3] = NULL;
      valid_tables[4] = NULL;
      
      /* 
       * get the union of the all the of values that are to be intersected 
       * first
       */
      while (!return_code && *field_values) {
	 for (ptr = *field_values;*ptr;ptr++)	/* upcase the field value */
	     *ptr = toupper (*ptr);

	 /* get rid of leading spaces */
	 while (**field_values == ' ') 
	     (*field_values)++;

	 return_code = set_union (fetchvalids (field_type, *field_values), 0);
	 IK_DFUN_CALL (sprintf (errbuf, ".IK_GetDepValids.getvalids.set_intersection: getting the union of %s and %s",
		field_type, *field_values));
	 IK_DPRINTF (10, LOG_DEBUG, errbuf);
	 field_values++;
      }
      if (return_code < 0) {
	 IK_vSyslog (LOG_ERR, ".IK_GetDepValids.getvalids.set_intersection.set_union_1 failed, IK_ImsErrno = %d - %s",
		     IK_ImsErrno, IK_GetMessage (IK_ImsErrno));
      }
      else {
	 /* 
	  * get the intersection of the dataset table
	  */
	 new_valids = valid_tables[1]->tbl;
	 old_valids = old_valid_tbls[1]->tbl;
      }
      /* 
       *  remove parameters that aren`t in the intersection 
       */
      if (!return_code && RemoveInvalidParams (old_valids, new_valids, 1) > 0) 
       {
	  /* reset the valids tables */
	 dataset_valids = new_valids;
	 (void) free (valid_tables[0]);
	 (void) free (valid_tables[2]);
	 (void) free (valid_tables[3]);
	 (void) free (valid_tables[4]);
	 valid_tables[0] = NULL;
	 valid_tables[1] = NULL; 
	 valid_tables[2] = NULL;
	 valid_tables[3] = NULL;
	 valid_tables[4] = NULL;

	 /* 
	  * ok, get the union of all valid datasets
	  */
	 for (;*dataset_valids == (char *) INVALID_ADDR || *dataset_valids;
	      dataset_valids++) 
	  {
	     if (*dataset_valids != (char *) INVALID_ADDR) {
		return_code = set_union (fetchvalids ("DATASET_ID", 
						      *dataset_valids), 1);
		if (return_code < 0) {
		   IK_vSyslog (LOG_ERR, ".IK_GetDepValids.getvalids.set_intersection.set_union_2 failed for %s x %s, IK_ImsErrno = %d - %s",
			       "DATASET_ID", *old_valids, 
			       IK_ImsErrno, IK_GetMessage (IK_ImsErrno));
		}
	     }
	  }
      }
      if (return_code < 0) {	/* reset the tables on error */
	 valid_tables[0] = old_valid_tbls[0];
	 valid_tables[1] = old_valid_tbls[1];
	 valid_tables[2] = old_valid_tbls[2];
	 valid_tables[3] = old_valid_tbls[3];
	 valid_tables[4] = old_valid_tbls[4];
	 IK_vSyslog (LOG_ERR, ".IK_GetDepValids.getvalids.set_intersection: NULL intersection of valids lists");
	 IK_ImsErrno = IK_EINVAL;
	 return_code = -1;
      }
      else {			/* free up the table upon success */
	 (void) free (old_valid_tbls[0]);
	 (void) free (old_valid_tbls[1]);
	 (void) free (old_valid_tbls[2]);
	 (void) free (old_valid_tbls[3]);
	 (void) free (old_valid_tbls[4]);
      }
   }				/* invalid tbl passed in */
   return return_code;
}


/*  this function computes a join (the union of 2 tables/sets)
 * 
 * Analysis: 
 *     
 *     Precondition 1: unable to aquire mode memory for the 
 *     	   valids table.
 *
 *     Postcondition 1: return -1, set IK_ImsErrno to IK_ENOMEM, 
 *     	   and log a message to syslog.
 *
 *     Precondition 2: unable to copy the new valids into the 
 *     	   old vailds table.
 *
 *     Postcondition 2: return -1, and log to syslog.
 *
 *     Precondition 3: the unioning of the tables is complete.
 *
 *     Postcondition 3: return 0.
 *
 * Notes:  
 *
 *   (1) the lists to be merged MUST be sorted to work correctly.
 *       
 * Return: upon success, 0. On failure, -1 and errno, IK_ImsErrno. */
static int set_union 
(
 IK_DepValidsStructP *tbl,	/* the valids table from gdbm */
 int all_tbls			/* union all tables or just the 
				 * dataset table ? */
)
{
   int return_code = 0;		/* no errors */

   char **old_valids,		/* the internal valids list */
        **new_valids,		/* one of the valids lists just brought 
				 * in from disk */
        ****old_valids_ptr,	/* the current valids table 
				 * (the next old_valids table) */
        ***new_valids_ptr,	/* the next new_valids table */
        **addr_start,		/* where to put the addr for the data */
        **ptr,			/* pointers used for sorting */
        *tmp;			/* a pointer used for swaping */

   int param_cnt,		/* the # of params in the current valids tbl */
       cmp,			/* used by strcmp(3) */
       tbl_cnt,
       new_addrs,		/* the number of address' needed for the 
				 * address block 
				 */
       index,
       size,			/* the size of the word copied in */
       distance,		/* the distance the data block was moved */
       data_blk_sz;		/* the aligned size */

   if (!tbl) {
      IK_vSyslog (LOG_ERR,
	  "trying to get the union of a NULL table, IK_ImsErrno = %d - %s",
		  IK_ImsErrno, IK_GetMessage (IK_ImsErrno));
      IK_ImsErrno = IK_EINVAL;
      return_code = -1;
   }
   else {
      /* 
       * get space for the tables,if needed 
       */
      for (tbl_cnt = 0; tbl_cnt < NUM_VALIDS; tbl_cnt++) {
	 if (!valid_tables[tbl_cnt])  {
	    if ((valid_tables[tbl_cnt] = calloc (sizeof (table) + (2*IK_BUFSZ),
						 sizeof (char *)))
		== NULL)
	     {
		IK_Syslog (LOG_ERR,
			   "unable to acquire memory for the valids tables");
		IK_ImsErrno = IK_ENOMEM;
		return_code = -1;
	     }
	    /* start off with 4K */
	    valid_tables[tbl_cnt]->gbytes = sizeof (table) + (2*IK_BUFSZ); 
	    valid_tables[tbl_cnt]->nbytes = sizeof (table);
	    valid_tables[tbl_cnt]->tbl = 
		(char **) ((unsigned int) valid_tables[tbl_cnt] + 
		    sizeof (void *) + sizeof(table));
	    valid_tables[tbl_cnt]->aligned_data = 
		(char *) valid_tables[tbl_cnt]->tbl;
#ifdef XXDEBUG
	    fprintf(stderr,"valid_tables[%d]: (line %d)\n",tbl_cnt,__LINE__);
	    fprintf(stderr,"\tgbytes = %d\n",valid_tables[tbl_cnt]->gbytes);
	    fprintf(stderr,"\tnbytes = %d\n",valid_tables[tbl_cnt]->nbytes);
	    fprintf(stderr,"\n");
#endif
	    
	 }
	 else if (valid_tables[tbl_cnt]->nbytes + tbl->nbytes >
		  valid_tables[tbl_cnt]->gbytes) 
	  {
	     /*
	      * need more memory, first we have to relocate all of the address
	      * that point to the data strings, then the pointer o the data 
	      * table and finally the pointer to the end of the table
	      */
	     char **pptr;
	     pptr = (char **) valid_tables[tbl_cnt];
	     IK_RELOC_LIST(((char **) *(valid_tables[tbl_cnt]->tbl)));
	     valid_tables[tbl_cnt]->tbl = (char **) IK_RELOC(&valid_tables[tbl_cnt]->tbl,
						   valid_tables[tbl_cnt]->tbl);
	     valid_tables[tbl_cnt]->aligned_data = (char *) IK_RELOC(&valid_tables[tbl_cnt]->aligned_data, 
							    valid_tables[tbl_cnt]->aligned_data);

	     if ((valid_tables[tbl_cnt] =
		  realloc (valid_tables[tbl_cnt],
			   valid_tables[tbl_cnt]->gbytes + (2*IK_BUFSZ)))
		 == NULL)
	     {
		 IK_Syslog (LOG_ERR,
		    "unable to acquire more memory for the valids tables");
		 IK_ImsErrno = IK_ENOMEM;
		 return_code = -1;
		 
	      } else {
		  pptr = (char **) valid_tables[tbl_cnt];

		  valid_tables[tbl_cnt]->tbl = 
		    (char **) IK_FIXUP(&valid_tables[tbl_cnt]->tbl,
				       valid_tables[tbl_cnt]->tbl);
		  valid_tables[tbl_cnt]->aligned_data = 
		    (char *) IK_FIXUP(&valid_tables[tbl_cnt]->aligned_data, 
				      valid_tables[tbl_cnt]->aligned_data);

		  IK_FIXUP_LIST (((char **) *(valid_tables[tbl_cnt]->tbl)));
		  valid_tables[tbl_cnt]->gbytes += (2*IK_BUFSZ); 
	      }
	  }
      }
      /* 
       * read in the tables for this valids entry 
       */
      for (tbl_cnt = 0,
	   old_valids_ptr = (char ****) valid_tables,
	   new_valids_ptr = (char ***) tbl->head;
	   !return_code && tbl_cnt < NUM_VALIDS;
	   old_valids_ptr++, tbl_cnt++)
       {
	  /* 
	   * find the start of the new tables
	   */
	  new_valids = *(new_valids_ptr + (unsigned int) tbl_cnt);
	  old_valids = **old_valids_ptr;

	  if (all_tbls == 0 && tbl_cnt != 1) {		
	     /* only wants to get union of dataset tbl */
	     continue;
	  }
	  else {		/*  */
	     /* 
	      * find the number of valid address to be added to 'old_valids' 
	      */
	     if ((new_addrs =
		  RemoveInvalidParams (old_valids, new_valids, 0)) < 0) {
		IK_vSyslog (LOG_ERR,
    ".IK_GetDepValids.getvalids.set_union.RemoveInvalidParams failed, \
IK_ImsErrno = %d - %s",
			    IK_ImsErrno, IK_GetMessage (IK_ImsErrno));
		return_code = -1;
	     }
	     else if (new_addrs > 0) {
		/* 
		 * find the end of the current valids list 
		 */
		for (addr_start = old_valids;*addr_start;addr_start++)
		    /* NULL body */;
		
		/* make room for the new valids in the old valids table */
		if (*old_valids)  /* only if these really are old */
		 {
		    /*  
		     * here, 
		     *     size         - is the size of the nth string
		     *     data_blk_sz - is the size of the data_block.
		     *     addr_start   - is the place to put new addresses, 
		     *            not the start of the address block
		     * 
		     * addr_start is the NULL that seperates the
		     * address and data blocks.  we want to move
		     * data_blk_sz bytes (the data for this table)
		     * from addr_start+1 to addr_start+1+new_addrs, to
		     * leave room for new_addrs for the new table and
		     * then update their respective pointers to
		     * reflect their new positions in memory.
		     */
		     
		    data_blk_sz = 
			(int) (((table *) *old_valids_ptr)->aligned_data - 
			       ((char *) addr_start+1));
		    
		    (void) memmove (addr_start+new_addrs+1, addr_start+1,
				    data_blk_sz);
		    
		    /* 
		     * make sure there is NULL between the new 
		     * addr_block and the data 
		     */
		    *(addr_start+new_addrs) = (char *) '\000'; 
		    
		    /* 
		     * add to the address, the distance they were moved
		     * now aliagned_size becomes the distance the address were 
		     * moved in memory (in bytes).
		     */
		    distance = new_addrs * sizeof (char *);
		    for (addr_start = old_valids; *addr_start; addr_start++)
			*addr_start += distance;
		    ((table *) *old_valids_ptr)->aligned_data += 
			(unsigned int) distance;
		 }	     /* if there exists an old valids table */
		else
		    ((table *) *old_valids_ptr)->aligned_data += 
			(new_addrs+1) * sizeof (char *);
		
		
		
		if (merge_tbls ((table *) *old_valids_ptr, new_valids) 
		    < 0) 
		 {
		    IK_vSyslog (LOG_ERR,
	".IK_GetDepValids.getvalids.set_union.merge_tbls: \
failed, IK_ImsErrno = %d - %s",
				IK_ImsErrno, IK_GetMessage (IK_ImsErrno));
		    return_code = -1;
		 }
	     }	/* only get the union of the dataset tables ? */
	  }	/* the were addresses to be added to old_valids */
       }	/* foreach valids table */
   }
   if (return_code < 0 && tbl) {      /* desperation time!!! */
      valid_tables[0]->tbl = tbl->head->daacs;
      valid_tables[1]->tbl = tbl->head->datasets;
      valid_tables[2]->tbl = tbl->head->sources;
      valid_tables[3]->tbl = tbl->head->sensors;
      valid_tables[4]->tbl = tbl->head->params;
      
   } else if (tbl) {
       (void) free (tbl);
   }
   
   return return_code;
}

/*  this function merges 2 tables together
 * 
 * Analysis: 
 *     
 *  Precondition 1: the first table is empty.
 *
 *  Postcondition 1: just added the valid entries in table2 to table1.
 *
 *  Precondition 2: The first table is NOT empty.
 *
 *  Postcondition 2: add the valid values from second table into the 
 *      first table,  sorted.
 *
 *  Precondition 3: one of the tables is NULL.
 *
 *  Postcondition 3: return -1, set IK_ImsErrno to IK_EINVAL, log a 
 *      message to syslog.
 *
 *  Precondition 4: one of the memmove/memcpy operations got an internal 
 *      error.  
 *
 *  Postcondition 4: return -1, log a message to syslog and set IK_ImsErrno
 *      to IK_ENOMEM.
 *
 * Notes:  
 *
 *  (1) this depends one the 2 lists being sorted.
 *
 *  (2) and that pointers to duplicate data have been maked 
 *      INVALID_ADDR
 *
 *  (3) the data block has allready been moved back to where is will end up
 *      when the new address block is constructed.  So merge_tbls only 
 *      has to worry about keeping the address block consitant.
 *
 * Return: upon success, 0. On failure, -1 and errno, IK_ImsErrno. */
static int merge_tbls 
(
 table *table1,		/* the original table to insert into */
 char **const table2	/* the table that has teh values */
) 
{
   char **tbl1_ptr,	/* a tmp ptr into table1->tbl */
        **tbl2_ptr,	/* a tmp ptr into table2 */
        **tbl1_end,	/* the end of table1->tbl */
        **addr_blk_end,	/* the eventual end of the addr block */
        **tbl2_end;	/* the end of table2 */
   int size,		/* the size of the string to be copied in */
       aligned_size,	/* the aligned size of the string */
       num_addrs,       /* add this many address from table2 -> table1 */
       cmp;		/* the comparison value of the 2 strings  */

   if (table1 == NULL || table2 == NULL) {
      IK_vSyslog (LOG_ERR, ".IK_GetDepValids.getvalids.set_union.merge_tbls:\
merge_tbls was passed an invalid table pointer");
      IK_ImsErrno = IK_EINVAL;
   }
   else if (errno) {
      IK_vSyslog (LOG_ERR, "HELLOOOOOO... someone didn't catch an error, errno is set to %d - %s",
		  errno, strerror (errno));
      IK_ImsErrno = IK_EPROTO;
   }
   else {
      /* 
       * find the end of the respective address blocks
       */
      for (tbl1_end = tbl1_ptr = table1->tbl;
	   *tbl1_end;tbl1_end++)
	  /* NULL body */;

      /* find the end of table2 */
      for (num_addrs = 0,tbl2_end = tbl2_ptr = table2;
	   *tbl2_end == (char *) INVALID_ADDR || *tbl2_end;
	   tbl2_end++)
	  /*
	   * count the number of addresses to add to table1
	   */
	  if (*tbl2_end != (char *) INVALID_ADDR) 
	      num_addrs++;
      
      addr_blk_end = tbl1_end + num_addrs;


      for (;!errno 	/* as long as : one of the mem* functions didn't fail */
                /* we still have a valid location to store the address */
		&& *tbl1_ptr && tbl1_ptr < tbl1_end 
		/* still addresses to store */
		&& *tbl2_ptr && tbl2_ptr < tbl2_end; 
	   tbl2_ptr++)
       {
	  if (*tbl2_ptr != (char *) INVALID_ADDR && *tbl2_ptr) {
	     /* 
	      * find out where to put the new valids 
	      */
	     for (;tbl1_ptr < tbl1_end && 
		  (cmp = strcmp (*tbl1_ptr, *tbl2_ptr)) < 0;
		  tbl1_ptr++)
		 /* NULL body */ ;

	     if (tbl1_ptr == tbl1_end && cmp > 0) /* did we go too far ? */
		 tbl1_ptr--;

	     /* make room for the new address 
	      * as long as we`re not at the end 
	      * of table1, 
	      * in that case, just overwrite the last word.
	      */
	     if (tbl1_ptr != addr_blk_end - 1) { 
		(void) memmove (tbl1_ptr+1, tbl1_ptr,
				(int) ((tbl1_end - tbl1_ptr) * sizeof (char *)));
		if (errno) 
		    IK_vSyslog (LOG_ERR, ".IK_GetDepValids.getvalids.set_union.\
merge_tbls.memmove_1, errno = %d - %s",
				errno, strerror (errno));
		tbl1_end++;	/* the end of the addr block just moved 
				 * out one more address */
	     }
	     *tbl1_ptr = table1->aligned_data; 
	     size = strlen (*tbl2_ptr) + 1;
	     (void) memcpy (table1->aligned_data, *tbl2_ptr, size);
	     if (errno) 
		 IK_vSyslog (LOG_ERR, ".IK_GetDepValids.getvalids.set_union.\
merge_tbls.memcpy_1, errno = %d - %s",
			     errno, strerror (errno));
	     table1->nbytes += (aligned_size = IK_ALIGN(size));
	     table1->aligned_data += (unsigned int) aligned_size;
	     
#ifdef XXDEBUG
	     fprintf(stderr,"table1: (line %d)\n",__LINE__);
	     fprintf(stderr,"\tgbytes = %d\n",table1->gbytes);
	     fprintf(stderr,"\tnbytes = %d\n",table1->nbytes);
	     fprintf(stderr,"\n");
#endif
	  }
       }
      /*  
       * check to see if we're at the top of the table1 and 
       * if there are more variables left in table2 that 
       * have to be stored into table1
       */
      if (!errno && tbl1_ptr == table1->tbl && tbl2_ptr < tbl2_end) {
	 for (;!errno && tbl2_ptr < tbl2_end;
	      tbl2_ptr++) 
	  {
	     if (*tbl2_ptr != (char *) INVALID_ADDR && *tbl2_ptr) {

		if (tbl1_ptr != tbl1_end) { /* if there is something to move */
		   
		   /* make room for the address */
		   (void) memmove (tbl1_ptr+1, tbl1_ptr,
				   (int) ((tbl1_end - tbl1_ptr) 
					  * sizeof (char *)));
		   if (errno) 
		       IK_vSyslog (LOG_ERR, ".IK_GetDepValids.getvalids.set_union.\
merge_tbls.memmove_2, errno = %d - %s",
				   errno, strerror (errno));
		}
		*tbl1_ptr = table1->aligned_data; 
		tbl1_end++;	/* the end of the addr block just moved 
				 * out one more address */
		size = strlen (*tbl2_ptr) + 1;
		(void) memcpy (table1->aligned_data, *tbl2_ptr, size);
		if (errno) 
		    IK_vSyslog (LOG_ERR, ".IK_GetDepValids.getvalids.set_union.merge_tbls.memcpy_2, errno = %d - %s",
				errno, strerror (errno));
		table1->nbytes += 
		    (aligned_size = IK_ALIGN(size));
		table1->aligned_data += (unsigned int) aligned_size;

#ifdef XXDEBUG
		fprintf(stderr,"table1: (line %d)\n",__LINE__);
		fprintf(stderr,"\tgbytes = %d\n",table1->gbytes);
		fprintf(stderr,"\tnbytes = %d\n",table1->nbytes);
		fprintf(stderr,"\n");
#endif		
		tbl1_ptr++;
	     }			/* if *tbl1_ptr is valid */
	  }			/* foreach parameter in tbl2 */
      }				/* if there's still parameters left to add */
      if (errno) IK_ImsErrno = IK_ENOMEM;
   }
   return (errno != 0 ? -1 : 0);
}
   

/*  this function creates a copy of the table for the user
 * 
 * Analysis: 
 *     
 *
 * Notes:  
 *
 * Return: upon success, 0. On failure, -1 and errno, IK_ImsErrno. */
static char **tblcpy 
(
 table *tbl,			/* the table to copy */
 char *field			/* the field to copy */
) 
{
   int return_code = 0;
   char **return_tbl;		/* the table to return */
   int nbytes;	                /* the number of btes actually used */
   char **ptr;	                /* the start of the table */
   char **addr_start,		/* where the address goes */
           *data_start;		/* where the dtat goes */
   int param_cnt;		/* the number of parameters */
   int n, size;			/* vars used to re-calc data_start */

   if (!tbl) {			
      /* if the table isn't defined, then the user just wanted
       * the non-dependant valids list
       */
      if (IK_GetValids (field, &return_tbl) < 0) 
	   return_code = -1;
   }
   else { 
      ptr = tbl->tbl;
      if ((return_tbl = calloc (sizeof (char), tbl->gbytes)) == NULL) { 
	 IK_vSyslog (LOG_ERR, ".tblcpy.calloc: error, errno = %d - %s",
		     errno, strerror (errno));
	 IK_ImsErrno = IK_ENOMEM;
	 return_code = -1;
      }
      else {
	 /* get # of parameters and the size need for the address block */
	 
	 for  (nbytes = param_cnt = 0;*ptr; 
	       param_cnt++,nbytes += sizeof (char *),ptr++);
	 nbytes += sizeof (void *); /* NULL teminates the addr block */
	 
	 for (ptr = tbl->tbl,addr_start = return_tbl, 
	      data_start =  (char *) return_tbl + ((unsigned int ) (param_cnt + 1) * sizeof (char *));
	      *ptr; 
	      addr_start++, ptr++, data_start += (unsigned int) size) 
	  {
	     n = strlen (*ptr);
	     *addr_start = data_start;
	     (void) memcpy (data_start, *ptr, n);
	     size = IK_ALIGN (n);
	     nbytes += size;
	  }
	 if (nbytes < tbl->gbytes) 
	     if ((return_tbl = realloc (return_tbl, nbytes)) == NULL) { 
		IK_vSyslog (LOG_ERR, ".tblcpy.realloc: error, errno = %d - %s",
			    errno, strerror (errno));
		return_code = -1;
		(void) free (return_tbl);
	     }
      }
   }
   return return_code == 0 ? return_tbl : NULL;
}


static char **return_table
(
 char *field		/* the table to return */
)
{
   char errbuf[IK_MAXBUFLEN];	/* used for logging messages to syslog */
   char **return_ptr;


   if (strcmp (field, "DATA_CENTER_ID") == 0) {
      IK_DFUN_CALL(sprintf (errbuf, ".IK_GetDepValids.getvalids:Returning the valids for %s", 
			    field));
      IK_DPRINTF(10, LOG_DEBUG, errbuf);
      return_ptr = tblcpy (valid_tables[0], field);
   }
   else if (strcmp (field, "DATASET_ID") == 0) {
      IK_DFUN_CALL(sprintf (errbuf, ".IK_GetDepValids.getvalids:Returning the valids for %s", 
			    field));
      IK_DPRINTF(10, LOG_DEBUG, errbuf);
      return_ptr = tblcpy (valid_tables[1], field);
   }
   else if (strcmp (field, "SOURCE_NAME") == 0) {
      IK_DFUN_CALL(sprintf (errbuf, ".IK_GetDepValids.getvalids:Returning the valids for %s", 
			    
			    field));
      IK_DPRINTF(10, LOG_DEBUG, errbuf);
      return_ptr = tblcpy (valid_tables[2], field);
   }
   else if (strcmp (field, "SENSOR_NAME") == 0) {
      IK_DFUN_CALL(sprintf (errbuf, ".IK_GetDepValids.getvalids:Returning the valids for %s", 
			    field));
      IK_DPRINTF(10, LOG_DEBUG, errbuf);
      return_ptr = tblcpy (valid_tables[3], field);
   }
   else if (strcmp (field, "PARAMETER") == 0) {
      IK_DFUN_CALL(sprintf (errbuf, ".IK_GetDepValids.getvalids:Returning the valids for %s", 
			    field));
      IK_DPRINTF(10, LOG_DEBUG, errbuf);
      return_ptr = tblcpy (valid_tables[4], field);
   }
   else {
      IK_vSyslog (LOG_ERR, ".IK_GetDepValids.getvalids.return_table: field is invalid |%s|",
		  field);
   }
   return (return_ptr);
}

/* -- QED -- */


