/* File: $RCSfile: IK_DepValid.c,v $
 * 
 * Synopsis:
 *  this file conatains the function defintions necessary to 
 * access the dependent valids
 *
 * The main function in this file (IK_GetDepValids) is called with 
 * the name of the field to be validated, a pointer to the 
 * table to return to the user, and a list of field value to be validated.
 *
 * 
 * Notes: */

/*--------------------------------------------------
 | $Log: IK_DepValid.c,v $
 | Revision 1.9  1999/03/24 21:01:28  solomon
 | Changed to use "ValidsCount" instead of the hard coded value of 1024 for
 | the maximum number of valids that can be processed.
 | Changed spelling of "dependant" to "dependent".
 | Shortened long lines.
 |
 | Revision 1.8  1997/10/20 17:26:29  solomon
 | Updated to GUI IK layer 7_0_0_13.
 |
 * Revision 7.0.1.3  1997/08/19  14:27:10  terrell
 * Modified IK_GetDepValids to process extended search valids.
 * **READY FOR BUILD**
 *
 * Revision 7.0.1.2  1997/07/29  14:30:20  terrell
 * Extended Search Valids - XClient: Still in development - Do not use in build.
 *
 * Revision 7.0  1997/04/11  17:54:01  ims
 * 6.1.1.1 Promoted to 7.0 J. Katen
 *
 * Revision 6.1.1.1  1996/10/21  14:18:25  winter
 * Copied from 6.0.1.3 after 6.1 promotion.
 *
 * Revision 6.0.1.3  1996/09/27  12:48:18  winter
 * Fixed some casting errors in calls to gdbm functions caused when gdbm.h
 * was modified to use prototypes.
 *
 * Revision 6.0.1.2  1996/09/25  18:25:28  winter
 * Added #include <string.h> for string function prototypes.
 *
 * Revision 6.0.1.1  1996/09/25  17:51:30  winter
 * Placeholder for new branch during comm s/w overhaul.
 *
 * Revision 6.0  1996/02/29  15:37:26  ims
 * COPIED FROM 5.1.1.8 FOR GUI_PROMO_6_0_960229.
 *
 * Revision 5.1.1.8  1996/01/05  23:55:32  solomon
 * Commented out code that set env[0] to the fieldName for new dependent valids
 * code.
 *
 * Revision 5.1.1.7  1996/01/02  23:58:23  solomon
 * Changed field to fieldName in check for PARAMETER, CA
 * PROCESSING_LEVEL
 *
 * Revision 5.1.1.6  1996/01/02  23:44:13  solomon
 * Moved comment about PARAMETER, CAMPAIGN, PROCESSING_LEVEL before if
 * statement.
 *
 * Revision 5.1.1.5  1996/01/02  23:15:29  solomon
 * Changed field to fieldName in call to IK_NewGetValids.
 *
 * Revision 5.1.1.4  1996/01/02  22:31:32  solomon
 * Corrected syntax error.
 *
 * Revision 5.1.1.3  1996/01/02  21:14:11  solomon
 * Replaced call to getvalids with IK_NewGetValids.
 * Added CAMPAIGN and PROCESSING_LEVEL to dependent valids.
 *
 * Revision 5.1.1.2  1995/12/28  19:54:32  ims
 * COPIED FROM 5.0.1.2 FOR GUI_PROMO_5_1_951228.
 *
 * Revision 5.0.1.2  1995/12/27  20:29:00  winter
 * SOLARIS 2.4 PORTING CHANGES!
 * Changed code which calls toupper() to copy argument to local buffer,
 * since toupper() can crash on some systems (e.g. Solaris 2.4/gcc) when
 * passed a pointer into a string literal.
 *
 * Revision 5.0.1.1  1995/12/27  19:02:39  winter
 * Placeholder for new branch.
 *
 * Revision 5.0  1995/11/06  13:03:33  ims
 * PROMOTION FROM GUI_4_5_8_951030 FOR GUI_PROMO_5_0_951106
 *
 * Revision 4.5.1.1  1995/10/09  17:26:07  winter
 * Changed to use new header file IK_GDBMetc.h and GDBM_BLOCK_SIZE macro.
 *
 * Revision 4.5  1995/07/27  18:42:01  ims
 * PROMOTION FROM GUI_4_4_8_950501 FOR GUI_PROMO_4_5_950726
 *
 * Revision 4.4  1995/02/13  22:19:55  ims
 * PROMOTION FROM GUI_4_4_950106 FOR GUI_PROMO_4_4_950213
 *
 * Revision 4.3  1994/08/26  10:49:17  ims
 * COPIED FROM GUI_4_3_940824.
 *
 * Revision 4.0.1.2  1994/07/28  14:53:40  ryan
 * Cleaned up some suspect pointer code.  Removed a few vestigial
 * variables that lint pointed out.
 *
 * Revision 4.0.1.1  1994/06/08  14:33:28  ims
 * COPIED FROM REVISION 3.1.1.1.
 *
 * Revision 3.1.1.1  1994/05/04  17:52:54  ims
 * COPIED FROM REVISION 3.0.1.4.
 *
 * Revision 3.0.1.4  1994/04/05  12:58:50  ryan
 * cleaned up error messages
 *
 * Revision 3.0.1.3  1994/03/10  16:19:44  ryan
 * cleaned up more code.
 *
 * Revision 3.0  1993/12/29  15:18:49  winter
 * ALPHA-1
 *
 | Revision 1.6  1993/04/21  17:14:12  sylvain
 | Changed the definition of IK_GetDepValids so that the last parameter is
 | 	a pointer to an array of pointers to parameter strings.
 | Incremented the maximum number of arguments that IK_GetDepValids can take in
 | 	the last array to 256.
 | Checked for the error case when too many parameters were passed in.
 |
 | Revision 1.5  1993/03/10  17:24:25  sylvain
 | I wasn't checking if the internal call to getvalids failed, now if it
 | failed,I set the return_code approriately.
 |
 | Revision 1.4  1993/02/26  00:07:18  sylvain
 | increased errbuf length to prevent over writing of memory used for
 | the env char pointer array.
 |
 | Revision 1.3  1993/02/25  19:12:04  sylvain
 | You can now call IK_GetDepValids to look at a field and then call it to 
 | select the field
 |
 | Revision 1.2  1993/02/19  19:47:11  sylvain
 | added a catch so that if the field_type isn't recognized as one of the
 | dependents, call IK_GetValids() to get the list from the non-dependent list
 |
 | Revision 1.1  1993/02/19  16:46:58  sylvain
 | Initial revision
 |
 +------------------------------------------------*/

static const char *rcsid = "$Id: IK_DepValid.c,v 1.9 1999/03/24 21:01:28 solomon Exp $";

#include "IK_Ims.h"		/* IMS master header file */

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>		/* for vprintf() and friends... */
#include <stddef.h>
#include <ctype.h>		/* needed for toupper() */
#include <errno.h>
#include <pwd.h>

#include "gdbm.h"		/* gdbm prototypes and defs */

#include "IK_Errno.h"		/* IMS error numbers */
#include "IK_Syslog.h"		/* error logging */
#include "IK_Fixup.h"		/* memory management macros */
#include "IK_DataDic.h"		/* need IK_PARAMETER_ID_SZ */
#include "IK_Msg.h"		/* for IK_GetMessage proto */

#include "IK_Valid.h"
#include "IK_DepValid.h"	/* dep. valids defs */
#include "IK_DepValidP.h"	/* dep. valids private defs */
#include "IK_GDBMetc.h"
#include "IK_NewValids.h"     /* New dependent valids code - added by Solomon */

#include "odldef.h"		/* ODL defs */
#include "odlinter.h"		/* ODL interface protoptypes */

/* This is the maximum length of a field or group name. IS THIS
   DEFINED SOMEWHERE ELSE UNDER ANOTHER NAME? */
#define MAX_FIELD_OR_GROUP_NAME_LEN (80)

extern char **getvalids(char **);

static int ValidsCount; /* number of valids in the list */

GDBM_FILE dep_valids_dbf = NULL, tag_dbf = NULL;


/* initialize dependent valids storage
 * 
 * Analysis:
 * 
 * Precondition 1: dependent valids storage does not exist 
 * 
 * Postcondition 1: create new dependent valids storage and return 0
 * 
 * Precondition 2: insufficient storage exists to create new dependent valids 
 *    storage
 * 
 * Postcondition 2: return -1 and set IK_ImsErrno to IK_ENOMEM
 * 
 * Precondition 3: insufficient privledge to create new dependent valids 
 *     storage
 * 
 * Precondition 3: return -1 and set IK_ImsErrno to IK_EPERM
 * 
 * Precondition 4: unable to get the Gaea data directory
 * 
 * Postcondition 4: log a msg to IK_Syslog, return -1 and set IK_ImsErrno to 
 *     IK_EPROTO
 *
 * Notes:
 * 
 *    (1) called from main()
 *
 *	Return: Upon success, 0. On failure, -1 and IK_ImsErrno */
int IK_DepValidsInit
(
 void				/* no parameter */
)
{
   char dep_valid_file[IK_MAXBUFLEN]; /* full pathname to the gdbm file */
   char tag_file[IK_MAXBUFLEN]; /* full pathname to the tags gdbm file */
   char *conf_ptr;		/* the GAEADATA_DIR */
   int return_code = 0;

   if ((conf_ptr = IK_SysConfig ("GaeaData")) == NULL) {
      IK_ImsErrno = IK_EPROTO;
      return_code = -1;
   }
   else {
      (void) sprintf (dep_valid_file, "%s%s", conf_ptr, DEP_VALID_FILE);
      if (!dep_valids_dbf)
	  dep_valids_dbf = gdbm_open(dep_valid_file, GDBM_BLOCK_SIZE, GDBM_READER, 0, 
				     IK_GDBMerr);
      if (!dep_valids_dbf) {
	 IK_MapGdbmErrno();
	 IK_vSyslog (LOG_ERR,
	     "unable to open the gdbm valids file %s, IK_ImsErrno = %d - %s", 
		     DEP_VALID_FILE, IK_ImsErrno, IK_GetMessage (IK_ImsErrno));
	 return_code = -1;
      }
      (void) sprintf (tag_file, "%s%s", conf_ptr, VALIDTAG_FILE);
      if (!tag_dbf)
	  tag_dbf = gdbm_open(tag_file, GDBM_BLOCK_SIZE, GDBM_READER, 0, 
				     IK_GDBMerr);
      if (!tag_dbf) {
	 IK_MapGdbmErrno();
	 IK_vSyslog (LOG_ERR,
	     "unable to open the gdbm tags file %s, IK_ImsErrno = %d - %s", 
		     DEP_VALID_FILE, IK_ImsErrno, IK_GetMessage (IK_ImsErrno));
	 return_code = -1;
      }
   }
   return return_code;
}

/* flush and close dependent valids storage
 * 
 * Analysis:
 * 
 * Precondition 1: dependent valids storage exists and is in use
 * 
 * Postcondition 1: close dependent valids storage
 * 
 * Precondition 2: dependent valids storage not in use
 * 
 * Postcondition 2: return -1 and set IK_ImsErrno to IK_EIO
 * 
 * Notes: 
 * 
 *	Return: Upon success, 0. On failure, -1 and IK_ImsErrno */
int IK_DepValidsClose
(
 void			/* no arguments */
)
{
    int err = 0;

    if (dep_valids_dbf)
	gdbm_close(dep_valids_dbf);
    else {
       IK_Syslog (LOG_ERR, ".IK_DepValidsClose: "
		  "you tried to close the valids file before it was opened");
       err = -1;
       IK_ImsErrno = IK_EIO;
    }
    return err;
}

/*****************************************************************************************
 *
 * NAME: IK_GetDepValids
 *
 * DESCRIPTION: Gets all dependent valids for a field from storage.  
 *              This routine returns all the dependent valids for a field 
 *              as a NULL terminated array of NULL terminated strings. 
 *              The space for the new dependent
 *              valids table is obtained using malloc(3).
 *
 * PARAMETERS:
 *     valids_table -- (char ***) Pointer for dependent valids table.
 *     field        -- (char *)   Field to look up in storage.
 *     field_value  -- (char **)  The first field to validate.
 *
 * RETURN VALUE:
 *     return_code  -- (int)      Function return code:
 *                                  0 = Successful
 *                                 -1 = Failure
 * 
 * PRE- & POST-CONDITIONS:
 *     Precondition  1: No Field_value was passed in (i.e. field_value == NULL)
 *     Postcondition 1: return 0, and set the valids_table to be all possible 
 *                      valids for that field
 *
 *     Precondition  2: dependent valids for field requested DOES exists.
 *     Postcondition 2: return 0 and, set the valids_table to be the  "joined" 
 *                      list of the internal valids table and the valids 
 *                      dependent on the field_value passed in.
 *
 *     Precondition  3: dependent valids for field requested DOES NOT exist. 
 *     Postcondition 3: return (-1), and set IK_ImsErrno to IK_ENOENT, and
 *                      log a message tp IK_Syslog.
 *
 *     Precondition  4: one of the field_values to be joined with the internal
 *                      valids table is not in the list of possible valids left
 *                      in the table.
 *                      (i.e. The join operation failed)
 *     Postcondition 4: return (-1) and set IK_ImsErrno to IK_EINVAL, and
 *                      log a message to IK_Syslog.
 *
 *     Precondition  5: an invalid table pointer was passed in
 *     Postcondition 5: return (-1) and set IK_ImsErrno to IK_EPROTO, and
 *                      log a message to IK_Syslog.
 * 
 * NOTES:
 *     1.  This function is recursive.
 *
 * REVISION HISTORY:
 *     DD MMM YYYY                       HUGHES STX Corporation
 *                                       Initial version
 *     07 JUL 1997  Lloyd M. Terrell     HUGHES STX Corporation
 *                                       Modified to process extended search valids.
 *
 *****************************************************************************************/
int IK_GetDepValids(char ***valids_table, char *field, char **field_value)
{

   int
       arg_index = 0,    /* Index into the environment. */
       i,                /* Loop index for initializing env. */
       return_code = 0;	 /* Function return code. */

   char
      **env,
       fieldName[MAX_FIELD_OR_GROUP_NAME_LEN + 1],
       /* This string is used to hold a copy of the field name
          so that it may be safely upper-cased. This is needed
          since strict compilers prevent this from working when
          a string literal is passed as the value of field. */
      *ptr;              /* A tmp pointer used to upcase the field name. */

    ValidsCount = IK_ValidsCnt();
    env = (char **) calloc(ValidsCount+1, sizeof(char *));
    for (i=0; i<ValidsCount+1; ++i) env[i]=NULL;  /* initialize env */
   
    if (!valids_table)
    {
        IK_vSyslog (LOG_ERR,
	           ".IK_GetDepValids: was passed an invalid table pointer");
        IK_ImsErrno = IK_EINVAL;
        return_code = -1;  /* *valids_table = NULL; */
    }
    else if (field)
    {
        (void) strcpy(fieldName, field);
        errno = 0;
        while (arg_index < ValidsCount && field_value && *field_value)
        {
            if (strcmp (*field_value, "") != 0) env[arg_index++] = *field_value;
	    field_value++;
	    /*field_value += (unsigned int) 1;*/
        }

        if (arg_index > ValidsCount+1)
        {
            IK_vSyslog (LOG_ERR,
            ".IK_GetDepValids called with to many arguments, the maximum is %d",
		        ValidsCount);
        }

        /* Call to getvalids changed to IK_NewGetValids by Mark Solomon. */
        if ((*valids_table = IK_NewGetValids (fieldName,env)) == NULL)
        {
            return_code = -1;
	    if (IK_ImsErrno == 0)
            {
	        IK_vSyslog (LOG_ERR,
                   ".IK_GetDepValids.getvalids returned -1 but IK_ImsErrno wasn't set");
	        IK_ImsErrno = IK_EPROTO;
	    }
        }
        else 
	    errno = IK_ImsErrno = return_code = 0;
    }
    else
    {
           /* call to getvalids changed to IK_NewGetValids by Mark Solomon */
           *valids_table = IK_NewGetValids (NULL,NULL);
/* 	   *valids_table = getvalids (NULL); */
    }

    return return_code;
} /* end IK_GetDepValids */



/*--- QED ---*/
