/*
 * Name: IK_DepValid.h
 *
 * Description: This file contains all of the public definitions
 * needed to access the dependent valids functions.
 *
 * Notes:
 *
 *-------------------------------------------------------------------------
 *
 * RCS information:
 *
 * $RCSfile: IK_DepValid.h,v $
 *
 * $Id: IK_DepValid.h,v 1.6 1997/03/06 15:38:52 amrhein Exp $
 *
 * $Log: IK_DepValid.h,v $
 * Revision 1.6  1997/03/06 15:38:52  amrhein
 * Updated to GUI's 6_1_12 IK
 *
 * Revision 6.1  1996/10/18  14:15:51  ims
 * Promoted for 6.1 J. Katen
 *
 * Revision 6.0  1996/02/29  15:37:29  ims
 * COPIED FROM 5.1 FOR GUI_PROMO_6_0_960229.
 *
 * Revision 5.1  1995/12/28  20:15:25  ims
 * COPIED FROM 5.0 FOR GUI_PROMO_5_1_951228.
 *
 * Revision 5.0  1995/11/06  13:03:33  ims
 * PROMOTION FROM GUI_4_5_8_951030 FOR GUI_PROMO_5_0_951106
 *
 * Revision 4.5  1995/07/27  18:42:02  ims
 * PROMOTION FROM GUI_4_4_8_950501 FOR GUI_PROMO_4_5_950726
 *
 * Revision 4.4.1.1  1995/02/13  22:34:39  ims
 * COPIED FROM 4.3.1.1 FOR GUI_PROMO_4_4_950213
 *
 * Revision 4.3.1.1  1994/08/26  11:45:10  ims
 * COPIED FROM REVISION 4.0.1.1.
 *
 * Revision 4.0.1.1  1994/06/08  17:01:35  ims
 * COPIED FROM REVISION 3.1.1.1.
 *
 * Revision 3.1.1.1  1994/04/18  12:56:56  winter
 * Extensive code cleanup by Eric Winter.
 *
 * Revision 3.1  1994/04/05  09:49:52  ims
 * Promotion from MAR28_RELEASE
 *
 * Revision 3.0  1993/12/29  15:18:49  winter
 * ALPHA-1
 *
 * Revision 1.2  1993/04/21  17:14:13  sylvain
 * Changes the prottype of IK_GetDepValids from taking n parameter to taking
 * 	3 parameters, with the last parameter being a pointer to an array
 * 	of the rest of the parameters.
 *
 * Revision 1.1  1993/02/19  16:47:47  sylvain
 * Initial revision
 *
*/

/*****************************************************************************/

#ifndef __IK_DEPVALID_H__
#define __IK_DEPVALID_H__

/*****************************************************************************/

/* Function prototypes */

/* The user will only get back a NULL terminated list, of NULL
 * terminated valids. */

/* These functions are defined in IK_DepValid.c. */
extern int IK_DepValidsInit(void);
extern int IK_DepValidsClose(void);
extern int IK_GetDepValids (char ***valids_table, char *field,
			    char **field_value);

/* This function is defined in IK_InDVals.c. */
extern int IK_IngestDepValids(const char *filename);

/*****************************************************************************/

#endif  /* !__IK_DEPVALID_H__ */
