/*
 * Name: IK_GDBMetc.h
 *
 * Description: This file contains data definitions and function
 * prototypes for extra IMS GDBM-related functions.
 *
 * Notes:
 *
 *-------------------------------------------------------------------------
 *
 * RCS information:
 *
 * $RCSfile: IK_GDBMetc.h,v $
 *
 * $Id: IK_GDBMetc.h,v 1.7 1997/10/20 17:26:29 solomon Exp $
 *
 * $Log: IK_GDBMetc.h,v $
 * Revision 1.7  1997/10/20 17:26:29  solomon
 * Updated to GUI IK layer 7_0_0_13.
 *
 * Revision 7.0.1.2  1997/10/08  13:47:10  walbert
 * For SMR 4208, added extern declaration for IK_SetGDBMFastWriteMode to
 * coincide with new function in IK_GDBMetc.c.
 *
 * Revision 7.0.1.1  1997/10/08  12:57:28  walbert
 * placeholder for new branch.
 *
 * Revision 7.0  1997/04/11  17:54:08  ims
 * 6.1 Promoted to 7.0 J. Katen
 *
 * Revision 6.1  1996/10/18  14:15:56  ims
 * Promoted for 6.1 J. Katen
 *
 * Revision 6.0  1996/02/29  15:37:58  ims
 * COPIED FROM 5.1 FOR GUI_PROMO_6_0_960229.
 *
 * Revision 5.1  1995/12/28  20:17:57  ims
 * COPIED FROM 5.0 FOR GUI_PROMO_5_1_951228.
 *
 * Revision 5.0  1995/11/06  13:34:19  ims
 * PROMOTION FROM GUI_4_5_8_951030 FOR GUI_PROMO_5_0_951106
 *
 * Revision 4.5.1.1  1995/10/09  17:24:23  winter
 * Added comment about prior inclusion of gdbm.h.
 *
 * Revision 4.5  1995/10/09  17:04:35  winter
 * Initial version.
 *
 * */

/*****************************************************************************/

#ifndef __IK_GDBMETC_H__
#define __IK_GDBMETC_H__

/*****************************************************************************/

/* #include directives */

/* NOTE - THIS FILE REQUIRES PRIOR INCLUSION OF gdbm.h! */

/* This header must be #included first in order to use
   autoconf-generated information. */
#include "IK_Ims.h"

/* Standard headers */

/* Third-party library headers */

/* IMS headers */

/*****************************************************************************/

/* #define directives */

/* This is the block size (in bytes) to use for GDBM files. */
#define GDBM_BLOCK_SIZE (512)

/*****************************************************************************/

/* Data types */

/*****************************************************************************/

/* Function prototypes */

extern void IK_MapGdbmErrno(void);
extern void IK_GDBMerr(char *msg);
extern GDBM_FILE IK_GDBMInit(char *gdbm_filenm);
extern IK_BOOLEAN IK_SetGDBMFastWriteMode(int *openMode);

/*****************************************************************************/

#endif  /* __IK_GDBMETC_H__ */
