/*
 * Name: IK_GranulP.h
 *
 * Description: This file defines data structures and manifest
 * contants for private IK_GranuleP data types and functions.
 *
 * Notes:
 *
 *---------------------------------------------------------------------------
 *
 * RCS information:
 *
 * $RCSfile: IK_GranulP.h,v $
 *
 * $Id: IK_GranulP.h,v 1.6 1997/03/06 15:38:52 amrhein Exp $
 *
 * $Log: IK_GranulP.h,v $
 * Revision 1.6  1997/03/06 15:38:52  amrhein
 * Updated to GUI's 6_1_12 IK
 *
 * Revision 6.1  1996/10/18  14:16:00  ims
 * Promoted for 6.1 J. Katen
 *
 * Revision 6.0  1996/02/29  15:38:20  ims
 * COPIED FROM 5.1 FOR GUI_PROMO_6_0_960229.
 *
 * Revision 5.1  1995/12/28  20:18:41  ims
 * COPIED FROM  FOR GUI_PROMO_5_1_951228.
 *
 * Revision 5.0  1995/11/06  13:03:43  ims
 * PROMOTION FROM GUI_4_5_8_951030 FOR GUI_PROMO_5_0_951106
 *
 * Revision 4.5  1995/07/27  18:42:16  ims
 * PROMOTION FROM GUI_4_4_8_950501 FOR GUI_PROMO_4_5_950726
 *
 * Revision 4.4.1.1  1995/02/13  22:35:23  ims
 * COPIED FROM 4.3.1.1 FOR GUI_PROMO_4_4_950213
 *
 * Revision 4.3.1.1  1994/08/26  11:53:17  ims
 * COPIED FROM REVISION 4.0.1.1.
 *
 * Revision 4.0.1.1  1994/06/08  17:08:38  ims
 * COPIED FROM REVISION 3.1.1.1.
 *
 * Revision 3.1.1.1  1994/04/18  13:42:31  winter
 * Extensive code cleanup by Eric WInter.
 *
 * Revision 3.1  1994/04/05  09:49:52  ims
 * Promotion from MAR28_RELEASE
 *
 * Revision 3.0.1.1  1994/03/22  14:34:10  winter
 * Cleaned up file. Added #include "IK_Granule.h" to prevent order-dependent
 * inclusion errors.
 *
 * Revision 3.0  1993/12/29  15:18:49  winter
 * ALPHA-1
 *
 * Revision 1.1  1993/01/06  19:24:07  honce
 * Initial revision
 *
*/

/*****************************************************************************/

#ifndef __IK_GRANULP_H__
#define	__IK_GRANULP_H__

/*****************************************************************************/

/* #include directives */

/* IMS headers */
#include "IK_Granule.h"

/*****************************************************************************/

struct IK_GranuleP {

  /* Public data structure */
  IK_Granule granule;

  /* sizeof(IK_Granule) + data */
  unsigned long nbytes;

  /* Data starts here */
  void *aligned_data;

};
typedef struct IK_GranuleP IK_GranuleP;

/*****************************************************************************/

#endif /* ! __IK_GRANULP_H__ */
