/*
 * Name: IK_Help.h
 *
 * Description: This file contains macros and manifest constants for
 * the Gaea help function.
 *
 * Notes:
 *
 *---------------------------------------------------------------------------
 *
 * RCS information:
 *
 * $RCSfile: IK_Help.h,v $
 *
 * $Id: IK_Help.h,v 1.6 1997/03/06 15:38:52 amrhein Exp $
 *
 * $Log: IK_Help.h,v $
 * Revision 1.6  1997/03/06 15:38:52  amrhein
 * Updated to GUI's 6_1_12 IK
 *
 * Revision 6.1  1996/10/18  14:16:02  ims
 * Promoted for 6.1 J. Katen
 *
 * Revision 6.0  1996/02/29  15:38:32  ims
 * COPIED FROM 5.1 FOR GUI_PROMO_6_0_960229.
 *
 * Revision 5.1  1995/12/28  20:19:14  ims
 * COPIED FROM 5.0 FOR GUI_PROMO_5_1_951228.
 *
 * Revision 5.0  1995/11/06  13:03:45  ims
 * PROMOTION FROM GUI_4_5_8_951030 FOR GUI_PROMO_5_0_951106
 *
 * Revision 4.5  1995/07/27  18:42:20  ims
 * PROMOTION FROM GUI_4_4_8_950501 FOR GUI_PROMO_4_5_950726
 *
 * Revision 4.4  1995/02/13  22:20:22  ims
 * PROMOTION FROM GUI_4_4_950106 FOR GUI_PROMO_4_4_950213
 *
 * Revision 4.3  1994/08/26  10:49:34  ims
 * COPIED FROM GUI_4_3_940824.
 *
 * Revision 4.0.1.3  1994/08/02  15:01:33  ryan
 * Changed function prototypes to reflect IK_Help.c version 4.0.1.3.
 *
 * Revision 4.0.1.2  1994/08/01  14:27:55  ryan
 * Added prototype for IK_HelpType_name.
 *
 * Revision 4.0  1994/06/08  17:09:50  ims
 * PROMOTION FROM REV4
 *
 * Revision 3.2.1.2  1994/05/09  13:30:41  ryan
 * added prototype for IK_MakeHelpKey.
 * added IK_HELP_HELP as per H. Friedeman's request.
 *
 * Revision 3.2.1.1  1994/05/04  19:23:36  winter
 * COPIED FROM REVISION 3.1.1.2.1.1.
 *
 * Revision 3.1.1.2.1.1  1994/04/18  13:47:11  winter
 * Code cleanup during file analysis. No major changes.
 *
 * Revision 3.1.1.2  1994/04/14  13:28:24  ryan
 * added IK_HELP_KEYWORD to IK_HelpType
 *
 * Revision 3.1.1.1  1994/04/14  13:26:38  ryan
 * adding in fix which got squashed during promotion.
 *
 * Revision 3.1  1994/04/05  09:49:52  ims
 * Promotion from MAR28_RELEASE
 *
 * Revision 3.0  1993/12/29  15:18:49  winter
 * ALPHA-1
 *
 * Revision 1.1  1992/10/16  19:44:51  honce
 * Initial revision
 *
*/

/*****************************************************************************/

#ifndef __IK_HELP_H__
#define __IK_HELP_H__

/*****************************************************************************/

/* Data type definitions */

enum IK_HelpType {
  IK_HELP_NONE,       /* zero reserved */
  IK_HELP_SCREEN,     /* info on screen */
  IK_HELP_LABEL,      /* info on why this field is here */
  IK_HELP_FIELD,      /* info on what field is used for */
  IK_HELP_CONTEXT,    /* JAM widget context sensitive help */
  IK_HELP_COMMAND,    /* info on commands */
  IK_HELP_FUNCTION,   /* info on functions */
  IK_HELP_SYSTEM,     /* info on system as a whole */
  IK_HELP_COUNT,      /* number of types of help */
  IK_HELP_KEYWORD,    /* info on keywords */
  IK_HELP_HELP,       /* help on help */
  IK_HELP_MAX         /* Symbolic entry which **must** come last */ 
};
typedef enum IK_HelpType IK_HelpType;

/*****************************************************************************/

/* External variable declarations */

extern char *IK_GetHelp(const IK_HelpType, const char *, const char *);
extern const char *IK_MakeHelpKey(const IK_HelpType, const char *,
				  const char *);
extern const char *IK_HelpType_name(const IK_HelpType type);
extern const char *IK_clean_string(const char *s);

/*****************************************************************************/

#endif   /* !__IK_HELP_H__ */
