/*
 * Name: IK_Msg.h
 *
 * Description: This file defines data structures and manifest
 * constants for IK_Msg().
 *
 * Notes:
 *
 *---------------------------------------------------------------------------
 *
 * RCS information:
 *
 * $RCSfile: IK_Msg.h,v $
 *
 * $Id: IK_Msg.h,v 1.6 1997/03/06 15:38:52 amrhein Exp $
 *
 * $Log: IK_Msg.h,v $
 * Revision 1.6  1997/03/06 15:38:52  amrhein
 * Updated to GUI's 6_1_12 IK
 *
 * Revision 6.1  1996/10/18  14:16:12  ims
 * Promoted for 6.1 J. Katen
 *
 * Revision 6.0  1996/02/29  15:40:13  ims
 * COPIED FROM 5.1 FOR GUI_PROMO_6_0_960229.
 *
 * Revision 5.1  1995/12/28  20:20:29  ims
 * COPIED FROM 5.0 FOR GUI_PROMO_5_1_951228.
 *
 * Revision 5.0  1995/11/06  13:03:56  ims
 * PROMOTION FROM GUI_4_5_8_951030 FOR GUI_PROMO_5_0_951106
 *
 * Revision 4.5  1995/07/27  18:42:52  ims
 * PROMOTION FROM GUI_4_4_8_950501 FOR GUI_PROMO_4_5_950726
 *
 * Revision 4.4  1995/02/13  22:20:45  ims
 * PROMOTION FROM GUI_4_4_950106 FOR GUI_PROMO_4_4_950213
 *
 * Revision 4.3  1994/08/26  10:49:50  ims
 * COPIED FROM GUI_4_3_940824.
 *
 * Revision 4.0.1.2  1994/07/14  15:26:38  ryan
 * changed prototype for IK_GetMessage to reflect changes in
 * IK_Msg.c (4.0.1.4).
 *
 * Revision 4.0.1.1  1994/06/08  17:12:53  ims
 * COPIED FROM REVISION 3.1.1.1.
 *
 * Revision 3.1.1.1  1994/04/18  13:51:19  winter
 * Extensive code cleanup by Eric Winter.
 *
 * Revision 3.1  1994/04/05  09:49:52  ims
 * Promotion from MAR28_RELEASE
 *
 * Revision 3.0  1993/12/29  15:18:49  winter
 * ALPHA-1
 *
 * Revision 1.7  1993/08/24  10:42:52  sylvain
 * added the prototype for IK_GetGuideAddr().
 *
 * Revision 1.6  1992/10/05  12:31:43  sylvain
 * delete the prototype IK_IngestErrno() from this file, and move it to
 * IK_Ingest.h
 *
 * Revision 1.5  1992/09/28  19:36:44  sylvain
 * added prototype for IK_GetArchive
 *
 * Revision 1.4  1992/09/28  13:12:50  sylvain
 * moved the definition for cpp to IK_Ims.h
 *
 * Revision 1.3  1992/09/26  21:09:14  sylvain
 * took out the IK_Message enum, so far it only now about error messages
 * ./
 *
 * Revision 1.1  1992/09/10  15:24:34  honce
 * Initial revision
 *
*/

/*****************************************************************************/

#ifndef __IK_MSG_H__
#define __IK_MSG_H__

/*****************************************************************************/

/* #include directives */

/* Third-party library headers */
#include "odldef.h"
#include "IK_Errno.h"   /* need typedef for IK_Errno */

/*****************************************************************************/

/* Data type definitions */

typedef enum IK_Message {
  IK_NO_MSG = 0
} IK_Message;

/*****************************************************************************/

/* Function prototypes */

extern const char *IK_GetMessage(IK_Errno);
extern AGGREGATE IK_GetArchive(char *);
extern int IK_GetGuideAddr(char *, char *);

/*****************************************************************************/

#endif   /* !__IK_MSG_H__ */
