/* File: $RCSfile: IK_Package.c,v $
 * 
 * Synopsis:
 * 
 * Notes: */

/*--------------------------------------------------
 | $Log: IK_Package.c,v $
 | Revision 1.8  2001/11/30 16:00:26  solomon
 | Fixed order options selection failing on pilsner by increasing the
 | IK_SOUNDEX_SZ from 40 to 100.
 |
 | Revision 1.7  1997/10/20 17:26:29  solomon
 | Updated to GUI IK layer 7_0_0_13.
 |
 * Revision 7.0.2.2  1997/06/04  16:51:00  winter
 * SMR 4063: Eliminated erroneous settings of error variables.
 *
 * Revision 7.0.2.1  1997/06/04  16:47:32  winter
 * Placeholder for new branch to clean up the mess on the 7.0.1 branch.
 *
 * Revision 7.0  1997/04/11  17:54:37  ims
 * 6.1.1.1 Promoted to 7.0 J. Katen
 *
 * Revision 6.1.1.1  1996/10/21  14:24:04  winter
 * Copied from 6.0.1.5 after 6.1 promotion.
 *
 * Revision 6.0.1.5  1996/10/01  19:19:16  winter
 * Removed !NDEBUG-dependent code.
 *
 * Revision 6.0.1.4  1996/09/26  13:45:56  winter
 * Moved #include "IK_Ims.h" to top of header list.
 * Added #include <string.h> for string function prototypes.
 *
 * Revision 6.0.1.3  1996/04/24  18:46:04  iredell
 * copy package_id to package_up before calling toupper.
 * this makes string package_up null terminated.
 *
 * Revision 6.0.1.2  1996/04/12  21:09:14  iredell
 * do not upper case package_id, but rather upper case local
 * item package_up.  fixes smrs 3564 and 3587.
 *
 * Revision 6.0.1.1  1996/04/01  19:42:35  jong
 * Fixed JPL's PK problems- soundex dataset not matched.
 *
 * Revision 6.0  1996/02/29  15:40:49  ims
 * COPIED FROM 5.1.1.4 FOR GUI_PROMO_6_0_960229.
 *
 * Revision 5.1.1.4  1996/02/15  20:23:49  winter
 * Fixed bugs arising from changing tag type again.
 *
 * Revision 5.1.1.3  1996/02/14  20:30:57  winter
 * Changed call to IK_MapArchiveIdent() to IK_MapArchiveTagToName().
 * Changed call to IK_MapDatasetIdent() to IK_MapDatasetTagToName().
 * Changed archive and dataset tag handling so that negative values are error
 * conditions, not NULL values.
 *
 * Revision 5.1.1.2  1996/01/17  20:52:30  winter
 * Added #include "IK_Map.h".
 *
 * Revision 5.1.1.1  1996/01/17  19:33:19  winter
 * Placeholder for new branch.
 *
 * Revision 5.1  1995/12/28  20:05:38  ims
 * COPIED FROM 5.0.1.1 FOR GUI_PROMO_5_1_951228.
 *
 * Revision 5.0.1.1  1995/11/06  13:52:25  ims
 * COPIED FROM 4.5.1.4 FOR GUI_PROMO_5_0_951106.
 *
 * Revision 4.5.1.4  1995/09/25  20:34:07  jong
 * Changed the packaging Info (ODL) search to "GaeaTmp" first then "GaeaData",
 * and saved the packaging info (ODL) to "GaeaTmp" if the message comes with
 * the Inventory Results message.
 *
 * Revision 4.5.1.3  1995/07/27  19:04:35  ims
 * COPIED FROM 4.4.2.1 FOR GUI_PROMO_4_5_950726
 *
 * Revision 4.4.2.1  1995/05/24  20:47:18  ims
 * The source code uses FILENAME_MAX to define size for strings that will
 * hold pathnames. Since HP/UX still supports filesystems with short filenames
 * (15 characters), FILENAME_MAX is set to 15 for HP/UX.
 *
 * Revision 4.4  1995/02/13  22:21:02  ims
 * PROMOTION FROM GUI_4_4_950106 FOR GUI_PROMO_4_4_950213
 *
 * Revision 4.3  1994/08/26  10:50:03  ims
 * COPIED FROM GUI_4_3_940824.
 *
 * Revision 4.0  1994/06/08  15:10:01  ims
 * PROMOTION FROM REV4
 *
 * Revision 3.1  1994/04/05  09:49:52  ims
 * Promotion from MAR28_RELEASE
 *
 * Revision 3.0.1.1  1994/01/27  19:38:24  winter
 * Placeholder revision to begin code cleanup.
 *
 * Revision 3.0  1993/12/29  15:18:49  winter
 * ALPHA-1
 *
 | Revision 1.6  1993/04/21  17:10:04  dandi
 | up cased the soundex name for the package filename
 |
 | Revision 1.5  1993/03/18  00:32:53  johnson
 | Got ride of the free_path variabel that was used to indicate whether the
 | Made a local copy of the value returned by soundex_dataset.
 | Set the last element in the soundexed_dataset array to NULL.
 |
 | Revision 1.4  1993/01/15  22:15:08  sylvain
 | cleaned up IK_GetPackage a bit
 | ,
 |
 | Revision 1.3  1992/11/25  16:37:36  sylvain
 | updated the comments, and added error checking for tag values of NULL
 | being passed in
 |
 | Revision 1.2  1992/11/24  18:01:28  sylvain
 | revised IK_GetPackage to get the package file using the dataset and archive
 | tags
 |
 | Revision 1.1  1992/11/06  17:48:34  honce
 | Initial revision
 |
 +------------------------------------------------*/

static const char *rcsid =
"$Id: IK_Package.c,v 1.8 2001/11/30 16:00:26 solomon Exp $";

#include "IK_Ims.h"		/* IMS configuration file */
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <ctype.h>
#include <errno.h>
#include <string.h>

#include "odldef.h"		/* ODL Definitions */
#include "odlinter.h"		/* more ODL definitions */

#include "IK_DataDic.h"		/* IMS Data Dictionary */
#include "IK_Errno.h"		/* IMS Error codes */
#include "IK_Valid.h"		/* prototype for IK_GetValids() */
#include "IK_Dataset.h"		/* IMS Dataset Metadata */
#include "IK_Package.h"		/* IMS Product Request Package info */
#include "IK_Map.h"

#define IK_SOUNDEX_SZ 100 /* the largest soundex possible was changed */
                          /* from 40 to 100 for future growth */
/* Check if running under HP/UX, this latter supports short filenames
 * (15 characters).
 */

#ifdef HPUX
#undef FILENAME_MAX
#define FILENAME_MAX 255
#endif

#ifndef PACKAGE_DIR
#   define PACKAGE_DIR "package"
#endif

/* internal functions */

/* static char* soundex_dataset (char*); */

/* Get a package from storage
 * 
 * If any of the values in the Package key are bad, IK_EINVAL is returned. If
 * the package ODL label can't be found, see fopen(3) for return values.
 *
 * Caller is responsible for calling NewAggregate() to create root;
 * 
 * Analysis:
 *
 *     Precondition 1: valid tags and package id are pased in
 *
 *     Postcondition 1: return the ODL package tree in "root"
 *
 *     Precondition 2: the archive or dataset tags, or the 
 *     	   package id is invalid.
 *
 *     Postcondition 2: log an error to syslog, return -1 as 
 *     	   the value of the function and set IK_ImsErrno to IK_EINVAL
 *
 *     Precondition 3: the package file can not be found
 * 
 *     Postcondition 3: return -1 as the value of the function and 
 *     	   set IK_ImsErrno to IK_NOENT
 *
 * Notes:
 * 
 *	Return: upon success, 0. On failure, -1 and IK_ImsErrno.
 *
 * Modification History:
 *
 * Wednesday 14 February 1996 (Eric Winter) - Changed call to
 * IK_MapArchiveIdent() to IK_MapArchiveTagToName(). Changed call to
 * IK_MapDatasetIdent() to call to IK_MapDatasetTagToName().
*/

int IK_GetPackage
(
 IK_ArchiveTag archive_tag,		/* the archive tag */
 IK_DatasetTag dataset_tag,		/* the dataset tag */
 char *package_id,		        /* the package_id */
 AGGREGATE *root		        /* the package to return */
)
{
   int            i,j;          /* index counter */
   char           *archive;	/* archive acronym */
   char           *dataset;	/* dataset ID */
   char           *sdataset;	/* the soundexed dataset */
   char           *spackage_ptr;  /* the soundeded package id */
   char            package[IK_PACKAGE_ID_SZ];	/* package ID */
   char            package_up[IK_PACKAGE_ID_SZ]; /* upper case PACKAGE ID */
   char           *path;	/* path to GaeaData */
   char            filename[FILENAME_MAX];	/* filename for package */
   FILE           *label;	                /* the package file */

   if (archive_tag == NULL || dataset_tag == NULL) 
       IK_ImsErrno = IK_EINVAL;
   else  IK_ImsErrno = 0;
   
   /* get archive acronym */
   
   if (!IK_ImsErrno && 
       (archive = IK_MapArchiveTagToName(archive_tag)))
    {
      /* get dataset id */
      if (dataset = IK_MapDatasetTagToName(dataset_tag)) {

         /* change to upper case - fix JPL's PK problem.  4/01/96 Jay */
         j =  strlen(dataset);
         for (i=0;i<j;i++)
            dataset[i]=toupper(dataset[i]);
         j = strlen(package_id);
         strcpy (package_up,package_id);
         for (i=0;i<j;i++)
            package_up[i]=toupper(package_id[i]);
	 
	 /* compress the dataset name */
	 /* get the soundex of the dataset name */
	 /*  
	  * if the package_id was returned from the DAAC as "*", then 
	  * the package will encompase everything in the dataset, so
	  * the package_id is just the same as the dataset id itselg.
	  */
	 if (strcmp (dataset,package_up) == 0) {
             sdataset = soundex_dataset(dataset);
	     (void) strcpy (package, sdataset);
         }
	 else {
             spackage_ptr = soundex_dataset(package_up);
             strcpy(package,spackage_ptr);
             sdataset = soundex_dataset(dataset);
         }

         /* get path to package data */
         path = IK_SysConfig("GaeaTmp");
	 /* build filename for package ODL label */
	 (void) sprintf(filename, "%s%s/%s/%s/%s", path, PACKAGE_DIR,
			archive, sdataset, package);
	 /* get package ODL label and parse into an ODL tree */
	 if (label = fopen(filename, "r")) {
	    ReadLabel(label, *root);
	    (void) fclose(label);
	 } 
	 else {
            /* get path to package data */
            if (!(path = IK_SysConfig("GaeaData")))
               path = "./";
            /* build filename for package ODL label */
            (void) sprintf(filename, "%s%s/%s/%s/%s", path, PACKAGE_DIR,
                        archive, sdataset, package);
            /* get package ODL label and parse into an ODL tree */
            if (label = fopen(filename, "r")) {
               ReadLabel(label, *root);
               (void) fclose(label);
            }
            else {
	       IK_vSyslog (LOG_ERR, "Package %s NOT FOUND,errno=%d - %s",
			filename, errno, strerror (errno));
	       IK_ImsErrno = IK_EIO;	/* file could not be opened */
            }
	 }
	 (void) free (dataset);
      }
      else 
	  IK_ImsErrno = IK_EINVAL;	/* bad dataset */
      (void) free (archive);
   }
   else
       IK_ImsErrno = IK_EINVAL;/* bad archive */
   

   return IK_ImsErrno ? -1 : 0;
}

char *soundex_dataset
(
 char *dataset			/* the full length dataset name */
)
{
   static char soundexed_dataset[IK_SOUNDEX_SZ];
   char *p, lastc;
   int i = 0;			/* the index into the soundex array */
   
   /* soundex the name - courtesy of Jhon Honce */
   p = dataset;
   lastc = NULL;
   do {
      switch (toupper(*p)) {
      case 'A':
      case 'E':
      case 'I':
      case 'O':
      case 'U':
      case 'W':
      case 'Y':
      case 'H':
	 break;
      default:
	 if (isalnum(*p) && lastc != *p) {
	    *(soundexed_dataset+i) = toupper(*p);
	    i++;
	 }
	 lastc = *p;
	 break;
      }
   } while (*++p);
   *(soundexed_dataset+i) = NULL;
   return soundexed_dataset;
}


/*-- QED --*/

