/* File: $RCSfile: IK_Package.h,v $
 * 
 * Synopsis: data structures and manifest constants for IK_Package
 * 
 * Notes: */

/*--------------------------------------------------
 | $Log: IK_Package.h,v $
 | Revision 1.6  1997/03/06 15:38:52  amrhein
 | Updated to GUI's 6_1_12 IK
 |
 * Revision 6.1  1996/10/18  14:16:22  ims
 * Promoted for 6.1 J. Katen
 *
 * Revision 6.0  1996/02/29  15:40:52  ims
 * COPIED FROM 5.1.1.4 FOR GUI_PROMO_6_0_960229.
 *
 * Revision 5.1.1.4  1996/02/12  20:41:03  winter
 * Added #include "IK_Map.h".
 *
 * Revision 5.1.1.3  1996/01/24  16:11:24  iredell
 * update definition of IK_PACKAGE_KEY_SZ.
 *
 * Revision 5.1.1.2  1996/01/02  20:31:44  iredell
 * updated the IK_BuildPackageKey prototype.
 *
 * Revision 5.1.1.1  1996/01/02  17:11:10  iredell
 * Base revision for 5.1.1 branch
 *
 * Revision 5.1  1995/12/28  20:22:44  ims
 * COPIED FROM 5.0.1.1 FOR GUI_PROMO_5_1_951228.
 *
 * Revision 5.0.1.1  1995/11/06  13:52:55  ims
 * COPIED FROM 4.5.1.1 FOR GUI_PROMO_5_0_951106.
 *
 * Revision 4.5.1.1  1995/09/25  20:40:43  jong
 * Moved soundex_dataset() to the prototype list.
 *
 * Revision 4.5  1995/07/27  18:43:06  ims
 * PROMOTION FROM GUI_4_4_8_950501 FOR GUI_PROMO_4_5_950726
 *
 * Revision 4.4  1995/02/13  22:21:03  ims
 * PROMOTION FROM GUI_4_4_950106 FOR GUI_PROMO_4_4_950213
 *
 * Revision 4.3  1994/08/26  10:50:04  ims
 * COPIED FROM GUI_4_3_940824.
 *
 * Revision 4.0  1994/06/08  17:20:19  ims
 * PROMOTION FROM REV4
 *
 * Revision 3.1  1994/04/05  09:49:52  ims
 * Promotion from MAR28_RELEASE
 *
 * Revision 3.0.1.1  1994/01/27  19:39:59  winter
 * Placeholder revision to begin code cleanup.
 *
 * Revision 3.0  1993/12/29  15:18:49  winter
 * ALPHA-1
 *
 | Revision 1.5  1992/11/24  18:02:09  sylvain
 | updated the IK_GetPackage() prototype.
 |
 | Revision 1.3  1992/11/06  17:48:56  honce
 | All C structures removed since packages are now ODL labels.  Added
 | function prototypes for new functions.
 |
 | Revision 1.2  1992/10/16  18:52:17  adler
 | Changed field name in IK_ProcessingOption struct from more_spec to
 | contact_required.
 |
 | Revision 1.1  1992/09/10  15:24:34  honce
 | Initial revision
 |
 +------------------------------------------------*/

#ifndef __IK_PACKAGE_H__
#define __IK_PACKAGE_H__

#ifdef Comment
static const char *rcsid =
"$Id: IK_Package.h,v 1.6 1997/03/06 15:38:52 amrhein Exp $";

#endif

#include "IK_Map.h"

#define	IK_PACKAGE_KEY_SZ	(IK_PACKAGE_ID_SZ + sizeof(IK_ArchiveTag) \
				+ sizeof(IK_DatasetTag) + IK_COPY_NUM_SZ)

extern int      IK_GetPackage (IK_ArchiveTag, IK_DatasetTag, char *, 
			      AGGREGATE *);

extern void     IK_StripPackageKey(IK_ArchiveTag, IK_DatasetTag, char *,
	char *, IK_SortKey *);

extern IK_SortKey *IK_BuildPackageKey(IK_ArchiveTag, IK_DatasetTag, char *, int);

extern char* soundex_dataset (char*);

#endif				/* !__IK_PACKAGE_H__ */
/*-- QED --*/
