/*
 * Name: IK_Patch.h
 *
 * Description: This file contains code which is used to patch bugs in
 * system libraries and any other required non-IMS fixes.
 *
 * Notes:
 *
 *-------------------------------------------------------------------------
 *
 * RCS information:
 *
 * $RCSfile: IK_Patch.h,v $
 *
 * $Id: IK_Patch.h,v 1.6 1997/03/06 15:38:52 amrhein Exp $
 *
 * $Log: IK_Patch.h,v $
 * Revision 1.6  1997/03/06 15:38:52  amrhein
 * Updated to GUI's 6_1_12 IK
 *
 * Revision 6.1.1.2  1997/01/14  02:59:34  winter
 * Removed prototypes for ims_free() and ims_realloc(). They are now in
 * IK_Ims.h, and the prototype varies by the return type of free().
 *
 * Revision 6.1.1.1  1997/01/13  16:32:01  winter
 * Placeholder for new branch to put ims_free() and ims_realloc() back.
 *
 * Revision 6.1  1996/10/18  14:16:23  ims
 * Promoted for 6.1 J. Katen
 *
 * Revision 6.0  1996/02/29  15:40:56  ims
 * COPIED FROM 5.1 FOR GUI_PROMO_6_0_960229.
 *
 * Revision 5.1  1995/12/28  20:23:00  ims
 * COPIED FROM 5.0 FOR GUI_PROMO_5_1_951228.
 *
 * Revision 5.0  1995/11/06  13:04:07  ims
 * PROMOTION FROM GUI_4_5_8_951030 FOR GUI_PROMO_5_0_951106
 *
 * Revision 4.5  1995/07/27  18:43:07  ims
 * PROMOTION FROM GUI_4_4_8_950501 FOR GUI_PROMO_4_5_950726
 *
 * Revision 4.4  1995/02/13  22:21:06  ims
 * PROMOTION FROM GUI_4_4_950106 FOR GUI_PROMO_4_4_950213
 *
 * Revision 4.3  1994/08/26  10:50:06  ims
 * COPIED FROM GUI_4_3_940824.
 *
 * Revision 4.0.1.2  1994/06/23  16:14:21  winter
 * Added conditional prototype for strdup().
 *
 * Revision 4.0.1.1  1994/06/20  19:34:38  winter
 * Added prototype for ims_free().
 *
 * Revision 4.0  1994/06/20  16:40:04  ims
 * Initial checkin of stub code.
 *
 * */

/*****************************************************************************/

#ifndef __IK_PATCH_H__
#define __IK_PATCH_H__

/*****************************************************************************/

/* #include directives */

/* This header must be #included first in order to use
   autoconf-generated information. */
#include "IK_Ims.h"

/* Standard headers */
#include <sys/types.h>

/* Third-party library headers */

/* IMS headers */

/*****************************************************************************/

/* #define directives */

/*****************************************************************************/

/* Data type definitions */

/*****************************************************************************/

/* Function prototypes */

#ifndef HAVE_STRDUP
extern char *strdup(const char *s);
#endif   /* !HAVE_STRDUP */

/*****************************************************************************/

#endif  /* __IK_PATCH_H__ */
