/*
 * $Id: IK_ProfileDef.h,v 1.6 1997/03/06 15:38:52 amrhein Exp $
 *
 *    Define the members of the user profile tree.
 *
 * $Log: IK_ProfileDef.h,v $
 * Revision 1.6  1997/03/06 15:38:52  amrhein
 * Updated to GUI's 6_1_12 IK
 *
 * Revision 6.1  1996/10/18  14:16:26  ims
 * Promoted for 6.1 J. Katen
 *
 * Revision 6.0  1996/02/29  15:41:09  ims
 * COPIED FROM 5.1 FOR GUI_PROMO_6_0_960229.
 *
 * Revision 5.1  1995/12/28  20:23:44  ims
 * COPIED FROM 5.0 FOR GUI_PROMO_5_1_951228.
 *
 * Revision 5.0  1995/11/06  13:04:10  ims
 * PROMOTION FROM GUI_4_5_8_951030 FOR GUI_PROMO_5_0_951106
 *
 * Revision 4.5  1995/07/27  18:43:11  ims
 * PROMOTION FROM GUI_4_4_8_950501 FOR GUI_PROMO_4_5_950726
 *
 * Revision 4.4  1995/02/13  22:21:10  ims
 * PROMOTION FROM GUI_4_4_950106 FOR GUI_PROMO_4_4_950213
 *
 * Revision 4.3  1994/08/26  10:50:09  ims
 * COPIED FROM GUI_4_3_940824.
 *
 * Revision 4.0  1994/06/08  17:21:22  ims
 * PROMOTION FROM REV4
 *
 * Revision 1.3.1.2  1994/05/25  19:55:29  ryan
 * SMR #408
 * Created new structure, IK_ProfileEntry.  Changed IK_ProfileDef to
 * be an array of IK_ProfileEntrys.  This way, we can specify a name
 * and kind for each User Profile member.  The ADDRESS field is a
 * sequence and all the rest are scalars.
 *
 * Revision 1.3.1.1  1994/05/25  15:48:52  ryan
 * new branch
 *
 * Revision 1.3  1994/04/25  20:13:05  ryan
 * added a few comments.
 *
 * Revision 1.2  1994/04/22  19:09:28  ryan
 * changed __PROFILEDEF_H__ to __IK_PROFILEDEF_H__.
 *
 * Revision 1.1  1994/04/22  17:45:09  ryan
 * Initial revision
 *
 *
 *
 */

#ifndef __IK_PROFILEDEF_H__
#define __IK_PROFILEDEF_H__

#include <stdio.h> /* get definition of NULL */
#include "odldef.h"

typedef struct
{
    char *name;
    VALUE_KIND kind;
} IK_ProfileEntry;

IK_ProfileEntry IK_ProfileDef[] =
{
    { "FIRST_NAME", KV_SCALAR },
    { "LAST_NAME",  KV_SCALAR },
    { "MIDDLE_INITIAL",  KV_SCALAR },
    { "ADDRESS",  KV_SEQUENCE },
    { "CITY",  KV_SCALAR },
    { "PHONE",  KV_SCALAR },
    { "EMAIL", KV_SCALAR },
    { "STATE",  KV_SCALAR },
    { "COUNTRY",  KV_SCALAR },
    { "ZIP",  KV_SCALAR },
    { "FAX",  KV_SCALAR },
    { "TITLE",  KV_SCALAR },
    { "ORGANIZATION", KV_SCALAR },
    { NULL, KV_UNKNOWN }
};


#endif /* __IK_PROFILEDEF_H__ */
