/* File: $RCSfile: IK_ResInv.c,v $
 * 
 * Synopsis: This file contains the IK_ function which support result
 * inventory screen.
 * 
 * Notes: */
/*----------------------------------------------------------------------
 | $Log: IK_ResInv.c,v $
 | Revision 1.6  1997/03/06 15:38:52  amrhein
 | Updated to GUI's 6_1_12 IK
 |
 * Revision 6.1.1.2  1997/01/13  17:13:10  winter
 * Moved IK_Ims.h to be first included header.
 *
 * Revision 6.1.1.1  1997/01/13  17:12:23  winter
 * Placeholder for new branch during re-introduction of ims_free() and
 * ims_realloc().
 *
 * Revision 6.1  1996/10/18  14:16:26  ims
 * Promoted for 6.1 J. Katen
 *
 * Revision 6.0.1.2  1996/04/23  19:19:21  iredell
 * check for ORG_CENTER_ID when making a new directory tree
 * for the gcmd search.  fixes smrs 3468, 3532.
 *
 * Revision 6.0.1.1  1996/04/22  17:32:40  iredell
 * Placeholder for new branch.
 *
 * Revision 5.1.1.3  1996/02/14  20:33:12  winter
 * Changed call to IK_MapDatasetIdent() to IK_MapDatasetTagToName().
 * Changed call to IK_MapArchiveIdent() to IK_MapArchiveTagToName().
 *
 * Revision 5.1.1.2  1996/01/17  20:52:30  winter
 * Added #include "IK_Map.h".
 *
 * Revision 5.1.1.1  1996/01/17  19:34:05  winter
 * Placeholder for new branch.
 *
 * Revision 5.1  1995/12/28  20:06:58  ims
 * COPIED FROM 5.0 FOR GUI_PROMO_5_1_951228.
 *
 * Revision 5.0  1995/11/06  13:04:11  ims
 * PROMOTION FROM GUI_4_5_8_951030 FOR GUI_PROMO_5_0_951106
 *
 * Revision 4.5  1995/07/27  18:43:12  ims
 * PROMOTION FROM GUI_4_4_8_950501 FOR GUI_PROMO_4_5_950726
 *
 * Revision 4.4  1995/02/13  22:21:11  ims
 * PROMOTION FROM GUI_4_4_950106 FOR GUI_PROMO_4_4_950213
 *
 * Revision 4.3  1994/08/26  10:50:10  ims
 * COPIED FROM GUI_4_3_940824.
 *
 * Revision 4.0  1994/06/08  15:17:17  ims
 * PROMOTION FROM REV4
 *
 * Revision 3.1  1994/04/05  09:49:52  ims
 * Promotion from MAR28_RELEASE
 *
 * Revision 3.0  1993/12/29  15:18:49  winter
 * ALPHA-1
 *
 | Revision 1.19  1993/03/18  00:33:12  sylvain
 | Added better error chacking and logging to syslog though out the file.
 | 	(check all return values from ODL routines and other IK* routines)
 | IK_ConfirmDirectory has been re-written, it no has one entry and one exit,
 | 	and only one call to free for each malloc'd area.
 | Only free the name in IK_MakeDirectoryTree if name exists.
 | Both IK_ConfirmDirectory and IK_MakeDirectoryTree now check for invalid
 | 	parameters passed in.
 | Replace the strlen of dataset->md_entry in IK_MakeDirectoryTree with the value
 | 	itself (just checking for existance, we don't need the fn. call)
 | Replaced the setting of IK_ImsErrno to setting it to IK_ENO_DIF in
 | 	IK_ConfirmDirectory
 |
 | Revision 1.18  1993/03/02  21:32:54  honce
 | Test for md_entry before creating a new Directory Search ODL tree.
 | Deleted unneeded test so that visible items can now be made invisible.
 | Added temporary variables for IK_BuildDatasetKey() to use, this plugged
 | a number of memory leaks.
 | Deleted malloc.h ANSI-C required stdlib.h instead.
 |
 | Revision 1.17  1993/02/12  22:02:25  lee
 | add IC_RestDatasetStatus to reset dataset bit before mark the dataset
 | flag and if reset dataset bit fail then return -1 and log error message
 | 
 | Revision 1.16  1993/02/05  17:38:39  lee
 | check md_entry_id is null or not
 | 
 | Revision 1.15  1992/11/25  20:34:31  lee
 | change md_entry to md_entry_id
 | 
 | Revision 1.14  1992/11/25  19:57:28  lee
 | add data_center_id parameter to gcmd_search tree
 | 
 | Revision 1.13  1992/11/18  19:07:11  lee
 | check dataset->marked.is_visible before flip the mark.
 | 
 | Revision 1.12  1992/11/17  18:56:56  lee
 | modify IK_makesearchtree to get right information.
 | 
 | Revision 1.11  1992/11/11  21:59:18  lee
 | add message_id parameter
 | 
 | Revision 1.10  1992/11/11  21:35:41  lee
 | change GCMD_Search to GCMD_SEARCH.
 | 
 | Revision 1.9  1992/11/11  21:16:48  lee
 | create tree root for confirmdirectory().
 | 
 | Revision 1.8  1992/11/11  18:10:03  lee
 | chnage markdataset if find dir info.
 | 
 | Revision 1.7  1992/11/11  17:48:20  lee
 | add markdataset call in the IK_ConfirmDirectory().
 | 
 | Revision 1.6  1992/10/19  20:39:49  lee
 | add free odl tree on IK_MakeDirectoryTree()
 | 
 | Revision 1.5  1992/10/19  20:03:24  lee
 | modify IK_ConfirmDirectory()
 | 
 | Revision 1.4  1992/10/19  15:33:11  lee
 | modify IK_Confirmdirectory()
 | 
 | Revision 1.3  1992/10/19  15:15:52  lee
 | modify Confirmdirectory()
 | 
 | Revision 1.2  1992/10/16  18:16:43  lee
 | take out IK_ImsErrno
 | 
 | Revision 1.1  1992/10/12  19:36:45  lee
 | Initial revision
 | 
 +---------------------------------------------------------------------*/

static const char *rcsid = "$Id: IK_ResInv.c,v 1.6 1997/03/06 15:38:52 amrhein Exp $";

#include "IK_Ims.h"

/* C lib */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

/* ODL lib */
#include "odldef.h"
#include "odlinter.h"

/* IMS lib */
#include "IK_Msg.h"
#include "IK_DataDic.h"
#include "IK_Granule.h"
#include "IK_Dataset.h"
#include "IK_Errno.h"
#include "IK_Syslog.h"
#include "IK_ResInv.h"
#include "IK_Map.h"

extern void IK_MapGdbmErrno(void);


/* Confirmation of directory information.
 * 
 * Confirmation the existing directory information of specific granule. The
 * space for the new ODL tree is obtained using malloc(3).
 * 
 * Analysis:
 * 
 * Precondition 1: A given granulue has directory information.
 * 
 * Postconditoin 1: RETURN (0) and NULL to directory search tree.
 * 
 * Precondition 2: A given granule does not have directory information.
 * 
 * Postcondition 2: Build directory search ODL tree. RETURN (0) and the root
 * of directory ODL search tree.
 * 
 * Precondition 3: Invalid granule is passed in.
 * 
 * Postcondition 3: RETURN (-1) SET ImsErrno to IK_ENOENT or IK_ENOBUF.
 * 
 * Precondition 4: Fail on building ODL tree.
 * 
 * Postcondition 4: RETURN (-1) SET ImsErrno to IK_BAD_ODLTREE.
 * 
 * Note:
 * 
 *	Return: upon success,0. On failure, -1. */

int             IK_ConfirmDirectory(
	IK_SortKey *selectgranule,	/* the pointer to current granule */
	AGGREGATE *gcmdsearch	/* the root of ODL search tree */
)
{
    IK_Dataset     *dataset;
    IK_Granule     *granule;
    IK_SortKey     *dataset_key;
    int             return_code = 0;

    if (!selectgranule) {
       IK_ImsErrno = IK_ENOENT;
       return_code = -1;
    }
    else {
       *gcmdsearch = NULL;
       if (IK_GetGranule(selectgranule, &granule) < 0) {
	  IK_vSyslog (LOG_ERR, ".IK_ConfirmDirectory.IK_GetGranule_1: unable to get the granule, IK_ImsErrno = %d - %s",
		      IK_ImsErrno, IK_GetMessage (IK_ImsErrno));
	  return_code = -1;
       }
       
       if (return_code == 0 &&
	   (dataset_key = IK_BuildDatasetKey(granule->archive_tag,
					     granule->dataset_tag)))
	{
	   if (IK_GetDataset(dataset_key, &dataset) < 0) {
	      IK_vSyslog (LOG_ERR, ".IK_ConfirmDirectory.IK_GetGranule_2: unable to get the granule, IK_ImsErrno = %d - %s",
			  IK_ImsErrno, IK_GetMessage (IK_ImsErrno));
	      return_code = -1;
	   }
	   else {
	      
	      if (dataset->md_title == NULL) {
		 if (dataset->md_entry == NULL) {
		    IK_Syslog (LOG_DEBUG, 
			       ".IK_ConfirmDirectory: no MD_ENTRY_ID given");
		    IK_ImsErrno = IK_ENO_DIF;
		    return_code = -1;
		 } 
		 else {
		    if ((*gcmdsearch = 
			 NewAggregate(NULL, KA_GROUP, "root", NULL)) == NULL) {
		       IK_MapGdbmErrno();
		       IK_vSyslog (LOG_ERR, ".IK_ConfirmDirectory.NewAggregate: IK_ImsErrno = %d - %s",
				   IK_ImsErrno, IK_GetMessage (IK_ImsErrno));
		       IK_ImsErrno = IK_EBAD_ODLTREE;
		       return_code = -1;
		    }
		    else {
		       if (IK_MakeDirectoryTree(granule, dataset, gcmdsearch)
			   < 0)
			{
			   IK_vSyslog (LOG_ERR, ".IK_ConfirmDirectory.IK_MakeDirectoryTree: unable to mark directory tree, IK_ImsErrno = %d - %s",
				       IK_ImsErrno, IK_GetMessage (IK_ImsErrno));
			   return_code = -1;
			}
		    }
		 }
	      }
	      else {
		 if (IC_ResetDatasetStatus() < 0) {
		    IK_vSyslog (LOG_ERR, ".IK_ConfirmDirectory.IC_ResetDatasetStatus: unable to reset the dataset, IK_ImsErrno = %d - %s",
				IK_ImsErrno, IK_GetMessage (IK_ImsErrno));
		    return_code = -1;
		 }
		 else {
		    (void) free(dataset_key);
		    dataset_key = IK_BuildDatasetKey(granule->archive_tag,
						     granule->dataset_tag);
		    if (dataset_key == NULL) {
		       IK_vSyslog (LOG_ERR, ".IK_ConfirmDirectory.IK_BuildDatasetKey: unable to build the dataset key for the granule, ernno = %d - %s",
				   errno, strerror (errno));
		       return_code = -1;
		    }
		    else {
		       if (IK_MarkDataset(dataset_key, IK_VISIBLE, 
					  IK_TOGGLE) < 0) 
			{
			   IK_vSyslog (LOG_ERR, ".IK_ConfirmDirectory.IK_MArkDataset: unable to mark dataset visible, IK_ImsErrno = %d - %s",
				       IK_ImsErrno, 
				       IK_GetMessage (IK_ImsErrno));
			   return_code = -1;
			}
		    }
		 }
	      }
	   }
	}
    }
    (void) free (dataset_key);
    (void) free (dataset);
    (void) free (granule);
    
    if (return_code < 0 && *gcmdsearch)
	(void) RemoveAggregate (*gcmdsearch);

    return return_code;
}


/* Build odl tree of directory search.
 * 
 * Analysis:
 * 
 * Precondition 1: A given granulue exist.
 * 
 * Postconditoin 1: Build directory search tree. RETURN (0) and NULL to
 * directory search tree.
 * 
 * Precondition 2: Invalid granule is passed in.
 * 
 * Postcondition 2: RETURN (-1) SET ImsErrno to IK_ENOENT or IK_ENOBUF.
 * 
 * Note:
 * 
 *	Return: upon success,0. On failure, -1.
 *
 * Modification History:
 *
 * Wednesday 14 February 1996 (Eric Winter) - Changed call to
 * IK_MapArchiveIdent() to IK_MapArchiveTagToName(). Changed call to
 * IK_MapDatasetIdent() to call to IK_MapDatasetTagToName().
*/

int             IK_MakeDirectoryTree(
	IK_Granule *granule,
	IK_Dataset *dataset,
	AGGREGATE *gcmdsearch
)
{

    AGGREGATE       aggregate;
    AGGREGATE       currentaggregate;
    PARAMETER       parameter;
    PARAMETER       newpar;
    VALUE           value;
    VALUE_DATA      value_data;
    char           *name;



    /* Create new Aggregate node of gcmd_search group */
    if (granule == NULL || dataset == NULL) {
       IK_vSyslog (LOG_ERR, ".IK_MakeDirectoryTree: invalid paremeter pased in");
       IK_ImsErrno = IK_ENOENT;
       return (-1);
    }

    currentaggregate = NewAggregate(*gcmdsearch, KA_GROUP, "GCMD_SEARCH", "");
    if (*gcmdsearch == NULL) {
	IK_ImsErrno = IK_ENOMEM;
	IK_Syslog(LOG_ERR, "Unable to create ODL gcmd_search Aggregate");
	return (-1);
    }
    parameter = NewParameter(currentaggregate, KP_ATTRIBUTE, "DATASET_ID");
    if (parameter == NULL) {
	IK_ImsErrno = IK_ENOMEM;
	IK_Syslog(LOG_ERR, "Unable to create ODL dataset_id parameter");
	return (-1);
    }
    parameter->value_kind = KV_SCALAR;

    name = IK_MapDatasetTagToName(granule->dataset_tag);
    if (name == NULL) {
       IK_vSyslog (LOG_ERR, ".IK_MarkDirectory.IK_MapDatasetTagToName: unable to get the dataset name for the tag",
		   IK_ImsErrno, IK_GetMessage (IK_ImsErrno));
       return (-1);
    }
    value_data = ODLConvertString(name, strlen(name));
    if (NewValue(parameter, &value_data) == NULL) {
	IK_ImsErrno = IK_ENOMEM;
	IK_Syslog(LOG_ERR, "Unable to create ODL value");
	return (-1);
    }
    free(name);

    parameter = NewParameter(currentaggregate, KP_ATTRIBUTE, "MD_ENTRY_ID");
    if (parameter == NULL) {
	IK_ImsErrno = IK_ENOMEM;
	IK_Syslog(LOG_ERR, "Unable to create ODL md_entry_id parameter");
	return (-1);
    }
    parameter->value_kind = KV_SCALAR;

    if (*dataset->md_entry) {
	value_data = ODLConvertString(dataset->md_entry, strlen(dataset->md_entry));
	if (NewValue(parameter, &value_data) == NULL) {
	    IK_ImsErrno = IK_ENOMEM;
	    IK_Syslog(LOG_ERR, "Unable to create ODL value");
	    return (-1);
	}
    } else {
	IK_ImsErrno = IK_ENO_DIF;
	IK_Syslog(LOG_ERR, "MD_ENTRY_ID is NULL");
	return (-1);
    }

/* Need to check for ORG_CENTER.  For directory searches, ORG_CENTER is
 * required.  Previously, if ORG_CENTER was not included, then routine
 * IK_TxMD used the DATA_CENTER_ID.  However, it has been discovered 
 * that this is not always correct, since the DATA_CENTER_ID may not 
 * equal the ORG_CENTER_ID.
 */

    if (*dataset->org_center) {
      parameter = NewParameter(currentaggregate, KP_ATTRIBUTE, "ORG_CENTER");
      if (parameter == NULL) {
        IK_ImsErrno = IK_ENOMEM;
        IK_Syslog(LOG_ERR, "Unable to create ODL org_center parameter");
        return (-1);
      }
      parameter->value_kind = KV_SCALAR;
      value_data = ODLConvertString(dataset->org_center, strlen(dataset->org_center));
        if (NewValue(parameter, &value_data) == NULL) {
            IK_ImsErrno = IK_ENOMEM;
            IK_Syslog(LOG_ERR, "Unable to create ODL value");
            return (-1);
        }
    } else {
        IK_ImsErrno = IK_ENO_DIF;
        IK_Syslog(LOG_ERR, "ORG_CENTER is NULL");
        return (-1);
    }

    parameter = NewParameter(currentaggregate, KP_ATTRIBUTE, "MESSAGE_ID");
    if (parameter == NULL) {
	IK_ImsErrno = IK_ENOMEM;
	IK_Syslog(LOG_ERR, "Unable to create ODL message_id parameter");
	return (-1);
    }
    parameter->value_kind = KV_SCALAR;

    name = IK_MapArchiveTagToName(granule->archive_tag);
    if (name == NULL) {
       IK_vSyslog (LOG_ERR, ".IK_MarkDirectory.IK_MapArchiveTagToName: unable to get the archive name for the tag",
		   IK_ImsErrno, IK_GetMessage (IK_ImsErrno));
       return (-1);
    }

    aggregate = IK_GetArchive(name);
    if (aggregate == NULL) {
	IK_ImsErrno = IK_ENOMEM;
	IK_Syslog(LOG_ERR, "Unable to create ODL data_center Aggregate");
	return (-1);
    }
    parameter = FindParameter(aggregate, "DATA_CENTER_ID");
    if (parameter == NULL) {
       IK_MapGdbmErrno();
       IK_ImsErrno = IK_ENOMEM;
       IK_vSyslog(LOG_ERR, ".IK_MarkDirectory.FindParameter: Unable to find the data_center_id parameter", IK_ImsErrno, IK_GetMessage (IK_ImsErrno));
       return (-1);
    }
    value = FirstValue(parameter);
    if (value != NULL) {
	newpar = CopyParameter(parameter);
	if (newpar == NULL) {
	    IK_ImsErrno = IK_ENOMEM;
	    IK_vSyslog(LOG_ERR, "Unable to copy data_center_id parameter");
	    return (-1);
	}
    }
    else {
       IK_MapGdbmErrno();
       IK_ImsErrno = IK_ENOMEM;
       IK_vSyslog(LOG_ERR, ".IK_MarkDirectory.FirstValue: Unable to find the first value in the data_center_id parameter", IK_ImsErrno, IK_GetMessage (IK_ImsErrno));
       return (-1);
    }

    currentaggregate = PasteAggregate(currentaggregate, aggregate);
    if (aggregate == NULL) {
       IK_MapGdbmErrno();
       IK_ImsErrno = IK_ENOMEM;
       IK_vSyslog(LOG_ERR, ".IK_MarkDirectory.PasteAggregate: Unable to paste ODL data_center Aggregate", IK_ImsErrno, IK_GetMessage (IK_ImsErrno));
       return (-1);
    }
    currentaggregate = ParentAggregate(currentaggregate);
    PasteParameter(currentaggregate, newpar);

    if (name) free(name);

    return (0);
}
