/*
 * FILE: IK_SysConf.c
 *
 * DESCRIPTION: This file fetches IMS-related environment variables,
 *              and supplies default values when they are not set.
 *
 *-----------------------------------------------------------------------------------------
 *
 * RCS information:
 *
 * $Id: IK_SysConf.c,v 1.67 2003/12/09 15:46:59 solomon Exp $
 *
 * $Log: IK_SysConf.c,v $
 * Revision 1.67  2003/12/09 15:46:59  solomon
 * UpdateToVersion3.6
 * Changed "REVNAME" to "imswww-3_6".
 *
 * Revision 1.66  2003/11/14 16:36:03  solomon
 * UpdateToThreeSixBetaOne
 * Changed REVNAME "imswww-3_6b_1".
 *
 * Revision 1.65  2003/09/09 15:15:01  solomon
 * UpdateToVersionThreeSixBeta
 * Changed "REVNAME" to "imswww-3_6b".
 *
 * Revision 1.64  2003/05/16 15:17:19  solomon
 * UpdateToVersionThreeFiveOne
 * Changed REVNAME to "imswww-3_5_1".
 *
 * Revision 1.63  2003/01/08 18:31:23  solomon
 * UpdateToVersionThreeFive
 * Changed "REVNAME" to "imswww-3_5".
 *
 * Revision 1.62  2002/12/24 14:58:36  solomon
 * UpdateToVersionThreeFiveBetaFive
 * Changed "REVNAME" to "imswww-3_5b_5".
 *
 * Revision 1.61  2002/10/25 13:54:11  solomon
 * UpdateToVersionThreeFiveBetaFour
 * Changed "REVNAME" to "imswww-3_5b_4".
 *
 * Revision 1.60  2002/10/23 20:26:47  solomon
 * UpdateToVersionThreeFiveBetaThree
 * Changed "REVNAME" to "imswww-3_5b_3".
 *
 * Revision 1.59  2002/09/24 18:54:00  solomon
 * UpdateToVersionThreeFiveBetaTwo.
 * Changed "REVNAME" to "imswww-3_5b_2".
 *
 * Revision 1.58  2002/09/03 17:14:10  solomon
 * UpdateToVersionThreeFiveBetaOne.
 * Changed "REVNAME" to "imswww-3_5b_1".
 *
 * Revision 1.57  2002/09/03 15:43:00  solomon
 * UpdateToVersionThreeFour.
 * Changed "REVNAME" to "imswww-3_4".
 *
 * Revision 1.56  2002/08/02 18:02:11  solomon
 * Changed "REVNAME" to "imswww-3_4b_10".
 *
 * Revision 1.55  2002/06/17 14:55:33  solomon
 * Changed "REVNAME" to "imswww-3_4b_9".
 *
 * Revision 1.54  2002/04/18 20:49:34  solomon
 * Changed "REVNAME" to "imswww-3_4b_8".
 *
 * Revision 1.53  2002/04/04 20:29:17  solomon
 * Changed "REVNAME" to "imswww-3_4b_7".
 *
 * Revision 1.52  2002/03/19 19:34:16  solomon
 * Changed "REVNAME" to "imswww-3_4b_6".
 *
 * Revision 1.51  2002/02/04 20:47:44  solomon
 * Changed "REVNAME" to "imswww-3_4b_5".
 *
 * Revision 1.50  2002/01/14 18:41:45  solomon
 * Changed "REVNAME" to "imswww-3_4b_4".
 *
 * Revision 1.49  2001/11/30 19:15:26  solomon
 * Changed "REVNAME" to "imswww-3_4b_3".
 *
 * Revision 1.48  2001/10/23 17:38:39  solomon
 * Changed "REVNAME" to "imswww-3_4b_2".
 *
 * Revision 1.47  2001/09/10 19:07:55  solomon
 * Changed "REVNAME" to "imswww-3_4b_1".
 *
 * Revision 1.46  2001/07/20 15:51:17  solomon
 * Changed the "REVNAME" to "imswww-3_4b".
 *
 * Revision 1.45  2001/06/29 18:01:02  solomon
 * Changed "REVNAME" to "imswww-3_3b_7".
 *
 * Revision 1.44  2001/06/21 20:15:35  solomon
 * Changed "REVNAME" to "imswww-3_3b_6".
 *
 * Revision 1.43  2001/05/08 14:28:42  solomon
 * Changed "REVNAME" to "imswww-3_3b_5".
 *
 * Revision 1.42  2001/04/25 13:24:29  solomon
 * Changed REVNAME to "imswww-3_3b_4".
 *
 * Revision 1.41  2001/04/17 18:36:03  solomon
 * Changed "REVNAME" to "imswww-3_3b_3".
 *
 * Revision 1.40  2001/03/27 20:26:01  solomon
 * Changed REVNAME to "imswww-3_3b_2".
 *
 * Revision 1.39  2001/03/20 14:46:49  solomon
 * Changed the build name to "imswww-3_3b_1".
 *
 * Revision 1.38  2001/01/05 15:43:59  solomon
 * Changed REVNAME to "imswww-3_3b".
 *
 * Revision 1.37  2001/01/05 14:49:17  solomon
 * Changed REVNAME to "imswww-3_2_1".
 *
 * Revision 1.36  2000/12/28 21:59:07  solomon
 * Changed the REVNAME to "imswww-3_2".
 *
 * Revision 1.35  2000/12/15 21:23:22  solomon
 * Changed "REVNAME" to "imswww-3_2b_4".
 *
 * Revision 1.34  2000/11/13 19:02:34  solomon
 * Changed REVNAME to "imswww-3_2b_3".
 *
 * Revision 1.33  2000/10/31 18:48:25  solomon
 * Changed "REVNAME" to "imswww-3_2b_1".
 *
 * Revision 1.32  2000/09/29 18:53:21  solomon
 * Changed REVNAME to "imswww-3_2b".
 *
 * Revision 1.31  2000/09/29 18:20:57  solomon
 * Changed REVNAME to "imswww-3_1_1".
 *
 * Revision 1.30  2000/09/21 18:58:41  solomon
 * Changed REVNAME to "imswww-3_1".
 *
 * Revision 1.29  2000/09/08 20:44:35  solomon
 * Changed "REVNAME" to "imswww-3_1b_5".
 *
 * Revision 1.28  2000/08/14 20:05:21  solomon
 * Changed REVNAME to "imswww-3_1b_4".
 *
 * Revision 1.27  2000/07/24 15:18:29  solomon
 * Changed REVNAME to "imswww-3_1b_3".
 *
 * Revision 1.26  2000/06/29 14:13:47  solomon
 * Changed REVNAME to "imswww-3_1b_2".
 *
 * Revision 1.25  2000/05/02 20:24:07  solomon
 * Changed the REVNAME "imswww-3_1b".
 *
 * Revision 1.24  2000/04/21 18:51:06  solomon
 * Changed REVNAME to "imswww-3_0_1".
 *
 * Revision 1.23  1999/10/18 18:15:35  solomon
 * Changed REVNAME to "imswww-3_0".
 *
 * Revision 1.22  1999/07/22 16:39:14  solomon
 * Changed the REVNAME to "imswww-2_4".
 *
 * Revision 1.21  1999/07/19 19:51:02  solomon
 * Changed the REVNAME to "imswww-2_3_1".
 *
 * Revision 1.20  1999/05/17 19:22:57  solomon
 * Changed REVNAME to "imswww-2_3".
 *
 * Revision 1.19  1999/01/13 20:20:08  solomon
 * Changed REVNAME "imswww-2_2".
 *
 * Revision 1.18  1998/11/03 18:27:27  solomon
 * Changed the "REVNAME" to "imswww-2_1_1".
 *
 * Revision 1.17  1998/07/24 20:14:48  solomon
 * Changed the REVNAME to "imswww-2_1".
 *
 * Revision 1.16  1998/05/15  15:28:13  solomon
 * Changed the REVNAME to "imswww-2_0_2".
 *
 * Revision 1.15  1998/02/20  22:35:49  solomon
 * Changed "REVNAME" to "imswww-2_0"
 *
 * Revision 1.14  1997/10/28  18:04:52  solomon
 * Changed REVNAME to "imswww-1_9"
 *
 * Revision 1.13  1997/10/20  17:26:29  solomon
 * Updated to GUI IK layer 7_0_0_13.
 *
 * Revision 7.0.1.1  1997/09/22  12:54:00  terrell
 * Modified function IK_SysConf to include a global IMS
 * system environment variable for the archive ODL.
 * Added new function IK_GetDataCenterFilename to build and
 * return the archive ODL path and file name.
 * ..
 *
 *
 * Revision 7.0  1997/04/11  17:54:50  ims
 * 6.1.1.5 Promoted to 7.0 J. Katen
 *
 * Revision 6.1.1.5  1997/03/17  18:30:07  winter
 * SMR 3918 - Removed support for the CHUI_GUIDE environment variable.
 *
 * Revision 6.1.1.4  1997/03/17  15:49:03  cavallo
 * Added the following variables to IK_SysConfig():
 * IMS_INV_RESULTS_SAVE, IMS_FIELD_SEPARATOR, IMS_SUBFIELD_SEPARATOR,
 * IMS_SEARCH_RESULTS_MAILER, and IMS_SEARCH_RESULTS_ENCODER.
 *
 * Revision 6.1.1.3  1997/03/10  12:21:12  winter
 * SMR 3912 - Now uses environment variables IMS_LOG_TX and IMS_LOG_RX to control
 * archiving of transmitted and received messages.
 *
 * Revision 6.1.1.2  1996/10/21  14:26:05  winter
 * Copied from 6.0.1.4 after 6.1 promotion.
 *
 * Revision 6.0.1.4  1996/09/26  14:42:05  winter
 * Moved #include "IK_Ims.h" to top of header list.
 * Moved #include <sys/*> headers to top of standard header list.
 * Added #include <string.h> for string function prototypes.
 *
 * Revision 6.0.1.3  1996/08/20  19:11:42  lrosen
 * Added env vars MY_FAVORITE_BROWSER and WELCOME_PAGE_ADDR.
 *
 * Revision 6.0.1.2  1996/03/19  17:04:34  marsans
 * Modifications made to check for environment variable BROWSE_SAVE to allow
 * for writing a browse file.  If the variable is set to NO, the browse
 * screen will be displayed with Save Browse File option disensitized.
 *
 * Revision 6.0.1.1  1996/03/16  20:03:44  marsans
 * Starting a new branch.
 *
 * Revision 6.0  1996/02/29  15:41:29  ims
 * COPIED FROM 5.1 FOR GUI_PROMO_6_0_960229.
 *
 * Revision 5.1  1995/12/28  20:09:08  ims
 * COPIED FROM 5.0 FOR GUI_PROMO_5_1_951228.
 *
 * Revision 5.0  1995/11/06  13:04:17  ims
 * PROMOTION FROM GUI_4_5_8_951030 FOR GUI_PROMO_5_0_951106
 *
 * Revision 4.5.1.1  1995/07/27  19:09:08  ims
 * COPIED FROM 4.4.1.1 FOR GUI_PROMO_4_5_950726
 *
 * Revision 4.4.1.1  1995/05/24  21:03:34  ims
 * The source code uses FILENAME_MAX to define size for strings that will hold
 * pathnames. Since HP/UX still supports file systems with short filenames
 * (15 characters), FILENAME_MAX is set to 15 for HP/UX.
 *
 * Revision 4.4  1995/02/13  22:21:24  ims
 * PROMOTION FROM GUI_4_4_950106 FOR GUI_PROMO_4_4_950213
 *
 * Revision 4.3.1.4  1994/11/15  14:21:33  ryan
 * SMR 1724
 * Added new system variable CommentsAddress which gets its value
 * from the environment variable IMS_COMMENTS_MAIL_DEST
 *
 * Revision 4.3.1.3  1994/11/03  15:41:44  ryan
 * SMR 1696
 * Fixed code which returned ChuiGuide.  Removed trailing slash.
 *
 * Revision 4.3.1.2  1994/08/26  12:19:09  ims
 * COPIED FROM REVISION 4.0.1.2.
 *
 * Revision 4.0.1.2  1994/07/26  21:51:36  heather
 * added Guide_Home_Addr to IK_SysConfig routine
 *
 * Revision 4.0.1.1  1994/06/14  22:26:23  heather
 * added ChuiGuide environment variable
 *
 * Revision 4.0  1994/06/08  15:23:49  ims
 * PROMOTION FROM REV4
 *
 * Revision 3.1.1.8  1994/06/02  14:24:23  ryan
 * changed logic for getting version information so that it uses REVNAME
 * instead of Client_Version.
 *
 * Revision 3.1.1.7  1994/06/01  23:19:35  heather
 * added CLIENT_VERSION to IK_SysConfig
 *
 * Revision 3.1.1.6  1994/05/23  13:10:22  heather
 * changed the default value returned for Syslog_Level to be LOG_ERR
 *
 * Revision 3.1.1.5  1994/05/20  19:33:43  heather
 * added SYSLOG_LEVEL to IK_SysConfig
 *
 * Revision 3.1.1.4  1994/05/12  15:14:43  kerbel
 * Changed IK_SysConfig() hanling of GaeaTmp.  If the IK_SysConfig()
 * is called with a parameter of "GaeaTmp", it will still attempt
 * to find the GAEATMP_DIR environment variable.  If this variable
 * does not exist it will default to $HOME/GAEATMP_DIR where GAEATMP
 * DIR is a preprocessor #define in IK_Ims.h which is set to gaea_tmp.
 * So the default for "GaeaTmp" is to return $HOME/gaea_tmp.  If this
 * directory does not exist it will be created.  All transient files
 * will now be stored in the GaeaTmp directory during a session.  This
 * directory should be wiped clean at the end of a session.
 *
 * This is part of the overhaul to move all transient files to GaeaTmp
 *
 * Revision 3.1.1.3  1994/05/02  14:43:19  ryan
 * removed unused function IK_SetConfig().  put in reference to
 * default GAEADATA_DIR value.  note that this depends on the use
 * of Autoconf.
 *
 * Revision 3.1.1.2  1994/04/11  20:37:07  kerbel
 * Added code to resolve DISK_ALLOC and GRANULE_LIMIT_CAP enivronment
 * variables to IK_SysConfig().
 *
 * Revision 3.1.1.1  1994/04/08  15:12:04  kerbel
 * This is the place holder revision that starts the branch
 *
 * Revision 3.1  1994/04/05  09:49:52  ims
 * Promotion from MAR28_RELEASE
 *
 * Revision 3.0.1.6  1994/03/23  14:53:29  ryan
 * removed check for ~ims/ims_data.  $GAEADATA_DIR must be set
 * or an error will occur.
 *
 * Revision 3.0.1.5  1994/03/23  13:17:57  ryan
 * added default values and cleaned up code.
 *
 * Revision 3.0.1.4  1994/02/16  14:02:35  ryan
 * added commented-out code to check value of $TMPDIR
 *
 * Revision 3.0.1.3  1994/02/08  19:12:59  ryan
 * cleaned up error-handling code.
 *
 * Revision 3.0.1.2  1994/01/26  20:40:35  ryan
 * cleaned up code to which determines "UserData" parameter.
 *
 * Revision 3.0.1.1  1994/01/26  18:56:43  ryan
 * This is the place holder revision that starts the branch.
 *
 * Revision 3.0  1993/12/29  15:18:49  winter
 * ALPHA-1
 *
 * Revision 1.4  1993/08/02  14:22:16  kerbel
 * This file now #include's <stdio.h> which eliminates the compiler warnings
 * 	generated by pwd.h function prototypes.
 *
 * Revision 1.3  1993/01/15  02:44:18  honce
 * Changed buffer from IK_MAXBUFLEN to FILENAME_MAX, more
 * bits this way.
 *
 * Revision 1.2  1992/12/15  20:29:29  sylvain
 * added GaeaTmp variable name.
 *
 * Revision 1.1  1992/10/01  17:01:10  honce
 * Initial revision
 *
 */

/*****************************************************************************/

/* Define the RCS identifier string. */
static const char *rcsid = "$Id: IK_SysConf.c,v 1.67 2003/12/09 15:46:59 solomon Exp $";

/*****************************************************************************/

/* #include directives */

/* This header must be #included first in order to use
   autoconf-generated information. */
#include "IK_Ims.h"

/* System headers */
#include <sys/stat.h>
#include <sys/types.h>

/* Standard headers */
#include <errno.h>
#include <pwd.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

/* IMS headers */
#include "IK_Errno.h"
#include "IK_Syslog.h"

/*****************************************************************************/

/* Local #define directives */

/* Check if running under HP/UX, it supports a filesystems with short
   filenames(15 characters). */
#ifdef HPUX 
#undef FILENAME_MAX
#define FILENAME_MAX (255)
#endif /* HPUX */

#ifndef FILENAME_MAX
#  define FILENAME_MAX 256
#endif /* FILENAME_MAX */

/******************************************************************************************
 *
 * Name: IK_SysConfig
 * 
 * DESCRIPTION: Retrieve a global IMS system variable.
 *              Think of these as intelligent env-variables.  Path variables have a
 *              trailing '/' added.
 *
 * PARAMETERS:
 *     variable -- (char *) Variable name to retrieve.
 *
 * RETURN VALUE:
 *     result   -- (char *) Pointer to static value. On failure, NULL.
 * 
 * GLOBAL VARIABLES:
 *
 * PRE- & POST-CONDITIONS:
 * 
 * NOTES:
 *     The following configuration variables are supported:
 * 
 *     GaeaData - where Gaea is keeping it's data files.  Either derived
 *     or can be set by the environment variable GAEADATA_DIR.  This
 *     directory and the enclosed files must be readable by all Gaea users.
 *
 *     UserData - where to create and store user's data files. Either
 *     derived or can be set by the environment variable USRDATA_DIR.
 *     This directory must be readable and writeable by the user.
 *
 *     GaeaTmp - get the place where you want your temp files to go.  This
 *     is either derived from the environment variable GAEATMP_DIR, or
 *     else it will default to the current directory.  This directory will
 *     hold the tmp debugging files that the network manager creates.
 *
 *     IMS_DATA_CENTER_FILE - get the archive ODL file name.  This is derived from
 *     the environment variable IMS_DATA_CENTER_FILE, or else will default to
 *     DATA_CENTER_FILE if IMS_DATA_CENTER_FILE doesn't exist.
 *
 *     DiskAlloc - get the disk quota allocated for the user.  This is
 *     derived from the environment variable DISK_ALLOC, or else will
 *     default to "-1" if DISK_ALLOC doesn't exist.
 *
 *     Guide_Home_Addr - URL for the home page for the Guide subsystem
 *
 *     GranLimitCap - get maximum granules allowed for the user.  This is
 *     derived from the environment variable GRANULE_LIMIT_CAP, or else it
 *     will default to "-1" if GRANULE_LIMIT_CAP doesn't exist.
 *
 *     SyslogLevel - Variable which determines the level of system logging
 *     to perform
 *
 *     REVNAME - Program revision name
 *
 *     CommentsAddress - Mailing address for comments
 *
 *     BrowseSave - YES by default
 *
 *     MY_FAVORITE_BROWSER - get the name of the web browser to use for
 *     links from the Welcome Page that are not on the host machine of the
 *     Welcome Page.
 *
 *     WELCOME_PAGE_ADDR - URL for the system welcome page
 *
 *     IMS_LOG_TX - If the environment variable IMS_LOG_TX is set, then
 *     log all transmitted ODL messages. Otherwise, do not log the
 *     messages.
 *
 *     IMS_LOG_RX - If the environment variable IMS_LOG_RX is set, then
 *     log all received ODL messages. Otherwise, do not log the messages.
 *
 * REVISION HISTORY:
 *     08 MAR 1997  Eric Winter          HUGHES STX Corporation
 *                                       SMR 3912 and others. Also updated comments.
 *                                       Added support for IMS_LOG_TX and IMS_LOG_RX
 *                                       environment variables.
 *     17 MAR 1997  Eric Winter          HUGHES STX Corporation
 *                                       SMR 3918 - Removed ChuiGuide/CHUI_GUIDE
 *                                       variable support.
 *     22 AUG 1997  Lloyd M. Terrell     HUGHES STX Corporation
 *                                       Modified to include a global IMS system
 *                                       variable for the Archive ODL.
 *
 *****************************************************************************************/
char *IK_SysConfig(char *variable)
{
    static char buffer[FILENAME_MAX];  /* stuff goodies here */

    struct passwd *pw_entry;           /* used to get the passwd entries */
    struct stat    info;               /* stat() information from file system */

    char 
       *env_variable,
       *result = buffer;

    /*-----------------------------------------------------------------------*/

    if (strcmp("GaeaData", variable) == 0) {
	if (env_variable = getenv("GAEADATA_DIR")) {
	    (void) sprintf(buffer, "%s/", env_variable);
	} else {
	    (void) sprintf(buffer, "%s/", GAEADATA_DIR);
	}
    } else if (strcmp("UserData", variable) == 0) {
	/* Now here's an accident waiting to happen.  Does "USER"
	 * have a "E" or not?
	 * -pmr
	 */
	if ((env_variable = getenv("USRDATA_DIR")) != (char *) NULL) {
	    strcpy(buffer, env_variable);
	} else {
	    /*
	     * Assuming the presence of a $HOME variable is dangerous
	     * and unnecessary.  A call to getpwuid() is much better.
	     * -pmr
	     */
	    if ((pw_entry = getpwuid(getuid())) != NULL) {
		(void) sprintf(buffer, "%s/%s", pw_entry->pw_dir,
			       USRDATA_DIR);
	    } else {
		/* We should never get here.  If getuid() or getpwuid()
		 * fails, we have big problems.
		 * -pmr
		 */
		IK_Syslog(LOG_ERR, "unable to determine login directory "
			  "for user's account");
		result = NULL;
	    }
	}
	if (stat(buffer, &info) == -1 && errno == ENOENT) {
	    if (mkdir(buffer, 0700) != 0) {
		IK_vSyslog(LOG_ERR, "Unable to create user data directory %s",
			   buffer);
		result = NULL;
	    }
	}
	(void) strcat(buffer, "/");
    } else if (strcmp("GaeaTmp", variable) == 0) {
	/*
	 * This is stupid.  This should be TmpData, not GaeaTmp.
	 * That would be more consistent.  It would also make more
	 * sense to honor $TMPDIR like many other applications do.
	 * -pmr
	 */
	if ((env_variable = getenv("GAEATMP_DIR")) != (char*) NULL) {
	    (void) sprintf(buffer, "%s/", env_variable);
	} else {
	    if ((pw_entry = getpwuid(getuid())) != NULL) {
		(void) sprintf(buffer, "%s/%s", pw_entry->pw_dir, GAEATMP_DIR);
	    } else {
		/* We should never get here.  If getuid() or getpwuid()
		 * fails, we have big problems.
		 * -pmr
		 */
		IK_Syslog(LOG_ERR, "unable to determine login directory for "
			  "user's account");
		result = NULL;
	    }
	}
	if (stat(buffer, &info) == -1 && errno == ENOENT) {
	    if (mkdir(buffer, 0700) != 0) {
		IK_vSyslog(LOG_ERR, "Unable to create gaeatmp directory %s",
			   buffer);
		result = NULL;
	    }
	}
	(void) strcat(buffer, "/");
    } else if (strcmp("IMS_DATA_CENTER_FILE", variable) == 0) {
        env_variable = getenv("IMS_DATA_CENTER_FILE");
	if (env_variable != NULL) {
	    (void) strcpy(buffer, env_variable);
	} else {
            /* DATA_CENTER_FILE is defined in IK_Ims.h */
            (void) strcpy(buffer, DATA_CENTER_FILE);
	}
    } else if (strcmp("DiskAlloc", variable) == 0) {
	if ((env_variable = getenv("DISK_ALLOC")) != (char *) NULL) {
	    (void) sprintf(buffer, "%s", env_variable);
	} else {
	    (void) strcpy(buffer, "-1");
	}
    } else if (strcmp("Guide_Home_Addr", variable) == 0) {
	if ((env_variable = getenv("GUIDE_HOME_ADDR")) != (char *) NULL) {
	    (void) sprintf(buffer, "%s", env_variable);
	} else {
	    (void) strcpy(buffer, " ");
	}
    } else if (strcmp("GranLimitCap", variable) == 0) {
	if ((env_variable = getenv("GRANULE_LIMIT_CAP")) != (char *) NULL) {
	    (void) sprintf(buffer, "%s", env_variable);
	} else {
	    (void) strcpy(buffer, "-1");
	}
    } else if (strcmp("SyslogLevel", variable) == 0) {
	if ((env_variable = getenv("SYSLOG_LEVEL")) != (char *) NULL) {
	    (void) sprintf(buffer, "%s", env_variable);
	} else {
	    (void) sprintf(buffer, "%d", LOG_ERR);
	}
    } else if (strcmp("REVNAME", variable) == 0) {
#ifndef REVNAME
#  define REVNAME "imswww-3_6"
#endif /* !REVNAME */
	(void) strcpy(buffer, REVNAME);
    } else if (strcmp("CommentsAddress", variable) == 0) {
	env_variable = getenv("IMS_COMMENTS_MAIL_DEST");
	if (env_variable != (char *) NULL) {
	    (void) strcpy(buffer, env_variable);
	} else {
	    /* default address temporarily hard-coded.  yuck.
	     * -pmr
	     */
	    (void) strcpy(buffer, "imsv0@eos.nasa.gov");
	}
    } else if (strcmp("BrowseSave", variable) == 0) {
        env_variable = getenv("BROWSE_SAVE");
        if (env_variable != (char *) NULL) {
            (void) strcpy(buffer, env_variable);
        } else {
            (void) strcpy(buffer, "YES");
        }
    } else if (strcmp("IMS_FIELD_SEPARATOR", variable) == 0) {
        env_variable = getenv("IMS_FIELD_SEPARATOR");
        if (env_variable != (char *) NULL) {
            (void) strcpy(buffer, env_variable);
        } else {
            (void) strcpy(buffer, " | ");
        }
    } else if (strcmp("IMS_SUBFIELD_SEPARATOR", variable) == 0) {
        env_variable = getenv("IMS_SUBFIELD_SEPARATOR");
        if (env_variable != (char *) NULL) {
            (void) strcpy(buffer, env_variable);
        } else {
            (void) strcpy(buffer, " : ");
        }
    } else if (strcmp("IMS_SEARCH_RESULTS_MAILER", variable) == 0) {
        env_variable = getenv("IMS_SEARCH_RESULTS_MAILER");
        if (env_variable != (char *) NULL) {
            (void) strcpy(buffer, env_variable);
        } else {
            (void) strcpy(buffer, "mail");
        }
    } else if (strcmp("IMS_SEARCH_RESULTS_ENCODER", variable) == 0) {
        env_variable = getenv("IMS_SEARCH_RESULTS_ENCODER");
        if (env_variable != (char *) NULL) {
            (void) strcpy(buffer, env_variable);
        } else {
			/*
			 *Some sites may want to compress before encoding, in
			 * which case the string would be "gzip -c | uuencode savedResults"
			 */
            (void) strcpy(buffer, "uuencode savedResults");
        }
    } else if (strcmp("IMS_INV_RESULT_SAVE", variable) == 0) {
        env_variable = getenv("IMS_INV_RESULT_SAVE");
        if (env_variable != (char *) NULL) {
            (void) strcpy(buffer, env_variable);
        } else {
            (void) strcpy(buffer, "yes");
        }
    } else if (strcmp("MY_FAVORITE_BROWSER", variable) == 0) {
        env_variable = getenv("MY_FAVORITE_BROWSER");
        if (env_variable != (char *) NULL) {
            (void) strcpy(buffer, env_variable);
        } else {
            result = NULL;
        }
    } else if (strcmp("WELCOME_PAGE_ADDR", variable) == 0) {
        env_variable = getenv("WELCOME_PAGE_ADDR");
        if (env_variable != (char *) NULL) {
            (void) strcpy(buffer, env_variable);
        } else {
            result = NULL;
        }
    } else if (strcmp("IMS_LOG_TX", variable) == 0) {
	env_variable = getenv("IMS_LOG_TX");
	if (env_variable != NULL) {
	    (void) strcpy(buffer, env_variable);
	} else {
	    result = NULL;
	}
    } else if (strcmp("IMS_LOG_RX", variable) == 0) {
	env_variable = getenv("IMS_LOG_RX");
	if (env_variable != NULL) {
	    (void) strcpy(buffer, env_variable);
	} else {
	    result = NULL;
	}
    } else {
	IK_vSyslog(LOG_ERR, "Reference to unrecognized system variable \"%s\"",
		   variable);
	result = NULL;
    }
    return(result);
} /* end IK_SysConfig */

/******************************************************************************************
 * 
 * NAME: IK_GetDataCenterFilename
 *
 * DESCRIPTION: Builds and returns the archive ODL path and file name.  The path name is
 *              retrieved from the IK_SysConf call with "GaeaData".  The file name is
 *              retrieved from the IK_SysConf call with "IMS_DATA_CENTER_FILE".  This
 *              function allocates the memory used to build the path/file name, therefore
 *              the memory being returned to the calling function needs to be freed.
 *
 * PARAMETERS:
 *     None
 *
 * RETURN VALUE:
 *     pc_archivePath -- (char *) Archive ODL full path and file name.
 *                                NULL = if an error occurs.
 *     
 * GLOBAL VARIABLES:
 *	
 * PRE- & POST-CONDITIONS:
 *
 * NOTES:
 *     The calling function should free the memory that is allocated for building
 *     the path/file name.
 *
 * REVISION HISTORY:
 *     22 AUG 1997  Lloyd M. Terrell     HUGHES STX Corporation
 *                                       Initial version
 *
 *****************************************************************************************/
char *IK_GetDataCenterFilename(void)
{
    char
       *pc_archivePath=NULL,    /* Archive ODL full path and file name. */
       *pc_envValue   =NULL;    /* Returned environment variable from IK_SysConfig. */

    /* Obtains the path where Gaea is keeping it's data files. */
    pc_envValue = IK_SysConfig("GaeaData");
    if (pc_envValue != (char *)NULL)
    {
        /* Allocate memory for archive path, 1 byte for null terminator, and 1 byte
           for '/'. */
        pc_archivePath = (char *) calloc(strlen(pc_envValue)+2, sizeof(char));
        if (pc_archivePath != (char *)NULL)
	{
	    /* Copies path name and "/" if needed. */
            strcpy(pc_archivePath, pc_envValue);
            if (pc_archivePath[strlen(pc_archivePath)-1] != '/')
                strcat(pc_archivePath, "/");

            /* Retrieves the data center file name (ie, archive.odl). */
            pc_envValue = IK_SysConfig("IMS_DATA_CENTER_FILE");
            if (pc_envValue != NULL)
            {
	        /* Re-allocates memory to append the data center file name to the path. */
                pc_archivePath=realloc(pc_archivePath,
                                         strlen(pc_archivePath)+strlen(pc_envValue)+1);
                if (pc_archivePath != (char *)NULL)
		{
                    strcat(pc_archivePath, pc_envValue);
                }
                else
		{
                    pc_envValue = NULL;
                }
            }
            else
	    {   /* Frees what we allocated, to be safe set to NULL. */
                free(pc_archivePath);
                pc_archivePath = NULL;
            }
        }
        else /* pc_archivePath == NULL, Unable to allocate memory for archive path. */
	{
            pc_envValue = NULL;
        }
    }
    else  /* pc_envValue == NULL, Unable to obtain data center file name. */
    {   /* This is redundant, but makes code clearer as to what should be returned. */
        pc_archivePath = (char *)NULL;
    }

    return pc_archivePath;

} /* end IK_GetDataCenterFilename */

