/*
 * Name: IK_Task.h
 *
 * Description: This file contains data definitions and function
 * prototypes for the IK_Task data structure, which is used as the
 * controlling mechanism for communication connections.
 *
 * Notes:
 *
 *-------------------------------------------------------------------------
 *
 * RCS information:
 *
 * $RCSfile: IK_Task.h,v $
 *
 * $Id: IK_Task.h,v 1.1 1997/03/06 15:38:52 amrhein Exp $
 *
 * $Log: IK_Task.h,v $
 * Revision 1.1  1997/03/06 15:38:52  amrhein
 * Initial revision
 *
 * Revision 6.1.1.3  1996/11/25  20:20:18  winter
 * Added IK_Task_CanExecute().
 *
 * Revision 6.1.1.2  1996/11/25  16:09:36  winter
 * Added prototype for IK_Task_Dump().
 *
 * Revision 6.1.1.1  1996/11/25  12:53:54  winter
 * Placeholder for new branch during Task Manager development.
 *
 * Revision 6.1  1996/11/25  12:53:05  winter
 * Initial checkin.
 *
 * */

/*****************************************************************************/

#if !defined(__IK_TASK_H__)
#define __IK_TASK_H__

/*****************************************************************************/

/* #include directives */

/* This header must be #included first in order to use
   autoconf-generated information. */
#include "IK_Ims.h"

/* System headers */

/* Standard headers */
#include <stdio.h>

/* Third-party library headers */

/* IMS headers */
#include "IK_Nm.h"

/*****************************************************************************/

/* #define directives */

/*****************************************************************************/

/* Data types */

/* This is the Task structure. It just acts as a wrapper around the
   CONNECTION_INFO structure. */
typedef struct IK_Task {

    CONNECTION_INFO *pCI;

} IK_Task;

/*****************************************************************************/

/* External variable declarations */

/*****************************************************************************/

/* Function prototypes (all functions in IK_Task.c) */

/* Task creation and deletion functions */
extern IK_Task *IK_Task_New(CONNECTION_INFO *pCI);
extern void IK_Task_Delete(IK_Task *ptask);

/* Task execution functions */
extern IK_BOOLEAN IK_Task_CanExecute(IK_Task *ptask);
extern IK_BOOLEAN IK_Task_DispatchTaskSegment(IK_Task *ptask);

/* Debugging functions */
extern void IK_Task_Dump(FILE *pFILE, IK_Task *ptask);

/*****************************************************************************/

#endif  /* !defined(__IK_TASK_H__) */
