/*
 * $Header: /imsdev/beta-3.5/src/IK_lib/RCS/IK_memory.c,v 1.6 1997/03/06 15:38:52 amrhein Exp $
 *
 *
 * $Log: IK_memory.c,v $
 * Revision 1.6  1997/03/06 15:38:52  amrhein
 * Updated to GUI's 6_1_12 IK
 *
 * Revision 6.1.1.1  1996/10/21  14:27:57  winter
 * Copied from 6.0.1.2 after 6.1 promotion.
 *
 * Revision 6.0.1.2  1996/09/26  12:50:18  winter
 * Added #include <sys/time.h> to avoid compiler warning on select()
 * prototype in <unistd.h>.
 *
 * Revision 6.0.1.1  1996/09/26  12:49:20  winter
 * Placeholder for new branch during comm s/w overhaul.
 *
 * Revision 6.0  1996/02/29  15:41:45  ims
 * COPIED FROM 5.1 FOR GUI_PROMO_6_0_960229.
 *
 * Revision 5.1  1995/12/28  20:10:01  ims
 * COPIED FROM 5.0 FOR GUI_PROMO_5_1_951228.
 *
 * Revision 5.0  1995/11/06  13:04:20  ims
 * PROMOTION FROM GUI_4_5_8_951030 FOR GUI_PROMO_5_0_951106
 *
 * Revision 4.5  1995/07/27  18:42:31  ims
 * PROMOTION FROM GUI_4_4_8_950501 FOR GUI_PROMO_4_5_950726
 *
 * Revision 0.2  1995/02/28  20:03:14  ryan
 * Commented-out debug code.  Added IK_Ims.h.
 *
 * Revision 0.1  1995/02/06  15:48:43  ryan
 * working version
 *
 *
 */

static char const * const rcsid =
"$Id: IK_memory.c,v 1.6 1997/03/06 15:38:52 amrhein Exp $";

#include "IK_Ims.h"

#include <sys/time.h>
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>

#include "IK_memory.h"

/*
IK_Fixup.h:
  
#define IK_RELOC             IK_reloc
#define IK_RELOC_LIST        IK_reloc_list
#define IK_PTR_RELOC_LIST(pptr, ptr) \
          ptr=IK_ptr_reloc_list(&pptr->aligned_data, ptr)

#define IK_FIXUP             IK_fixup
#define IK_FIXUP_LIST        IK_fixup_list
#define IK_PTR_FIXUP_LIST(pptr, ptr) \
          ptr=IK_ptr_fixup_list(&pptr->aligned_data, ptr)

 */

/*
 *
 *
 *
 */
ptrdiff_t
IK_reloc(void const *anchor, void const *ptr)
{
/*#ifdef DEBUG
    fprintf(stderr,"inside IK_reloc\n");
#endif*/
    
    return ((ptrdiff_t)ptr - (ptrdiff_t)anchor);
}

/*
 *
 *
 *
 */
void
IK_reloc_list(char ** const ptr)
{
    char
	**ptrs;
    
/*#ifdef DEBUG
    fprintf(stderr,"entering IK_reloc_list\n");
#endif*/
    
    for (ptrs=ptr; ptrs[0] != NULL; *(ptrs)++) {
	*ptrs = (char *) IK_reloc(ptr,*ptrs);
    }
/*#ifdef DEBUG
    fprintf(stderr,"leaving IK_reloc_list\n");
#endif*/
    
    return;
}

/*
 *
 *
 *
 */
char**
IK_ptr_reloc_list(void * const * const aligned_data, char ** ptr)
{
/*#ifdef DEBUG
    fprintf(stderr,"entering IK_ptr_reloc_list\n");
#endif*/
    if (!ptr)
	return NULL;

    IK_reloc_list(ptr);
    ptr = (char**) IK_reloc((void const *)aligned_data, (void const *)ptr);

/*#ifdef DEBUG
    fprintf(stderr,"leaving IK_ptr_reloc_list\n");
#endif*/

    return ptr;
}

/*
 *
 *
 *
 */
ptrdiff_t
IK_fixup(void const *anchor, void const *ptr)
{
/*#ifdef DEBUG
    fprintf(stderr,"inside IK_fixup\n");
#endif*/
     return ((ptrdiff_t)ptr + (ptrdiff_t)anchor);
}

/*
 *
 *
 *
 */
void
IK_fixup_list(char ** const ptr)
{ 
    char
	**ptrs;
    
/*#ifdef DEBUG
    fprintf(stderr,"entering IK_fixup_list\n");
#endif*/
    for (ptrs=ptr; ptrs[0] != NULL; *(ptrs)++) { 
	*ptrs = (char *) IK_fixup(*ptrs,ptr);
    } 
/*#ifdef DEBUG
    fprintf(stderr,"leaving IK_fixup_list\n");
#endif*/
    return;
}


/*
 *
 *
 *
 */
char**
IK_ptr_fixup_list(void * const * const aligned_data, char ** ptr)
{
/*#ifdef DEBUG
    fprintf(stderr,"entering IK_ptr_fixup_list\n");
#endif*/
    if (!ptr)
	return NULL;
    
    /* find the real beginning of the data */
    ptr = (char**) IK_fixup((void const *)aligned_data, (void const *)ptr);
    /* fix all the string addresses */
    IK_fixup_list(ptr);

/*#ifdef DEBUG
    fprintf(stderr,"leaving IK_ptr_fixup_list\n");
#endif*/
    return ptr;
}

