/*************************************************************
 *
 * NAME
 *    IW_ODL - additional routines for dealing with ODL
 *
 * DESCRIPTION
 *    
 *
 * AUTHOR
 *    Eryq (Erik Dorfman)
 *    Hughes STX Corporation
 *
 *************************************************************/

#ifndef __IW_ODL_h__
#define __IW_ODL_h__

#include <stdio.h>
#include "odldef.h"
#include "odlinter.h"

#include "IW_Chunk.h"


/************************************************************
 *
 * Types
 *
 ************************************************************/

/* Options when outputting ODL to chunks: */
typedef struct IW_ODLWriteOpts {
  char *except_groups;    /* don't output these groups: "GRANULE|PACKAGE" */
  char *except_params;    /* don't output these parameters */
} IW_ODLWriteOpts;


/************************************************************
 *
 * Prototypes
 *
 ************************************************************/

/* Parsing: */
AGGREGATE IW_ODLReadFile (char *, AGGREGATE);

/* Modification: */
int IW_ODLAddStringParam(AGGREGATE, char *, char *);

/* Iteration: */
AGGREGATE IW_ODLFirstChildGroup (AGGREGATE, char *);
AGGREGATE IW_ODLNextChildGroup  (AGGREGATE, char *, AGGREGATE);

/* Stringification: */
char  *IW_ODLJoinSequence     (PARAMETER, char *);
char  *IW_ODLParamStringified (PARAMETER, char *);
char  *IW_ODLValueStringified (VALUE value);
char  *IW_ODLValueString      (VALUE value);

/* Vectors and sequences: */
char **IW_ODLVectorFromSequence (PARAMETER);
void   IW_ODLVectorFree         (char **);

/* Output options: */
void IW_ODLWriteOptsClear (IW_ODLWriteOpts *);

/* Output: */
int IW_ODLWriteChunk       (IW_Chunksp *, AGGREGATE, IW_ODLWriteOpts *);
int IW_ODLWriteChunkGroup  (IW_Chunksp *, AGGREGATE, IW_ODLWriteOpts *);
int IW_ODLWriteChunkFields (IW_Chunksp *, AGGREGATE, IW_ODLWriteOpts *);



#endif /* __IW_ODL_h__ */

/******************** end of file "IW_ODL.h" ********************/
