/************************************************************
 * IW_Str.h
 ************************************************************
 *
 * DESCRIPTION
 *    String-processing package for the WebLib C utilities.
 *
 * AUTHOR
 *    Eryq (Erik Dorfman)
 *    Hughes STX Corporation
 *    3 Jan 1995
 */

#ifndef __IW_Str_h__
#define __IW_Str_h__

#include "IW.h"


/************************************************************
 *
 * Types
 *
 ************************************************************/

/* A variable-size string: */
typedef struct IW_Str {
  char *buf;
  int len;
} IW_Str;



/************************************************************
 *
 * Functions
 *
 ************************************************************/

extern char *IW_Strdup   (char *s);
extern char *IW_Stradd   (char *old, char *more);
extern int   IW_Strequal (char *s, char *t);
extern int   IW_Strcasecmp  (register char *s, register char *t);
extern int   IW_Strncasecmp (register char *s, register char *t, int n);
extern void  IW_Strsplit    (char *s, char *split, char *argv[]);
extern char *IW_Strdowncase (char *str);
extern char *IW_Strupcase   (char *str);

extern IW_Str *IW_StrNew  (char *s);
extern void    IW_StrFree (IW_Str *this);
extern IW_Str *IW_StrCat  (IW_Str *this, char *s);
extern char   *IW_StrBuf  (IW_Str *this);
extern int     IW_StrLen  (IW_Str *this);



#endif /* __IW_Str_h__ */

/******************** end of file "IW_Str.h" ********************/
