#include <malloc.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include "gd.h"

/*
 * After debugging, this goes back to gd.c
 * Virtual overlays:
 * TODO: Want to declare a virtual background color
 * Blending with backround causes overwrite
 * Blending with non-bg color casues new color to be computed:
 */

int gdImageBlendPixel(gdImagePtr im, int x, int y, int color, int ratio)
{
  int rstat = 0;
  int p;
  int c_in, c_out;
  extern int gyTraceFlag;

  int red_1, red_2, green_1, green_2, blue_1, blue_2;

  if (color >= 0) {
    if (gdImageBoundsSafe(im, x, y)) {
				/* See if new color == old color */
      c_in = im->pixels[x][y];	/* whats already there */
				/* get rgb components */
				/*  */
      if (gdImageGetTransparent(im) != c_in) {

	red_1   = im->red[c_in];
	green_1 = im->green[c_in];
	blue_1  = im->blue[c_in];

	
	red_2   = im->red[color];
	green_2 = im->green[color];
	blue_2  = im->blue[color];
				/* indicate to caller that some
				   non-trivial blending has occured
				   done something significant */
	rstat = 0;
	if (red_1 != red_2 || green_1 != green_2 || blue_1 != blue_2)
	  rstat = 1;
	else 
	  return rstat;
#ifdef	BLENDTRACE
	if (gyTraceFlag)
	  fprintf(stderr, "BlendPixel(%d %d): %d %d %d and %d %d %d r=%d\n",
		  x, y, 
		  red_1, green_1, blue_1, red_2, green_2, blue_2,
		  rstat);
#endif

	red_1   = (red_1 + red_2) / 2;
	green_1 = (green_1 + green_2) / 2;
	blue_1  = (blue_1 + blue_2) / 2;
	c_out = gdImageColorExact(im, red_1, green_1, blue_1);
      } else {
	red_2   = im->red[color];
	green_2 = im->green[color];
	blue_2  = im->blue[color];
	c_out = color;
#ifdef	BLENDTRACE
	if (gyTraceFlag)
	  fprintf(stderr, "BlendPixel(%d %d): BG %d %d %d\n",
		  x, y, 
		  red_2, green_2, blue_2);
#endif
	rstat = 1;
      }
      
      if (c_out < 0){
	c_out = gdImageColorAllocate(im, red_1, green_1, blue_1);
	if (c_out < 0){
	  c_out = gdImageColorClosest(im, red_1, green_1, blue_1);
	}
      }
      if (c_out < 0)
	im->pixels[x][y] = color;
      else 
      	im->pixels[x][y] = c_out;
    }
  }
  return rstat;
}
