#include <stdio.h>
#include "gd.h"
#include "gdfontg.h"
#include "gdfonts.h"

int main(void)
{
  /* for loops */
  int i, j;
  /* Input and output files */
  FILE *in;
  FILE *out;

  /* Input and output images */
  gdImagePtr im_in, im_out, im_scatch;

  /* Brush image */
  gdImagePtr brush;

  /* Color indexes */
  int white;
  int blue;
  int red;
  int green;
  int yellow;

  /* Points for polygon */
  gdPoint points[3];

  /* Create output image, 182 by 260 pixels. */
  im_out = gdImageCreate(182, 260);
  im_scatch = gdImageCreate(182, 260);

  /* First color allocated is background. */
  white = gdImageColorAllocate(im_out, 255, 255, 255);

  /* Set transparent color. */
  gdImageColorTransparent(im_out, white);

  /* Try to load demoin.gif and paste part of it into the
		output image. */

  in = fopen("demoin.gif", "rb");

  yellow = gdImageColorAllocate(im_out, 255, 255, 0);
  red = gdImageColorAllocate(im_out, 255, 0, 0);
  green = gdImageColorAllocate(im_out, 0, 255, 0);
  blue = gdImageColorAllocate(im_out, 0, 0, 255);

  if (!in) {
    fprintf(stderr, "Can't load source image; this demo\n");
    fprintf(stderr, "is much more impressive if demoin.gif\n");
    fprintf(stderr, "is available.\n");
    im_in = 0;
  } else {
    im_in = gdImageCreateFromGif(in);
    fclose(in);
    /* Now copy, and magnify as we do so */
    /*    gdImageCopyResized(im_out, im_in, 
		       16, 16, 0, 0, 96, 96, 127, 127);		*/
    gdImageCopy(im_out, im_in, 0, 0, 0, 0, 160, 180);
    gdImageCopy(im_scatch, im_in, 0, 0, 90, 100, 50, 70);
    gdImageCopy(im_out, im_scatch, 20, 186, 0, 0, 50, 70);
    gdImageFilledRectangle(im_out, 132, 76, 152, 94, white);
  }


  /* Polygon */
  points[0].x = 32;
  points[0].y = 0;
  points[1].x = 0;
  points[1].y = 64;	
  points[2].x = 64;
  points[2].y = 64;	
  gdImageFilledPolygon(im_out, points, 3, green);

  /* Text */
  gdImageString(im_out, gdFontGiant, 16, 16, "hi", yellow);
  gdImageStringUp(im_out, gdFontSmall, 32, 64, "upside", red);

				/* Blend */
  gdSetMode(GD_BLEND, 128);
  for(i=80; i<128; i++){
    for(j=0; j<32; j++){
      gdImageSetPixel(im_out, j, i, blue);
    }
  }

  for(i=96; i<128; i++){
    for(j=0; j<64; j++){
      gdImageSetPixel(im_out, j, i, green);
    }
  }
  gdSetMode(GD_COPY, 128);
				/* Interlace, and Write GIF */
  gdImageInterlace(im_out, 1);
  out = fopen("demoout.gif", "wb");
  gdImageGif(im_out, out);
  fclose(out);
  gdImageDestroy(im_out);
  if (im_in) {
    gdImageDestroy(im_in);
  }
  return 0;
}


