/*
 * Copyright (c) 1996 U.S. Geological Survey (USGS)
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of USGS not be used in advertising or
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.  USGS makes no representations about the
 * suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 *
 * USGS DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL USGS
 * BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
 * OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */

/* glismapper.h */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "gd.h"
#include "miscanfill.h"
#include "mipoly.h"
#include "mapper.h"
#include "gdfontmb.h"
#include "gdfontt.h"

#ifndef GLOBAL
#define GLOBAL extern
#endif

GLOBAL gdImagePtr image;
GLOBAL gdImagePtr small_dot;
GLOBAL gdImagePtr small_green_dot;
GLOBAL gdImagePtr small_black_dot;
GLOBAL gdImagePtr med_dot;
GLOBAL gdImagePtr large_dot;
GLOBAL gdImagePtr star;
GLOBAL gdImagePtr target;
GLOBAL gdImagePtr box2;
GLOBAL gdImagePtr cross;
GLOBAL Entity *entities;
GLOBAL int width;
GLOBAL int projection;  /* 0 = ortho , 1 = gnomonic */
GLOBAL int height;
GLOBAL int zoom_percent;
GLOBAL float grid_increment;
GLOBAL char mapdir[256];
GLOBAL char symboldir[256];
GLOBAL POINT center;
GLOBAL int radius;
GLOBAL GC entity_gc;
GLOBAL GC grid_gc;
GLOBAL GC map_gc[15];
GLOBAL GC land_gc;
GLOBAL GC label_gc;
GLOBAL int water_layer;
GLOBAL int political_layer;
GLOBAL int rail_layer;
GLOBAL int roads_layer;
GLOBAL int populated_places_layer;
GLOBAL int napp_layer;
GLOBAL int nhap_bw_layer;
GLOBAL int nhap_cir_layer;
GLOBAL int wrs1_layer;
GLOBAL int wrs2_layer;
GLOBAL int background;
GLOBAL int black;
GLOBAL int white;
GLOBAL int red;
GLOBAL int blue;
GLOBAL int cyan;
GLOBAL int magenta;
GLOBAL int orange;
GLOBAL int gray25;
GLOBAL int zoom_report_only;


extern int setup_mapper(void);
extern void LoadEntities(FILE *);
extern void DrawRefaid(void);
extern int ortho(int, float, float, float, float, int *, int *);
extern int invortho(int, float, float, int, int, float *, float *);
extern int gnomonic(int, float, float, float, float, int *, int *);
extern int invgnomonic(int, float, float, int, int, float *, float *);
extern int allocate_color(gdImagePtr, char *);
extern int miFilledPolygon(gdImagePtr im, DDXPointPtr ptsIn, int count, int c);
