
typedef struct _LLink {
  struct _LLink *next;
  void *info;
} LLink;

typedef struct _LHead {
  LLink *head;
  LLink *tail;
  LLink *this;
  size_t info_size;
  char type[40];		/* Consistency check */
} LHead;

typedef struct _GRing {
  char name[750];
  LHead *H;			/* list of polys */
  LHead *P;			/* list of polys */
  LHead *current;		/* list of points */
} GRing;


int GRingParse(char *inp, char *label);
void prepare_rings();
void expand_ring(double lat, double lon);
void process_ring ();
void do_ring (char *label);
int declare_ring(char *label, int kind);
