#include	<stdio.h>
#include	<math.h>
#include	"gring.h"
#include	"memory.h"

#undef		STANDALONE
int complete_ring(double lats[], double lons[], int sides, int kind);

/**************************************** TOKEN *************************/
typedef struct _Tokenizer {
  char delimiter;
  char *next_token;
  char *base;
  long maxSize;
  long currentSize;
} StringTokenizer;

StringTokenizer *newTokenizer (char *string, char letter);
char *nextToken(char *space, StringTokenizer *st, int noblank);


StringTokenizer *newTokenizer(char *string, char letter)
{
  StringTokenizer *st;
  st = (StringTokenizer *) malloc(sizeof (StringTokenizer));

  st->delimiter = letter;
  st->next_token = string;
  st->base = string;
  st->currentSize = st->maxSize = strlen(string);
  return st;
}

char *nextToken(char *space, StringTokenizer *st, int noblank)
{
  char *s, *d;
  int eos;
  int havenone;

  d = space;
  havenone = 1;
  while(havenone){
    if (s = st->next_token){	/* Assignement intentional */
      eos = 0;
      while(*s && *s != st->delimiter){
	*d++ = *s++;
      }
      if (*s) {
	st->next_token = s+1;
      } else {
	st->next_token = (char *) 0L;
      }
    } else {
      eos = 1;
    }
    if (eos || (space != d))
      havenone = 0;
    if (noblank == 0)
      havenone = 0;
  }
  *d = '\0';
  return (eos) ? (char *) 0L : space;
}
void destroyTokenizer (StringTokenizer **str)
{
  if (str){
    if (*str)
      free (*str);
    *str = NULL;
  }
  return;
}

/**************************************** GRING heart*******************/

static int first_time = 1;

void GRingInit()
{
  
}


/**************************************** G-RING *************************/
				/* Maybe this file should be called
				 tokenring? Someone may get confused ...*/

int GRingParse(char *inp, char *label)
{
  StringTokenizer *st;
  int tcnt;
  char space[750], TheLabel[750];
  double lat, lon;
  int TheKind;
  int rstat;

  if (first_time){
    prepare_rings();
    first_time = 0;
  }

  rstat = -3;
  st = newTokenizer (inp, ' ');
  tcnt = 0;
  while(nextToken(space, st, 1)){
    switch(tcnt){
    case 0:
      if (strcmp(space, "QRING:")) {
	rstat = -1;
	goto bail_out;
      }
      break;
    case 1:
				/* Label/glyph */
      strcpy(TheLabel, space);
      strcpy(label, TheLabel);	/* caller wants to know */ 
      break;
    case 2:
      if (space[0] == 'P' || space[0] == 'p'){
	TheKind = 1;
      } else if (space[0] == 'H' || space[0] == 'h'){
	TheKind = 0;
      } else {
	TheKind = -1;
      }

      rstat = declare_ring(TheLabel, TheKind);

      break;
    default:
      if (tcnt & 1) {		/* odd = lat, even = lon */
	lat = atof(space);
      }
      else {
	lon = atof(space);
	expand_ring(lat, lon);
      }
    }
    tcnt++;
  }

bail_out:
  destroyTokenizer(&st);
  return rstat;
}



/* QRING  1 P 45.0 -40.0 45.0 40.0 10.0 50.0 -40.0 40.0 
   -50.0 -10.0 -10.0 -70.0    */

#define	TEST "QRING: 1 P 1 2 3 4 5 6 7 8"

#define	TEST1 "QRING: 1 P 45.0 -40.0 45.0 40.0 10.0 50.0 -40.0   40.0 -50.0 -10.0 -10.0 -70.0 "

char *testthem[] = {
"QRING: 1 P 11 22 33 44 55 66 77 88",
"QRING: 1 P 40.0 -100.0 40.0 -80.0 20.0 -80.0 20.0 -100.0",
"QRING: 1 H 5.0 -10.0 5.0 -5.0 2.0 -5.0",
"QRING: 1 H 6.0 5.0 6.0 10.0 2.0 10.0 2.0 5.0",
"QRING: 2 P 40.0 -100.0 40.0 -80.0 20.0 -80.0 20.0 -100.0",
"QRING: 2 H 35.0 -95.0 35.0 -85.0 30.0 -85.0 30.0 -95.0"
};
tok_main()
{
  int i;
  char label[750];
  int rstat;
  if (rstat = GRingParse(TEST, label)){
    printf("Syntax error: %d\n", rstat);
    exit(1);
  }

  exit(0);
  for(i=0; i<6; i++){
    if (rstat = GRingParse(testthem[i], label)){
      printf("Syntax error on %d: %d\n", i, rstat);
      exit(1);
    }
  }

  process_rings();
  MY_chkmem();
  exit(0);


}

#ifdef	STANDALONE
int complete_ring(double lats[], double lons[], int sides, int kind)
{
  printf("Sides = %d\n", sides);
  printf("Kind = %d\n", kind);
}
main()
{
  tok_main();
  process_rings();
}
#endif
