#define MINIMUM_COVER	22	/* covers smaller than this get glyphs */
#define MAX_POLYPOINTS	4

#define	POLE_NONE	0
#define	POLE_NORTH	1
#define	POLE_SOUTH	2
#define	POLE_BOTH	3

typedef struct _Cover {
  char type;
  char pole_inside;
  int r, g, b;			/* [ed:new:gyuri] */
  double lat[MAX_POLYPOINTS];
  double lon[MAX_POLYPOINTS];
  int npoints;
  struct _Cover *next;
  char label[8];		/* [ed:new:gyuri] */
  int zerosize;			/* [ed:new:gyuri] */
  char path[8];  
} Cover;


typedef struct _View {
  int layers[N_MAP_LAYERS];
  int projection;
  int resolution;
  int backface;
  int gridinc;
  int center_lat;
  int center_lon;
  int width;
  int height;
  int center_x;
  int center_y;
  double zfact;
  int displayLabels;          /* Display MISR labels? [jsa] */
  int labelLatLong;          /* Should we Label the Lat/Longs? [jsa] */
  char baseImage[80];        /* Use this image as the 'base' rather then create
                                a 'blank image' */
  double radius;

  MapGCStr gc_init;
  MapGCStr gc_cil, gc_cil_bk;
  MapGCStr gc_grid, gc_grid_bk;
  MapGCStr gc_riv, gc_riv_bk;
  MapGCStr gc_ibd, gc_ibd_bk;
  MapGCStr gc_nbd, gc_nbd_bk;
  MapGCStr gc_cov, gc_cov_bk;


  gdImagePtr image;
  gdImagePtr scratch;
  Cover *cover;

  struct _View *next;
} View;
