package IMSWG.IU;

import java.awt.*;
import java.applet.*;

/**
 * This class provides a framework for running applets within a Frame,
 * allowing you to run an applet as a stand-alone application.
 *
 * To use this class, add the following <b>main()</b> to your applet:
 * <pre>
 * static public void main(String[] args) {
 *      new AppletFrame((Applet) new YourApplet(), width, height);
 * }
 * </pre>
 * @version 1.0 from an example in "Core Java"
 * @author Joe McMahon
 */

public class AppletFrame extends Frame {

    /**
     * This method creates a frame, titles it, and sizes it appropriately.
     * It then adds the applet to itself and runs it.
     * @param a The applet to be run
     * @param x The window width
     * @param y The window height
     */

    public AppletFrame(Applet a, int x, int y) {
        setTitle(a.getClass().getName());
        resize(x,y);
        add("Center",a);
        a.init();
        show();
        a.start();
    }

    /**
     * This method handles the "close" event for the frame.
     * @param e The Event to be handled.
     */

    public boolean handleEvent(Event e) {
        if (e.id == Event.WINDOW_DESTROY) {
            System.exit(0);
        }
        return super.handleEvent(e);
    }
}

