package IMSWG.IU;

/**
 * Create an ODL message and store in a Vector.
 *
 * @author Ed Seufert
 */

import java.util.Vector;
import IMSWG.IU.StringVector;

public class ODL {

        // Global variables;

	private StringVector theODL;  // Holds the ODL
        private int tabcount;         // How many tabs to indent the ODL
        private String indent;        // String to do the indentation 
                                      // (tabcount * 5) spaces.

	public ODL () {

		theODL = new StringVector();
                tabcount = 0;
                indent = "";
	}

	public void startGroup (String s) {

		theODL.addElement(indent+"GROUP = "+s+"\n");
                // started new group so increase indent by one tab.
                ++tabcount;
                indent = tab();
        }

        public void endGroup (String s) {

                // ended a group so decrease indent by one tab.
                --tabcount;
                indent = tab();
                theODL.addElement(indent+"END_GROUP = "+s+"\n"); 
        }

        public void add(String key,String value) {

                if (!value.equals(null)) {
		     theODL.addElement(indent+key+" = \""+value+"\"\n");
                }
        }

        public void add(String key,String[] values) {

                theODL.addElement(indent+key+" = (\n");

                for (int i=0; i < values.length; i++) {
                   if (i != values.length-1) {
                      theODL.addElement(indent+"\""+values[i]+"\",\n");
                   } else {
                       theODL.addElement(indent+"\""+values[i]+"\"\n");
                   }
                } 
		theODL.addElement(indent+" )\n");
        }

        public void add(String key, Vector values) {


                theODL.addElement(indent+key+" = (\n");
System.out.println("ODL.add(String key, Vector values");
System.out.println("ODL.add - values.size() = "+values.size());
                for (int i=0; i < values.size(); i++) {
                  if (i != values.size()-1) {
                     theODL.addElement(indent+"\""+values.elementAt(i)+"\",\n");
                  } else {
                      theODL.addElement(indent+"\""+values.elementAt(i)+"\"\n");
                  }
                }
                theODL.addElement(indent+" )\n");
        }


        public void add(String key, StringVector values) {


                theODL.addElement(indent+key+" = (\n");

                for (int i=0; i < values.size(); i++) {
                  if (i != values.size()-1) {
                     theODL.addElement(indent+"\""+values.elementAt(i)+"\",\n");
                  } else {
                      theODL.addElement(indent+"\""+values.elementAt(i)+"\"\n");
                  }
                }
                theODL.addElement(indent+" )\n");
        }

        public void add(ODL odl) {

            if (odl == null) {
                    return;
            } else {

                StringVector values = odl.done();
                for (int i=0; i < values.size(); i++) {
                    theODL.addElement(indent+values.elementAt(i));
                }
   	    }
        }



        public StringVector done() {

                return theODL;             
        }

        private String tab() {

                String tab = "";
                for (int i=0; i < tabcount; i++) {

                	tab = tab+"     ";			

                }
           	return tab;
        }
}
