package IMSWG.IU;

import java.util.*;
import java.net.*;
import java.io.*;
import java.net.URL;
// import IMSWG.IU.PostException;

/**
 * This class allows the applet to communicate with a CGI program
 * via a HTTP Post.
 * @author Jim Amrhein

 Create a new Post object 
       Post postTo = new Post("http://harp.../imsDepVal.cgi");

 Add to the message that will be sent :
         postTo.add(vodl);

 Post to the Server
         postTo.send();

 Get the results :
         Vector response = postTo.results();

 */

public class Post {
	private URLConnection urlConnect = null;
	private String contentTypeValue = "application/x-www-form-urlencoded";
        private Vector theResults ;
	private String error_number = null;
	private String error_string = null;
	private StringVector theMessage; 

  public Post(String passedURL) throws PostException {
         try {
             URL connectToURL = new URL(passedURL);
	     urlConnect = connectToURL.openConnection();
             urlConnect.setDoOutput(true);
             urlConnect.setDoInput(true);
             // uc.setAllowUserInteraction(false);
             urlConnect.setUseCaches (false);

             // Specify the content type.
	     // Default - "application/x-www-form-urlencoded"

             urlConnect.setRequestProperty("Content-Type", contentTypeValue);

	     
             // Default is 10
	     theResults = new Vector(25);
	     theMessage = new StringVector(); 
         }
         catch (MalformedURLException ex) {
             // System.out.println("POST URLException"+ex);
             throw new PostException("Post:MalformedURL :" + ex);
         }
         catch (SocketException e) {
              // System.out.println("POST SocketException"+e);
		throw new PostException("Post:Socket :" + e);
         }
         catch (IOException e) {
              // System.out.println("POST IOException"+e);
		throw new PostException("Post:Socket :" + e);
         }    
  }

  public void setContentType (String value) {
	contentTypeValue = value;
  }


  public void send () throws PostException {

        String nextline;
        String comment_line = "<!-";
        String errorline = null;
        DataOutputStream dos;

        // Send the data
       try {
           dos = new DataOutputStream(
                     new BufferedOutputStream(urlConnect.getOutputStream()));
           //dos.writeBytes(theMessage);
        for (int i=0; i < theMessage.size(); i++) {
              dos.writeBytes( theMessage.elementAt(i));
        }

           dos.close();

       DataInputStream dis = new DataInputStream(
                           new BufferedInputStream(urlConnect.getInputStream()));


        // Read the response

        while((nextline = dis.readLine()) != null) {
          if ( nextline.startsWith(comment_line)) {
                   errorline = nextline;
		   // There was an error on the WG side, we need the applet
                   // to stop, and inform the user of this state .
		   throw new PostException("Send :" + errorline);
          }
	  else {
		   theResults.addElement(nextline);
	  }
        }
        dis.close();
 
      }
      catch (IOException e) {
         System.out.println("POST IOException"+e);
	 throw new PostException("Send:IO : " + e);
      }
  }


  /* ADD Methods 
  * Used to build a message that will eventually be sent
  *
  */

  public void add (String message) {
	theMessage.addElement(message+"\n");
  
  }

  public void add (StringVector message) {
        for (int i=0; i < message.size(); i++) {
              theMessage.addElement(message.elementAt(i));
//		System.out.print("adding : "+(message.elementAt(i)));
        }
  }

 public void add(String[] message) {
	for (int i=0; i < message.length; i++) {
         	theMessage.addElement(message[i]);
//                System.out.print("adding : "+(message[i]));
        }

  }

  /* RESULT Method
  * the response from the server
  */

  public Vector results () {
	theResults.trimToSize();
	return (theResults);
  }

}
