package IMSWG.IU;


/**
 * Wrapper class to make vector of strings.
 * Insures that only strings are put into the Vector. 
 * Use like a Vector, though not all Vector methods have been implemented.
 * Why a wrapper class instead of extending from Vector?  
 * 1) many of the methods of Vector are final and thus can not be overridden.
 * 2) you should not use inherited methods as they may not be string safe.
 *
 * @see Vector
 * @author Ed Seufert
 */

import java.util.Vector;
import java.util.Enumeration;

public class StringVector {

	private Vector v = new Vector();

        public void addElement(String s) { v.addElement(s); }

        public int size() { return v.size(); }

        public Enumeration elements() { return v.elements(); }

        public String elementAt(int i) { return (String) v.elementAt(i); }

        public void copyInto(String[] array) { v.copyInto(array); }

        public StringVector cloneStringVector() { return (StringVector) v.clone(); }

        public void removeAllElements() { v.removeAllElements(); } 

        public boolean removeElement(String s) { 
              return v.removeElement(s);
        }
}



