package IMSWG.IW.DepValid;

import java.awt.*;
import java.util.*;
import java.lang.*;
import IMSWG.IW.DepValid.*;

/**
 * This class is to support the display of the attribute pull-down menu.
 * @author Mark Solomon
 */

public class DisplayAttribute extends Choice {

   DisplaySelection myDisplay;

   /**
   * Stores a local copy of the DisplaySelection
   * @see DisplaySelection
   */

   public DisplayAttribute(DisplaySelection displaySelection) {
      myDisplay= displaySelection;
   }
      
   /**
   * Gets the list of attributes from the Attributes object and displays
   * them in a Choice list.  Uses the current attribute from the Attributes
   * object to set the current selection.
   * @see Attribute
   */

   public Choice display() {
      String[] newPrettyList = 
         new String[myDisplay.attribute.prettyList.size()];
      newPrettyList = myDisplay.attribute.getpretty();
      for (int i = 0; i < newPrettyList.length; i++) {
         this.addItem(newPrettyList[i]);
      }
      String type = myDisplay.attribute.get();
      String attributeArray[] = 
         new String[myDisplay.attribute.attributeList.size()];
      attributeArray = myDisplay.attribute.getlist();
      for (int j = 0; j < attributeArray.length; j++) {
         if(attributeArray[j].equals(type)) this.select(j);
      }
      return this;
   }

   /**
   * When the user changes the category the changeCat method of
   * DisplaySelection is called.
   * @see DisplaySelection#changeCat
   */

   public boolean action(Event evt, Object arg) {
      String[] validsStrings = new String[myDisplay.displayValids.validsList.countItems()];
      if (evt.target instanceof Choice) {
         validsStrings = myDisplay.displayValids.validsList.getSelectedItems();
        
         int intValue = this.getSelectedIndex();
         myDisplay.changeCat(intValue, validsStrings);
      }
      return true;
   }
}
