package IMSWG.IW.DepValid;

import java.awt.*;
import java.util.*;
import java.lang.*;
import IMSWG.IW.DepValid.*;

/**
 * This class is to support the Display of Filters
 * @author Mark Solomon
 */

public class DisplayFilters extends Panel {

   DisplaySelection myDisplay;
   List filtersList = new List(Constants.FILTER_ROWS,true);

   /**
   * The constructor stores a local copy of the DisplaySelection.
   * @see DisplaySelection
   */

   public DisplayFilters(DisplaySelection displaySelection) {
      myDisplay = displaySelection;
   }

   /**
   * Sets up for the initial display of the filters based on the
   * filters object.
   * @see Filters
   */

   public Panel display() {
      String[] newFiltersList = 
         new String[myDisplay.filters.filtersList.size()];
      newFiltersList = myDisplay.filters.getlist();
      setLayout(new BorderLayout());
      add("North", new Label("Filters:"));
      for (int i = 0; i < newFiltersList.length; i ++) {
         filtersList.addItem(newFiltersList[i],i);
      }
      add("South", filtersList);
      return this;
   }

   /**
   * Clears the filters list and sets the list based on the filters 
   * object.
   * @see Filters
   */

   public void update() {
      String[] newFiltersList = 
         new String[myDisplay.filters.filtersList.size()];
      newFiltersList = myDisplay.filters.getlist();
      if(filtersList.countItems() > 0) {
         filtersList.clear();
      }
      for (int i = 0; i < newFiltersList.length; i ++) {
         filtersList.addItem(newFiltersList[i],i);
      }
   }

   /**
   * If a filter is selected or deselected applyFilters will handle the
   * action.
   * @see DisplaySelection#applyFilters
   */

   public boolean handleEvent(Event event) {
      String[] filterStrings = new String[filtersList.countItems()];
      switch(event.id) {
         case Event.LIST_SELECT:
         case Event.LIST_DESELECT:
            // do something if event.target is scrolling list
            filterStrings = filtersList.getSelectedItems();
            myDisplay.applyFilters(filterStrings);
         default:
            return super.handleEvent(event);
      }
   }    

}
