package IMSWG.IW.DepValid;

import java.awt.*;
import java.util.*;
import java.lang.*;
import IMSWG.IW.DepValid.*;

/**
 * This class is to support the Display of the Definition and Guide Buttons.
 * @author Mark Solomon
 */

public class DisplayMoreInfo extends Panel {

   DisplaySelection myDisplay;
   Button definition = new Button("Definition");
   Button detailed = new Button("Detailed Document");
   Panel myPanel;


   /**
    * Sets a local copy of a DisplaySelection.
    */
   public DisplayMoreInfo(DisplaySelection displaySelection) {
      myDisplay= displaySelection;
   }

   /**
    * Displays a "Definition" button and a "Detailed Document" button.
    */
   public Panel display() {
      myPanel = this;
      setLayout(new FlowLayout(FlowLayout.LEFT));
      add(definition);
      add(detailed);
      update();
      return this;
   }

   /**
    * If the info type is not available for the category String cat,
    * disable the button.  If it is available for the cat, enable the button.
    */
   public Panel update() {
      String cat = myDisplay.attribute.get();
      if(!myDisplay.attribute.defOK(cat)) definition.disable();
      if(!myDisplay.attribute.guideOK(cat)) detailed.disable();
      if(myDisplay.attribute.defOK(cat)) definition.enable();
      if(myDisplay.attribute.guideOK(cat)) detailed.enable();
      return myPanel;
   }

   /**
    * If the definition button is pressed, popupDef will handle the action, and
    * if the detailed button is pressed, popupGuide will handle the action.
    * @see DisplaySelection#popupDef
    * @see DisplaySelection#popupGuide
    */
   public boolean action(Event e, Object arg) {
//    System.out.println("in action");
      String[] validsStrings = new String[myDisplay.displayValids.validsList.countItems()];
      Object eventTarget = e.target;
      if(eventTarget == definition) {
//       System.out.println("popupDef");
         validsStrings = myDisplay.displayValids.validsList.getSelectedItems();
         myDisplay.selectMoreInfo(validsStrings);
         myDisplay.popupDef();
         return true;
      }
      if(eventTarget == detailed) {
//       System.out.println("popupGuide");
         validsStrings = myDisplay.displayValids.validsList.getSelectedItems();
         myDisplay.selectMoreInfo(validsStrings);
         myDisplay.popupGuide();
         return true;
      }
      return false;
   }

}
