package IMSWG.IW.DepValid;

import java.awt.*;
import java.util.*;
import java.lang.*;
import IMSWG.IW.DepValid.*;

/**
 * This class is to support the Display of Patterns.
 * @author Mark Solomon
 */

public class DisplayPatterns extends Panel {

   DisplaySelection myDisplay;
   TextField patternsText = new TextField(Constants.PATTERN_WIDTH);

   /**
    * Sets a local copy of DisplaySelection.
    */

   public DisplayPatterns(DisplaySelection displaySelection) {
      myDisplay= displaySelection;
   }

   /**
    * Sets up for the display of the patterns entry box.
    */

   public Panel display() {
      setLayout(new BorderLayout());
      add("North", 
          new Label("Type-in:  Filter the choices by pattern-matching."));
      add("South", patternsText);
      return this;
   }  

   /**
    * Sets a new value in the patterns entry box from the Patterns object.
    * @see Patterns
    */

   public void update() {
      String newPattern = myDisplay.patterns.get();
      patternsText.setText(newPattern);
   }

   /**
    * If a new pattern is typed the action is handled by applyPattern in
    * DisplaySelection.
    * @see DisplaySelection#applyPattern
    */

   public boolean action(Event evt, Object arg) {
      if (evt.target instanceof TextField) {
         String choiceValue = (String) arg;
         myDisplay.applyPattern(choiceValue);
         return true;
      }
      else {
         return false;
      }
   }

}
