package IMSWG.IW.DepValid;

import java.awt.*;
import java.util.*;
import java.lang.*;
import IMSWG.IW.DepValid.*;

/**
 * This class is to support the Display of a Query.
 * @author Mark Solomon
 */

public class DisplayQuery extends Panel {

   DisplaySelection myDisplay;
   List queryListArea = new List(Constants.QUERY_ROWS,false);
   Button validateQuery = new Button("Validate Search Criteria");
   /**
    * Sets a local copy of DisplaySelection.
    */

   public DisplayQuery(DisplaySelection displaySelection) {
      myDisplay= displaySelection;
   }

   /**
    * Uses query.queryList to display the query in a List.
    * @see Query
    */

   public Panel display() {
      String[] newQueryList = new String[myDisplay.query.queryList.size()];
      newQueryList = myDisplay.query.getlist();
      setLayout(new BorderLayout());
      Panel queryTop = new Panel();
      queryTop.setLayout(new FlowLayout(FlowLayout.LEFT));
      queryTop.add(new Label("Current Search Criteria:"));
      queryTop.add(validateQuery);
      add("North", queryTop);
      for (int i = 0; i < newQueryList.length; i ++) {
         queryListArea.addItem(newQueryList[i]);
      }
      add("South", queryListArea);
      return this;
   }

   /**
    * Clears the query List and updates it using query.queryList.
    * @see Query
    */

   public void update() {
      String[] newQueryList = new String[myDisplay.query.queryList.size()];
      newQueryList = myDisplay.query.getlist();
      if(queryListArea.countItems() > 0) {
         queryListArea.clear();
      }
//    System.out.println("newQueryList length: "+newQueryList.length);
      if(newQueryList.length > 0) {
         for (int i = 0; i < newQueryList.length; i ++) {
            if(newQueryList[i] != null) 
               queryListArea.addItem(newQueryList[i]);
         }
      }
   }

   /**
    * Currently, nothing happens if you select or deselect a query entry.
    */

   public boolean handleEvent(Event event) {
      switch(event.id) {
         case Event.LIST_SELECT:
         case Event.LIST_DESELECT:
            return true;
         default:
            return super.handleEvent(event);
        
      }
   }
   /**
    * If the "validateQuery" button is pressed the action is handled by the select
    * method of DisplaySelection; 
    * @see DisplaySelection#select
    */

   public boolean action(Event e, Object arg) {
     String[] validsStrings = new String[myDisplay.displayValids.validsList.countItems()];
      Object target = e.target;
      if(target == validateQuery) {
         validsStrings = myDisplay.displayValids.validsList.getSelectedItems();
         boolean doWeLockIt = true;
         myDisplay.select(validsStrings, doWeLockIt);
         return true;        
      }
      
      return false;
   }

}
