package IMSWG.IW.DepValid;

import java.awt.*;
import java.util.*;
import java.lang.*;
import IMSWG.IW.DepValid.*;

/**
 * This class is to support the Display of the Valids.
 * @author Mark Solomon
 */

public class DisplayValids extends Panel {

   DisplaySelection myDisplay;
   List validsList = new List(Constants.VALID_ROWS,true);
   int i;
   int j;
   Button all = new Button("All");
   Button none = new Button("None");

   /**
    * Sets a local copy of DisplaySelection.
    */

   public DisplayValids(DisplaySelection displaySelection) {
      myDisplay= displaySelection;
   }

   /**
    * Uses valids.selectedList and valids.validsList to display the valids.
    * It also sets the display of the "all" and "none" buttons.
    * It makes the selectedList items "selected" and removes the 
    * selectedList items from the validsList.
    * @see Valids
    */

   public Panel display() {
      String[] selectedValidsList = 
         new String[myDisplay.valids.selectedList.size()];
      selectedValidsList = myDisplay.valids.getSelected();
      setLayout(new BorderLayout());
      Panel validsTop = new Panel();
      Panel validsBottom = new Panel();
      validsTop.setLayout(new BorderLayout());
      validsBottom.setLayout(new FlowLayout(FlowLayout.LEFT));
      validsBottom.add(all);
      validsBottom.add(none);
      j = 0;
      if(selectedValidsList != null && selectedValidsList.length > 0) {
         for (j = 0; j < selectedValidsList.length; j ++) {
	    if(selectedValidsList[j] != null) {
               validsList.addItem(selectedValidsList[j],j);
               myDisplay.valids.validsList.removeElement(selectedValidsList[j]);
               validsList.select(j);
	    }
         }
      }
      String[] newValidsList = new String[myDisplay.valids.validsList.size()];
      newValidsList = myDisplay.valids.getlist();
      if(newValidsList != null && newValidsList.length > 0) {
         for (i = 0; i < newValidsList.length; i ++) {
            if(newValidsList[i] != null) validsList.addItem(newValidsList[i]);
         }
      }
      validsTop.add("North", new Label("Choices:"));
      validsTop.add("Center", myDisplay.displayMoreInfo.display());
      validsTop.add("South", validsList);
      add("North", validsTop);
      add("South", validsBottom);
      return this;
   }

   /**
    * Clears the validsList and redisplays first the selectedList and then the
    * validsList.
    * It makes the selectedList items "selected" and removes the selectedList
    * items from the validsList.
    * @see Valids
    */

   public void update() {
      String[] selectedValidsList = 
         new String[myDisplay.valids.selectedList.size()];
      selectedValidsList = myDisplay.valids.getSelected();
      if(validsList.countItems() > 0) {
         validsList.clear();
      }
      j = 0;
      if(selectedValidsList != null && selectedValidsList.length > 0) {
         for (j = 0; j < selectedValidsList.length; j ++) {
            validsList.addItem(selectedValidsList[j],j);
            myDisplay.valids.validsList.removeElement(selectedValidsList[j]);
            validsList.select(j);
         }
      }
      String[] newValidsList = new String[myDisplay.valids.validsList.size()];
      newValidsList = myDisplay.valids.getlist();
//    System.out.println("newValidsList.length is: "+newValidsList.length);
      if(newValidsList != null && newValidsList.length > 0) {
         for (i = 0; i < newValidsList.length; i ++) {
//        System.out.println("i is: "+i+newValidsList[i]);
            if(newValidsList[i] != null) validsList.addItem(newValidsList[i]);
         }
      }
   }

   /**
    * If an item is selected or deselected the action is handled by
    * the select method of DisplaySelection.
    * @see DisplaySelection#select
    */

   public boolean handleEvent(Event event) {
      String[] validsStrings = new String[validsList.countItems()];
      switch(event.id) {
         case Event.LIST_SELECT:
         case Event.LIST_DESELECT:
         validsStrings = myDisplay.displayValids.validsList.getSelectedItems();
         myDisplay.selectValids(validsStrings);
         default:
            return super.handleEvent(event);
      }
   }

   /**
    * If the "all" button is pressed the action is handled by the selectAll
    * method of DisplaySelection; if the "none" button is pressed, the action
    * is handled by the selectNone method of DisplaySelection.
    * @see DisplaySelection#selectAll
    * @see DisplaySelection#selectNone
    */

   public boolean action(Event e, Object arg) {
      Object target = e.target;
      if(target == all) {
         myDisplay.selectAll();
         return true;
      }
      if(target == none) {
         myDisplay.selectNone();
         return true;
      }
      return false;
   }

}
