package IMSWG.IW.DepValid;

import java.awt.*;
import java.util.*;
import java.lang.*;
import IMSWG.IU.ODL;
import IMSWG.IW.DepValid.*;


/**
 * This class is to support the Patterns.
 * @author Mark Solomon
 */

public class Patterns{

   Selection myDisplaySelection;
   String myPattern = new String();

   /**
    * Saves a local copy of Selection.
    */

   public Patterns(Selection displaySelection) {
      myDisplaySelection = displaySelection;
   }

   /**
    * Sets the pattern to the input String.
    */

   public void set(String newPattern) {
      myPattern = newPattern;
   }

   /**
    * Returns the pattern as a String.
    */

   public String get(){
      return myPattern;
   }

   /**
    * Clears the pattern by setting it to a null String.
    */

   public void clear() {
      myPattern = "";
   }

   /**
    * Creates an ODL object and adds an item "PATTERNS".
    */

   public ODL toODL() {

      if (myPattern == null || myPattern.length() == 0) {
         return null;
      } else {
         ODL odl = new ODL();
         odl.add("PATTERNS",myPattern);
         return odl;
      }
   }
}
