package IMSWG.IW;

import java.lang.*;

/**
 * This class represents a Latitude, Longitude pair.
 * Checks if lat and lon are in allowed range.
 */

public class LatLonPoint{

   double latitude;
   double longitude;

  /**
   * Constructors
   */

   public LatLonPoint(double dlat, double dlon) throws Exception{
  
      this.validateLat(dlat);
      this.validateLon(dlon);
 
      latitude = dlat;
      longitude = dlon;
   }

   public LatLonPoint(String slat, String slon) throws Exception{

      double dlat = (Double.valueOf(slat)).doubleValue(); 
      double dlon = (Double.valueOf(slon)).doubleValue();

      this.validateLat(dlat);
      this.validateLon(dlon);

      latitude = dlat;
      longitude = dlon;
   }

   public void setLat(double plat) throws Exception{
    
      this.validateLat(plat);
      latitude = plat;
   }

   public void setLat(String slat) throws Exception{

      double dlat = (Double.valueOf(slat)).doubleValue();
      this.validateLat(dlat);
      latitude = dlat; 
   }

   public void setLon(double dlon) throws Exception{

      this.validateLon(dlon);
      longitude = dlon;
   }

   public void setLon(String slon) throws Exception{

      double dlon = (Double.valueOf(slon)).doubleValue(); 
      this.validateLon(dlon);
      longitude = dlon; 
   }

   public double getLat() {

     return latitude;
   }
  
   public double getLon() {

      return longitude;
   }
   public boolean validateLat(double dlat) throws Exception{
      
      if (dlat <= 90.0 && dlat >= -90.0) {
          return true;
      } else {
          throw new Exception("Lat "+ dlat +" out of range of 90 to -90");
      }
   }

   public boolean validateLon(double dlon) throws Exception{

      if (dlon <= 180.0 && dlon >= -180.0) {
          return true;
      } else {
          throw new Exception("Lon "+ dlon + " out of range of 180 to -180"); 
      }
   }
} // end of class LatLonPoint
