package IMSWG.IW.Mapplet;

import java.awt.Button;
import java.awt.Event;

import IMSWG.IW.Mapplet.MasterGlobe;

public class ClearButton extends Button{

  MasterGlobe localMasterGlobe;

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // ClearButton - Constructor.  Store local link to MasterGlobe.
  //
  public ClearButton(MasterGlobe parentMasterGlobe) {
    super("Clear All Fields");
    localMasterGlobe = parentMasterGlobe;
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // action - When CLEAR button is pressed, set the pan to 0 latitude
  //          and 0 longitude, and set the zoom to 1.
  //
  public boolean action(Event e, Object o) {

    // Clear the drawn selected region.
    localMasterGlobe.updateDrawing();

    // Clear the polygon array values.
    localMasterGlobe.clearPolygonArray();

    // Now set the GeoPolygon to be cleared.
    localMasterGlobe.internalPolygon.clearTextFields();

    // Set the center latitude and longitude to 0.
    localMasterGlobe.pan.centerLat.setCenterLat(0);
    localMasterGlobe.pan.centerLon.setCenterLon(0);

    // Now set the Zoom factor to 1.
    localMasterGlobe.zoom.setZoomFactor(1);

    // The following is stupid, but for some unknown reason
    // the zoom choice menu disappears after the setZoomFactor()
    // in Netscape (not in Appletviewer!).  Also, just calling
    // localMasterGlobe.zoom.show() DIDN'T work!!!
    localMasterGlobe.zoom.hide();
    localMasterGlobe.zoom.show();

    // Set the flag in the parameters hash indicating no geo is selected.
    localMasterGlobe.parameters.updateHash("p.geoselected", "0");

    return true;
  }
}
    
