package IMSWG.IW.Mapplet;

import java.awt.*;
import IMSWG.IW.Mapplet.GeoPolygon;
import IMSWG.IW.Mapplet.MasterGlobe;
/**
 * Description:
 *    Corner Points component for Web Gateway's Mapplet.
 *    This file contains the classes for opening a pop-up window when the
 *    user selects Corner Points menu item from the Mapplet Map Options Menu.
 *    The pop-up displays the corner points.
 */
public class CornerPointsMenuItem extends MenuItem {

    MasterGlobe localMasterGlobe;
    GeoPolygon localGeoPoly;
    public CornerPointsFrame window;
    String title = "Corner Points";

    public CornerPointsMenuItem(MasterGlobe theMasterGlobe) { 
        super("Corner Points");
        localMasterGlobe = theMasterGlobe;
        localGeoPoly =  localMasterGlobe.internalPolygon;
        
        window = new CornerPointsFrame(title,localGeoPoly);
        
    }
/**
 * void die() - dispose of the frame - called when mapplet ends.
 */
 public void die() {
    window.die();
    return;
 }

/* boolean cornerPointsMenuAction() - handles Corner Points menu item click
 *  by showing pop-up window.
 */
 public boolean cornerPointsMenuAction(){  

     if (!window.isShowing()){
        window.show();
        return true;
     }
   
      return false;
    
 }
}

