package IMSWG.IW.Mapplet;

import java.awt.*;

import IMSWG.IW.Mapplet.CornerPointsMenuItem;
import IMSWG.IW.Mapplet.GeoPolygon;
import IMSWG.IW.Mapplet.DisplayOptions;
import IMSWG.IW.Mapplet.ResetMenuItem;
import IMSWG.IW.Mapplet.ClearMenuItem;
import IMSWG.IW.Mapplet.MasterGlobe;
import IMSWG.IW.Mapplet.HelpMenuItem;
import IMSWG.IW.Mapplet.Mapplet;

/** Description:
 *    This class is the menu bar at the top of the Mapplet Frame.
 *    The Menu bar contains the Map Options Menu with menu items of Corner
 *    Points, Display Options, Clear and Restore.
 */
public class DisplayMenu extends MenuBar {

    Menu mapOptions = new Menu("Map Options");
    GeoPolygon localGeoPoly;
    MasterGlobe localMasterGlobe;
    DisplayOptions displayoptions;
    Mapplet myMapplet;
    ClearMenuItem clear;
    ResetMenuItem reset;
    CornerPointsMenuItem corner;
    HelpMenuItem hlp;

    public DisplayMenu(MasterGlobe theMasterGlobe, Mapplet theMapplet) { 
        super();
        myMapplet = theMapplet;
        localMasterGlobe = theMasterGlobe;
        localGeoPoly =  localMasterGlobe.internalPolygon;
        boolean alloptions = false;
        if(localMasterGlobe.mappletOriginalParameters.getValueOf("MapCgiScript").equals("drawglobe.cgi")){
           alloptions = true;
        } 
        displayoptions = new DisplayOptions(localGeoPoly,alloptions);
    }
/**
 * void setMapOptions() - intializes the menu bar with the menu items
 */
    public void setMapOptions() {
        corner = cornerPoints();
        mapOptions.add(corner);
        mapOptions.add(displayoptions);
        clear = clearMenu();
        mapOptions.add(clear);
        reset = resetMenu();
        mapOptions.add(reset);
        hlp = helpMenu();
        mapOptions.add(hlp);
        this.add(mapOptions);

     }
/**
 * resetMenu() - returns an object of ResetMenuItem to be inserted into
 * the menu.
 */
     public ResetMenuItem resetMenu() {
        return (new ResetMenuItem(localMasterGlobe));
     }
/**
 * clearMenu() - returns an object of ClearMenuItem to be inserted into
 * the menu.
 */
     public ClearMenuItem clearMenu() {
        return (new ClearMenuItem(localMasterGlobe));
     }
/**
 * cornerPoints() - returns an object of CornerPointsMenuItem to be inserted into
 * the menu.
 */
     public CornerPointsMenuItem cornerPoints() {
         return (new CornerPointsMenuItem(localMasterGlobe));
     }
/**
 * helpMenu() - returns an object of HelpMenuItem to be inserted into
 * the menu.
 */
     public HelpMenuItem helpMenu() {
        return(new HelpMenuItem());
     }
/**
 * closeResources() - kill the map options and corner points windows when mapplet
 * ends.
 */
     public void closeResources() {
        // Kill the display options window (if it exists).
        displayoptions.die();
       // Kill the corner points window (if it exitst).
        corner.die();
     }
}
