package IMSWG.IW.Mapplet;


import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.awt.GridLayout;
import java.awt.FlowLayout;
import java.util.*;
import IMSWG.IW.Parameters;
public class GeoPolygon {
    typeInTextField pointOneLat, pointOneLong ;
    typeInTextField pointTwoLat , pointTwoLong ;
    typeInTextField pointThreeLat , pointThreeLong ;
    typeInTextField pointFourLat , pointFourLong ;
    Parameters interalParameterHash;
    String NULL = "";

 // Constructor 
 public GeoPolygon(Parameters parameters, Parameters originalParameters) { 
    interalParameterHash = parameters;
    // Should be set in Modelet 
     String mode     = originalParameters.getValueOf("passedMode");
     interalParameterHash.updateHash("mode", mode);
//    interalParameterHash.updateHash("mode","SSLCTGEO"); 
    // Should be set when the User does the RubberBanding
    interalParameterHash.updateHash("p.geotype","POLYGON_LOC"); 
 }

  public Panel typeIn() {
    Panel frame = new Panel();  // Stop Textfields from growing
    frame.setLayout( new GridLayout (5,3,3,5));
    frame.add(new Label (" Point : "));
    frame.add(new Label ("Latitude : "));
    frame.add(new Label ("Longitude : "));

    // frame.add(new Label ("    1 :    "));
    frame.add(new Label ("Upper Left   :"));
    pointOneLat = new typeInTextField();
    pointOneLong = new typeInTextField();

    frame.add(pointOneLat);
    frame.add(pointOneLong);

    // frame.add(new Label ("    2 :    "));
    frame.add(new Label ("Upper Right :"));
    pointTwoLat = new typeInTextField();
    pointTwoLong = new typeInTextField();
    frame.add(pointTwoLat);
    frame.add(pointTwoLong);

    // frame.add(new Label ("   3 :     "));
    frame.add(new Label ("Lower Right :"));
    pointThreeLat = new typeInTextField();
    pointThreeLong = new typeInTextField();
    frame.add(pointThreeLat);
    frame.add(pointThreeLong);

    // frame.add(new Label ("    4 :    "));
    frame.add(new Label ("Lower Left   :"));
    pointFourLat = new typeInTextField();
    pointFourLong = new typeInTextField();
    frame.add(pointFourLat);
    frame.add(pointFourLong);
    return frame;
  }

 public void fillTextFields() {
        pointOneLat.setTextField( getPointOneLat()) ;
        pointOneLong.setTextField(getPointOneLong() );
        pointTwoLat.setTextField(getPointTwoLat() );
        pointTwoLong.setTextField(getPointTwoLong()) ;
        pointThreeLat.setTextField(getPointThreeLat()) ;
        pointThreeLong.setTextField(getPointThreeLong()) ;
        pointFourLat.setTextField(getPointFourLat()) ;
        pointFourLong.setTextField(getPointFourLong()) ;
 }


 public void clearTextFields() {
    // System.out.println("clearTextFields");
    pointOneLat.setTextField("") ;
    interalParameterHash.removeKey("p.0.lat");
    pointOneLong.setTextField("");
    interalParameterHash.removeKey("p.0.lon");
    pointTwoLat.setTextField("" );
    interalParameterHash.removeKey("p.1.lat");
    pointTwoLong.setTextField("") ;
    interalParameterHash.removeKey("p.1.lon");
    pointThreeLat.setTextField("") ;
    interalParameterHash.removeKey("p.2.lat");
    pointThreeLong.setTextField("") ;
    interalParameterHash.removeKey("p.2.lon");
    pointFourLat.setTextField("") ;
    interalParameterHash.removeKey("p.3.lat");
    pointFourLong.setTextField("") ;
    interalParameterHash.removeKey("p.3.lon");
	// repaint();
 }

public void convertRange2Poly() {
	String north = interalParameterHash.getValueOf("p.north");
        String south = interalParameterHash.getValueOf("p.south");
        String east = interalParameterHash.getValueOf("p.east");
        String west = interalParameterHash.getValueOf("p.west");
           // System.out.println("North = "+north);
        String oneLat, twoLat;
        String oneLong, fourLong;
        String twoLong, threeLong;
        String threeLat, fourLat;
          oneLat = twoLat = north;
          oneLong = fourLong = west;
        twoLong = threeLong = east;
        threeLat = fourLat = south;
          // System.out.println("One = "+oneLat+" "+oneLong);
          // System.out.println("Two = "+twoLat+" "+twoLong);
          // System.out.println("Three = "+threeLat+" "+threeLong);
          //   System.out.println("Four = "+fourLat+" "+fourLong);
       
          // interalParameterHash.updateHash("p.0.lat", oneLat);
	updatePoint( "p.0", oneLat, oneLong);
	updatePoint( "p.1", twoLat, twoLong);
	updatePoint( "p.2", threeLat, threeLong);
	updatePoint( "p.3", fourLat, fourLong);
          // System.out.println("Points updated!");
}

 public void setProjection(String projection) {

        interalParameterHash.updateHash("p.projection",projection );
 }

 public String getProjection() {

        String value  = interalParameterHash.getValueOf("p.projection");
        return(value);
 }

 public void setZoom(int zoom) {
        interalParameterHash.updateHash("p.zoom",Integer.toString(zoom));
 }

 public int getZoom() {
    String stringValue  = interalParameterHash.getValueOf("p.zoom");
    // if getValueOf is "null" then it'll return ""
    // getZoom will return 1 in that case
    if (stringValue.equals("")) {
        return (1);
    }
    else {
       int intValue = (Integer.valueOf(stringValue)).intValue(); 
       return(intValue);
    } 
 }

 public void setCenterLat(double centerLat) {

  interalParameterHash.updateHash("p.tangent.lat", convertDouble2String(centerLat));
 }

 // Gives a developer to update ANY tag value ( key )
 public void setParamTag(String key, String value) {
    interalParameterHash.updateHash( key , value );
 }

 public double getCenterLat() {

     	String value  = interalParameterHash.getValueOf("p.tangent.lat");
	double doubleValue = convertString2Double(value);
        return(doubleValue);

 }

 public void setCenterLon(double centerLon) {

  interalParameterHash.updateHash("p.tangent.lon", convertDouble2String(centerLon));
 }

 public double getCenterLon() {

       String value  = interalParameterHash.getValueOf("p.tangent.lon");
        double doubleValue = convertString2Double(value);
        return(doubleValue);

 }

 public void setPole(String pole) {

        interalParameterHash.updateHash("p.pole",pole);

 }

 public String getPole() {

        String pole = interalParameterHash.getValueOf("p.pole");
        return(pole);
 }

 public void updatePoint(String point ,String lat ,String lon ) {
       interalParameterHash.updateHash(point+".lat", lat );
       interalParameterHash.updateHash(point+".lon", lon );
 }

 public void updatePoint2(String point ,double lat ,double lon ) {
      
       interalParameterHash.updateHash(point+".lat", convertDouble2String(lat));
       interalParameterHash.updateHash(point+".lon", convertDouble2String(lon));
 }

public double convertString2Double(String stringValue) {
       double returnValue;
       try {
         returnValue = (Double.valueOf(stringValue)).doubleValue();
       }
       catch (NumberFormatException e) {
         returnValue = 0.0;
       }
       return ( returnValue) ;
}

public String convertInt2String(int intValue) {
	String returnValue = Integer.toString(intValue);
       return ( returnValue) ;
}


public String convertDouble2String(double doubleValue) {
       String returnValue = Double.toString(doubleValue);
       return ( returnValue) ;
}


  public boolean checkPointOne() {
    if ( NULL.equals(getPointOneLat()) && NULL.equals(getPointOneLong()))
	{ return ( false); }
    return (true);
  }


  public double getPointDouble(String stringValue) {
   String value  = interalParameterHash.getValueOf(stringValue);
   // if getValueOf is "null" then it'll return ""
   // getPointDouble will return 999.99 in that case 
   if (value.equals("")) {
	return (999.99);
   } 
   else {
     double doubleValue = convertString2Double(value);
     return(doubleValue);
   } 
  }

  public String getPointOneLat() {
     String value  = interalParameterHash.getValueOf("p.0.lat");
     value = trimValue(value,4);
     return(value);
  }

  public String getPointOneLong() {
     String value = interalParameterHash.getValueOf("p.0.lon");
     value = trimValue(value,4);
     return(value);
  }

  public String getPointTwoLat() {
     String value = interalParameterHash.getValueOf("p.1.lat");
     value = trimValue(value,4);
     return(value);
  }
  public String getPointTwoLong() {
     String value = interalParameterHash.getValueOf("p.1.lon");
     value = trimValue(value,4);
     return(value);
  }
  public String getPointThreeLat() {
     String value = interalParameterHash.getValueOf("p.2.lat");
     value = trimValue(value,4);
     return(value);
  }

  public String getPointThreeLong() {
     String value = interalParameterHash.getValueOf("p.2.lon");
     value = trimValue(value,4);
     return(value);
  }

  public String getPointFourLat() {
     String value = interalParameterHash.getValueOf("p.3.lat");
     value = trimValue(value,4);
     return(value);
  }
  public String getPointFourLong() {
     String value = interalParameterHash.getValueOf("p.3.lon");
     value = trimValue(value,4);
     return(value);
  }

  public String trimValue(String stringValue, int toLength) {
    // Seperate the string by the "&"'s
    StringTokenizer separatedValues = new StringTokenizer(stringValue,".");
    int numLines = separatedValues.countTokens();
    String [] lines = new String[numLines];
    String integer = separatedValues.nextToken();
    String fraction = (separatedValues.nextToken())+"0000";
    String subFraction = fraction.substring(0,toLength);
    // System.out.println("integer : "+integer+" "+integer.length()+"\n");
    // System.out.println("fraction : "+fraction+" "+fraction.length()+"\n");
    // System.out.println("subfraction : "+subFraction+" "+subFraction.length()+"\n");
    return(integer+"."+subFraction);
  }
}



// class typeInTextField extends TextField {
class typeInTextField extends Label {

    public typeInTextField() {
 //       super(8);
	 super();
//	super.setEditable(false);
    }

    public void getValue() {
    }

    public void setTextField(String value) {
        setText(value);
// Aligns the numbers Right justified
//	setAlignment(2);	
    }
}
