package IMSWG.IW.Mapplet;

import java.awt.*;
import java.net.*;
import java.applet.Applet;
import IMSWG.IW.ModeletTools;
// import IMSWG.IW.Mapplet.EarthData;
import IMSWG.IW.Mapplet.GeoPolygon;
import IMSWG.IW.Mapplet.DisplayOptions;
import IMSWG.IU.ObjectRegistry;
import IMSWG.IW.Parameters;

/* Hacked by GYF for GSFC/NASA */
/* This program is a Java port of my Pink port of 
   Eichin's UNIX version of my
   Multics version of the original RLE version.
   THVV 04/18/96
   GYF 07/02/97
*/

/* This program is a Pink port of Eichin's UNIX version of my
   Multics version of the original RLE version.
   THVV 6/1/94 */

/* This program draws the globe from any viewpoint.
   I have copied the Multics PL/I port of the program,
   and the data set as well.
   _Mark Eichin <eichin@athena.mit.edu> */

/* This program draws the globe from any viewpoint.
   I have copied the CTSS incarnation of the program.
   THVV May 5 1972 */

/* The original version of this rogram was written in MAD for 7094 CTSS
   by either Rob Stotz or Daniel Thornhill about 1966, to demonstrate
   the ARDS terminal (based on a Tektronix storage tube).
   The display data was digitized from a globe by a contractor for
   the MIT Research Laboratory for Electronics (RLE). */


// ================================================================
//The view of the globe.
//  The data model is almost degenerate.. just the location of the
//  display center.  The paint() method does all the work.

// In the port to Java, I encountered some problems.  The compiler
// gave bogus undefined variable and statement not reached errors
// until I reduced the number of local vars in the paint() method.

public class Globe extends Canvas {

  private static final Color BACKGROUND_COLOR = Color.white;
  private static final Color RUBBERBANDING_COLOR = Color.red;
  boolean turnoffdisplayoptions = false;
  int statusTotal;

  double lat;
  double lon;
  double rot;

  int sel_x = 0;
  int sel_y = 0;
  int sel_w = 0;
  int sel_h = 0;

  int[] arrayX = new int[5];
  int[] arrayY = new int[5];
  int zoom_hundredths = 100;

  int FoldViewSize;
  int GlobeBorderWidth;
  int GlobeDiameter;
  int GlobeRadius;
  int GlobeCenterPos;
//  double ZoomFactor = 1.41;
  GeoPolygon internalPolygon;
  private double fa1, fa2, fa3, fa4, fa5, fa6, fa7, fa8, fa9;
  private double La1, La2, La3, La4, La5, La6, La7, La8, La9;
  private double cosa, cosp, cost, sina, sint, sinp;
  private double rad;

  final static int X = 0;
  final static int Y = 1;
  final static int Z = 2;
  final static int n_points = 6048;

  final static double degToRadians = 1.745329e-2; // pi / 180 
  final static int PosY = -1; // which way y runs in graphics coords

 

  public Globe() { // constructor
    this.FoldViewSize = 512;
    this.lat = 0.0;
    this.lon = 0.0;
    this.rot = 0.0;

    //double frac;

    GlobeBorderWidth = 8;
    GlobeDiameter = FoldViewSize-2*GlobeBorderWidth;
    GlobeRadius = GlobeDiameter/2;
    GlobeCenterPos = GlobeBorderWidth+GlobeRadius;

    //frac =  0.0e0;



  }
  public Globe(int fsize) {
    this.FoldViewSize = fsize;

    this.lat = 0.0;
    this.lon = 0.0;
    this.rot = 0.0;

    GlobeBorderWidth = 8;
    GlobeDiameter = FoldViewSize-2*GlobeBorderWidth;
    GlobeRadius = GlobeDiameter/2;
    GlobeCenterPos = GlobeBorderWidth+GlobeRadius;
//    System.out.println("Fodl size = "+fsize);



  }
  public Globe(int fsize, GeoPolygon polygon) {
    this.FoldViewSize = fsize;
    this.internalPolygon = polygon;

    this.lat = 0.0;
    this.lon = 0.0;
    this.rot = 0.0;

    GlobeBorderWidth = 8;
    GlobeDiameter = FoldViewSize-2*GlobeBorderWidth;
    GlobeRadius = GlobeDiameter/2;
    GlobeCenterPos = GlobeBorderWidth+GlobeRadius;
//    System.out.println("Fodl size = "+fsize);


  }

  public void turnoffDisplayOptions() {

	turnoffdisplayoptions = true; 

  }

  private double latlontox(double lat, double lon){
    double r;
    r = Math.sin(degToRadians * lon) * Math.cos(degToRadians * lat);
    return r;
  }
  private double latlontoz(double lat, double lon){
    double r;
    r = Math.cos(degToRadians * lon) * Math.cos(degToRadians * lat);
    return r;
  }
  private double latlontoy(double lat, double lon){
    double r;
    r = Math.sin(lat * degToRadians);
    return r;
  }
  void setup_screen () { // [ed:new:gyuri]

    this.FoldViewSize = this.size().width;

    GlobeDiameter = FoldViewSize-2*GlobeBorderWidth;
    GlobeRadius = GlobeDiameter/2;
    GlobeCenterPos = GlobeBorderWidth+GlobeRadius;
//    System.out.println("New Fold size = "+this.size().width);
  }
  void setup_coefficients () {
    //	phi and theta are latitude and longitude of the display center, and
    //	..alpha is rotation around the center. Radius 1.0 is full screen.
    double phi; 
    double theta; 
    double alpha;
    double radius;

    double radus;

    /* double irad; */

    radius = 1.0e0;                         // for now
    radus = radius * (double) GlobeRadius;  // 512.e0; 
    //
    //irad = radus + 0.5e0;
    //
    rad = radus;

    phi = this.lat;
    theta = this.lon;
    alpha = this.rot;

    if (phi < 0)  phi = 360.0e0 + phi; /* was: - phi GyF */
    if (theta < 0) theta = 360.0e0 + theta; /* was: - theta GyF */

    sinp = Math.sin(phi * degToRadians);
    cosp = Math.cos(phi * degToRadians);
    sint = Math.sin(theta * degToRadians);
    cost = Math.cos(theta * degToRadians);
    sina = Math.sin(alpha * degToRadians);
    cosa = Math.cos(alpha * degToRadians);

    // long, lat, rot or t, p, a.
    // inverse would be -a -p -t
    //
    fa1 = cost * cosa + sinp * sina * sint;
    fa2 = -cosp * sina;
    fa3 = cost * sina * sinp - sint * cosa;
    fa4 = cost * sina - sint * cosa * sinp;
    fa5 = cosp * cosa;
    fa6 = -cost * cosa * sinp - sint * sina;
    fa7 = sint * cosp;
    fa8 = sinp;
    fa9 = cost * cosp;
    //
    // these are inverters:
    //
    La1 = cost * cosa + sinp * sina * sint;
    La2 = cost * sina - sinp * sint * cosa;
    La3 = cosp * sint;
    La4 = -sina * cosp;
    La5 = cosp * cosa;
    La6 = sinp;
    La7 = -sint * cosa + cost * sina * sinp;
    La8 = -sint * sina - cost * sinp * cosa;
    La9 = cost * cosp;
    //
    // do the same for gy1 - gy9 too
    // except I know have inverse coefficients too...
  }
  // new: gyuri
  // What if I did my own matrix stuff?
  // would I get the same result?
  // lemme assume that rot (alpha) = 0 for now..
  // and only deal with lat/lon rotations
  // do a new i_x(), and i_y() function with x,y,z inputs, just like here.

 double screentox(int x){
   double r;
   r = (x - GlobeCenterPos);
   r *= 100;
   r /= zoom_hundredths;
   r /= rad;
   return r;
 }
 double screentoy(int y){
    double r;
    r = (GlobeCenterPos - y);
    r *= 100;
    r /= zoom_hundredths;
    r /= rad;
    return r;
  }
  double i_x(double ix, double iy, double iz){
    double r=0.0;
    r =(La1 * ix + La2 * iy + La3 * iz);
    return r;
  }
  double i_y(double ix, double iy, double iz){
    double r=0.0;
    r =(La4 * ix + La5 * iy + La6 * iz);
    return r;
  }

  double i_z(double ix, double iy, double iz){
    double r=0.0;
    r =(La7 * ix + La8 * iy + La9 * iz);
    return r;
  }

  double calculatex(double x, double y, double z) {
    double r;
    r = (fa1 * x + fa2 * y + fa3 * z);
    return r;
  }
  double calculatey(double x, double y, double z) {
    double r;
    r = (fa4 * x + fa5 * y + fa6 * z);
    return r;
  }
  
  double calculatez(double x, double y, double z) {
    double r;
    r = fa7 * x + fa8 * y + fa9 * z;
    return r;
  }
  
  public void paint(Graphics g) {
    double x0, y0, z0;
    double z;
    int ix; 
    int iy;

    int icentr;
    int jcentr;
    int xprev;
    int yprev;
    int line;

    // get the pointer to the display options.

    DisplayOptions display;

    display = (DisplayOptions)ObjectRegistry.getObject("DisplayOptions");


//    int input[][] = EarthData.data_input;

    //Polygon poly;

    ix = 0; 
    iy = 0;
    xprev = 0;
    yprev = 0;
    // setup_screen(); // [ed:new:gyuri]

    icentr = GlobeCenterPos;
    jcentr = PosY*GlobeCenterPos;
    line = 0;
    setup_coefficients();

   if (display.fast()) {

    g.setColor(Color.black);
    g.fillRect(0,0,FoldViewSize,FoldViewSize);
    g.setColor(Color.green.darker().darker().darker());
    /* repaint the green circle */
    /* was:
    g.fillOval(GlobeBorderWidth,GlobeBorderWidth,GlobeDiameter,GlobeDiameter);
    */
    {
      int x, y, w, h, cx, cy;
      int w05;

      w05 = GlobeDiameter/2;
      cx = GlobeBorderWidth + w05;
      x = cx - (zoom_hundredths * w05) / 100;
      w = (zoom_hundredths * (w05 + w05))/100;

      cy = cx;
      y = x;
      h = w;

      g.fillOval(x, y, w, h);
    }

    g.setColor(BACKGROUND_COLOR);

/*    for (int i = n_points-1; i>=0; i--) {
      //poly = new Polygon();

      if(input[i][X] == -1 && 
	 input[i][Y] == -1 && 
	 input[i][Z] == -1) continue;

      while (i >= 0) {
	if(input[i][X] == -1 && 
	   input[i][Y] == -1 && 
	   input[i][Z] == -1) break;

	z0 = input[i][Z] / 1.e3 - 1.0e0;
	y0 = input[i][Y] / 1.e3 - 1.0e0;
	x0 = input[i][X] / 1.e3 - 1.0e0;

	if (calculatez(x0, y0, z0) < 0.0e0) { // < frac
	  break; // positive Z only, ignore point on back
	}

	ix = (int) (rad * calculatex(x0, y0, z0));
	iy = (int) (rad * calculatey(x0, y0, z0));
	if (false && (i >= n_points-10)) {
	  double inx, iny, inz;
	  double bx, by, norm;
//	  System.out.println("Data = "+x0+", "+y0+", "+z0);
	  inx = calculatex(x0, y0, z0);
	  iny = calculatey(x0, y0, z0);
	  inz = calculatez(x0, y0, z0);

	  // System.out.println("XY "+inx+", "+iny+" Z = "+inz);
	  bx = i_x(inx, iny, inz);
	  by = i_y(inx, iny, inz);
	  // System.out.println("Bak -> "+bx+"  "+by+"\n");
	  norm =  inx*inx + iny*iny + inz*inz;
	  // System.out.println("Norm -> "+ norm);
	}

	if (Math.abs(ix) > GlobeRadius || Math.abs(iy) > GlobeRadius) 
	  break;

	ix *= zoom_hundredths;
	ix /= 100;
	ix = ix + icentr;	// original pgm had origin at screen center


	iy *= zoom_hundredths;
	iy /= 100;
	iy = iy + jcentr;	// .. adjust

	if (line != 0) { // skip the first time thru the loop
	  g.drawLine(xprev,PosY*yprev,ix,PosY*iy);
	}
	// poly.addPoint(ix,PosY*iy) doesn't quite work, edge effectsl /

	line++;
	xprev = ix;
	yprev = iy;
	i--;
      } // while

      //g.fillPolygon(poly);

      line = 0;
    } 
// for

*/

    z0 = 1.0;
    y0 = 0.0;
    x0 = 0.0;
    ix = (int) (rad *calculatex(x0, y0, z0));
    ix *= zoom_hundredths;
    ix /= 100;
    ix = ix + icentr;


    iy = (int) (rad *calculatey(x0, y0, z0));
    iy *= zoom_hundredths;
    iy /= 100;
    iy = iy + jcentr;
//    g.setColor(Color.green);
//    g.drawLine(ix-2  , PosY*iy-2, ix+2, PosY*iy+2);
//    g.drawLine(ix-2  , PosY*iy+2, ix+2, PosY*iy-2);

  {
	/* Need xyz for lat=1, lon=-2. */
	
    x0 = latlontox(20.0, 45.0);
    y0 = latlontoy(20.0, 45.0);
    z0 = latlontoz(20.0, 45.0);

    ix = (int) (rad *calculatex(x0, y0, z0));
    ix *= zoom_hundredths;
    ix /= 100;
    ix = ix + icentr;


    iy = (int) (rad *calculatey(x0, y0, z0));
    iy *= zoom_hundredths;
    iy /= 100;
    iy = iy + jcentr;
//    g.drawLine(ix-2  , PosY*iy-2, ix+2, PosY*iy+2);
//    g.drawLine(ix-2  , PosY*iy+2, ix+2, PosY*iy-2);

  }

    } else {
        
	Image imageMap;
	imageMap = getGIFMap();
        g.setColor(BACKGROUND_COLOR);
        g.fillRect(0, 0,this.FoldViewSize,this.FoldViewSize);
        g.drawImage(imageMap, 0 , 0 ,this);

    } // end if (zoom_hundredths < 400)

    double lat0 = this.internalPolygon.getPointDouble("p.0.lat");
    double lon0 = this.internalPolygon.getPointDouble("p.0.lon");
    double lat1 = this.internalPolygon.getPointDouble("p.1.lat");
    double lon1 = this.internalPolygon.getPointDouble("p.1.lon");
    double lat2 = this.internalPolygon.getPointDouble("p.2.lat");
    double lon2 = this.internalPolygon.getPointDouble("p.2.lon");
    double lat3 = this.internalPolygon.getPointDouble("p.3.lat");
    double lon3 = this.internalPolygon.getPointDouble("p.3.lon");
    int[] newX0 = new int[1];
    int[] newY0 = new int[1];
    int[] newX1 = new int[1];
    int[] newY1 = new int[1];
    int[] newX2 = new int[1];
    int[] newY2 = new int[1];
    int[] newX3 = new int[1];
    int[] newY3 = new int[1];
    statusTotal = 0;
    int status = this.getXY(lat0, lon0, newX0, newY0);
    statusTotal += status;
    status = this.getXY(lat1, lon1, newX1, newY1);
    statusTotal += status;
    status = this.getXY(lat2, lon2, newX2, newY2);
    statusTotal += status;
    status = this.getXY(lat3, lon3, newX3, newY3);
    statusTotal += status;

    int minsize = 1;

    if((statusTotal >= 0) && (lat0 <= 90.0)) {
      arrayX[0] = newX0[0];
      arrayX[1] = newX1[0];
      arrayX[2] = newX2[0];
      arrayX[3] = newX3[0];
      arrayY[0] = newY0[0];
      arrayY[1] = newY1[0];
      arrayY[2] = newY2[0];
      arrayY[3] = newY3[0];
      arrayX[4] = newX0[0];
      arrayY[4] = newY0[0];

      /* Check if the polygon is too small to be seen on the 
       * map, if less than the minimum size visible then 
       * show at icon size.
       */ 
      
      // check X size
      if (arrayX[1] - arrayX[0] < minsize) { 
    
           arrayX[1] = arrayX[0] + minsize;
           arrayX[2] = arrayX[0] + minsize;
           arrayX[3] = arrayX[0];

      }
      // check Y size
      if (arrayY[2] - arrayY[1] < minsize) {

           arrayY[1] = arrayY[0];
           arrayY[2] = arrayY[0] + minsize;
           arrayY[3] = arrayY[0] + minsize;

      }

      g.setColor(BACKGROUND_COLOR);
      g.setXORMode(RUBBERBANDING_COLOR);
      g.drawPolygon(arrayX, arrayY, 5);
      g.setColor(BACKGROUND_COLOR);
      
    }

  } // end paint()

  public Image getGIFMap () {

        

       Image image;
       MediaTracker tracker;
       URL mapURL = null;
       String cgiString; 
       Graphics gc;

       DisplayOptions display;

       display = (DisplayOptions)ObjectRegistry.getObject("DisplayOptions");

       String zoom = Integer.toString(this.zoom_hundredths/100);
       String height = Integer.toString(this.FoldViewSize);
       String width = Integer.toString(this.FoldViewSize); 
       double lat = this.internalPolygon.getCenterLat();
       String clat = Double.toString(lat);
       double lon = this.internalPolygon.getCenterLon();
       String clon = Double.toString(lon);     
       String trans = "no";

       // Check if legal values for lat and lon.

       if (lat < -90.0 || lat > 90.0) {

		image = createImage(this.FoldViewSize,this.FoldViewSize);
                gc = image.getGraphics();
                gc.setColor(BACKGROUND_COLOR);
                gc.fillRect(0,0,this.FoldViewSize,this.FoldViewSize);
                gc.setColor(RUBBERBANDING_COLOR);
                gc.drawString("Warning:",20,12);
                gc.drawString("Latitude ",20,24);
                gc.drawString(" "+lat,20,36);
                gc.drawString("is invalid, ",20,48);
                gc.drawString("must be",20,60);
                gc.drawString("between",20,72);
                gc.drawString("-90 and",20,84);
                gc.drawString("+90.",20,96);
                return image;

       } else if (lon < -180 || lon > 180) {

                image = createImage(this.FoldViewSize,this.FoldViewSize);
                gc = image.getGraphics();
                gc.setColor(BACKGROUND_COLOR);
                gc.fillRect(0,0,this.FoldViewSize,this.FoldViewSize);
                gc.setColor(RUBBERBANDING_COLOR);
                gc.drawString("Warning:",20,12);
                gc.drawString("Longitude ",20,24);
                gc.drawString(" "+lon,20,36);
                gc.drawString("is invalid, ",20,48);
                gc.drawString("must be",20,60);
                gc.drawString("between",20,72);
                gc.drawString("-180 and",20,84);
                gc.drawString("+180.",20,96);
                return image;

       } 


       // Get user's preferences for the display options.
   
       String proj = "ortho";
       if (!turnoffdisplayoptions) proj = display.getProjection();
       String polit = "no"; 
       if (!turnoffdisplayoptions) polit = display.getPolitical();
       String lakriv = "no";
       if (!turnoffdisplayoptions) lakriv = display.getRivers();
       String grid = "20";
       if (!turnoffdisplayoptions) grid = display.getGridSpacing();
       String wrs = "no";
       if (!turnoffdisplayoptions) wrs = display.getWRS();
       String rail = "no";
       if (!turnoffdisplayoptions) rail = display.getRail();
       String roads = "no";
       if (!turnoffdisplayoptions) roads = display.getRoads();
       String places = "no";
       if (!turnoffdisplayoptions) places = display.getPlaces();

       // Build Base URL for the cgi program to be called.
        
       // First get reference to the original parameters which
       // includes the WG host and CgiUrl.
       Parameters originalParameters;
       originalParameters = (Parameters)ObjectRegistry.getObject("originalParameters");
       String CgiUrl = originalParameters.getValueOf("CgiUrl");
       String protocol = originalParameters.getValueOf("protocol");
       String host = originalParameters.getValueOf("httpd_host");
//       ModeletTools.debug ("host is "+host);
//       ModeletTools.debug ("CgiUrl is "+CgiUrl);

//       String base = "http://harp.gsfc.nasa.gov/ims-bin/dev/";
//       String base = "http://"+host+CgiUrl;
     
       String script = originalParameters.getValueOf("MapCgiScript"); 

       cgiString = "?proj="+URLEncoder.encode(proj)+
                   "&zoom="+URLEncoder.encode(zoom)+
                   "&height="+URLEncoder.encode(height)+
                   "&width="+URLEncoder.encode(width)+
                   "&clat="+URLEncoder.encode(clat)+
                   "&clon="+URLEncoder.encode(clon)+
		   "&trans="+URLEncoder.encode(trans)+
                   "&polit="+URLEncoder.encode(polit)+
                   "&lakriv="+URLEncoder.encode(lakriv)+
                   "&wrs="+URLEncoder.encode(wrs)+
                   "&rail="+URLEncoder.encode(rail)+
                   "&roads="+URLEncoder.encode(roads)+
                   "&places="+URLEncoder.encode(places)+
                   "&grid="+URLEncoder.encode(grid);

       tracker = new MediaTracker(this);

       try {

              mapURL = new URL (protocol+"://"+host+CgiUrl+script+cgiString);
              System.out.println("Using "+protocol+"://"+host+CgiUrl+script+cgiString);

//            mapURL = new URL ("http://harp.gsfc.nasa.gov/~imswww/dev/pics/world-atlas.gif");

//            mapURL = new URL ("http://harp.gsfc.nasa.gov/ims-bin/dev/imswdbtile.cgi?proj=ortho&zoom=2&height=100&width=100&clat=38&clon=%2D78&trans=yes&polit=yes&lakriv=yes&grid=10"); 

       } catch (MalformedURLException e) {

            e.printStackTrace();

       }

       // get the map GIF by making a call to the CGI program.

       image = ModeletTools.getImage(mapURL);

       // add to the image tracker so we make sure we've gotten the gif.

       tracker.addImage(image,0);

       try {

              tracker.waitForAll();

        } catch (InterruptedException e) { }

        if (tracker.isErrorAny()) {

              System.out.println("An error occured loading the image");
        } 

	return image;

  } // end method getGIFMap

  public Dimension preferredSize () {
//    System.out.println("Prefer "+ FoldViewSize);
    return new Dimension (FoldViewSize,FoldViewSize);
  }
  
  public double normalize_lat(double angle) {
    double x = angle;
    if (x >= 90.0) x = 90.0;
    if (x < -90.0) x = -90.0;
    return x;
  }
  public double normalize(double angle) {
    double x = angle;
    if (x >= 360.0) x -=360.0;
    if (x < 0.0) x += 360.0;
    return x;
  }

  public void tilt(double angle) {
    this.lat += angle;
    this.lat = normalize_lat(this.lat);
    repaint();

  }
  public void rotate(double angle) {
    this.lon += angle;
    this.lon = normalize(this.lon);
    repaint();
  }

  public void setZoom(int percent){
    this.zoom_hundredths = percent;
    repaint();
  }
  public void setLon(Double x) {
    this.lon = normalize(x.doubleValue());
    repaint();
  }
  public void setLat(Double x) {
    this.lat = normalize_lat(x.doubleValue());
    repaint();
  }
  public void setRot(Double x) {
    this.rot = normalize(x.doubleValue());
    repaint();
  }

  public double getLon() { // getters
    return this.lon;
  }
  public double getLat() {
    return this.lat;
  }
  public double getRot() {
    return this.rot;
  }
  public int getZoom() {
    return this.zoom_hundredths;
  }
  public void normalizeXY(int x, int y, int[] newX, int[] newY) {
    int tempX, tempY;
    double doubleX, doubleY, rho;
    newX[0] = x;
    newY[0] = y;
    if ( zoom_hundredths > 100 ) {
	return;
    }
    tempX = x - GlobeCenterPos;
    tempY = -(y - GlobeCenterPos);
    doubleX = (double) tempX;
//    System.out.println("doubleX = "+doubleX);
    doubleY = (double) tempY;
//    System.out.println("doubleY = "+doubleY);
    rho = Math.sqrt(doubleX*doubleX + doubleY*doubleY);
//    System.out.println("rho = "+rho);
    if(rho > (double) GlobeRadius) {
      doubleX = doubleX/rho * (double) GlobeRadius;
    // System.out.println("doubleX = "+doubleX);
      doubleY = doubleY/rho * (double) GlobeRadius;
    // System.out.println("doubleY = "+doubleY);
      tempX = (int) doubleX;
    // System.out.println("tempX = "+tempX);
      tempY = (int) doubleY;
    // System.out.println("tempY = "+tempY);
      newX[0] = tempX + GlobeCenterPos;
      newY[0] = GlobeCenterPos - tempY;
    }
  }
  public int getLatLon(int x, int y, double[] latResult, double[] lonResult) {
    float[] newLat = new float[1];
    float[] newLon = new float[1];
    // convert x and y to points relative to the map center
    x = x - GlobeCenterPos;
    y = -(y - GlobeCenterPos);
    float xfloat = (float) x;
    float yfloat = (float) y;
    float given_lat0 = (float) lat;
    float given_lon0 = (float) lon;
    String given_map_projection_name = "ORTHOGRAPHIC";
    float given_scale = (float) zoom_hundredths / (float) 100;
    given_scale = 1/given_scale;
    float given_equatorial_radius = (float) GlobeRadius;
//    System.out.println("given_scale = "+ given_scale);
//    System.out.println("given_equatorial_radius = "+ given_equatorial_radius);
    mapx Ortho = new mapx();
    Ortho.init_mapx(given_map_projection_name,
     given_lat0, given_lon0,
     given_scale,
     given_equatorial_radius);
    int status = Ortho.map_to_geo(xfloat, yfloat, newLat, newLon);
    latResult[0] = (double) newLat[0];
    lonResult[0] = (double) newLon[0];

    return status;

  }

  public String poleIncluded(int x1, int y1, int x2, int y2) {

	String pole; // default is neither pole

        int[] nx  = new int[1];
        int[] ny  = new int[1];
        int[] sx  = new int[1];
        int[] sy  = new int[1];
        int nstatus,sstatus;

        nstatus = getXY(90.0,0.0,nx,ny); // north pole
        sstatus = getXY(-90.0,0.0,sx,sy); // south pole

   	// check north pole
        
        if 
        ( (nx[0] >= x1 && nx[0] <= x2) && 
          (ny[0] >= y1 && ny[0] <= y2) && 
          (nstatus >= 0 ) ) {

		pole = "N";

        // check south pole
        } else if 
        ( (sx[0] >= x1 && sx[0] <= x2) && 
          (sy[0] >= y1 && sy[0] <= y2) && 
          (sstatus >= 0 ) ) {

		pole = "S";

        // set for neither pole
        } else {

		pole = "X";

        } 		

	return pole; 

  }

  public int getXY(double latDouble, double lonDouble, int[] x, int[] y){
    float[] newX = new float[1];
    float[] newY = new float[1];
    float given_lat0 = (float) lat;
    float given_lon0 = (float) lon;
    float latInput = (float) latDouble;
    float lonInput = (float) lonDouble;
    String given_map_projection_name = "ORTHOGRAPHIC";
    float given_scale = (float) zoom_hundredths / (float) 100;
    given_scale = 1/given_scale;
    float given_equatorial_radius = (float) GlobeRadius;
//    System.out.println("given_scale = "+ given_scale);
//    System.out.println("given_equatorial_radius = "+ given_equatorial_radius);
    mapx Ortho = new mapx();
    Ortho.init_mapx(given_map_projection_name,
     given_lat0, given_lon0,
     given_scale,
     given_equatorial_radius);
    int status = Ortho.geo_to_map(latInput, lonInput, newX, newY);
    x[0] = (int) newX[0] + GlobeCenterPos;
    y[0] = GlobeCenterPos - (int) newY[0];
    return status;
  }
  public boolean mouseDown(java.awt.Event evt, int x, int y) {
    /* was: spinning = !spinning; instead, track the mouse.... */
    Graphics g = getGraphics();
    g.setColor(BACKGROUND_COLOR);
    double[] newLat = new double[1];
    double[] newLon = new double[1];
    int[] newX = new int[1];
    int[] newY = new int[1];
    int status = this.getLatLon(x, y, newLat, newLon);
    status = this.getXY(newLat[0], newLon[0], newX, newY);
    g.setXORMode(RUBBERBANDING_COLOR);
    g.drawRect(sel_x, sel_y, sel_w, sel_h);
    sel_x = x;    // remove older box 
    sel_y = y;
    sel_w = 0;
    sel_h = 0;
    dragBox(g, x, y);
    return true;
  }
  void dragBox(Graphics g, int x, int y) {
    if (x < sel_x) {
      sel_w = 0;
      sel_h = 0;
    } else if (y < sel_y) {
      sel_w = 0;
      sel_h = 0;
    } else {
      sel_w = x - sel_x;
      sel_h = y - sel_y;
    }
    g.drawRect(sel_x, sel_y, sel_w, sel_h);
  }
  public boolean mouseDrag(java.awt.Event evt, int x, int y) {
    Graphics g = getGraphics();
    g.setColor(BACKGROUND_COLOR);
    String whatColor = (g.getColor()).toString();
    // System.out.println("Color is "+whatColor);

    g.setXORMode(RUBBERBANDING_COLOR);
    g.drawRect(sel_x, sel_y, sel_w, sel_h);
    dragBox(g, x, y);
    return true;
  }
  public boolean mouseUp (Event e, int x, int y) {
    Graphics g = getGraphics();
    g.setColor(BACKGROUND_COLOR);
    g.setXORMode(RUBBERBANDING_COLOR);
    g.drawRect(sel_x, sel_y, sel_w, sel_h);
    dragBox(g, x, y);
    double[] newLat = new double[1];
    double[] newLon = new double[1];
    int status = this.getLatLon(sel_x, sel_y, newLat, newLon);
    this.internalPolygon.updatePoint2("p.0",newLat[0],newLon[0]);
    status = this.getLatLon(sel_x+sel_w, sel_y, newLat, newLon);
    this.internalPolygon.updatePoint2("p.1",newLat[0],newLon[0]);
    status = this.getLatLon(sel_x+sel_w, sel_y+sel_h, newLat, newLon);
    this.internalPolygon.updatePoint2("p.2",newLat[0],newLon[0]);
    status = this.getLatLon(sel_x, sel_y+sel_h, newLat, newLon);
    this.internalPolygon.updatePoint2("p.3",newLat[0],newLon[0]);
    this.internalPolygon.fillTextFields();
    this.internalPolygon.setProjection("ORTHOGRAPHIC");
    this.internalPolygon.setZoom(this.zoom_hundredths/100);
    this.internalPolygon.setCenterLat(this.lat);
    double centerLon = this.lon;
    if(centerLon > 180.0) centerLon = centerLon - 360.0;
    this.internalPolygon.setCenterLon(centerLon);

    // set pole included in GeoPolygon

    String pole = "Z";
   
    // pole = this.poleIncluded(sel_x,sel_y,sel_x+sel_w,sel_y+sel_h);
    ModeletTools.debug ("pole included is"+pole);
    this.internalPolygon.setPole(pole);


    g.setPaintMode();
    /* repaint(); */
    return true;
  }

} // end Globe
