package IMSWG.IW.Mapplet;

import java.awt.Button;
import java.awt.Event;
import java.awt.Graphics;

import IMSWG.IW.Mapplet.MasterGlobe;

public class ResetButton extends Button{

  MasterGlobe localMasterGlobe;

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // ResetButton - Constructor.  Store local link to MasterGlobe.
  //
  public ResetButton(MasterGlobe parentMasterGlobe) {
    super("Revert to Last Stored Value ");
    localMasterGlobe = parentMasterGlobe;
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // action - When RESET button is pressed, set the pan to 0 latitude
  //          and 0 longitude, and set the zoom to 1.
  //
  public boolean action(Event e, Object o) {
    Double value;

    // First reset the Parameters.
    localMasterGlobe.parameters.copy(
      localMasterGlobe.mappletOriginalParameters);

    // Now reset the GeoPolygon.
    localMasterGlobe.internalPolygon.interalParameterHash.copy(
      localMasterGlobe.mappletOriginalParameters);

    localMasterGlobe.internalPolygon.fillTextFields();

    // Now reset the Pan.
    double lon = localMasterGlobe.internalPolygon.getCenterLon();
    localMasterGlobe.pan.centerLon.setCenterLon(lon);

    double lat = localMasterGlobe.internalPolygon.getCenterLat();
    localMasterGlobe.pan.centerLat.setCenterLat(lat);

    // Now reset the Zoom.
    int zoom = localMasterGlobe.internalPolygon.getZoom();
    localMasterGlobe.zoom.setZoomFactor(zoom);

    // The following is stupid, but for some unknown reason
    // the zoom choice menu disappears after the setZoomFactor()
    // in Netscape (not in Appletviewer!).  Also, just calling
    // localMasterGlobe.zoom.show() DIDN'T work!!!
    localMasterGlobe.zoom.hide();
    localMasterGlobe.zoom.show();

    // Set the geo selected flag in the parameters hash to the original value.
    String origGeo = new String(
      localMasterGlobe.mappletOriginalParameters.getValueOf("p.geoselected"));
    localMasterGlobe.parameters.updateHash("p.geoselected", origGeo);

    return true;
  }
}
