package IMSWG.IW;

import java.util.*;
import java.net.URLEncoder;
import IMSWG.IW.URLDecoder;

public class Parameters {

  Hashtable internalHashList;

  Hashtable uglyToPretty = new Hashtable();
  Hashtable prettyToUgly = new Hashtable();

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // Parameters - Constructor takes no arguments.  Creates hash table.
  //
  public Parameters () {
    internalHashList  = new Hashtable();
  }
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // parseParameters - Takes String of hidden parameters, parses it into
  //                   parameter / value pairs and stores in hash table.
  //
  public void parseParameters (String hiddenParameters) {
    String value = new String();
    Vector valueList;
    URLDecoder urlDecoder = null;

    // Convert Special characters back from %...
    String decodedParameters = urlDecoder.decode(hiddenParameters);
 //    System.out.println("Decoded" + decodedParameters + "\n");

    // Seperate the string by the "&"'s
    StringTokenizer hiddenValues = new StringTokenizer(decodedParameters,"&");
    int numLines = hiddenValues.countTokens();
    String [] lines = new String[numLines];
    int [] line_widths = new int [ numLines];
//    	System.out.println("parseHiddenParameters List :" + "numLines = "
//numLines);
    for (int i=0; i < numLines ; ++i) {
//          System.out.println("String : "+lines[numLines]); 
      try {
          StringTokenizer line = new StringTokenizer(hiddenValues.nextToken(),"=");

          int lineCount = line.countTokens();
          String key =  line.nextToken();
          if (line.hasMoreTokens()) value = line.nextToken();

      // Kludge - script_names has to handle the following string :
      //	/debug=0/ims
      // So we add "/debug"+"="+"0/ims" to get the above string
      // There should be an easier way to handle this problem !!!
          if (key.equals("script_name")) {
               String value2 = null;
//            System.out.println("Number of Tokens  = "+line.countTokens());
//            if (line.hasMoreTokens()) value2 = line.nextToken();
	      if (line.hasMoreTokens()) {
			value2 = line.nextToken();
                        value = value +"="+value2;
//                      System.out.println("Value  = "+value);
	        }
            //  }
          }
 //      System.out.println("Key :" + key + " Values :" + value);
          if ((internalHashList.get(key)) == null) {
	    if (value == "") {
//	     System.out.println("Null Values :" + key);
	    }
	    valueList = new Vector(1);
	    valueList.addElement(value);
          }
          else {
	    valueList = new Vector(5,10);
	    valueList = (Vector)internalHashList.get(key);
	    valueList.addElement(value);
          }
          internalHashList.put(key, valueList);
      // String Key =new String(line.nextElement().toString()); // key
      // String Value=new String(((String)line.nextElement()).trim());
      // System.out.println("Output:" + Key + " = " +
      //                    internalHashList.get(Key).toString() + "\n");
      }
     catch (NoSuchElementException e) {
                 System.out.println("StringTokenizer threw " + e.toString());
      }
    }
  }
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // printHashList - Method to print the hash table of this Parameters object
  //                 to standard output.  Used for debugging.
  //
  public void printHashList () {
    Enumeration keys = internalHashList.keys();
    System.out.println("printHashList Elements :");
    while (keys.hasMoreElements()) {
      String parameter = (String)keys.nextElement().toString();
      Vector values = (Vector)internalHashList.get(parameter);
      System.out.println(parameter + ": " + values.toString());
    }
  }

  // Generic version of getJumpNames
  // Take a list of pretty-ugly pairs and
  // create two vectors, one with pretty values
  // and one with ugly values.
  //

  public Vector[] getPrettyUglyList (String s) {

    	Vector prettyNames = new Vector(10);
        Vector uglyNames   = new Vector(10);
        Vector both[] = {prettyNames,uglyNames};
        
    	String ugly = null;
    	String pretty = null;

    	String listNames = getValueOf(s);
    	
	// Separate the string by the ":"'s
    	StringTokenizer nameItems = new StringTokenizer(listNames,":");
    	int numLines = nameItems.countTokens();

    	for (int i=0; i < numLines ; ++i) {
            String key = nameItems.nextToken();

            // Build name-mapping hashes.
            StringTokenizer splitPairs = new StringTokenizer(key,"!");
            pretty = splitPairs.nextToken();

      	    // Some pretty names have a "" for their equivalent, which makes
            // StringTokenizer throw a NoSuchElementException. Assume a "" if
            // the exception occurs.
            try {
                 ugly   = splitPairs.nextToken();
            }
            catch (NoSuchElementException e) {
                 ugly = "";
            }

            prettyNames.addElement(pretty);
            uglyNames.addElement(ugly);

    	}

    return(both);

  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // getJumpNames - Returns Vector of jump names from the hash table.
  //
  public Vector getJumpNames () {
    Vector jumpNames = new Vector(10);
    String ugly;
    String pretty;

    String listNames = getValueOf("jumpmenu");
    // System.out.println("getJumpNames = " + listNames);
    // Separate the string by the ":"'s
    StringTokenizer nameItems = new StringTokenizer(listNames,":");
    int numLines = nameItems.countTokens();
    for (int i=0; i < numLines ; ++i) {
      String key = nameItems.nextToken();
      // System.out.println("getJumpNames Key = " + key);

      // Build name-mapping hashes.
      StringTokenizer splitPairs = new StringTokenizer(key,"!");
      pretty = splitPairs.nextToken();

      // Some pretty names have a "" for their equivalent, which makes
      // StringTokenizer throw a NoSuchElementException. Assume a "" if
      // the exception occurs.
      try {
        ugly   = splitPairs.nextToken();
      }
      catch (NoSuchElementException e) {
        ugly = "";
      }
      prettyToUgly.put(pretty,ugly);
      uglyToPretty.put(ugly,pretty);

      // Add new name to Vector.
      jumpNames.addElement(pretty);
    }
    return(jumpNames);
  }

  /**
   * getPretty - maps an ugly name to a pretty one.
   */
  public String getPretty(String ugly) {
    return (String)uglyToPretty.get(ugly);
  }

  /**
   * getUgly - maps a pretty name to an ugly one.
   */
  public String getUgly(String pretty) {
    return (String)prettyToUgly.get(pretty);
  }


  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // getSession - Returns the String sid from the hash table.
  //
  public String getSession () {
    String sid =
      ((Vector)(internalHashList.get("sid"))).firstElement().toString();
    // System.out.println(" getSession: " + sid);
    return(sid);
  }
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // getGaeaTmp - Returns the String gaeatmp from the hash table.
  //
  public String getGaeaTmp () {
    String gaeaTmp =
      ((Vector)(internalHashList.get("gaeatmp"))).firstElement().toString();
    // System.out.println(" gaeatmp: " + gaeaTmp);
    return(gaeaTmp);
  }
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // getHttpdHost - Returns the String httpd_host from the hash table.
  //
  public String getHttpdHost() {
    String httpdHost =
      ((Vector)(internalHashList.get("httpd_host"))).firstElement().toString();
    // System.out.println(" httpd_host: " + httpdHost);
    return(httpdHost);
  }
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // getCgiUrl - Returns the String CgiUrl from the hash table.
  //
  public String getCgiUrl() {
    String scriptName =
      ((Vector)(internalHashList.get("CgiUrl"))).firstElement().toString();
    // System.out.println(" scriptName: " + scriptName);
    return(scriptName);
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // getScriptName - Returns the String script_name from the hash table.
  //
  public String getScriptName() {
    String scriptName =
      ((Vector)(internalHashList.get("script_name"))).firstElement().toString();
    // System.out.println(" scriptName: " + scriptName);
    return(scriptName);
  }
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // getNorth - Returns the String of the value for "north" from hash table.
  //
  public String getNorth () {
    String north =
      ((Vector)(internalHashList.get("north"))).firstElement().toString();
    // System.out.println(" getNorth: " + north);
    return(north);
  }
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // getValueOf - Returns the String of the value for the requested key.
  //
  public String getValueOf (String key) {
    String valueOf;
    if (internalHashList.containsKey(key)) {
      valueOf =
	((Vector)(internalHashList.get(key))).firstElement().toString();
    }
    else valueOf = "";  
    return(valueOf);
  }
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // convertObj2String - Returns a String of the object passed in.
  //
  public String convertObj2String (Object item) {
    String returnValue = "";
    returnValue =
      ((Vector)(internalHashList.get(item))).firstElement().toString();
    // System.out.println(" convertObj : " + returnValue);
    return(returnValue);
  }
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // updateHash - Given a key and value, if key is in the hash, sets the value
  //              for the key in the hash, else adds key/value pair to hash.
  //
  public void updateHash (String key, String value) {
    Vector valueList  = new Vector(1);

    // System.out.println("updateHash - I'm here!");
   /* System.out.println("Storing Key :" + key + " Value = " + value);
    System.out.println("Key is in hash already? " +
		       internalHashList.containsKey(key)); */

    /*   if (hashList.containsKey(key)) {
	 if (value == "") {
	 // System.out.println("Null Values :" + key);
	 }
	 valueList.addElement(value);
	 }
	 else {
	 valueList = (Vector)hashList.remove(key);
	 valueList.addElement(value);
	 }
     */

    if (internalHashList.containsKey(key)) {
      /* System.out.println("Current value for" + key + " = " +
			 internalHashList.get(key)); */
      valueList = (Vector)internalHashList.get(key);
      valueList.removeAllElements();	

      //System.out.println("Test again = " + internalHashList.containsKey(key));
      //System.out.println("Get = " + internalHashList.get(key));
      //System.out.println("Value = " + value);

      valueList.addElement(value);
    }
    else {
      // System.out.println("Adding Key :" + key + " value="+value);
      valueList.addElement(value);
    }
    //System.out.println(" Before adding Key :" + key + " Value = " +
    // internalHashList.get(key));

    internalHashList.put(key, valueList);
  }
 public void removeKey(String key) {
    internalHashList.remove(key) ;
    // System.out.println("Removing Key :"+key);
    // System.out.println("Is key in Hash ? : "+internalHashList.containsKey(key));  
 }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // constructPostString - Returns a URL encoded String of the elements
  //                       of the hash table.
  //
  public String constructPostString () {
    String parameterList = "";
    Enumeration elements = internalHashList.elements();

    //    while (elements.hasMoreElements()) {
    //      String Elements = (String)elements.nextElement().toString();
    //    }

    // Get the List of all the Parameters(Keys)
    Enumeration keys = internalHashList.keys();

    while (keys.hasMoreElements()) {
      String parameter = (String)keys.nextElement().toString();
      Vector values = (Vector)internalHashList.get(parameter);
      int valuesSize = values.size();
      // System.out.println(parameter + " :" + valuesSize);
      for (int i=0; i < valuesSize; ++i) {
	String value = ((String)(values.elementAt(i).toString())) ;
	// System.out.println("     Parameter : " + value + "\n");
	parameterList = parameterList + parameter + "=" + value + "&";
      }
    }
    String encodedParameterList = URLEncoder.encode(parameterList);
    // System.out.println("constructPostString output: " + encodedParameterList);
     return parameterList;
//    return encodedParameterList;
  }
  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // copy - Sets the internal hash table of this object to be a copy
  //        of the hash table from the passed in Parameters object.
  //        Note we clone the vector because origvalues is really a
  //        reference.
  //
  public void copy (Parameters param1) {
    internalHashList.clear();
    Enumeration keys = param1.internalHashList.keys();
    while (keys.hasMoreElements()) {
      String parameter = (String)keys.nextElement().toString();
      Vector origvalues = (Vector)param1.internalHashList.get(parameter);
      Vector newvalues = new Vector();
      newvalues = (Vector) origvalues.clone();
      internalHashList.put(parameter, newvalues);
    }
  }
}
