package IMSWG.IW.SubSet;

import java.lang.*;
import java.awt.*;
import java.util.*;

/** Bands class - used to Rset or get names or status of the bands.
  * The bands are normally the bands of Landsat 7 but can be used 
  * for any set of bands.
  * 
  * there are methods for finding out which ones are currently selected,
  * the defaults or all the bands names.  And, there are methods to set 
  * the defaults and the currently selected.
  * @author Charles brown
  */ 
  public class Bands  {
    //int numBands = 7;
    //String allBands[] = new String[numBands];
    //String defaultBands[] = new String[numBands];
    //String selectedBands[] = new String[numBands];
    //String currentBands[] = new String[numBands];
    Vector allBands = new Vector();
    Vector defaultBands = new Vector();
    Vector selectedBands = new Vector();
    int allBandsLength;  
    int selBandsLength;  
    int defBandsLength;  
    
    public Bands(String[] initBands) {
      // initialize the bands array with Constructor array, initBands
      setAllBands(initBands);
      // initialize the default bands array
      // currently, assume all bands as default
      String defBands[] = new String[7];
      defBands[0] = "band 1";
      defBands[1] = "band 2";
      defBands[2] = "band 3";
      defBands[3] = "band 4";
      defBands[4] = "band 5";
      defBands[5] = "band 6";
      defBands[6] = "band 7";
      setDefaultBands(defBands);
    }

    /**  getAllBands returns an array containing the string descriptions
      *  for all the bands.
      */
    public String[] getAllBands() {
      String[] newBands = new String[allBandsLength];
      allBands.copyInto(newBands);
      return newBands;
    }

    /**  setAllBands accepts an array containing the string descriptions
      *  for all the bands and sets the internal array.
      */
    public void setAllBands(String[] bands) {
      int i;
      allBands.removeAllElements();
      for (i=0; i < bands.length; i++) {
        allBands.addElement(bands[i]);
      }
      allBandsLength = i;
    }

    /**  getDefaultBands returns an array containing only the bands
      *  that are set as default.  
      */
    public String[] getDefaultBands() {
      String[] defBands = new String[defBandsLength];
      defaultBands.copyInto(defBands);
      return defBands;
    }

    /**  setDefaultBands accepts an array containing only the bands
      *  to be highlighted as default bands.  
      */
    public void setDefaultBands(String[] defBands) {
      int i;
      defaultBands.removeAllElements();
      for (i=0; i < defBands.length; i++) {
        defaultBands.addElement(defBands[i]);
      }
      defBandsLength = i; 
    }

    /**  getSelectedBands returns an array of Strings containing only the bands
      *  that have been selected.  Assumes that the internal array has
      *  "ON" or "OFF" in the string elements, set by setSelectedBands.
      */
    public String[] getSelectedBands() {
      String[] selBands = new String[selBandsLength];
      selectedBands.copyInto(selBands);
      return selBands;
    }

    /**  setSelectedBands accepts an array containing only the bands
      *  that have been selected.  Sets internal selectedBands
      *  array with the same "ON" or "OFF" strings.
      */
    public void setSelectedBands(String selBands[]) {
      int i;
      selectedBands.removeAllElements();
      for (i=0; i < selBands.length; i++) {
        selectedBands.addElement(selBands[i]);
      }
      selBandsLength = i; 
    }
    
}














