package IMSWG.IW.SubSet;

import IMSWG.IW.SubSet.Cost;
import java.awt.*;
import java.applet.*;

/** DialogThread class - extends Thread class 
 * 
 * used to provide a thread for a Wait type dialog message so that
 * user knows that the cost estimation has been sent to the cost
 * server and to please wait.  The user will be able to hit a cancel button
 * and a callback to SubSet will be initiated. 
 *  @author Charles Brown
 */


class WaitDialog extends Frame {
   Cost wdCost;
  
   // Constructor
   WaitDialog (Cost c) {
      wdCost = c;

      setTitle ("Compute Cost and Scanlines Status");
      setLayout (new GridLayout (2,1));
    
      // init Wait message
      add ( new Label ("Cost server is processing .... Please Wait"));
      add ( new Button ("Cancel"));
      resize (375, 275);
      System.out.println ("in waitdialog: new gridlayout");    
   }
  
   public boolean action (Event evt, Object obj) {
      if (evt.target instanceof Button) {
         System.out.println ("calling dialogCancelled");

         // Set cgi flag to false to notify the applet to cancel 
         // running threads but stay open, not to go back to cgi.
         // Since the user cancelled the request maybe wants to
         // do more work with the applet.
         wdCost.setToCgiFlag (false);
         wdCost.cancelThreads ();
      }
      return true;
   }
}

public class DialogThread extends Thread {
   WaitDialog wd;
   Cost cost;
 
   // Constructor
   public DialogThread (Cost c) {
     cost = c;
   }

   public void run () { 
      // popup a simple wait dialog window with a cancel button
      wd = new WaitDialog (cost);
      wd.resize (300,100);
      wd.show ();
    
      // loop until parent stops thread, waiting 1000 
      // milliseconds between each check.
      while (true) { 
         try {
            Thread.sleep (1000);
         }
         catch (InterruptedException e) { }
         System.out.println ("threadDialog sleep for 1 second ");
      }
   }
     
   public void dialogCancelled () {
      System.out.println ("threadDialog.dialogCancelled called");
      wd.dispose ();
      stop ();
   }    
}
