package IMSWG.IW.SubSet;

import java.awt.*;
import java.applet.*;
import java.util.*;
import java.net.*;

import IMSWG.IU.*;
import IMSWG.IW.*;
//import IMSWG.IW.SubSet.CornerPointsMenuItem;
import IMSWG.IW.SubSet.GeoPolygon;
import IMSWG.IW.SubSet.DisplayOptions;
import IMSWG.IW.SubSet.ResetMenuItem;
import IMSWG.IW.SubSet.ClearMenuItem;
import IMSWG.IW.SubSet.MasterGlobe;
import IMSWG.IW.Mapplet.HelpMenuItem;
import IMSWG.IW.SubSet.SubSet;
import IMSWG.IW.SubSet.BandList;

/** Description:
 *    This class is the menu bar at the top of the Mapplet Frame.
 *    The Menu bar contains the Map Options Menu with menu items of 
 *    Display Options, Clear and Restore.
 */
public class DisplayMenu extends MenuBar {

    Menu mapOptions = new Menu("Map Options");
    GeoPolygon localGeoPoly;
    MasterGlobe localMasterGlobe;
    DisplayOptions displayoptions;
    SubSet myMapplet;
    ClearMenuItem clear;
    ResetMenuItem reset;
//    CornerPointsMenuItem corner;

    HelpMenuItem hlp;
    Parameters subsetParameters;
    BandList localBandList;
    FullSubWidget fullsubwidget;

    public DisplayMenu(MasterGlobe theMasterGlobe, SubSet theMapplet) { 
        super();
        myMapplet = theMapplet;
        localBandList = myMapplet.bandlist;
        fullsubwidget = myMapplet.fullsubwidget;
        localMasterGlobe = theMasterGlobe;
        localGeoPoly =  localMasterGlobe.internalPolygon;
        boolean alloptions = false;
        if(localMasterGlobe.mappletOriginalParameters.getValueOf("MapCgiScript").equals("drawglobe.cgi")){
           alloptions = true;
        } 
        displayoptions = new DisplayOptions(localGeoPoly,alloptions,localMasterGlobe);
        // Get SubSet params, passed via applet tag SUBSET.
        subsetParameters = new Parameters();
        subsetParameters.parseParameters(myMapplet.applet.getParameter("SUBSET"));

    }
/**
 * void setMapOptions() - intializes the menu bar with the menu items
 */
    public void setMapOptions() {
        mapOptions.add(displayoptions);
        reset = resetMenu();
        mapOptions.add(reset);
        hlp = helpMenu();
        mapOptions.add(hlp);
        this.add(mapOptions);

     }
/**
 * resetMenu() - returns an object of ResetMenuItem to be inserted into
 * the menu.
 */
     public ResetMenuItem resetMenu() {
       String defbands = subsetParameters.getValueOf("defbands");
       StringTokenizer defbandsTokens = new StringTokenizer(defbands,":");
       int defbandsCount = defbandsTokens.countTokens();
       String[] defbandsArray = new String[defbandsCount];
       for (int i=0; i < defbandsCount; ++i) {
         defbandsArray[i] = defbandsTokens.nextToken();
       }
       String selbands = subsetParameters.getValueOf("selbands");
       StringTokenizer selbandsTokens = new StringTokenizer(selbands,":");
       int selbandsCount = selbandsTokens.countTokens();
       String[] selbandsArray = new String[selbandsCount];
       for (int i=0; i < selbandsCount; ++i) {
         selbandsArray[i] = selbandsTokens.nextToken();
       }
       // Send the selected bands to ResetMenuItem.  If there r none selected,
       // send the default bands.
       if (selbandsCount != 0) 
         return (new ResetMenuItem(localMasterGlobe, selbandsArray, localBandList, fullsubwidget));
       else
         return (new ResetMenuItem(localMasterGlobe, defbandsArray, localBandList, fullsubwidget));
     }
/**
 * clearMenu() - returns an object of ClearMenuItem to be inserted into
 * the menu.
 */
     public ClearMenuItem clearMenu() {
        return (new ClearMenuItem(localMasterGlobe));
     }
/**
 * cornerPoints() - returns an object of CornerPointsMenuItem to be inserted
 * into the menu.
 */
//     public CornerPointsMenuItem cornerPoints() {
//        return (new CornerPointsMenuItem(localMasterGlobe));
//     }
/**
 * helpMenu() - returns an object of HelpMenuItem to be inserted into
 * the menu.
 */
     public HelpMenuItem helpMenu() {
        return(new HelpMenuItem());
     }
/**
 * closeResources() - kill the map options window when mapplet
 * ends.
 */
     public void closeResources() {
        // Kill the display options window (if it exists).
        displayoptions.die();
  
     }
}
