package IMSWG.IW.SubSet;

import java.awt.*;
import java.applet.*;

import IMSWG.IW.SubSet.FullSub;

/** FullSubWidget class - used to set up a checkbox widget for selecting the
  * full subinterval.
  * Note: uses a callback to the parent, SubSet.fullsubChanged, method which
  *       allows SubSet to determine what happens when the fullsubinterval 
  *       selection flag is changed.
  * @author Ed Seufert 
  */

public class FullSubWidget extends Panel {
  public SubSet subset;
  private Checkbox fullsubChkBx;

  FullSubWidget(SubSet s) {
     subset = s;
     fullsubChkBx = new Checkbox("Select Entire subinterval");
     fullsubChkBx.setState(subset.fullsub.getFullSub());
     this.add(fullsubChkBx);
  }

  public void setPrev() {

     subset.fullsub.reset();
     fullsubChkBx.setState(subset.fullsub.getFullSub()); 
  }


  public void update() {

     fullsubChkBx.setState(subset.fullsub.getFullSub());
  }


  // handle the event for selecting or de-selecting the checkbox 
  public boolean action(Event evt, Object obj) {
     if (evt.target.equals(fullsubChkBx)) {

        subset.fullsub.setFullSub(fullsubChkBx.getState());
        // do call back to subset.
        subset.changedFullSub(); 
        return true;
     }
     return false;
  } 
}
