package IMSWG.IW.SubSet;


import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.awt.BorderLayout;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.FlowLayout;
import java.util.*;
import IMSWG.IU.Constraints;
import IMSWG.IW.Parameters;
public class GeoPolygon {
    typeInTextField pointOneLat, pointOneLong ;
    typeInTextField pointTwoLat , pointTwoLong ;
    typeInTextField pointThreeLat , pointThreeLong ;
    typeInTextField pointFourLat , pointFourLong ;
    typeInTextField centerLat, centerLong;
    Parameters interalParameterHash;
    String NULL = "";

 // Constructor 
 public GeoPolygon(Parameters parameters) { 
    interalParameterHash = parameters;
    // Should be set in Modelet 
    interalParameterHash.updateHash("mode","SLCTGEO"); 
    // Should be set when the User does the RubberBanding
    interalParameterHash.updateHash("p.geotype","POLYGON_LOC"); 
 }

  public Panel typeIn() {
    Panel frame = new Panel();  // Stop Textfields from growing
  
    GridBagLayout gridBag = new GridBagLayout();
    GridBagConstraints consts = new GridBagConstraints();
    frame.setLayout(gridBag);

// The second argument to buildConstraints specifies the column cell coordinate.
// The third argument is the row cell coordinate.  The fourth argument is the 
// number of cells the component spans in width.  The fifth argument is the
// number of cells the component spans in height.
// The 6th argument to buildConstraints specifies the horizontal percentage of 
// the panel this column should take up.  The last argument to
// buildConstraints specifies the vertical percentage of the panel this row
// should take. For instance in the following line the column would take up 
// 10 percent of available space and the row would take up 40 percent.
//    buildConstraints(consts, 0, 0, 1, 1, 10, 40);
//                             ^  ^  ^  ^______________________
//                             |  |  |___________             |
//                             |  \________     |             |
//                             |          |     |             |
//                           column 0    row 0  1 cell wide  1 cell high
// the fill constraint specifies which dimensions of a component should grow
// when available space is larger than default size. The following line indicates
// that there will be no filling.
//    consts.fill = GridBagConstraints.NONE;

// the anchor contstraint specifies how the component should be displayed
// within its grid cells when it is smaller than those cells. The following
// line anchors the component in the southwest part of the cell
//    consts.anchor = GridBagConstraints.SOUTHWEST;
//  Here is the grid:
//           Column 0        Column 1        Column 2
//       |---------------------------------------------------|     ^
// row 0 | fake label  | "Subset Window"  | "Coordinates"    |     |
//       |  (0,0)      |   (1,0)          |   (2,0)          |    30%
//       |-------------|------------------|------------------|     ^
// row 1 | fake label  |  Latitude Label  |  Longitude Label |     |
//       |  (0,1)      |   (1,1)          |   (2,1)          |     |
//       |             |                  |                  |    10%  
//       |-------------|------------------|------------------|     ^
// row 2 | U.L. label  |   point one lat  |  point one long  |     |
//       | (0,2)       |   (1,2)          |   (2,2)          |    10%
//       |-------------|------------------|------------------|     ^
// row 3 | U.R. label  |  point two lat   | point two long   |     |
//       | (0,3)       |   (1,3)          |   (2,3)          |    10%
//       |-------------|------------------|------------------|     ^
// row 4 | L.R.label   |  point three lat | point three long |     |
//       | (0,4)       |   (1,4)          |   (2,4)          |     |
//       |             |                  |                  |    10%
//       |-------------|------------------|------------------|     ^
// row 5 | L.L. label  |  point four lat  | point four long  |     |
//       | (0,5)       |  (1,5)           |   (2,5)          |    30%
//       |---------------------------------------------------|
//        <-10 % -----><-------- 45% -----><---45%----------->
//  fake label to fill the cell is put in the southwest part of the cell.
//  The cell takes up 10 percent of the space horizontally and 30 percent of 
// the space vertically.  There is no filling so this component will not stretch
// to fill available space.
    consts.fill = GridBagConstraints.NONE;
    consts.anchor = GridBagConstraints.SOUTHEAST;
    Constraints.buildConstraints(consts, 0, 0, 1, 1, 10, 30);
    Label fakeLabel = new Label ("Subset",Label.RIGHT);
    gridBag.setConstraints(fakeLabel,consts);
    frame.add(fakeLabel);

// Subset Window title label takes 45% of the horizontal space,
// don't need to specify vertical space since that was done 
// for this row by fake label
// no filling is done and the label is placed in the southwest
//  part of the cell.
    Constraints.buildConstraints(consts, 1, 0, 1, 1, 45, 0);
    consts.anchor = GridBagConstraints.SOUTHWEST;
    consts.fill = GridBagConstraints.NONE;
    Label windowTitle = new Label ("  Window",Label.LEFT);
    gridBag.setConstraints(windowTitle,consts);
    frame.add(windowTitle);

// coordinates title label takes up 45 percent of the horizontal space,
// don't need to specify vertical space since that was done for this
// column by the fake label.
// The label is anchored to the southwest of the cell
    Constraints.buildConstraints(consts, 2, 0, 1, 1, 45, 0);
    consts.anchor = GridBagConstraints.SOUTHWEST;
    Label titleLable = new Label("Coordinates",Label.LEFT);
    gridBag.setConstraints(titleLable, consts);
    frame.add(titleLable);

//  blank label to fill the cell is put in the southwest part of the cell.
//  The cell takes up 10 percent of the space horizontally and 10 percent of 
// the space vertically.  There is no filling so this component will not stretch
// to fill available space.
    consts.fill = GridBagConstraints.NONE;
    consts.anchor = GridBagConstraints.SOUTHWEST;
    Constraints.buildConstraints(consts, 0, 1, 1, 1, 0, 10);
    Label blankLabel = new Label ("      ");
    gridBag.setConstraints(blankLabel,consts);
    frame.add(blankLabel);

// Latitude label - don't need to specify horizontal or vertical space 
// since that was done for this row by Point label and this column by
// subset window title. No filling is done
// and the label is placed in the southwest part of the cell.
    Constraints.buildConstraints(consts, 1, 1, 1, 1, 0, 0);
    consts.anchor = GridBagConstraints.SOUTHWEST;
    consts.fill = GridBagConstraints.NONE;
    Label latLabel = new Label ("Latitude");
    gridBag.setConstraints(latLabel,consts);
    frame.add(latLabel);

// Longitude label - don't need to specify horizontal or vertical space since
// that was done for this column by the fake label, and for this row by
// the coordinates title.
// The label is anchored to the southwest of the cell
    Constraints.buildConstraints(consts, 2, 1, 1, 1, 0, 0);
    consts.anchor = GridBagConstraints.SOUTHWEST;
    Label longLabel = new Label ("Longitude");
    gridBag.setConstraints(longLabel, consts);
    frame.add(longLabel);

// Upper Left label - don't need to specify horizontal space since that was
// done for this column by the fake label. Vertical space for this row is 10%.
// The label is anchored to the northwest of the cell
    Constraints.buildConstraints(consts, 0, 2, 1, 1, 0, 10);
    consts.anchor = GridBagConstraints.NORTHWEST;
    Label ULLabel = new Label ("Upper Left");
    gridBag.setConstraints(ULLabel,consts);
    frame.add(ULLabel);

// Point one lat  - don't need to specify horizontal and vertical spaces
// because that has been done for this row and column already
// the field is anchored to the northwest of the cell
    Constraints.buildConstraints(consts, 1, 2, 1, 1, 0, 0); 

    pointOneLat = new typeInTextField();
    pointOneLat.setTextField("-000.0000");
    gridBag.setConstraints(pointOneLat,consts);
    frame.add(pointOneLat);

// Point one long  - don't need to specify horizontal and vertical spaces
// because that has been done for this row and column already
// the field is anchored to the northwest of the cell
    Constraints.buildConstraints(consts, 2, 2, 1, 1, 0, 0); 

    pointOneLong = new typeInTextField();
    pointOneLong.setTextField("-000.0000");
    gridBag.setConstraints(pointOneLong, consts);
    frame.add(pointOneLong);

// upper right label - the vertical space for this row is 10%
//  the label is anchored to the northwest of the cell 
    Constraints.buildConstraints(consts, 0, 3, 1, 1, 0, 10);

    Label URLabel = new Label ("Upper Right");
    gridBag.setConstraints(URLabel, consts);
    frame.add(URLabel);

// point two lat - horizontal and vertical space already defined for this
// row and column.  The field is anchored to the northwest of the cell.
    Constraints.buildConstraints(consts, 1, 3, 1, 1, 0, 0);

    pointTwoLat = new typeInTextField();
    pointTwoLat.setTextField("-000.0000");
    gridBag.setConstraints(pointTwoLat, consts);
    frame.add(pointTwoLat);

// point two long - horizontal and vertical space already defined for this
// row and column.  The field is anchored to the northwest of the cell.
    Constraints.buildConstraints(consts, 2, 3, 1, 1, 0, 0);

    pointTwoLong = new typeInTextField();
    pointTwoLong.setTextField("-000.0000");
    gridBag.setConstraints(pointTwoLong, consts);
    frame.add(pointTwoLong);


// LR label - this row takes up 10% of available space.  The label is anchored
// to the northwest of the cell
    Constraints.buildConstraints(consts, 0, 4, 1, 1, 0, 10);

    Label LRLabel =new Label ("Lower Right");
    gridBag.setConstraints(LRLabel, consts);
    frame.add(LRLabel);

// point three lat - don't need to specify horizontal and vertical space. 
// The component is anchored to the northwest of the cell.
    Constraints.buildConstraints(consts, 1, 4, 1, 1, 0, 0);

    pointThreeLat = new typeInTextField();
    pointThreeLat.setTextField("-000.0000");
    gridBag.setConstraints(pointThreeLat, consts);
    frame.add(pointThreeLat);

// point three long - don't need to specify horizontal and vertical space. 
// The component is anchored to the west of the cell.
    Constraints.buildConstraints(consts, 2, 4, 1, 1, 0, 0);

    pointThreeLong = new typeInTextField();
    pointThreeLong.setTextField("-000.0000");
    gridBag.setConstraints(pointThreeLong, consts);
    frame.add(pointThreeLong);

// LL label - this row takes up 10% of available space.  The label is anchored
// to the northwest of the cell
    Constraints.buildConstraints(consts, 0, 5, 1, 1, 0, 10);

    Label LLLabel = new Label ("Lower Left");
    gridBag.setConstraints(LLLabel, consts);
    frame.add(LLLabel);

// point four lat - don't need to specify horizontal and vertical space. 
// The component is anchored to the northwest of the cell.
    Constraints.buildConstraints(consts, 1, 5, 1, 1, 0, 0);

    pointFourLat = new typeInTextField();
    pointFourLat.setTextField("-000.0000");
    gridBag.setConstraints(pointFourLat, consts);
    frame.add(pointFourLat);

// point four long - don't need to specify horizontal and vertical space. 
// The component is anchored to the northwest of the cell.
    Constraints.buildConstraints(consts, 2, 5, 1, 1, 0, 0);

    pointFourLong = new typeInTextField();
    pointFourLong.setTextField("-000.0000");
    gridBag.setConstraints(pointFourLong, consts);
    frame.add(pointFourLong);

// Center label 
// The label is anchored to the northwest of the cell
    Constraints.buildConstraints(consts, 0, 6, 1, 1, 0, 20);
    Label CLabel = new Label ("Center");
    gridBag.setConstraints(CLabel, consts);
    frame.add(CLabel);

// center lat - don't need to specify horizontal and vertical space.
// The component is anchored to the northwest of the cell.
    Constraints.buildConstraints(consts, 1, 6, 1, 1, 0, 0);
    centerLat = new typeInTextField();
    centerLat.setTextField("-000.0000");
    gridBag.setConstraints(centerLat, consts);
    frame.add(centerLat);

// center long - don't need to specify horizontal and vertical space.
// The component is anchored to the northwest of the cell.
    Constraints.buildConstraints(consts, 2, 6, 1, 1, 0, 0);

    centerLong = new typeInTextField();
    centerLong.setTextField("-000.0000");
    gridBag.setConstraints(centerLong, consts);
    frame.add(centerLong);

    return frame;
  }

 public void fillTextFields() {

        pointOneLat.setTextField(   getPointDegMin("p.0.lat"));
        pointOneLong.setTextField(  getPointDegMin("p.0.lon"));
        pointTwoLat.setTextField(   getPointDegMin("p.1.lat"));
        pointTwoLong.setTextField(  getPointDegMin("p.1.lon"));
        pointThreeLat.setTextField( getPointDegMin("p.2.lat"));
        pointThreeLong.setTextField(getPointDegMin("p.2.lon"));
        pointFourLat.setTextField(  getPointDegMin("p.3.lat"));
        pointFourLong.setTextField( getPointDegMin("p.3.lon"));
        centerLat.setTextField(  getPointDegMin("p.4.lat"));
        centerLong.setTextField( getPointDegMin("p.4.lon"));
 }


 public void clearTextFields() {
    // System.out.println("clearTextFields");
    pointOneLat.setTextField("") ;
    interalParameterHash.removeKey("p.0.lat");
    pointOneLong.setTextField("");
    interalParameterHash.removeKey("p.0.lon");
    pointTwoLat.setTextField("" );
    interalParameterHash.removeKey("p.1.lat");
    pointTwoLong.setTextField("") ;
    interalParameterHash.removeKey("p.1.lon");
    pointThreeLat.setTextField("") ;
    interalParameterHash.removeKey("p.2.lat");
    pointThreeLong.setTextField("") ;
    interalParameterHash.removeKey("p.2.lon");
    pointFourLat.setTextField("") ;
    interalParameterHash.removeKey("p.3.lat");
    pointFourLong.setTextField("") ;
    interalParameterHash.removeKey("p.3.lon");
    centerLat.setTextField("") ;
    interalParameterHash.removeKey("p.4.lat");
    centerLong.setTextField("") ;
    interalParameterHash.removeKey("p.4.lon");

	// repaint();
 }

public void convertRange2Poly() {
	String north = interalParameterHash.getValueOf("p.north");
        String south = interalParameterHash.getValueOf("p.south");
        String east = interalParameterHash.getValueOf("p.east");
        String west = interalParameterHash.getValueOf("p.west");
           // System.out.println("North = "+north);
        String oneLat, twoLat;
        String oneLong, fourLong;
        String twoLong, threeLong;
        String threeLat, fourLat;
          oneLat = twoLat = north;
          oneLong = fourLong = west;
        twoLong = threeLong = east;
        threeLat = fourLat = south;
          // System.out.println("One = "+oneLat+" "+oneLong);
          // System.out.println("Two = "+twoLat+" "+twoLong);
          // System.out.println("Three = "+threeLat+" "+threeLong);
          //   System.out.println("Four = "+fourLat+" "+fourLong);
       
          // interalParameterHash.updateHash("p.0.lat", oneLat);
	updatePoint( "p.0", oneLat, oneLong);
	updatePoint( "p.1", twoLat, twoLong);
	updatePoint( "p.2", threeLat, threeLong);
	updatePoint( "p.3", fourLat, fourLong);
          // System.out.println("Points updated!");
}

 public void setProjection(String projection) {

        interalParameterHash.updateHash("p.projection",projection );
 }

 public String getProjection() {

        String value  = interalParameterHash.getValueOf("p.projection");
        return(value);
 }

 public void setZoom(int zoom) {
        interalParameterHash.updateHash("p.zoom",Integer.toString(zoom));
 }

 public int getZoom() {
    String stringValue  = interalParameterHash.getValueOf("p.zoom");
    // if getValueOf is "null" then it'll return ""
    // getZoom will return 1 in that case
    if (stringValue.equals("")) {
        return (1);
    }
    else {
       int intValue = (Integer.valueOf(stringValue)).intValue(); 
       return(intValue);
    } 
 }

 public void setCenterLat(double centerLat) {

  interalParameterHash.updateHash("p.tangent.lat", convertDouble2String(centerLat));
 }

 // Gives a developer to update ANY tag value ( key )
 public void setParamTag(String key, String value) {
    interalParameterHash.updateHash( key , value );
 }

 public double getCenterLat() {

     	String value  = interalParameterHash.getValueOf("p.tangent.lat");
	double doubleValue = convertString2Double(value);
        return(doubleValue);

 }

 public void setCenterLon(double centerLon) {

  interalParameterHash.updateHash("p.tangent.lon", convertDouble2String(centerLon));
 }

 public double getCenterLon() {

       String value  = interalParameterHash.getValueOf("p.tangent.lon");
        double doubleValue = convertString2Double(value);
        return(doubleValue);

 }

 public void setPole(String pole) {

        interalParameterHash.updateHash("p.pole",pole);

 }

 public String getPole() {

        String pole = interalParameterHash.getValueOf("p.pole");
        return(pole);
 }

 public void updatePoint(String point ,String lat ,String lon ) {
       interalParameterHash.updateHash(point+".lat", lat );
       interalParameterHash.updateHash(point+".lon", lon );
 }

 public void updatePoint2(String point ,double lat ,double lon ) {
      
       interalParameterHash.updateHash(point+".lat", convertDouble2String(lat));
       interalParameterHash.updateHash(point+".lon", convertDouble2String(lon));
 }

public double convertString2Double(String stringValue) {
       double returnValue;
       try {
         returnValue = (Double.valueOf(stringValue)).doubleValue();
       }
       catch (NumberFormatException e) {
         returnValue = 0.0;
       }
       return ( returnValue) ;
}

public String convertInt2String(int intValue) {
	String returnValue = Integer.toString(intValue);
       return ( returnValue) ;
}


public String convertDouble2String(double doubleValue) {
       String returnValue = Double.toString(doubleValue);
       return ( returnValue) ;
}


  public boolean checkPointOne() {
    if ( NULL.equals(getPointOneLat()) && NULL.equals(getPointOneLong()))
	{ return ( false); }
    return (true);
  }


  public double getPointDouble(String stringValue) {
   String value  = interalParameterHash.getValueOf(stringValue);
   // if getValueOf is "null" then it'll return ""
   // getPointDouble will return 999.99 in that case 
   if (value.equals("")) {
	return (999.99);
   } 
   else {
     double doubleValue = convertString2Double(value);
     return(doubleValue);
   } 
  }

  public String getPointOneLat() {
     String value  = interalParameterHash.getValueOf("p.0.lat");
     value = trimValue(value,4);
     return(value);
  }

  public String getPointOneLong() {
     String value = interalParameterHash.getValueOf("p.0.lon");
     value = trimValue(value,4);
     return(value);
  }

  public String getPointTwoLat() {
     String value = interalParameterHash.getValueOf("p.1.lat");
     value = trimValue(value,4);
     return(value);
  }
  public String getPointTwoLong() {
     String value = interalParameterHash.getValueOf("p.1.lon");
     value = trimValue(value,4);
     return(value);
  }
  public String getPointThreeLat() {
     String value = interalParameterHash.getValueOf("p.2.lat");
     value = trimValue(value,4);
     return(value);
  }

  public String getPointThreeLong() {
     String value = interalParameterHash.getValueOf("p.2.lon");
     value = trimValue(value,4);
     return(value);
  }

  public String getPointFourLat() {
     String value = interalParameterHash.getValueOf("p.3.lat");
     value = trimValue(value,4);
     return(value);
  }
  public String getPointFourLong() {
     String value = interalParameterHash.getValueOf("p.3.lon");
     value = trimValue(value,4);
     return(value);
  }



  public String getPointDegMin(String point) {

    String value  = interalParameterHash.getValueOf(point);
    StringTokenizer separatedValues = new StringTokenizer(value,".");
    String degString = separatedValues.nextToken();
    // extract fraction, convert to minutes and round:
    String fractionString = "0."+(separatedValues.nextToken());
    double minDouble = Math.round(convertString2Double(fractionString)*60);
    if (minDouble > 59) {
       minDouble = 0.0;
       int degint = Integer.valueOf(degString).intValue() + 1;
       degString = Integer.toString(degint); 
    }
    String minString = Long.toString(Math.round(minDouble));
    return(degString+"d "+minString+"m");
  }



  public String trimValue(String stringValue, int toLength) {
    // Seperate the string by the "&"'s
    StringTokenizer separatedValues = new StringTokenizer(stringValue,".");
    int numLines = separatedValues.countTokens();
    String [] lines = new String[numLines];
    String integer = separatedValues.nextToken();
    String fraction = (separatedValues.nextToken())+"0000";
    String subFraction = fraction.substring(0,toLength);
    // System.out.println("integer : "+integer+" "+integer.length()+"\n");
    // System.out.println("fraction : "+fraction+" "+fraction.length()+"\n");
    // System.out.println("subfraction : "+subFraction+" "+subFraction.length()+"\n");
    return(integer+"."+subFraction);
  }
}



// class typeInTextField extends TextField {
class typeInTextField extends Label {

    public typeInTextField() {
	 super();
//	super.setEditable(false);
    }

    public void getValue() {
    }

    public void setTextField(String value) {
        setText(value);
// Aligns the numbers Right justified
//	setAlignment(2);	
    }
}
