package IMSWG.IW.SubSet;

import java.awt.*;
import java.net.*;
import java.applet.Applet;
import IMSWG.IW.ModeletTools;
import IMSWG.IW.SubSet.mapx;
import IMSWG.IW.SubSet.GeoPolygon;
import IMSWG.IW.SubSet.DisplayOptions;
import IMSWG.IW.SubSet.SubInterval;
import IMSWG.IW.Parameters;
import IMSWG.IW.LatLonPoint;

/* Hacked by GYF for GSFC/NASA */
/* This program is a Java port of my Pink port of 
   Eichin's UNIX version of my
   Multics version of the original RLE version.
   THVV 04/18/96
   GYF 07/02/97
*/

/* This program is a Pink port of Eichin's UNIX version of my
   Multics version of the original RLE version.
   THVV 6/1/94 */

/* This program draws the globe from any viewpoint.
   I have copied the Multics PL/I port of the program,
   and the data set as well.
   _Mark Eichin <eichin@athena.mit.edu> */

/* This program draws the globe from any viewpoint.
   I have copied the CTSS incarnation of the program.
   THVV May 5 1972 */

/* The original version of this rogram was written in MAD for 7094 CTSS
   by either Rob Stotz or Daniel Thornhill about 1966, to demonstrate
   the ARDS terminal (based on a Tektronix storage tube).
   The display data was digitized from a globe by a contractor for
   the MIT Research Laboratory for Electronics (RLE). */


// ================================================================
//The view of the globe.
//  The data model is almost degenerate.. just the location of the
//  display center.  The paint() method does all the work.

// In the port to Java, I encountered some problems.  The compiler
// gave bogus undefined variable and statement not reached errors
// until I reduced the number of local vars in the paint() method.

public class Globe extends Canvas {

  private static final Color BACKGROUND_COLOR = Color.white;
  private static final Color RUBBERBANDING_COLOR = Color.red;
  boolean turnoffdisplayoptions = false;
  int statusTotal;

  double lat;
  double lon;
  double rot;

  int sel_x = 0;
  int sel_y = 0;
  int sel_w = 0;
  int sel_h = 0;

  int[] arrayX = new int[5];
  int[] arrayY = new int[5];
  int zoom_hundredths = 100;

  int FoldViewSize;
  int GlobeBorderWidth;
  int GlobeDiameter;
  int GlobeRadius;
  int GlobeCenterPos;
  GeoPolygon internalPolygon;
  private double fa1, fa2, fa3, fa4, fa5, fa6, fa7, fa8, fa9;
  private double La1, La2, La3, La4, La5, La6, La7, La8, La9;
  private double cosa, cosp, cost, sina, sint, sinp;
  private double rad;

  final static int X = 0;
  final static int Y = 1;
  final static int Z = 2;
  final static int n_points = 6048;

  final static double degToRadians = 1.745329e-2; // pi / 180 
  final static int PosY = -1; // which way y runs in graphics coords

  LatLonPoint[] coverage; 
  public DisplayOptions display;
  Parameters originalParameters;

  public Globe(int fsize, GeoPolygon polygon,SubInterval passedsubinterval,
               Parameters poriginalParameters) {
    this.FoldViewSize = fsize;
    this.internalPolygon = polygon;
    this.coverage = passedsubinterval.getcoverage();      
    this.originalParameters = poriginalParameters;
    this.lat = 0.0;
    this.lon = 0.0;
    this.rot = 0.0;

    GlobeBorderWidth = 8;
    GlobeDiameter = FoldViewSize-2*GlobeBorderWidth;
    GlobeRadius = GlobeDiameter/2;
    GlobeCenterPos = GlobeBorderWidth+GlobeRadius;

  }

  public void turnoffDisplayOptions() {

	turnoffdisplayoptions = true; 

  }

  private double latlontox(double lat, double lon){
    double r;
    r = Math.sin(degToRadians * lon) * Math.cos(degToRadians * lat);
    return r;
  }
  private double latlontoz(double lat, double lon){
    double r;
    r = Math.cos(degToRadians * lon) * Math.cos(degToRadians * lat);
    return r;
  }
  private double latlontoy(double lat, double lon){
    double r;
    r = Math.sin(lat * degToRadians);
    return r;
  }
  void setup_screen () { // [ed:new:gyuri]

    this.FoldViewSize = this.size().width;

    GlobeDiameter = FoldViewSize-2*GlobeBorderWidth;
    GlobeRadius = GlobeDiameter/2;
    GlobeCenterPos = GlobeBorderWidth+GlobeRadius;
//    System.out.println("New Fold size = "+this.size().width);
  }
  void setup_coefficients () {
    //	phi and theta are latitude and longitude of the display center, and
    //	..alpha is rotation around the center. Radius 1.0 is full screen.
    double phi; 
    double theta; 
    double alpha;
    double radius;

    double radus;

    /* double irad; */

    radius = 1.0e0;                         // for now
    radus = radius * (double) GlobeRadius;  // 512.e0; 
    //
    //irad = radus + 0.5e0;
    //
    rad = radus;

    phi = this.lat;
    theta = this.lon;
    alpha = this.rot;

    if (phi < 0)  phi = 360.0e0 + phi; /* was: - phi GyF */
    if (theta < 0) theta = 360.0e0 + theta; /* was: - theta GyF */

    sinp = Math.sin(phi * degToRadians);
    cosp = Math.cos(phi * degToRadians);
    sint = Math.sin(theta * degToRadians);
    cost = Math.cos(theta * degToRadians);
    sina = Math.sin(alpha * degToRadians);
    cosa = Math.cos(alpha * degToRadians);

    // long, lat, rot or t, p, a.
    // inverse would be -a -p -t
    //
    fa1 = cost * cosa + sinp * sina * sint;
    fa2 = -cosp * sina;
    fa3 = cost * sina * sinp - sint * cosa;
    fa4 = cost * sina - sint * cosa * sinp;
    fa5 = cosp * cosa;
    fa6 = -cost * cosa * sinp - sint * sina;
    fa7 = sint * cosp;
    fa8 = sinp;
    fa9 = cost * cosp;
    //
    // these are inverters:
    //
    La1 = cost * cosa + sinp * sina * sint;
    La2 = cost * sina - sinp * sint * cosa;
    La3 = cosp * sint;
    La4 = -sina * cosp;
    La5 = cosp * cosa;
    La6 = sinp;
    La7 = -sint * cosa + cost * sina * sinp;
    La8 = -sint * sina - cost * sinp * cosa;
    La9 = cost * cosp;
    //
    // do the same for gy1 - gy9 too
    // except I know have inverse coefficients too...
  }
  // new: gyuri
  // What if I did my own matrix stuff?
  // would I get the same result?
  // lemme assume that rot (alpha) = 0 for now..
  // and only deal with lat/lon rotations
  // do a new i_x(), and i_y() function with x,y,z inputs, just like here.

 double screentox(int x){
   double r;
   r = (x - GlobeCenterPos);
   r *= 100;
   r /= zoom_hundredths;
   r /= rad;
   return r;
 }
 double screentoy(int y){
    double r;
    r = (GlobeCenterPos - y);
    r *= 100;
    r /= zoom_hundredths;
    r /= rad;
    return r;
  }
  double i_x(double ix, double iy, double iz){
    double r=0.0;
    r =(La1 * ix + La2 * iy + La3 * iz);
    return r;
  }
  double i_y(double ix, double iy, double iz){
    double r=0.0;
    r =(La4 * ix + La5 * iy + La6 * iz);
    return r;
  }

  double i_z(double ix, double iy, double iz){
    double r=0.0;
    r =(La7 * ix + La8 * iy + La9 * iz);
    return r;
  }

  double calculatex(double x, double y, double z) {
    double r;
    r = (fa1 * x + fa2 * y + fa3 * z);
    return r;
  }
  double calculatey(double x, double y, double z) {
    double r;
    r = (fa4 * x + fa5 * y + fa6 * z);
    return r;
  }
  
  double calculatez(double x, double y, double z) {
    double r;
    r = fa7 * x + fa8 * y + fa9 * z;
    return r;
  }
  
  public void paint(Graphics g) {

     // Clear map and display message:
     Image imageMsg = createImage(this.FoldViewSize,this.FoldViewSize);
     Graphics gc = imageMsg.getGraphics();
     gc.setColor(BACKGROUND_COLOR);
     gc.fillRect(0,0,this.FoldViewSize,this.FoldViewSize);
     gc.setColor(RUBBERBANDING_COLOR);
     gc.drawString("Updating map...",20,12);
     g.clearRect(0, 0,this.FoldViewSize,this.FoldViewSize);
     g.drawImage(imageMsg,0,0,null);

     // Fetch new map:
     Image map = getGIFMap();

     // Clear message and display new message:
     g.clearRect(0, 0,this.FoldViewSize,this.FoldViewSize);
     g.setColor(BACKGROUND_COLOR);
     g.fillRect(0, 0,this.FoldViewSize,this.FoldViewSize);
     g.drawImage(map, 0 , 0 ,null);

     // Do an additional drawing on the image (boxes, sliders, etc.)
     // by overriding morepaint in child classes. 
     morepaint(g);

  } // end paint()

  // Abstract method, override in child class to do additional drawing on 
  // the map.
  public void morepaint(Graphics g) {

     return;
  }

  public Image getGIFMap () {

        

       Image image;
       MediaTracker tracker;
       URL mapURL = null;
       String cgiString; 
       Graphics gc;

       String zoom = Integer.toString(this.zoom_hundredths/100);
       String height = Integer.toString(this.FoldViewSize);
       String width = Integer.toString(this.FoldViewSize); 
       double lat = this.internalPolygon.getCenterLat();
       String clat = Double.toString(lat);
       double lon = this.internalPolygon.getCenterLon();
       String clon = Double.toString(lon);     
       String trans = "no";

       // Check if legal values for lat and lon.

       if (lat < -90.0 || lat > 90.0) {

		image = createImage(this.FoldViewSize,this.FoldViewSize);
                gc = image.getGraphics();
                gc.setColor(BACKGROUND_COLOR);
                gc.fillRect(0,0,this.FoldViewSize,this.FoldViewSize);
                gc.setColor(RUBBERBANDING_COLOR);
                gc.drawString("Warning:",20,12);
                gc.drawString("Latitude ",20,24);
                gc.drawString(" "+lat,20,36);
                gc.drawString("is invalid, ",20,48);
                gc.drawString("must be",20,60);
                gc.drawString("between",20,72);
                gc.drawString("-90 and",20,84);
                gc.drawString("+90.",20,96);
                return image;

       } else if (lon < -180 || lon > 180) {

                image = createImage(this.FoldViewSize,this.FoldViewSize);
                gc = image.getGraphics();
                gc.setColor(BACKGROUND_COLOR);
                gc.fillRect(0,0,this.FoldViewSize,this.FoldViewSize);
                gc.setColor(RUBBERBANDING_COLOR);
                gc.drawString("Warning:",20,12);
                gc.drawString("Longitude ",20,24);
                gc.drawString(" "+lon,20,36);
                gc.drawString("is invalid, ",20,48);
                gc.drawString("must be",20,60);
                gc.drawString("between",20,72);
                gc.drawString("-180 and",20,84);
                gc.drawString("+180.",20,96);
                return image;

       } 


       // Get user's preferences for the display options.
   
       String proj = "ortho";
       if (!turnoffdisplayoptions) proj = display.getProjection();
       String polit = "no"; 
       if (!turnoffdisplayoptions) polit = display.getPolitical();
       String lakriv = "no";
       if (!turnoffdisplayoptions) lakriv = display.getRivers();
       String grid = "20";
       if (!turnoffdisplayoptions) grid = display.getGridSpacing();
       String wrs = "no";
       if (!turnoffdisplayoptions) wrs = display.getWRS();
       String rail = "no";
       if (!turnoffdisplayoptions) rail = display.getRail();
       String roads = "no";
       if (!turnoffdisplayoptions) roads = display.getRoads();
       String places = "no";
       if (!turnoffdisplayoptions) places = display.getPlaces();

       // Build Base URL for the cgi program to be called.
        
       // First get reference to the original parameters which
       // includes the WG host and CgiUrl.
       String CgiUrl = originalParameters.getValueOf("CgiUrl");
       String protocol = originalParameters.getValueOf("protocol");
       String host = originalParameters.getValueOf("httpd_host");
//       ModeletTools.debug ("host is "+host);
//       ModeletTools.debug ("CgiUrl is "+CgiUrl);

//       String base = "http://harp.gsfc.nasa.gov/ims-bin/dev/";
//       String base = "http://"+host+CgiUrl;
     
       String script = originalParameters.getValueOf("MapCgiScript"); 

       cgiString = "?proj="+URLEncoder.encode(proj)+
                   "&zoom="+URLEncoder.encode(zoom)+
                   "&height="+URLEncoder.encode(height)+
                   "&width="+URLEncoder.encode(width)+
                   "&clat="+URLEncoder.encode(clat)+
                   "&clon="+URLEncoder.encode(clon)+
		   "&trans="+URLEncoder.encode(trans)+
                   "&polit="+URLEncoder.encode(polit)+
                   "&lakriv="+URLEncoder.encode(lakriv)+
                   "&wrs="+URLEncoder.encode(wrs)+
                   "&rail="+URLEncoder.encode(rail)+
                   "&roads="+URLEncoder.encode(roads)+
                   "&places="+URLEncoder.encode(places)+
                   "&grid="+URLEncoder.encode(grid);

       tracker = new MediaTracker(this);

       try {

              mapURL = new URL (protocol+"://"+host+CgiUrl+script+cgiString);
              System.out.println("Using "+protocol+"://"+host+CgiUrl+script+cgiString);

//            mapURL = new URL ("http://harp.gsfc.nasa.gov/~imswww/dev/pics/world-atlas.gif");

//            mapURL = new URL ("http://harp.gsfc.nasa.gov/ims-bin/dev/imswdbtile.cgi?proj=ortho&zoom=2&height=100&width=100&clat=38&clon=%2D78&trans=yes&polit=yes&lakriv=yes&grid=10"); 

       } catch (MalformedURLException e) {

            e.printStackTrace();

       }

       // get the map GIF by making a call to the CGI program.

       image = ModeletTools.getImage(mapURL);

       // add to the image tracker so we make sure we've gotten the gif.

       tracker.addImage(image,0);

       try {

              tracker.waitForAll();

        } catch (InterruptedException e) { }

        if (tracker.isErrorAny()) {

              System.out.println("An error occured loading the image");
        } 

	return image;

  } // end method getGIFMap


  /**
   * drawSubintervalCoverage draws polygon representing the subinterval's
   * (granule) geo coverage.
   */

   public void drawSubintervalCoverage(Graphics g) {

      int X[][] = new int[4][1];
      int Y[][] = new int[4][1];
      for (int i=0;i<4;++i) {
         getXY(coverage[i].getLat(),coverage[i].getLon(),X[i],Y[i]);
      }
      // Build arrays to use in drawing the polygon,
      // repeating first point to close the polygon.
      int arrayX[] = {X[0][0],X[1][0],X[2][0],X[3][0],X[0][0]};
      int arrayY[] = {Y[0][0],Y[1][0],Y[2][0],Y[3][0],Y[0][0]};

      g.setColor(Color.green.darker());
      g.drawPolygon(arrayX, arrayY, 5);
}

  public Dimension preferredSize () {
//    System.out.println("Prefer "+ FoldViewSize);
    return new Dimension (FoldViewSize,FoldViewSize);
  }
  
  public double normalize_lat(double angle) {
    double x = angle;
    if (x >= 90.0) x = 90.0;
    if (x < -90.0) x = -90.0;
    return x;
  }
  public double normalize(double angle) {
    double x = angle;
    if (x >= 360.0) x -=360.0;
    if (x < 0.0) x += 360.0;
    return x;
  }

  public void tilt(double angle) {
    this.lat += angle;
    this.lat = normalize_lat(this.lat);
    repaint();

  }
  public void rotate(double angle) {
    this.lon += angle;
    this.lon = normalize(this.lon);
    repaint();
  }

  public void setZoom(int percent){
    this.zoom_hundredths = percent;
    repaint();
  }
  public void setLon(Double x) {
    this.lon = normalize(x.doubleValue());
    repaint();
  }
  public void setLat(Double x) {
    this.lat = normalize_lat(x.doubleValue());
    repaint();
  }
  public void setRot(Double x) {
    this.rot = normalize(x.doubleValue());
    repaint();
  }

  public double getLon() { // getters
    return this.lon;
  }
  public double getLat() {
    return this.lat;
  }
  public double getRot() {
    return this.rot;
  }
  public int getZoom() {
    return this.zoom_hundredths;
  }
  public void normalizeXY(int x, int y, int[] newX, int[] newY) {
    int tempX, tempY;
    double doubleX, doubleY, rho;
    newX[0] = x;
    newY[0] = y;
    if ( zoom_hundredths > 100 ) {
	return;
    }
    tempX = x - GlobeCenterPos;
    tempY = -(y - GlobeCenterPos);
    doubleX = (double) tempX;
//    System.out.println("doubleX = "+doubleX);
    doubleY = (double) tempY;
//    System.out.println("doubleY = "+doubleY);
    rho = Math.sqrt(doubleX*doubleX + doubleY*doubleY);
//    System.out.println("rho = "+rho);
    if(rho > (double) GlobeRadius) {
      doubleX = doubleX/rho * (double) GlobeRadius;
    // System.out.println("doubleX = "+doubleX);
      doubleY = doubleY/rho * (double) GlobeRadius;
    // System.out.println("doubleY = "+doubleY);
      tempX = (int) doubleX;
    // System.out.println("tempX = "+tempX);
      tempY = (int) doubleY;
    // System.out.println("tempY = "+tempY);
      newX[0] = tempX + GlobeCenterPos;
      newY[0] = GlobeCenterPos - tempY;
    }
  }
  public int getLatLon(int x, int y, double latResult[], double lonResult[]) {
    float[] newLat = new float[1];
    float[] newLon = new float[1];
    // convert x and y to points relative to the map center
    x = x - GlobeCenterPos;
    y = -(y - GlobeCenterPos);
    float xfloat = (float) x;
    float yfloat = (float) y;
    float given_lat0 = (float) lat;
    float given_lon0 = (float) lon;
    String given_map_projection_name = "ORTHOGRAPHIC";
    float given_scale = (float) zoom_hundredths / (float) 100;
    given_scale = 1/given_scale;
    float given_equatorial_radius = (float) GlobeRadius;
//    System.out.println("given_scale = "+ given_scale);
//    System.out.println("given_equatorial_radius = "+ given_equatorial_radius);
    mapx Ortho = new mapx();
    Ortho.init_mapx(given_map_projection_name,
     given_lat0, given_lon0,
     given_scale,
     given_equatorial_radius);
    int status = Ortho.map_to_geo(xfloat, yfloat, newLat, newLon);
    latResult[0] = (double) newLat[0];
    lonResult[0] = (double) newLon[0];

    return status;

  }

  public String poleIncluded(int x1, int y1, int x2, int y2) {

	String pole; // default is neither pole

        int nx[] = new int[1];
        int ny[] = new int[1]; 
        int sx[] = new int[1]; 
        int sy[] = new int[1]; 
        int nstatus,sstatus;

        nstatus = getXY(90.0,0.0,nx,ny); // north pole
        sstatus = getXY(-90.0,0.0,sx,sy); // south pole

   	// check north pole
        
        if 
        ( (nx[0] >= x1 && nx[0] <= x2) && 
          (ny[0] >= y1 && ny[0] <= y2) && 
          (nstatus >= 0 ) ) {

		pole = "N";

        // check south pole
        } else if 
        ( (sx[0] >= x1 && sx[0] <= x2) && 
          (sy[0] >= y1 && sy[0] <= y2) && 
          (sstatus >= 0 ) ) {

		pole = "S";

        // set for neither pole
        } else {

		pole = "X";

        } 		

	return pole; 

  }

  public int getXY(double latDouble, double lonDouble, int x[], int y[]){
    float[] newX = new float[1];
    float[] newY = new float[1];
    float given_lat0 = (float) lat;
    float given_lon0 = (float) lon;
    float latInput = (float) latDouble;
    float lonInput = (float) lonDouble;
    String given_map_projection_name = "ORTHOGRAPHIC";
    float given_scale = (float) zoom_hundredths / (float) 100;
    given_scale = 1/given_scale;
    float given_equatorial_radius = (float) GlobeRadius;
    mapx Ortho = new mapx();
    Ortho.init_mapx(given_map_projection_name,
     given_lat0, given_lon0,
     given_scale,
     given_equatorial_radius);
    int status = Ortho.geo_to_map(latInput, lonInput, newX, newY);
    x[0] = (int) newX[0] + GlobeCenterPos;
    y[0] = GlobeCenterPos - (int) newY[0];
    return status;
  }

} // end Globe
