package IMSWG.IW.SubSet;

import java.awt.*;
import java.util.*;

 /** 
  * Show path and current number start and end row selected. 
  * @author Ed Seufert
  */

public class PathRow extends Panel {

   String sRow;
   String eRow;
   String Path;

   Font Bold = new Font("Helvetica",Font.BOLD,12);

   Label srowLabel = new Label (" Begin Row: 000.0",Label.RIGHT);
   Label erowLabel = new Label ("   End Row: 000.0",Label.RIGHT);
   // Constructor:
   PathRow(float path) { 
       float srow = (float) 0.0;
       float erow = (float) 0.0;
       Path = trimValue(Float.toString(path),0);
       Label pathLabel = new Label ("     Path: "+Path,Label.RIGHT);
       setLayout (new BorderLayout ());
       setFont(Bold);
       add("North",pathLabel);
       add("Center",srowLabel);
       add("South",erowLabel);
       set(srow,erow);
   } 

   public void set(float srow, float erow) {

      sRow = trimValue(Float.toString((float) Math.round(srow*10.0)/10),1);
      eRow = trimValue(Float.toString((float) Math.round(erow*10.0)/10),1);

      this.srowLabel.setText("Begin Row: "+sRow);
      this.erowLabel.setText("  End Row: "+eRow);

   }

  public String srow() { return sRow; }

  public String erow() { return eRow; }

  public String trimValue(String stringValue, int toLength) {
    // Separate the string by the "&"'s
    StringTokenizer separatedValues = new StringTokenizer(stringValue,".");
    int numLines = separatedValues.countTokens();
    String [] lines = new String[numLines];
    String integer = separatedValues.nextToken();
    if (toLength == 0) {return integer;} 
    String fraction = (separatedValues.nextToken())+"0000";
    String subFraction = fraction.substring(0,toLength);
    return(integer+"."+subFraction);
  }
}
