package IMSWG.IW.SubSet;

import java.awt.MenuItem;
import java.awt.Event;
import java.awt.Graphics;

import IMSWG.IW.SubSet.MasterGlobe;
import IMSWG.IW.SubSet.BandList;
import IMSWG.IW.SubSet.FullSubWidget;

public class ResetMenuItem extends MenuItem{

  MasterGlobe localMasterGlobe;
  BandList localBandlist;
  FullSubWidget fullsubwidget;
  String[] prevbands;

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // ResetMenuItem - Constructor.  Store local link to MasterGlobe.
  //
  public ResetMenuItem(MasterGlobe parentMasterGlobe, String[] prevBands, BandList parentBandList, FullSubWidget parentfullsubwidget) {
    super("Revert to Last Stored Value ");
    localMasterGlobe = parentMasterGlobe;
    prevbands = prevBands;
    localBandlist = parentBandList;
    fullsubwidget = parentfullsubwidget;
  }

  // - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  // action - When RESET menu item is selected, set the pan to 0 latitude
  //          and 0 longitude, and set the zoom to 1.
  //
//  public boolean action(Event e, Object o) {
  public boolean resetMenuAction(){
    Double value;
//    System.out.println(" Reset menu item event ");
    // First reset the Parameters.
    localMasterGlobe.parameters.copy(
      localMasterGlobe.mappletOriginalParameters);

    // Now reset the GeoPolygon.
    localMasterGlobe.internalPolygon.interalParameterHash.copy(
      localMasterGlobe.mappletOriginalParameters);

    localMasterGlobe.internalPolygon.fillTextFields();

    // Now reset the Pan.
    double lon = localMasterGlobe.internalPolygon.getCenterLon();
    localMasterGlobe.pan.centerLon.setCenterLon(lon);

    double lat = localMasterGlobe.internalPolygon.getCenterLat();
    localMasterGlobe.pan.centerLat.setCenterLat(lat);

    // Now reset the Zoom.
    int zoom = localMasterGlobe.internalPolygon.getZoom();
    localMasterGlobe.zoom.setZoomFactor(zoom);

    // The following is stupid, but for some unknown reason
    // the zoom choice menu disappears after the setZoomFactor()
    // in Netscape (not in Appletviewer!).  Also, just calling
    // localMasterGlobe.zoom.show() DIDN'T work!!!
    localMasterGlobe.zoom.hide();
    localMasterGlobe.zoom.show();

    // Set the geo selected flag in the parameters hash to the original value.
    String origGeo = new String(
      localMasterGlobe.mappletOriginalParameters.getValueOf("p.geoselected"));
    localMasterGlobe.parameters.updateHash("p.geoselected", origGeo);

    // Set the previously selected bands in the bandlist object
    localBandlist.setPrevSelections(prevbands);


     // Set the previously selected full subinterval flag
     fullsubwidget.setPrev();
    return true;
  }
}
