package IMSWG.IW.SubSet;

import java.awt.*;
import java.util.*;

 /** 
  * Show min/max and current number of scenes selected. 
  * @author Ed Seufert
  */

public class SceneSize extends Label {

   float ScanLinesPerScene = (float) 335.0;
   String Min;
   String Max;
   String Size;
   String ScanLines;

   SceneSize(float min, float max, float size) { 
       // Round up to 1 significant digit.
       float rMin = (float) Math.round(min*10.0)/10;
       float rMax = (float) Math.round(max*10.0)/10;
       this.Min = trimValue(Float.toString(rMin),1);
       this.Max = trimValue(Float.toString(rMax),1);
       set(size);
   } 
   public void set(float size) {
      // Round up to 1 significant digit.
      float rSize = (float) Math.round(size*10.0)/10;
      
      this.Size = trimValue(Float.toString(rSize),1);
//      this.ScanLines = Long.toString(Math.round(rSize*ScanLinesPerScene));    
 
      setText("Subset size limit is "+Min+" to "+Max+" scenes, "+
              "current selection is approx. "+Size+" scenes.");
   }


  public String trimValue(String stringValue, int toLength) {
    // Separate the string by the "&"'s
    StringTokenizer separatedValues = new StringTokenizer(stringValue,".");
    int numLines = separatedValues.countTokens();
    String [] lines = new String[numLines];
    String integer = separatedValues.nextToken();
    String fraction = (separatedValues.nextToken())+"0000";
    String subFraction = fraction.substring(0,toLength);
    return(integer+"."+subFraction);
  }
}
