package IMSWG.IW.SubSet;

import java.lang.*;
import IMSWG.IW.LatLonPoint;

/**
 * This class represents the subinterval (granule).
 * @author Ed Seufert
 */

public class SubInterval{

   // Globals
   float min;  // minimum size, in scenes, allowed for the subset region.
   float max;  // maximum size, in scenes, allowed for the subset region.
   float total; // The total number of scenes in the current subinterval
   float firstrow; // first row of the subinterval.
   float lastrow; // last row of the subinterval.
   String granuleID = new String(); // granule id.
   String datasetID = new String(); // dataset id.
   LatLonPoint[] coverage = new LatLonPoint[4]; // spatial coverage.


  /**
   * The constructor 
   */
   public SubInterval(float pmin, 
                      float pmax, 
                      String pgranuleID, 
                      String pdatasetID,
                      LatLonPoint[] pcoverage, 
                      float ptotal, 
                      float frow,
                      float lrow) {

   min = pmin;
   max = pmax;
   total = ptotal;
   granuleID = pgranuleID;
   datasetID = pdatasetID;
   coverage = pcoverage;
   firstrow = frow;
   lastrow = lrow;

   } // end of SubInterval constructor. 

  /**
   * Accessor methods
   */

   public float getfirstrow() {

      return firstrow;
   }

   public float getlastrow() {

      return lastrow;
   }


   public float getmin() {

      return min;
   }

   public float getmax() {

      return max;

   }

   public float gettotal() {

      return total;

   }

   public String getgranuleID() {
 
      return granuleID;

   }

   public String getdatasetID() {

      return datasetID;

   }

   public LatLonPoint[] getcoverage() {

      return coverage;

   }

} // end of class SubInterval
