package IMSWG.IW.SubSet;

import java.awt.*;
import java.io.*;
import java.lang.*;
import java.util.*;
 
public class WarningDialog extends Frame {

  Button quitButton = new Button ("Close");
  Panel buttonPanel = new Panel ();
  Panel messagePanel = new Panel ();
  Cost cost;


  // Constructor
  WarningDialog (Cost cost) {

    super ("Warning");
    this.cost = cost;

    buttonPanel.add (quitButton);

    setLayout (new BorderLayout (2, 1));
    add ("South", buttonPanel);
  }

  public void setMessagePanel (Vector msg) {

    int panelRows = msg.size() + 3;
    messagePanel.setLayout (new GridLayout (panelRows, 1));

    Label label1 = new Label ("Unable to compute the cost for this granule.");
    Label label2 = new Label ("You must have a cost computed before ordering.");
    Label label3 = new Label ("Problem encountered:");

    messagePanel.add (label1);
    messagePanel.add (label2);
    messagePanel.add (label3);

    for (int i=0; i < msg.size(); ++i) {
       Label response = new Label((String)msg.elementAt(i));
       messagePanel.add (response);
    }

    // Resize the new window
    resize (375, 400);
    add ("North", messagePanel);
  }

  public void setMessagePanel (Label comment) {
    messagePanel.setLayout (new GridLayout (5, 1));

    Label label1 = new Label ("DAAC did not return cost...");
    Label label2 = new Label ("You must have a cost computed before ordering.");
    Label label3 = new Label ("DAAC Comments:");
    Label label4 = comment;
    Label label5 = new Label 
                  ("If you want to try again hit RETRY, otherwise hit QUIT");
    
    messagePanel.add (label1);
    messagePanel.add (label2);
    messagePanel.add (label3);
    messagePanel.add (label4);
    messagePanel.add (label5);

    // Resize the new window
    resize (375, 300);
    add ("North", messagePanel);
  }

  public void setMessagePanel () {
    messagePanel.setLayout (new GridLayout (4, 1));

    Label label1 = new Label ("Cost Estimate failed...");
    Label label2 = new Label ("There seems to be a problem with the system");
    Label label3 = new Label ("You must have a cost computed before ordering.");
    Label label4 = new Label 
                  ("If you want to try again hit RETRY, otherwise hit QUIT");
    
    messagePanel.add (label1);
    messagePanel.add (label2);
    messagePanel.add (label3);
    messagePanel.add (label4);

    // Resize the new window
    resize (375, 300);
    add ("North", messagePanel);
  }

   public boolean action (Event evt, Object obj) {
      boolean handled = false;

      if (evt.target instanceof Button) {
         if (evt.target == quitButton) {   // Cancel pressed
            //System.out.println("WarningDialog cancelling");
            dispose ();
            cost.cancelThreads ();
//            cost.mySubSet.goAwayCancel ();
            handled = true;
         }
      }
      return handled;
   }

}
