#include <Gaea_config.h>
#include	"sqtFuncs.h"
#include	<stdio.h>

extern long sq_tr2off();
extern unsigned long sqtPow2[];

main(argc, argv)
    int argc;
    char *argv[];
{
    long l, lo, hi, num;
    int level;

    if (argc == 1)
	exit(1);

    if (argc == 3) {
	lo = atol(argv[1]);
	hi = atol(argv[2]);
	test_range(lo, hi, 0);
    }
    if (argc == 4) {
	lo = atol(argv[1]);
	hi = atol(argv[2]);
	test_range(lo, hi, 1);
    }

    if (argc == 2) {
	level = atoi(argv[1]);
	test_level(level);
    }
    exit(0);
}
test_level(level)
    int level;
{
    long lo, hi;
    int twok;
				/* nodes(0) = 20 */
				/* nodes(1) = 80 */
				/* nodes(k) = 20 * 4^k */

				/* start(0) = 0 */
				/* start(1) = start(0) + nodes(0) */
				/* start(k) = start(k-1) + nodes(k-1) */
				/*  = 20 * (4^k-1) / 3 */
				/*  = 20 * ((1 << (k+k)) - 1) */
    twok = level+level;
    lo = 20 * ((1L << twok) - 1);
    lo /= 3;
    hi = lo + 20 * (1L << twok);
    test_range(lo, hi, 0);
}

test_range(lo, hi, trace)
    long lo, hi;
    int trace;
{
    long num;
    long count = 0L;
    Sqt_Trixel trc, trbak, trint;

    Sqt_Trixel bunch[18];

    char cbuf[80], bbuf[80], line[80], ibuf[80];
    int len;
    long l;


    num = hi - lo;
    sqt_icosinit();

    for(l = lo; l<hi; l++){
	sq_n2tr(&trc, l);	/* input c */
	if(1){
	    int match;
	    char output[80];
	    sq_tr2ascii(&trc, output);
	    sq_trparse(output);
	    sq_currentlex(&trbak);

	    match = 0;
	    if (! sq_equal(&trbak, &trc))
		match != 1;

	    if (match)
		printf("\n");
	    if (match & 1)
		printf("In  %s\n", output); /* original */

	    if (trace || match || (num  < 100 )){
		sq_tr2ascii(&trbak, cbuf);
		printf("Out %s (%s)\n", cbuf, output);
	    }
	    count++;
	    if ( (count % 500000L) == 0){
		fprintf(stdout, "%ld trixels tested (%ld to go)\n",
			count, hi - count);
		fflush(stdout);
	    }
	}
    }
    fprintf(stdout, "A total of %ld trixels tested\n", count);
    exit(0);
}
