#include	"ansi.h"
#ifndef _SQT_3D_
#define	_SQT_3D_


typedef	struct {
    int x0, y0, x1, y1;
    int w, h;
} ViewPort;

typedef	struct {
    double x0, y0, x1, y1;
    double dx, dy;
} DataWindow;

typedef struct _Imaging {
    ViewPort	viewport;
    DataWindow	datawindow;
    double	perspective[3][4];
    double	rigid[4][4];
    double	cam[3];
    double	dir[3];
    double	lon, lat;
} Imaging;

typedef	double Matrix[4][4];

void World2Cam _ANSI_ARGS_ 
((double pos[3],		/* cam. position */
  double direction[3],		/* cam. direction */
  double mat[4][4]		/* returns 4x4 xform matrix */
));


void Cam2Perspective _ANSI_ARGS_ 
((double rigid[4][4],		/* 4x4 rigid matrix */
  double perspect[3][4],	/* return 3x4 perspective patrix */
  double focus			/* camera focus length */
));

void ProjectXYZ _ANSI_ARGS_
((double perspect[3][4],	/* specify 3x4 perspective matrix */
  double xyz[3],		/* specify input point */
  double uv[3]			/* return homogenous 2D point */
));

void TransformXYZ _ANSI_ARGS_
((double perspect[3][4],	/* specify 4x4 rigid matrix */
  double xyz_in[3],		/* specify input point */
  double xyz_out[3]		/* return output point */
));
  
void SqtViewportAttributes _ANSI_ARGS_ 
((Imaging *image,
  int width, int height		/* width and height refer to */
				/* the X11 window or canvas */
				/* scrollable region dimension */
));

void SqtUV2XY _ANSI_ARGS_ 
((Imaging *image,
  double u,
  double v,
  int *x,
  int *y
));

void Sqt3D_mat_vec _ANSI_ARGS_ ((Matrix mat, double vec[3], double res[3]));
void Sqt3D_about   _ANSI_ARGS_ ((double a[], double costh, double sinth, Matrix m));

#endif
