#include	<math.h>

void ll2xyzRad(lon, lat, vec)
     double lon;
     double lat;
     double *vec;
{
  double theta, phi;

  theta = lon;
  phi = (M_PI_2 - lat);
  vec[0] = sin(phi) * cos(theta);
  vec[1] = sin(phi) * sin(theta);
  vec[2] = cos(phi);
}
void ll2xyz(lon, lat, vec)
     double lon;
     double lat;
     double *vec;
{
  double theta, phi;

  theta = (lon*M_PI)/180.0;
  phi = ((90.0 - lat)*M_PI)/180.0;
  vec[0] = sin(phi) * cos(theta);
  vec[1] = sin(phi) * sin(theta);
  vec[2] = cos(phi);
}
void xyz2llrad (vec, lon, lat)	/* like place2ll() */
     double *vec;
     double *lon, *lat;
{
  double theta, phi, sinphi, mag, tmp;
  double local_vec[3];
  mag = vec[0] * vec[0];
  mag += vec[1] * vec[1];
  mag += vec[2] * vec[2];
  mag = sqrt(mag);

  local_vec[0] = vec[0] / mag;
  local_vec[1] = vec[1] / mag;
  local_vec[2] = vec[2] / mag;
  phi = acos(local_vec[2]);

  tmp = local_vec[1] / sin(phi);

  if(tmp > 1.0) tmp = 1.0;
  else if(tmp < -1.0) tmp = -1.0;

  theta = asin(tmp);
  
  *lon = theta;
  if(local_vec[0] < 0.0) {	/* [ed:bugfix, make it in xyz2ll too] */
      if(local_vec[1] < 0.0) {
	  *lon = -M_PI - *lon;
      }
      else {
	  *lon = M_PI - *lon;
      }
  }
  *lat = M_PI_2 - phi;
}
void xyz2ll (vec, lon, lat)	/* like place2ll() */
     double *vec;
     double *lon, *lat;
{
  double theta, phi, sinphi, mag, tmp;
  double local_vec[3];
  mag = vec[0] * vec[0];
  mag += vec[1] * vec[1];
  mag += vec[2] * vec[2];
  mag = sqrt(mag);

  local_vec[0] = vec[0] / mag;
  local_vec[1] = vec[1] / mag;
  local_vec[2] = vec[2] / mag;
  phi = acos(local_vec[2]);

  tmp = local_vec[1] / sin(phi);

  if(tmp > 1.0) tmp = 1.0;
  else if(tmp < -1.0) tmp = -1.0;

  theta = asin(tmp);
  
  *lon = (180.0 * theta) / M_PI;
  if(local_vec[0] < 0.0) {	/* [ed:bugfix, make it in xyz2ll too] */
      if(local_vec[1] < 0.0) {
	  *lon = -180.0 - *lon;
      }
      else {
	  *lon = 180.0 - *lon;
      }
  }
  *lat = 90.0 - ( (180.0 * phi) / M_PI ) ;
}

