#include <Gaea_config.h>
#include	"sqtFuncs.h"
#include	<ctype.h>
#include	<math.h>


#define		LPAREN		(050)
#define		RPAREN		(051)
#define		DEC_POINT	('.')
#ifndef	NULL
#define	NULL (void *) 0L
#endif
#define		isgood(c)	(isalnum(c) || (c=='.'))

static Sqt_Trixel	private_trixel;

static char *token _ANSI_ARGS_ ((char *in,
				 char **out,
				 int *len,
				 Sqt_Token *type));
PTF UserFunction = (PTF) NULL;

#define	copy_point(d, s) {d[0]=s[0];d[1]=s[1];d[2]=s[2];}
#define	average_point(r, p, q) {\
				  r[0]=(p[0]+q[0])/2.0; \
				  r[1]=(p[1]+q[1])/2.0; \
				  r[2]=(p[2]+q[2])/2.0;}

#define	swap_new_old	{\
			   ftmp = new_1;new_1 = old_1; old_1 = ftmp;\
			   ftmp = new_2;new_2 = old_2; old_2 = ftmp;\
			   ftmp = new_3;new_3 = old_3; old_3 = ftmp;}

#define swap(A, B, C) {C=A; A=B; B=C;}


extern double sqtEVAL();
/**************************************************************************/
int  sq_equal(tra, trb)
    Sqt_Trixel *tra, *trb;
{
    register char *a, *b;
    int len;
    if (tra->inum != trb->inum)
	return 0;

    if ((len = tra->len) != trb->len)
	return 0;
    a = tra->string;
    b = trb->string;
    while(len-- > 0){
	if (*a++ != *b++)
	    return 0;
    }
    return 1;
}

long sq_tr2n(tra)
    Sqt_Trixel	*tra;
{
    register tmp;
    register char *s;
    s = tra->string;	/* null to 0, one to one. */
    tmp = 0;
    if(!*s)return(tra->inum-1);
    while(*s){
	tmp *= 4;		/* was: 5 */
	tmp += *s++ - '0';	/* was: '0' */
    }
    tmp *= 20;
    tmp += tra->inum-1;
    return(tmp);
}

void sq_n2tr(tra, n)
    Sqt_Trixel	*tra;
    long n;
{
    register num, len, rem;
    register char *s, *t;
    num = n;
    len = 0;
    t = s = tra->string;

    tra->inum = (num%20)+1;

    num /= 20;
    if(!num){		/* NULL string if only icosahedral triangle */
	*s = '\0';
	tra->len = 0;
	return;
    }
    while(num){
	rem = (num%4);
	if(rem){
	  *s++ = rem + '0';	/* was (num%5) + '0' */
	  num /= 4;
	}
	else {
	  *s++ = '4';
	  num /= 4;
	  num--;		/* pre-borrowed with the '4' */
	}
	len++;
    }
    tra->len = len;

    *s = '\0';

    len /= 2;
    while(len--){		/* reverse by in-place swapping */
	if(*t == '0'){		/* check and fix for '0' in string */
		*t = '4';
		(*(t+1))--;
	}
	num = (int) *--s;
	*s = *t;
	*t++ = (char)num;
    }
}

long sq_tr2off(tra)
     Sqt_Trixel *tra;
{
  long tmp;
  register char *s;
  long off;
  int level;
  
  
  s = tra->string;	/* null to 0, one to one. */
  level = tra->len;
  off = 1 << (2 * level);	/* */
  off *= (tra->inum - 1);
  
  tmp = 0;
  
  if(!*s)
    return (off);
  
  while(*s) {
    tmp *= 4;		/* was: 5 */
    tmp += *s++ - '1';	/* was: '0' */
  }
  off += tmp;
  return(off);
}

void sq_off2tr(off, level, tra)
    long off;
    int level;
    Sqt_Trixel *tra;
{
    char *s;
    long tmp;

    tmp = off / (1 << (2 * level)); /* [opt] optimizable */

    tra->inum = tmp + 1;

    tra->len = level;
    s = tra->string;
    s += level;
    *s = '\0';
    tmp = off % (1 << (2 * level)); /* [opt] optimizable */
    while(level > 0){
	*--s = (tmp % 4) + '1';
	tmp /= 4;
	level--;
    }

}

/**************************************************************************/
void sq_xyz(tra)
     Sqt_Trixel *tra;
{
  int i;
  char *s;
  int ix, c;
  double p1[3], p2[3], p3[3];
  double q1[3], q2[3], q3[3];
  double *ftmp, *new_1, *new_2, *new_3;
  double *old_1, *old_2, *old_3;

  new_1 = p1;
  new_2 = p2;
  new_3 = p3;

  old_1 = q1;
  old_2 = q2;
  old_3 = q3;

  ix = tra->inum - 1;

/*
  for(i=0; i<3; i++){
    old_1[i] = Icos[ix].A[i];
    old_2[i] = Icos[ix].B[i];
    old_3[i] = Icos[ix].C[i];
  }
 */

  old_1[0] = sqtIcosvert[ix][0]->x;
  old_1[1] = sqtIcosvert[ix][0]->y;
  old_1[2] = sqtIcosvert[ix][0]->z;

  old_2[0] = sqtIcosvert[ix][1]->x;
  old_2[1] = sqtIcosvert[ix][1]->y;
  old_2[2] = sqtIcosvert[ix][1]->z;

  old_3[0] = sqtIcosvert[ix][2]->x;
  old_3[1] = sqtIcosvert[ix][2]->y;
  old_3[2] = sqtIcosvert[ix][2]->z;

  s = tra->string;
  i = tra->len;
  while(i-- > 0){
    c = *s++;
    switch (c) {
    case '1':
      copy_point(new_1, old_1);
      average_point(new_2, old_3, old_1);
      average_point(new_3, old_1, old_2);
      break;
    case '2':
      average_point(new_1, old_2, old_3);
      copy_point(new_2, old_2);
      average_point(new_3, old_1, old_2);
      break;
    case '3':
      average_point(new_1, old_2, old_3);
      average_point(new_2, old_3, old_1);
      copy_point(new_3, old_3);
      break;
    case '4':
      average_point(new_1, old_2, old_3);
      average_point(new_2, old_3, old_1);
      average_point(new_3, old_1, old_2);
    }
    swap_new_old;
  }
  copy_point(tra->corners[0], old_1);
  copy_point(tra->corners[1], old_2);
  copy_point(tra->corners[2], old_3);

/*
 * Compute the center point of the triangle
 */

  tra->center[0] = ( old_1[0] + old_2[0] + old_3[0] ) / 3.0;
  tra->center[1] = ( old_1[1] + old_2[1] + old_3[1] ) / 3.0;
  tra->center[2] = ( old_1[2] + old_2[2] + old_3[2] ) / 3.0;
}

/**************************************************************************/
/*
 * pt should be on the sphere surface (unit distance 1 from origin),
 * but this isn't required - it will be treated as though it were actually
 * lying at unit distance from the origin along the vector going through
 * pt
 */

void sq_tra(tra, depth)	/* Convert location to trixel address */
     Sqt_Trixel *tra;
     int depth;
{
  int face = (-1);
  Sqt_Plane *Iface;
  Sqt_Point pt;
  double t;
  char *s;
  Sqt_Plane *Iside0, *Iside1, *Iside2;
  int d0, d1, d2, dum;
  int center, i;
  double ptx, pty, ptz;
  double pintx, pinty, pintz;

  tra->len = depth;

  pt.x = ptx = tra->center[0];
  pt.y = pty = tra->center[1];
  pt.z = ptz = tra->center[2];

				/* Step 1: Determine which face */
  if (ptx > 0)
    if (pty > 0)
      if (ptz > 0)  /* Face 0, 1 (main triangle), 2, or 7 */
	if(sqtEVAL (&pt, sqtIcosside[1][0].Iplane) > 0)
	  face = 2;
	else if(sqtEVAL (&pt, sqtIcosside[1][1].Iplane) > 0)
	  face = 7;
	else if(sqtEVAL (&pt, sqtIcosside[1][2].Iplane) > 0)
	  face = 0;
	else face = 1;
      else  /* Face 5, 6 (main triangle), 15, or 7 */
	if(sqtEVAL (&pt, sqtIcosside[6][0].Iplane) > 0)
	  face = 15;
	else if(sqtEVAL (&pt, sqtIcosside[6][1].Iplane) > 0)
	  face = 5;
	else if(sqtEVAL (&pt, sqtIcosside[6][2].Iplane) > 0)
	  face = 7;
	else face = 6;
    else
      if (ptz > 0)		/* Face 0, 3, 4 (main triangle) or 13 */
	if(sqtEVAL (&pt, sqtIcosside[4][0].Iplane) > 0)
	  face = 0;
	else if(sqtEVAL (&pt, sqtIcosside[4][1].Iplane) > 0)
	  face = 13;
	else if(sqtEVAL (&pt, sqtIcosside[4][2].Iplane) > 0)
	  face = 3;
	else face = 4;
      else /* Face 5, 13, 14 (main triangle) or 19 */
	if(sqtEVAL (&pt, sqtIcosside[14][0].Iplane) < 0)
	  face = 19;
	else if(sqtEVAL (&pt, sqtIcosside[14][1].Iplane) > 0)
	  face = 13;
	else if(sqtEVAL (&pt, sqtIcosside[14][2].Iplane) > 0)
	  face = 5;
	else face = 14;
  else /* ptx <= 0 */
    if (pty > 0)
      if (ptz > 0)		/* Face 2, 8, 9 (main triangle) or 10 */
	if(sqtEVAL (&pt, sqtIcosside[9][0].Iplane) < 0)
	  face = 10;
	else if(sqtEVAL (&pt, sqtIcosside[9][1].Iplane) < 0)
	  face = 8;
	else if(sqtEVAL (&pt, sqtIcosside[9][2].Iplane) > 0)
	  face = 2;
	else face = 9;
      else /* Face 8, 15, 16 (main triangle) or 17 */
	if(sqtEVAL (&pt, sqtIcosside[16][0].Iplane) < 0)
	  face = 15;
	else if(sqtEVAL (&pt, sqtIcosside[16][1].Iplane) < 0)
	  face = 8;
	else if(sqtEVAL (&pt, sqtIcosside[16][2].Iplane) < 0)
	  face = 17;
	else face = 16;
    else
      if (ptz > 0)		/* Face 3, 10, 11 (main triangle) or 12 */
	if(sqtEVAL (&pt, sqtIcosside[11][0].Iplane) < 0)
	  face = 12;
	else if(sqtEVAL (&pt, sqtIcosside[11][1].Iplane) < 0)
	  face = 10;
	else if(sqtEVAL (&pt, sqtIcosside[11][2].Iplane) < 0)
	  face = 3;
	else face = 11;
      else			/* Face 12, 17, 18 (main triangle) or 19 */
	if(sqtEVAL (&pt, sqtIcosside[18][0].Iplane) < 0)
	  face = 17;
	else if(sqtEVAL (&pt, sqtIcosside[18][1].Iplane) < 0)
	  face = 12;
	else if(sqtEVAL (&pt, sqtIcosside[18][2].Iplane) < 0)
	  face = 19;
	else face = 18;
  tra->inum = face + 1;

				/* Step 2: Figure out where on face */
				/* (still in terms of xyz) */
  Iface = &sqtIcosface[face];

  t = Iface->D / (Iface->A * ptx + Iface->B * pty + Iface->C * ptz);

  pintx = t * ptx;
  pinty = t * pty;
  pintz = t * ptz;

				/* Step 3: Determine distances from */
				/* intersection point to triangle sides */
  Iside0 = sqtIcosside[face][0].Iplane;
  Iside1 = sqtIcosside[face][1].Iplane;
  Iside2 = sqtIcosside[face][2].Iplane;
  d0 = (double)sqtPow2[MAXDEPTH+1] * (1.0 -
              (fabs(pintx * Iside0->A + pinty * Iside0->B +
		    pintz * Iside0->C - Iside0->D) / sqtFactor));
  d1 = (double)sqtPow2[MAXDEPTH+1] * (1.0 -
               (fabs(pintx * Iside1->A + pinty * Iside1->B +
		     pintz * Iside1->C - Iside1->D) / sqtFactor));
  d2 = (double)sqtPow2[MAXDEPTH+1] * (1.0 -
               (fabs(pintx * Iside2->A + pinty * Iside2->B +
		     pintz * Iside2->C - Iside2->D) / sqtFactor));

  /* Step 4: Compute trixel path */
  s = tra->string;	/* intialize path value */
  center = sqtPow2[MAXDEPTH];
  for(i=0; i<depth; i++)
  {
    if(d0 < center) /* child is '1' */
    {
      *s++ = '1';
      d1 -= center;
      d2 -= center;
      center >>= 1;
      swap(d1, d2, dum);
    }
    else if (d1 < center) /* child is '2' */
    {
      *s++ = '2';
      d0 -= center;
      d2 -= center;
      center >>= 1;
      swap (d0, d2, dum);
    }
    else if (d2 < center) /* child is '3' */
    {
      *s++ = '3';
      d0 -= center;
      d1 -= center;
      center >>= 1;
      swap (d0, d1, dum);
    }
    else /* child is 3 */
    {
      *s++ = '4';
      d0 = center*2 - d0;
      d1 = center*2 - d1;
      d2 = center*2 - d2;
      center >>= 1;
    }
  } /* end for */
}


static void tr_action(function)
     PTF function;
{
  UserFunction = function;
}

static char *token(in, out, len, type)
     char *in;
     char **out;
     int *len;
     Sqt_Token *type;
{
  char *s;
  int c;

  s = in;
  *type = eol;
  *len = 0;

  if (!s) {
    return (char *) 0;
  }
  while (*s){
    c = *s;
    while (isspace(c) && c) {
      c = *++s;
    }
    if(!c) {
      *type = eol;
      return (char *) 0;
    }

    if (c == LPAREN){
      *len = 1;
      *type = lparen;
      s++;
      return s;
    }
    if (c == RPAREN) {
      *len = 1;
      *type = rparen;
      s++;
      return s;
    }
    if (!isgood(c)) {
      *len = 1;
      *type = illegal;
      *out = s;
      s++;
      return s;
    }

    *type = word;
    *out = s;
    while (isgood(c) && c) {
      (*len)++;
      c = *++s;
    }
    return s;
  }
  return s;
}

/*
 *   			(t  12   12345   7  )
 */

/*
 * Flat expressions
 */

void sq_copy(trd, trs, parts)
     Sqt_Trixel *trd, *trs;
     long parts;
{
    int len;
    trd->inum = trs->inum;
    len = trs->len;
    strncpy (trd->string, trs->string, len);
    trd->len = len;
    trd->string[len] = '\0';
}

static void processField(field, tokenStr)
     int field;
     char *tokenStr;
{
  switch(field) {
  case 0:
    private_trixel.inum = atoi(tokenStr);
    break;
  case 1:
    strcpy(private_trixel.string, tokenStr);
    break;
  case 2:
    private_trixel.len = atoi(tokenStr);
    break;
  }
}
void sq_currentlex (tra)
     Sqt_Trixel *tra;
{
    int len;
    sq_copy(tra, &private_trixel, 0L);
				/* Correct for possibly bogus */
				/* length field */
    len = strlen(tra->string);
    tra->len = len;
}

void sq_trparse(buffer)
     char *buffer;
{
  char *s;
  char *tok;
  int len;
  Sqt_Token tt;
  char tokenStr[256];
  int building = 0;
  int field = 0;
  s = buffer;
  private_trixel.len = 0; /* for primitive (level 0) trixels */
  private_trixel.string[0] = '\0';
  do {
    s = token(s, &tok, &len, &tt);
    if (tt != eol) {
      if(building) {
	strncpy(tokenStr, tok, len);
	tokenStr[len] = '\0';
	switch(tt) {
	case lparen:
	  building = 1;
	  break;
	case word:
	  if (tokenStr[0] == 't')
	    field = 0;
	  else {
	    processField(field, tokenStr);
	    field++;
	  }
	  break;
	case rparen:
	  building = 0;
	  if(UserFunction) {
	    (*UserFunction) (&private_trixel, "");
	  }
	  break;
	}
      }
      else {
	if (tt == lparen)
	  building = 1;
      }
    }
  }
  while (tt != eol);
}

void sq_tr2ascii (tra, buf)
    Sqt_Trixel *tra;
    char *buf;
{
    if (!buf)
	return;
    if (!tra) {
	strcpy(buf, "NaT");
	return;
    }
    
    tra->string[tra->len] = '\0';

    if ((tra->inum < 1) || (tra->inum > 20)) {
	sprintf(buf, "(Terr %2d.\"%s\" [%d])",
		tra->inum,tra->string,tra->len);
    }
    else {
	sprintf(buf, "(ta %2d %s %d)",
		tra->inum,tra->string,tra->len);
    }
    return;
}

void sq_norm(tra, length)
    Sqt_Trixel *tra;
    double length;
{
    double ftmp;
    extern double sqrt();

    /*
   * Make tra->xyz's to be at length away from origin
   */

    int i;
    double norm;

    for(i=0; i<3; i++){
	ftmp = tra->corners[i][0];	norm =  ftmp * ftmp;
	ftmp = tra->corners[i][1];	norm += ftmp * ftmp;
	ftmp = tra->corners[i][2];	norm += ftmp * ftmp;
	norm = sqrt(norm);

	tra->corners[i][0] /= norm;
	tra->corners[i][1] /= norm;
	tra->corners[i][2] /= norm;

    }
}

#define	nx	normal[0]
#define	ny	normal[1]
#define	nz	normal[2]

void sq_surfacenormals(tra, normal)
    Sqt_Trixel *tra;
    double *normal;
{
    double ax, ay, az, bx, by, bz;
    double ftmp;
    double *nr = normal;

    ax = tra->corners[1][0] - tra->corners[0][0];
    ay = tra->corners[1][1] - tra->corners[0][1];
    az = tra->corners[1][2] - tra->corners[0][2];

    bx = tra->corners[2][0] - tra->corners[0][0];
    by = tra->corners[2][1] - tra->corners[0][1];
    bz = tra->corners[2][2] - tra->corners[0][2];

    *nr++ = ay * bz - az * by;
    *nr++ = az * bx - ax * bz;
    *nr   = ax * by - ay * bx;
}
