#include <Gaea_config.h>
#include	<stdio.h>
#include	<sqtTypes.h>
#include	<sqtFuncs.h>
#include	<sqtQTypes.h>
#include       	<sqtQFuncs.h>

void sqtErrWarn	 _ANSI_ARGS_ ((char *));
void sqtErrExit  _ANSI_ARGS_ ((char *));

/************************************


  ***********************************/

void sq_Qprint(sphere, q, msg)
    SqtQnode *sphere;
    SqtQnode *q;
    char *msg;
{
    Sqt_Trixel tra;
    char ascii_tr[80];
    static char suffix[] = " ";
    sq_Q2tr(sphere, q, &tra);

    suffix[0] = (q->body.nonterm) ? 'n' : ' ';
    sq_tr2ascii(&tra, ascii_tr);
    fprintf(stdout, "%s: %s %s\n",
	   msg,
	   ascii_tr, suffix);
}

void sq_Q2tr(sphere, qa, tra)
    SqtQnode	*sphere;
    SqtQnode	*qa;
    Sqt_Trixel	*tra;
{
    register char *sa;
    register i;
    tra->len = i = qa->body.level;
    if(i==0){
	tra->inum = 1 + (qa - sphere); /* Yes, it does compensate */
					  /* for size */
	tra->string[0] = '\0';
	return;
    }
    *(sa = &(tra->string[i])) = '\0';
    while(i--){		/* nonzero if we get here */
	*(--sa) = qa->body.tlabel;
	qa = sqtQParent(qa);
    }
    if(sqtQParent(qa) != 0)
	sqtErrExit ("sq_Q2tr: qa parent not null");

    tra->inum = 1 + (qa - sphere);
    return;
}

SqtQnode *sq_tr2Q(sphere, tra, dif)
    SqtQnode *sphere;
    Sqt_Trixel	*tra;
    int *dif;
{
    register i;
    register char *sa;
    int trlen;
    SqtQnode *tmpq;

    i = tra->inum;
    sa = tra->string;
    tmpq = &sphere[i - 1];	/* Lowest inum is 1, not zero */
    i = trlen = tra->len;

    while(i--){
	if(sqtQ_terminal(tmpq)){
	    *dif = (trlen - tmpq->body.level);
	    return(tmpq);
	}
	tmpq = tmpq->sons[*sa++ - '0'];
    }
    *dif = 0;
    return(tmpq);
}

SqtQnode *sq_insert (tra, sphere)
    Sqt_Trixel *tra;
    SqtQnode *sphere;
{
    
    register i;
    register char *sa;
    int trlen;
    SqtQnode *tmpq;

    i = tra->inum;
    sa = tra->string;
    tmpq = &sphere[i - 1];	/* Lowest inum is 1, not zero */
    i = trlen = tra->len;

    while(i--){
	if(sqtQ_terminal(tmpq))
	    sqtQ_split(tmpq);
	tmpq = tmpq->sons[*sa++ - '0'];
    }
    return(tmpq);
}


void sqtQ_prdump(colorlabel)
    char *colorlabel;
{
    return;
}

int sq_Q12nbrs(sphere, q, q12)
    SqtQnode *sphere;
    SqtQnode *q;
    SqtQnode *q12[];
{
    Sqt_Trixel tra;
    Sqt_Trixel bunch[18];
    int n, i;
    int dif;

    sq_Q2tr(sphere, q, &tra);
    n = sq_12neighbors(&tra, bunch);
    for(i=0; i<n; i++){
	q12[i] = sq_tr2Q(sphere, &bunch[i], &dif);
    }
    return n;
}
int sq_Qnbrs(sphere, q, q3)
    SqtQnode *sphere;
    SqtQnode *q;
    SqtQnode *q3[];
{
    Sqt_Trixel tra;
    Sqt_Trixel trio[3];
    int dif;

    sq_Q2tr(sphere, q, &tra);
/*
 *	tr_negh(&tra, &trio); # if this works out, I'll be using tr_nearest
 *	instead of tr_negh.
 */
    sq_neighbors(&tra, &trio);
    q3[0] = sq_tr2Q(sphere, &trio[0], &dif);
    q3[1] = sq_tr2Q(sphere, &trio[1], &dif);
    q3[2] = sq_tr2Q(sphere, &trio[2], &dif);
    return 3;
}

#include	<stdio.h>

void sqtErrWarn(msg)
    char *msg;
{
    fprintf(stderr, "sqt Warning: \"%s\"\n", msg);
}

void sqtErrExit(msg)
    char *msg;
{
    fprintf(stderr, "sqt Panic: \"%s\"\n", msg);
    exit(1);
}

