#include <Gaea_config.h>
#include	<sqtTypes.h>
#include	<sqtFuncs.h>
#include	"ansi.h"

static int chaseback  _ANSI_ARGS_ ((int nc, char *begin, char *end));
static int xlate      _ANSI_ARGS_ ((Sqt_Trixel *tr, char *s, int dir));
static int notctrdir  _ANSI_ARGS_ ((Sqt_Trixel *));
static void extend    _ANSI_ARGS_ ((Sqt_Trixel *, int));
static void shrink    _ANSI_ARGS_ ((Sqt_Trixel *));
static int neghno     _ANSI_ARGS_ ((Sqt_Trixel *tra, Sqt_Trixel *trb));


int sq_neightbors _ANSI_ARGS_ ((Sqt_Trixel *ct, Sqt_Trixel *nbrs));
int sq_synonyms   _ANSI_ARGS_ ((Sqt_Trixel *tra, Sqt_Trixel *syns));
int sq_getneighbor _ANSI_ARGS_ ((Sqt_Trixel *tra, Sqt_Trixel *trb, int dir));


extern int   sqtAdjacencyTypes[21][21];
extern int   sqtAdjacencyList[21][4];
extern char *sqtCorrespondence[4];
extern int   sqtDirectionTable[3][3];

static void shrink(tra)
    Sqt_Trixel *tra;
{
    register char  *t;
    t = tra->string + tra->len - 1;
    *t = '\0';
    tra->len--;
}

static void extend (tra, child)
    Sqt_Trixel *tra;
    int child;
{
    char ch;
    char *s;
    ch = child + '1';
    s = tra->string + tra->len;
    *s++ = ch;
    *s = '\0';
    tra->len++;
}


static int notctrdir(tra)	/* which neighbor selector takes me to ..4 ? */
    Sqt_Trixel *tra;
{
    register char *begin, *cptr;
    register int dir;
    cptr = tra->string;
    begin = cptr;
    while(*cptr)
	if(*cptr++ == '4')
	    begin = cptr;
    dir = *--cptr - '1';
    return chaseback(dir, begin, cptr);
}

static int xlate(tra, s, dir)
    Sqt_Trixel *tra;
    char *s;
    int dir;
{
    register char *tname, *sname;
    int adj_type;
    int tlen;
    
    adj_type = sqtAdjacencyTypes
	[tra->inum]		/* row */
	[sqtAdjacencyList[tra->inum][dir+1]]; /* col */

    tlen = tra->len;
    tname = tra->string;
    sname = s;
    while(tlen--)
	*sname++ = sqtCorrespondence[adj_type][*tname++ - '1'];
    *sname = '\0';			/* make sure terminates normally */
    return(sqtAdjacencyList[tra->inum][dir+1]);
}

static int chaseback(nc, begin, cptr)
     int nc;
     char *begin, *cptr;
{
  register res;
  res = nc;
  while(cptr >= begin){
    if(*cptr != '4')
      res = sqtDirectionTable[(*cptr--) - '1'][res];
    else cptr--;
  }
  return(res);
}

sq_12neighbors(tra, bunch)
    Sqt_Trixel *tra;
    Sqt_Trixel bunch[];
{
    char c;
    register char *tnameend;
    register i, j;
    int nrUniq;
    Sqt_Trixel syns[6];
/*
 * When we extend the name, we must remember to "unextend" it
 * before we return from here 
 */
    nrUniq = 0;			/* counter of non-unique trixels */

    tnameend = tra->string + tra->len;	/* these two are */
    extend(tra, 0);					/* strongly bound */

    for(i=0; i<3; i++){
	c = '1' + i;
	*tnameend = c;
	sq_synonyms(tra, syns);
	for(j=0; j<6; j++){
	    shrink(&syns[j]);
	    {
		register int k;
		k = 0;
		while(k < nrUniq){
		    if(sq_equal(&bunch[k], &syns[j]))
			goto nosave;
		    k++;
		}
		sq_copy(&bunch[nrUniq++], &syns[j], 0L);
	    }
	  nosave:
	    continue;
	}
    }
    shrink(tra);				/* Undo extend */
    return nrUniq;
}

sq_neighbors(tra, nbrs)
    Sqt_Trixel *tra;
    Sqt_Trixel *nbrs;
{
				/* Uses: sq_chaseback, sq_xlate */

    register lev;
    register char *cptr, *begin;
    char *bro[3];
    int newclo[3], open[3], closed[3];
    int i, nc, itmp;
    
    for(i=0; i<3; i++){
	open[i] = 1;
	closed[i] = newclo[i] = 0;
	bro[i] = nbrs[i].string;
	nbrs[i].len = tra->len;
/*
 * changes later, if open[i] does not become zero :
 */
	nbrs[i].inum = tra->inum;
    }

    cptr = tra->string;
    begin = tra->string;
    lev = -1;
    while(*cptr){
	lev++;
	/* new state */
	if(*cptr == '4'){
	    for(i=0; i<3; i++){
		newclo[i] = closed[i] = 1;
		open[i] = 0; 
		strncpy(bro[i], tra->string, lev);
		*(bro[i]+lev) = '0' + i + 1;
		*(bro[i]+lev+1) = '\0';
		begin = tra->string + lev + 1;
	    }	
	}
	else {
	    nc = (*cptr) - '0' - 1;
	    itmp = chaseback(nc, begin, cptr);
	    closed[itmp] = 1;
	    open  [itmp] = 0;
	    for(i=0; i<3; i++){
		if(itmp == i){
		    strncpy(bro[i], tra->string, lev);
		    *(bro[i]+lev) = '4';
		    *(bro[i]+lev+1) = '\0';
		}
		else if(closed[i]){
		    *(bro[i]+lev) = *cptr;
		    *(bro[i]+lev+1) = '\0';
		}
		

	    }
	}
    cptr++;
    }
    for(i=0; i<3; i++){
      if(open[i]){
	nbrs[i].inum = xlate(tra, bro[i], i);
      }
    }
    i = open[0] + (open[1] << 1) + (open[2] << 2);
    itmp = open[0] + open[1] + open[2];
    return(i | ((3-itmp) << 3));
}

static int neghno(tra, trb)
    Sqt_Trixel *tra, *trb;
{
    register i;
    Sqt_Trixel trio[3];

    sq_neighbors(tra, trio);

    for(i=0; i<3; i++){
	if( sq_equal(trb, &trio[i]))return(i);
    }
    return(-1);
}


int sq_getneighbor(tra, trb, dir)
    Sqt_Trixel *tra;
    Sqt_Trixel *trb;
    int dir;
{
    register lev;
    register char *s_cptr, *bro;
    char *s_begin;
    int newclo, open, closed;
    int nc;
    if(dir<0 || dir>2){
	return -1;			/* [ed:error:fatal] */
    }

    open = 1;
    closed = newclo = 0;
/*
 * changes later, if open does not become zero :
 */
    trb->inum = tra->inum;

    s_cptr  = tra->string;	/* current ptr in input trixel name */
    s_begin = tra->string;	/* chaseback to last '4' (not incl) */

    bro     = trb->string;
    *bro = 0;
    trb->len = tra->len;
    lev = -1;
    while(*s_cptr){
	lev++;
				/* new state */
	if(*s_cptr == '4'){
	    newclo = closed = 1;
	    open = 0; 
	    strncpy(bro, tra->string, lev);
	    *(bro+lev) = '0' + dir + 1;
	    *(bro+lev+1) = '\0';
	    s_begin = tra->string + lev + 1;
	}
	else {
	    nc = (*s_cptr) - '0' - 1;
	    newclo = chaseback(nc, s_begin, s_cptr);
	    if(newclo == dir){
		closed = 1;
		open   = 0;
		strncpy(bro, tra->string, lev);
		*(bro+lev) = '4';
		*(bro+lev+1) = '\0';
	    }
	    else if(closed){
		*(bro+lev) = *s_cptr;
		*(bro+lev+1) = '\0';
	    }
	}
	s_cptr++;
    }
    if(open)
	trb->inum = xlate(tra, bro, dir);

    return(neghno(trb,tra));
}

sq_synonyms(tra, syns)	/* Generate synonyms for same vertex */
    Sqt_Trixel	*tra;
    Sqt_Trixel	*syns;		/* caller responsible for size */
{
    register i, tmp;
    int proh;		/* neighbors of tra are *NOT* in this direction */
    int dir1, dir2;	/* the two sides of tra */
    int b1,b2;		/* back pointers from next trixel to current ones */
    int degree;		/* of this vertex. Either 5 or 6 */
    int smallest;	/* smallest trn value so far */

    proh = notctrdir(tra);
/*
 * printf("Vertex.c:synonyms.proh = %d\n",proh);
 */
    dir1 = (proh+1)%3;
    dir2 = (proh+2)%3;	/* mod 3 trixel border */
    b1   = 2 * sq_getneighbor(tra, &syns[0], dir1); /* 1 */
    b2   = 2 * sq_getneighbor(tra, &syns[1], dir2); /* 2 */

    dir1 = (2 * notctrdir(&syns[0])+b1)%3;
    dir2 = (2 * notctrdir(&syns[1])+b2)%3;
    b1   = 2 * sq_getneighbor(&syns[0], &syns[2], dir1); /* 3 */
    b2   = 2 * sq_getneighbor(&syns[1], &syns[3], dir2); /* 4 */

    dir1 = (2 * notctrdir(&syns[2])+b1)%3;
    dir2 = (2 * notctrdir(&syns[3])+b1)%3;
    b1   = 2 * sq_getneighbor(&syns[2], &syns[4], dir1); /* 5 */
    b2   = 2 * sq_getneighbor(&syns[3], &syns[5], dir2); /* 6 */

    degree = (sq_equal(&syns[4],&syns[5])) ? 5 : 6; /* 4 ?= 5 */

    smallest = sq_tr2n(tra);
    for(i=0;i<degree-1;i++){
	if((tmp = sq_tr2n(&syns[i])) < smallest){
				/* i is the index of the smallest */
				/* trn value*/
	    smallest = tmp;
	}
    }
    return(smallest);
}

